




// **********************************************
// Verteiler-Programme
// **********************************************




procedure CONST_to_Device;
begin


  case CONIN_Device of

  Device_Serial : CONST_von_UART_lesen;
  |

  Device_ITP3_DS0 : DEV_NR:=DEV_DS0;
                    ConsoleIn:=ITP3_empfange_CONST;
  |

  Device_ITP3_DS1 : DEV_NR:=DEV_DS1;
                    ConsoleIn:=ITP3_empfange_CONST;
  |

  Device_ITP3_DS2 : DEV_NR:=DEV_DS2;
                    ConsoleIn:=ITP3_empfange_CONST;
  |

  Device_ITP3_DS3 : DEV_NR:=DEV_DS3;
                    ConsoleIn:=ITP3_empfange_CONST;
  |

  Device_ITP3_DS4 : DEV_NR:=DEV_DS4;
                    ConsoleIn:=ITP3_empfange_CONST;
  |

  endcase;

  Z80_CONIN;

end CONST_to_Device;







procedure CONIN_to_Device;
begin

  case CONIN_Device of

  Device_Serial : UART_CONIN_Schleife;
  |

  Device_ITP3_DS0 : DEV_NR:=DEV_DS0;
                    ITP3_CONIN_Schleife;
  |

  Device_ITP3_DS1 : DEV_NR:=DEV_DS1;
                    ITP3_CONIN_Schleife;
  |

  Device_ITP3_DS2 : DEV_NR:=DEV_DS2;
                    ITP3_CONIN_Schleife;
  |

  Device_ITP3_DS3 : DEV_NR:=DEV_DS3;
                    ITP3_CONIN_Schleife;
  |

  Device_ITP3_DS4 : DEV_NR:=DEV_DS4;
                    ITP3_CONIN_Schleife;
  |

  endcase;

  Z80_CONIN;

end CONIN_to_Device;









procedure CONOUT_to_Device;
begin

  // einlesen des auszugebenden Bytes
  Z80_CONOUT;

  direkt_CONOUT_to_Device;

end CONOUT_to_Device;










procedure LIST_to_Device;
begin

  Z80_LIST;
  {
  case LIST_Device of

  Device_Serial : xxx;
  |

  Device_ITP3_DS0 : DEV_NR:=DEV_DS0;
                    xxx;
  |

  Device_ITP3_DS1 : DEV_NR:=DEV_DS1;
                    xxx;
  |

  Device_ITP3_DS2 : DEV_NR:=DEV_DS2;
                    xxx;
  |

  Device_ITP3_DS3 : DEV_NR:=DEV_DS3;
                    xxx;
  |

  endcase;
    }
end LIST_to_Device;








procedure SOUND_to_Device;
begin

  Z80_SOUND;

  case SOUND_Device of

  {
  // nicht implementert
  Device_Serial : UART_SOUND_senden;
  |
  }

  Device_ITP3_DS0 : DEV_NR:=DEV_DS0;
                    ITP3_sende_SOUND(SOUNDOut);
  |

  Device_ITP3_DS1 : DEV_NR:=DEV_DS1;
                    ITP3_sende_SOUND(SOUNDOut);
  |

  Device_ITP3_DS2 : DEV_NR:=DEV_DS2;
                    ITP3_sende_SOUND(SOUNDOut);
  |

  Device_ITP3_DS3 : DEV_NR:=DEV_DS3;
                    ITP3_sende_SOUND(SOUNDOut);
  |

  Device_ITP3_DS4 : DEV_NR:=DEV_DS4;
                    ITP3_sende_SOUND(SOUNDOut);
  |

  endcase;


end SOUND_to_Device;






// **********************************************





function Laufwerk_ist_vorhanden : Byte;
var
  Liv_Byte : Byte;
  Eintrag_Wert : Byte;
  LW_Nummer : Byte;
begin

  Eintrag_Wert:=DISKNO_in_Schnittstelle;

  case Eintrag_Wert of

    Device_lokal_Flash : Liv_Byte:=0;
    |

    Device_Serial : Liv_Byte:=0;
    |

    Device_ITP3_DS0..Device_ITP3_DS4 : Liv_Byte:=0;
    |

  else

    Liv_Byte:=$FF;

  endcase;

  Result:=Liv_Byte;

end Laufwerk_ist_vorhanden;





procedure LW_vorhanden;
var
  LW_ok : Byte;
begin

  LW_ok:=Laufwerk_ist_vorhanden;

  // warten bis /IORQ inaktiv wird (High)
  warte_solange_IORQ_Low;

  // Das naechste Byte ist das einzulesende Zeichen
  warte_solange_IORQ_High;

  DDRC:=%11111111;
  PortC:=LW_ok;

  IORQ_Ende;

end LW_vorhanden;








// **********************************************





procedure Auswerten_IORQ;
var
  IO_Wert : Byte;
begin


  if BitLow(WR_Z80_E) then

    // Daten-Port auf Lesen
    DDRC  :=  %00000000;

    IO_Wert := PinC;

    case IO_Wert of



      // CP/M Device Routinen
      IORQ_CONOUT      : CONOUT_to_Device;
      |

      IORQ_CONIN       : CONIN_to_Device;
      |

      IORQ_CONST       : CONST_to_Device;
      |

      IORQ_LIST        : LIST_to_Device;
      |

      IORQ_SOUND       : SOUND_to_Device;
      |



      // interne RAM-Floppy auf dem Board (LW A:)
      IORQ_RAM2ARR     : START_RAM2ARR;
      |

      IORQ_ARR2RAM     : START_ARR2RAM;
      |





      // CP/M Hilfsroutinen
      IORQ_BDOS2RAM    : START_BDOS2RAM;
      |

      IORQ_CCP2RAM     : START_CCP2RAM;
      |


      // Sektor, Track und Disk an den uC senden
      IORQ_STD2UC      : STD_an_uC;
      |

      // Ist das aktuelle Laufwerk vorhanden?
      IORQ_LW_ok       : LW_vorhanden;
      |

      IORQ_LW_CONOUT   : Geraete_anzeigen;
                         Laufwerke_Verteiler_anzeigen;
                         IORQ_Ende;

      |

      // je nach Laufwerk wird nun READ oder WRITE
      // ausgefuehrt
      IORQ_RD_DISK2ARR : Laufwerke_Verteiler_READ;
      |

      IORQ_WR_ARR2DISK : Laufwerke_Verteiler_WRITE;
      |


    else

      SER0_String:='x80';
      WriteLn_SER0;

    endcase; { case IO_Wert of }

  endif; // if BitLow(WR_Z80) then

end Auswerten_IORQ;




