

// ****************************
// *** ITP3-Server-Routinen ***
// *** Hardware-Teil        ***
// ****************************


VAR


  // Ausgangs-Definitionen
  ITP3_D0_A[PortA,0] : bit; // D0 - Ausgang
  ITP3_D1_A[PortA,1] : bit; // D1 - Ausgang
  ITP3_D2_A[PortA,2] : bit; // D2 - Ausgang
  ITP3_D3_A[PortA,3] : bit; // D3 - Ausgang

  // Port-Richtungs-Definitionen (E/A)
  ITP3_D0_D[DDRA,0] : bit;  // D0 - Ein-/Ausgang (Direction)
  ITP3_D1_D[DDRA,1] : bit;  // D1 - Ein-/Ausgang (Direction)
  ITP3_D2_D[DDRA,2] : bit;  // D2 - Ein-/Ausgang (Direction)
  ITP3_D3_D[DDRA,3] : bit;  // D3 - Ein-/Ausgang (Direction)
  ITP3_DR_D[DDRB,0] : bit;  // DR - Device Receive - (Direction)

  // Eingangs-Definitionen
  ITP3_D0_E[PinA,0] : bit;  // D0 - Eingang
  ITP3_D1_E[PinA,1] : bit;  // D1 - Eingang
  ITP3_D2_E[PinA,2] : bit;  // D2 - Eingang
  ITP3_D3_E[PinA,3] : bit;  // D3 - Eingang
  ITP3_DR_E[PinB,0] : bit;  // DR - Device Receive - Eingang


  // DS fuer Client 1
  ITP3_DS0_A[PortA,4] : bit; // DS0 - Device Select - Ausgang
  ITP3_DS0_D[DDRA,4] : bit;  // DS0 - Device Select (Direction)
  ITP3_DS0_E[PinA,4] : bit;  // DS0 - Device Select - Eingang

  ITP3_DS1_A[PortA,5] : bit; // DS1 - Device Select - Ausgang
  ITP3_DS1_D[DDRA,5] : bit;  // DS1 - Device Select (Direction)
  ITP3_DS1_E[PinA,5] : bit;  // DS1 - Device Select - Eingang

  ITP3_DS2_A[PortA,6] : bit; // DS2 - Device Select - Ausgang
  ITP3_DS2_D[DDRA,6] : bit;  // DS2 - Device Select (Direction)
  ITP3_DS2_E[PinA,6] : bit;  // DS2 - Device Select - Eingang

  ITP3_DS3_A[PortD,0] : bit; // DS3 - Device Select - Ausgang
  ITP3_DS3_D[DDRD,0] : bit;  // DS3 - Device Select (Direction)
  ITP3_DS3_E[PinD,0] : bit;  // DS3 - Device Select - Eingang

  ITP3_DS4_A[PortD,1] : bit; // DS3 - Device Select - Ausgang
  ITP3_DS4_D[DDRD,1] : bit;  // DS3 - Device Select (Direction)
  ITP3_DS4_E[PinD,1] : bit;  // DS3 - Device Select - Eingang






// ****************************
// *** ITP3-Server-Routinen ***
// *** Softwareteil         ***
// ****************************


CONST

{

  Konfiguration WHO_ARE_YOU - Byte
  D7 - CONOUT
  D6 - CONIN
  D5 - LIST
  D4 - SOUND
  D3 - DIVE
  D2 - READER
  D1 - N.N.
  D0 - N.N.

}


  // Befehlscode fuer ITP3
  ITP3_WHO_ARE_YOU : Byte = 01;
  ITP3_ERROR_CODE  : Byte = 02;

  ITP3_CONOUT  : Byte = 03;
  ITP3_CONST   : Byte = 04;
  ITP3_CONIN   : Byte = 05;
  ITP3_STD     : Byte = 06;
  ITP3_RD_SEC  : Byte = 07;
  ITP3_WR_SEC  : Byte = 08;
  ITP3_SOUND   : Byte = 09;
  ITP3_READER  : Byte = 10;


  DEV_DS0 : Byte = 00;
  DEV_DS1 : Byte = 01;
  DEV_DS2 : Byte = 02;
  DEV_DS3 : Byte = 03;
  DEV_DS4 : Byte = 04;


VAR
  DEV_NR : Byte;
  CONOUT_Device_NR1, CONOUT_Device_NR2,
  CONIN_Device,
  LIST_Device, SOUND_Device,
  READER_Device : Byte;



procedure Init_ITP3;
begin

  // alle Datenleitungen auf Eingang schalten
  ClearBit(ITP3_D0_D);
  ClearBit(ITP3_D1_D);
  ClearBit(ITP3_D2_D);
  ClearBit(ITP3_D3_D);

  // Device Select auf Ausgang
  SetBit(ITP3_DS0_D);
  SetBit(ITP3_DS0_A);

  SetBit(ITP3_DS1_D);
  SetBit(ITP3_DS1_A);

  SetBit(ITP3_DS2_D);
  SetBit(ITP3_DS2_A);

  SetBit(ITP3_DS3_D);
  SetBit(ITP3_DS3_A);

  SetBit(ITP3_DS4_D);
  SetBit(ITP3_DS4_A);


  // DR auf Eingang
  ClearBit(ITP3_DR_D);

  // ITP-Device 0 ist selektiert
  DEV_NR:=DEV_DS0;

  CONOUT_Device_NR1:=no_Device;
  CONOUT_Device_NR2:=no_Device;
  CONIN_Device:=no_Device;
  LIST_Device:=no_Device;
  SOUND_Device:=no_Device;
  READER_Device:=no_Device;


end Init_ITP3;




procedure DEV_NR_ClearBit;
begin

  case  DEV_NR of
    DEV_DS0 : ClearBit(ITP3_DS0_A);
    |
    DEV_DS1 : ClearBit(ITP3_DS1_A);
    |
    DEV_DS2 : ClearBit(ITP3_DS2_A);
    |
    DEV_DS3 : ClearBit(ITP3_DS3_A);
    |
    DEV_DS4 : ClearBit(ITP3_DS4_A);
    |
  endcase;

end DEV_NR_ClearBit;




procedure DEV_NR_SetBit;
begin

  case  DEV_NR of
    DEV_DS0 : SetBit(ITP3_DS0_A);
    |
    DEV_DS1 : SetBit(ITP3_DS1_A);
    |
    DEV_DS2 : SetBit(ITP3_DS2_A);
    |
    DEV_DS3 : SetBit(ITP3_DS3_A);
    |
    DEV_DS4 : SetBit(ITP3_DS4_A);
    |
  endcase;

end DEV_NR_SetBit;







// Byte senden

procedure ITP3_sende_Halbbyte(SB : Byte);
var
  b1 : Byte;
begin

  // D0 setzen
  b1:=SB and %00000001;
  if b1=0 then
    ClearBit(ITP3_D0_A);
  else
    SetBit(ITP3_D0_A);
  endif;

  // D1 setzen
  b1:=SB and %00000010;
  if b1=0 then
    ClearBit(ITP3_D1_A);
  else
    SetBit(ITP3_D1_A);
  endif;

  // D2 setzen
  b1:=SB and %00000100;
  if b1=0 then
    ClearBit(ITP3_D2_A);
  else
    SetBit(ITP3_D2_A);
  endif;

  // D3 setzen
  b1:=SB and %00001000;
  if b1=0 then
    ClearBit(ITP3_D3_A);
  else
    SetBit(ITP3_D3_A);
  endif;

  // jetzt wird dem Client mitgeteilt, das Daten fuer ihn anliegen
  DEV_NR_ClearBit;

  // warten solange der Client die Daten uebernimmt
  while BitHigh(ITP3_DR_E) do
  endwhile;

  // Client hat die Daten uebernommen,
  // die DS-Leitung wird wieder frei gegeben
  DEV_NR_SetBit;

  // warten solange, bis der Client die DR-Leitung
  // wieder frei gibt
  while BitLow(ITP3_DR_E) do
  endwhile;

end ITP3_sende_Halbbyte;




procedure ITP3_sende_Byte(SB : Byte);
var
  b1 : Byte;
begin

  // alle Datenleitungen auf Ausgang schalten
  SetBit(ITP3_D0_D);
  SetBit(ITP3_D1_D);
  SetBit(ITP3_D2_D);
  SetBit(ITP3_D3_D);

  // Steuerleitungen setzen
  DEV_NR_SetBit;    // DSX auf 1

  ClearBit(ITP3_DR_D);  // DR auf Eingang

  // senden des Low-Halbbyte
  b1:=SB;
  b1:=b1 and %00001111;
  ITP3_sende_Halbbyte(b1);

  // senden des High-Halbbyte
  b1:=SB;
  SHR(b1);
  SHR(b1);
  SHR(b1);
  SHR(b1);
  ITP3_sende_Halbbyte(b1);

  // alle Datenleitungen auf Eingang schalten
  ClearBit(ITP3_D0_D);
  ClearBit(ITP3_D1_D);
  ClearBit(ITP3_D2_D);
  ClearBit(ITP3_D3_D);

end ITP3_sende_Byte;







// Test-Byte senden

function ITP3_sende_Test_Halbbyte(SB : Byte) : Boolean;
var
  b1 : Byte;
  Wait_counter : Word;
  Result_Byte : Boolean;
begin

  // D0 setzen
  b1:=SB and %00000001;
  if b1=0 then
    ClearBit(ITP3_D0_A);
  else
    SetBit(ITP3_D0_A);
  endif;

  // D1 setzen
  b1:=SB and %00000010;
  if b1=0 then
    ClearBit(ITP3_D1_A);
  else
    SetBit(ITP3_D1_A);
  endif;

  // D2 setzen
  b1:=SB and %00000100;
  if b1=0 then
    ClearBit(ITP3_D2_A);
  else
    SetBit(ITP3_D2_A);
  endif;

  // D3 setzen
  b1:=SB and %00001000;
  if b1=0 then
    ClearBit(ITP3_D3_A);
  else
    SetBit(ITP3_D3_A);
  endif;

  // jetzt wird dem Client mitgeteilt, das Daten fuer ihn anliegen
  DEV_NR_ClearBit;

  // warten solange der Client die Daten uebernimmt
  Wait_counter:=0;
  Result_Byte:=true;
  while Result_Byte do

    if BitLow(ITP3_DR_E) then
      Result_Byte:=false;
    endif;

    if Wait_counter>60000 then
      Result_Byte:=false;
    endif;

    Inc(Wait_counter);

  endwhile;



  // hat der Client reagiert, dann ist
  // ter test erfolgreich
  if BitLow(ITP3_DR_E) then


    // die DS-Leitung wird wieder frei gegeben
    DEV_NR_SetBit;


    Result_Byte:=true;

    // Client hat die Daten uebernommen,

    // warten solange, bis der Client die DR-Leitung
    // wieder frei gibt
    while BitLow(ITP3_DR_E) do
    endwhile;

  else

    // die DS-Leitung wird wieder frei gegeben
    DEV_NR_SetBit;

    Result_Byte:=false;

  endif;


  Result:=Result_Byte;

end ITP3_sende_Test_Halbbyte;




function ITP3_sende_Test_Byte(SB : Byte) : Boolean;
var
  b1 : Byte;
  Result_Byte : Boolean;
begin

  // alle Datenleitungen auf Ausgang schalten
  SetBit(ITP3_D0_D);
  SetBit(ITP3_D1_D);
  SetBit(ITP3_D2_D);
  SetBit(ITP3_D3_D);

  // Steuerleitungen setzen
  DEV_NR_SetBit;    // DSX auf 1

  ClearBit(ITP3_DR_D);  // DR auf Eingang

  // senden des Low-Halbbyte
  b1:=SB;
  b1:=b1 and %00001111;
  Result_Byte:=ITP3_sende_Test_Halbbyte(b1);

  if Result_Byte then

    // senden des High-Halbbyte
    b1:=SB;
    SHR(b1);
    SHR(b1);
    SHR(b1);
    SHR(b1);
    ITP3_sende_Halbbyte(b1);

  endif;

  // alle Datenleitungen auf Eingang schalten
  ClearBit(ITP3_D0_D);
  ClearBit(ITP3_D1_D);
  ClearBit(ITP3_D2_D);
  ClearBit(ITP3_D3_D);

  Result:=Result_Byte;

end ITP3_sende_Test_Byte;







// Byte empfangen

function ITP3_empfange_Halbbyte : Byte;
var
  Result_Byte : Byte;
begin

  // SA

  // nun wird dem Client durch Aktivierung
  // der DSX-Leitung mitgeteilt,
  // dass der Server das naechste Halbbyte
  // empfangen kann
  DEV_NR_ClearBit;

  // SB

  // warten, solange bis der Client das
  // Halbbyte bereit stellt
  while BitHigh(ITP3_DR_E) do
  endwhile;

  // SC

  // nun liegt das Halbbyte an

  Result_Byte:=%00000000;

  // D0 einlesen
  if BitHigh(ITP3_D0_E) then
    Result_Byte:=Result_Byte or %00000001;
  endif;

  // D1 einlesen
  if BitHigh(ITP3_D1_E) then
    Result_Byte:=Result_Byte or %00000010;
  endif;

  // D2 einlesen
  if BitHigh(ITP3_D2_E) then
    Result_Byte:=Result_Byte or %00000100;
  endif;

  // D3 einlesen
  if BitHigh(ITP3_D3_E) then
    Result_Byte:=Result_Byte or %00001000;
  endif;

  // SD

  // jetzt wird dem Client mitgeteilt,
  // das der Server das Halbbyte
  // uebernommen hat
  DEV_NR_SetBit;

  // SE

  // warten solange bis der Client die
  // Bestaetigung angenommen hat
  while BitLow(ITP3_DR_E) do
  endwhile;

  // SF

  Result:=Result_Byte;

end ITP3_empfange_Halbbyte;






function ITP3_empfange_Byte : Byte;
var
  Result_Byte_01 : Byte;
  Result_Byte_02 : Byte;
begin

  // alle Datenleitungen auf Eingang schalten
  ClearBit(ITP3_D0_D);
  ClearBit(ITP3_D1_D);
  ClearBit(ITP3_D2_D);
  ClearBit(ITP3_D3_D);

  DEV_NR_SetBit;

  // unteres Halbbyte
  Result_Byte_01:=ITP3_empfange_Halbbyte;

  // oberes Halbbyte
  Result_Byte_02:=ITP3_empfange_Halbbyte;

  SHL(Result_Byte_02);
  SHL(Result_Byte_02);
  SHL(Result_Byte_02);
  SHL(Result_Byte_02);

  Result_Byte_01:=Result_Byte_01+Result_Byte_02;

  Result:=Result_Byte_01;

end ITP3_empfange_Byte;





// ****************************
// *** ITP3-Server-Routinen ***
// *** Softwareteil - 2 -   ***
// ****************************






procedure ITP3_sende_CONOUT(CO_Byte : Byte);
begin

  ITP3_sende_Byte(ITP3_CONOUT);
  ITP3_sende_Byte(CO_Byte);

end ITP3_sende_CONOUT;







procedure ITP3_sende_SOUND(SND_Byte : Byte);
begin

  ITP3_sende_Byte(ITP3_SOUND);
  ITP3_sende_Byte(SND_Byte);

end ITP3_sende_SOUND;





function ITP3_empfange_CONST : Byte;
var
  RESULT_Byte : Byte;
begin

  ITP3_sende_Byte(ITP3_CONST);
  RESULT_Byte:=ITP3_empfange_Byte;

  Result:=RESULT_Byte;

end ITP3_empfange_CONST;






function ITP3_empfange_CONIN : Byte;
var
  RESULT_Byte : Byte;
begin

  ITP3_sende_Byte(ITP3_CONIN);
  RESULT_Byte:=ITP3_empfange_Byte;

  Result:=RESULT_Byte;

end ITP3_empfange_CONIN;







procedure ITP3_CONIN_Schleife;
begin

  ConsoleIn:=0;

  while ConsoleIn=0 do
    ConsoleIn:=ITP3_empfange_CONST;
  endwhile;

  ConsoleIn:=ITP3_empfange_CONIN;

end ITP3_CONIN_Schleife;





// ***********************
// ITP3 - Laufwerk
// ***********************



procedure ITP3_sende_STD;
begin

  ITP3_sende_Byte(ITP3_STD);
  ITP3_sende_Byte(SECTOR);
  ITP3_sende_Byte(TRACK_L);
  ITP3_sende_Byte(TRACK_H);
  ITP3_sende_Byte(DISKNO);


end ITP3_sende_STD;





procedure ITP3_Sektor_lesen;
var
  b1 : Byte;
begin

  ITP3_sende_Byte(ITP3_RD_SEC);

  for Sektor_Puffer_Zeiger:=0 to 127 do
    b1:=ITP3_empfange_Byte;
    Sektor_Puffer[Sektor_Puffer_Zeiger]:=b1;
  endfor;

end ITP3_Sektor_lesen;







procedure ITP3_Sektor_schreiben;
var
  b1 : Byte;
begin

  ITP3_sende_Byte(ITP3_WR_SEC);

  for Sektor_Puffer_Zeiger:=0 to 127 do

    b1:=Sektor_Puffer[Sektor_Puffer_Zeiger];
    ITP3_sende_Byte(b1);

  endfor;

end ITP3_Sektor_schreiben;









// ***********************
// ITP3 - Anschlussabfrage
// ***********************



function ITP3_DEV_zu_Device : Byte;
var
  CON_Device : Byte;
begin

  case DEV_NR of

    DEV_DS0 : CON_Device:=Device_ITP3_DS0;
    |

    DEV_DS1 : CON_Device:=Device_ITP3_DS1;
    |

    DEV_DS2 : CON_Device:=Device_ITP3_DS2;
    |

    DEV_DS3 : CON_Device:=Device_ITP3_DS3;
    |

    DEV_DS4 : CON_Device:=Device_ITP3_DS4;
    |

  endcase;

  Result:=CON_Device;

end ITP3_DEV_zu_Device;




procedure ITP3_pruefe_einen_Anschluss;
var
  ok_Byte : Boolean;
  WHO_ARE_YOU_Byte : Byte;
  b1 : Byte;
  CO_DEV : Byte;
begin

  ok_Byte:=ITP3_sende_Test_Byte(ITP3_WHO_ARE_YOU);

  if ok_Byte then

    WHO_ARE_YOU_Byte:=ITP3_empfange_Byte;


    if WHO_ARE_YOU_Byte>0 then
      if DEV_NR=DEV_DS3 then
        ITP3_DS34_nicht_genutzt:=false;
      endif;
      if DEV_NR=DEV_DS4 then
        ITP3_DS34_nicht_genutzt:=false;
      endif;
    endif;


    // CONOUT
    b1:=WHO_ARE_YOU_Byte and %10000000;

    if b1>0 then
      CO_DEV:=ITP3_DEV_zu_Device;

      if CONOUT_Device_NR1=no_Device then
        CONOUT_Device_NR1:=CO_DEV;
      else
        // falls das gleiche Device zum zweiten
        // mal erkannt wurde
        if CO_DEV<>CONOUT_Device_NR1 then
          CONOUT_Device_NR2:=CO_DEV;
        endif;
      endif;

    endif;

    // CONIN
    b1:=WHO_ARE_YOU_Byte and %01000000;

    if b1>0 then
      CONIN_Device:=ITP3_DEV_zu_Device;
    endif;

    // LIST
    b1:=WHO_ARE_YOU_Byte and %00100000;

    if b1>0 then
      LIST_Device:=DEV_NR;
    endif;


    // SOUND
    b1:=WHO_ARE_YOU_Byte and %00010000;

    if b1>0 then
      SOUND_Device:=ITP3_DEV_zu_Device;
    endif;


    // DRIVE
    b1:=WHO_ARE_YOU_Byte and %00001000;

    if b1>0 then

      case DEV_NR of

        DEV_DS0 : Laufwerke_Verteiler[0]:=Device_ITP3_DS0;
        |

        DEV_DS1 : Laufwerke_Verteiler[1]:=Device_ITP3_DS1;
        |

        DEV_DS2 : Laufwerke_Verteiler[2]:=Device_ITP3_DS2;
        |

        DEV_DS3 : Laufwerke_Verteiler[3]:=Device_ITP3_DS3;
        |

        DEV_DS4 : Laufwerke_Verteiler[4]:=Device_ITP3_DS4;
        |

      endcase;

    endif;


    // READER
    b1:=WHO_ARE_YOU_Byte and %00000100;

    if b1>0 then
      READER_Device:=DEV_NR;
    endif;


  endif;

end ITP3_pruefe_einen_Anschluss;







procedure ITP3_pruefe_Anschluesse;
begin


  DEV_NR:=DEV_DS0;
  ITP3_pruefe_einen_Anschluss;

  DEV_NR:=DEV_DS1;
  ITP3_pruefe_einen_Anschluss;

  DEV_NR:=DEV_DS2;
  ITP3_pruefe_einen_Anschluss;

  DEV_NR:=DEV_DS3;
  ITP3_pruefe_einen_Anschluss;

  DEV_NR:=DEV_DS4;
  ITP3_pruefe_einen_Anschluss;



  DEV_NR:=DEV_DS0;
  ITP3_pruefe_einen_Anschluss;

  DEV_NR:=DEV_DS1;
  ITP3_pruefe_einen_Anschluss;

  DEV_NR:=DEV_DS2;
  ITP3_pruefe_einen_Anschluss;

  DEV_NR:=DEV_DS3;
  ITP3_pruefe_einen_Anschluss;

  DEV_NR:=DEV_DS4;
  ITP3_pruefe_einen_Anschluss;



  DEV_NR:=DEV_DS0;
  ITP3_pruefe_einen_Anschluss;

  DEV_NR:=DEV_DS1;
  ITP3_pruefe_einen_Anschluss;

  DEV_NR:=DEV_DS2;
  ITP3_pruefe_einen_Anschluss;

  DEV_NR:=DEV_DS3;
  ITP3_pruefe_einen_Anschluss;

  DEV_NR:=DEV_DS4;
  ITP3_pruefe_einen_Anschluss;



end ITP3_pruefe_Anschluesse;










