


// *** Z80 Hardware-Steuerprogramme ***



procedure sende_50_Takte;
var
  Zaehler : Byte;
begin

  for Zaehler:=1 to 100 do
    SetBit(CLK_Z80);
    NOP;
    NOP;
    ClearBit(CLK_Z80);
  endfor;

end sende_50_Takte;






// laedt das Z80-BIOS in den RAM
// und startet es durch RESET
procedure Z80_RESET_und_URLOAD;
begin


  // 0. /RESET auf High setzen
  SetBit(RESET_Z80);

  sende_50_Takte;


  // 1. /RESET auf LOW setzen
  ClearBit(RESET_Z80);


  // 2a. Senden von min. 3 Takten (10 Takte)
  sende_50_Takte;

  // 2b. /RESET auf High setzen
  SetBit(RESET_Z80);


  lade_meic_Array_in_RAM;


  // 9. /RESET auf LOW setzen
  ClearBit(RESET_Z80);

  // 10a. Senden von min. 3 Takten (10 Takte)
  sende_50_Takte;


  // 10b. /RESET auf High setzen
  SetBit(RESET_Z80);

end Z80_RESET_und_URLOAD;








procedure IORQ_Ende;
begin

  // warten bis /IORQ inaktiv wird (High)
  warte_solange_IORQ_Low;

  DDRC:=%00000000;

end IORQ_Ende;









procedure Z80_CONOUT;
begin

  // warten bis /IORQ inaktiv wird (High)
  warte_solange_IORQ_Low;

  // Das naechste Byte ist das auszugebende Zeichen
  warte_solange_IORQ_High;

  ConsoleOut := PinC;

  IORQ_Ende;

end Z80_CONOUT;








procedure Z80_LIST;
var
  IO_Wert : Byte;
begin

  // warten bis /IORQ inaktiv wird (High)
  warte_solange_IORQ_Low;

  // Das naechste Byte ist das auszugebende Zeichen
  warte_solange_IORQ_High;

  IO_Wert := PinC;

//  ByteToHexString(IO_Wert);
 // SER0_String:='l'+Byte_String;
//  WriteLn_SER0;

  IORQ_Ende;

end Z80_LIST;







procedure Z80_SOUND;
begin

  // warten bis /IORQ inaktiv wird (High)
  warte_solange_IORQ_Low;

  // Das naechste Byte ist das auszugebende Zeichen
  warte_solange_IORQ_High;

  SoundOut := PinC;


  IORQ_Ende;

end Z80_SOUND;








procedure Z80_CONIN;
begin

  // warten bis /IORQ inaktiv wird (High)
  warte_solange_IORQ_Low;

  // Das naechste Byte ist das einzulesende Zeichen
  warte_solange_IORQ_High;

  DDRC:=%11111111;
  PortC:=ConsoleIn;

  IORQ_Ende;

end Z80_CONIN;










procedure STD_an_uC;
begin

  // warten bis /IORQ inaktiv wird (High)
  warte_solange_IORQ_Low;

  // Das naechste Byte ist der SECTOR
  warte_solange_IORQ_High;

  SECTOR := PinC;


  // warten bis /IORQ inaktiv wird (High)
  warte_solange_IORQ_Low;

  // Das naechste Byte ist der TRACK_L
  warte_solange_IORQ_High;

  TRACK_L := PinC;


  // warten bis /IORQ inaktiv wird (High)
  warte_solange_IORQ_Low;

  // Das naechste Byte ist der TRACK_H
  warte_solange_IORQ_High;

  TRACK_H := PinC;


  // warten bis /IORQ inaktiv wird (High)
  warte_solange_IORQ_Low;

  // Das naechste Byte ist der DISKNO
  warte_solange_IORQ_High;

  DISKNO := PinC;


  IORQ_Ende;


end STD_an_uC;















