PROGRAM zmeic;

DEVICE = MEGA32;

{$I mega32_Register.INC}

CONST

 // TaktFrequenz in KHz
  TaktFrequenz : Word = 14746;
  UBRR_VAL : Byte = 15;  // 57600 Baud
//  UBRR_VAL : Byte = 7;  // 115200 Baud
//  UBRR_VAL : Byte = 3;  // 230400 Baud
//  UBRR_VAL : Byte = 95;  // 9600 Baud


 // TaktFrequenz in KHz
//  TaktFrequenz : Word = 16000;
//  UBRR_VAL : Byte = 7;  // 125000 Baud
//  UBRR_VAL : Byte = 9;  // 100000 Baud
//  UBRR_VAL : Byte = 15;  // 62500 Baud
//  UBRR_VAL : Byte = 4;  // 200000 Baud
//  UBRR_VAL : Byte = 1;  // 500000 Baud

 // TaktFrequenz in KHz
//  TaktFrequenz : Word = 18432;
//  UBRR_VAL : Byte = 19;  // 57600 Baud
//  UBRR_VAL : Byte = 9;  // 115200 Baud
//  UBRR_VAL : Byte = 8;  // 128000 Baud
//  UBRR_VAL : Byte = 4;  // 230400 Baud


  // Befehlscode fuer IORQ
  IORQ_CONOUT      : Byte = 01;
  IORQ_CONIN       : Byte = 02;
  IORQ_CONST       : Byte = 03;
  IORQ_START_PROG  : Byte = 04;
  IORQ_RAM2ARR     : Byte = 05;
  IORQ_ARR2RAM     : Byte = 06;
  IORQ_STD2UC      : Byte = 07;
  IORQ_BDOS2RAM    : Byte = 08;
  IORQ_CCP2RAM     : Byte = 09;
  IORQ_LIST 	   : Byte = 10;
  IORQ_SOUND       : Byte = 11;
  IORQ_RD_DISK2ARR : Byte = 12;
  IORQ_WR_ARR2DISK : Byte = 14;
  IORQ_LW_ok       : Byte = 15;
  IORQ_LW_CONOUT   : Byte = 16;



  no_Device          : Byte = 00;
  Device_Serial      : Byte = 01;
  Device_ITP3_DS0    : Byte = 02;
  Device_ITP3_DS1    : Byte = 03;
  Device_ITP3_DS2    : Byte = 04;
  Device_ITP3_DS3    : Byte = 05;
  Device_ITP3_DS4    : Byte = 06;
  Device_lokal_Flash : Byte = 07;


CONST
  nul  : Byte = $00;
  xon  : Byte = $11;
  xoff : Byte = $13;
  CR   : Byte = $0D;
  LF   : Byte = $0A;


  // Befehlscode fuer UART
  UART_WHO_AM_I   : Byte = 01;
  UART_ERROR_CODE : Byte = 02;

  UART_CONOUT : Byte = 03;
  UART_CONST  : Byte = 04;
  UART_CONIN  : Byte = 05;
  UART_READ   : Byte = 06;
  UART_WRITE  : Byte = 07;
  UART_STD    : Byte = 08;



VAR

  // Globale Variablen

{ Port A ist fuer ITP3 und
  wird in ITP3_SRV_PORT.INC verwaltet
}

{
B0 - siehe ITP3_SRV_PORT.INC
B1 - Z80_IRRQ = E
B2 - RAM_OE   = E
B3 - RAM_WE   = E
B4 - G_RAM_SW = A / H
B5 - MOSI = A / L
B6 - MISO = E / L
B7 - SCK  = A / L
}
  IORQ_Z80_E[PINB,1] : bit; // E

  OE_RAM_A[PortB,2]  : bit; // A
  OE_RAM_D[DDRB,2]   : bit; // D

  WE_RAM_A[PortB,3]  : bit; // E
  WE_RAM_D[DDRB,3]   : bit; // E

  G_RAMSW[PortA,7]  : bit; // A / H



// nur die LEDs !!!
  LED_GE1_D[DDRD,3]  : bit; // A / LED
  LED_GE2_D[DDRB,4]  : bit; // A / LED

  LED_GE1_A[PortD,3]  : bit; // A / LED
  LED_GE2_A[PortB,4]  : bit; // A / LED

  LED_DS0_D[DDRA,4]  : bit; // A / LED
  LED_DS1_D[DDRA,5]  : bit; // A / LED
  LED_DS2_D[DDRA,6]  : bit; // A / LED

  LED_DS0_A[PortA,4]  : bit; // A / LED
  LED_DS1_A[PortA,5]  : bit; // A / LED
  LED_DS2_A[PortA,6]  : bit; // A / LED



{
C0..C7 - D0_Z80..D7_Z80
}


{
D0 - RXD0      = E
D1 - TXD0      = A / L
D2 - SCL - I2C = E
D3 - SDA - I2C = E
D4 - RD_Z80    = E
D5 - WR_Z80    = E
D6 - RESET_Z80 = A / H
D7 - CLK_Z80   = A / L
}

  RD_Z80_E[PIND,4]   : bit; // E
  WR_Z80_E[PIND,5]   : bit; // E
  RESET_Z80[PortD,6] : bit; // A
  CLK_Z80[PortD,7]   : bit; // A

  SERIAL_RXD_D[DDRD,0]  : bit; // E RXD
  SERIAL_TXD_D[DDRD,1]  : bit; // E TXD


  Array_Pos : Word;

  ConsoleIn, ConsoleOut, SoundOut : Byte;
  ConsoleIn_gelesen,
  DEVICE_VECTOR_gelesen : Boolean;


  Steuer_String : String[50];
  Anzeige_String : String[80];

  // Sektor-Puffer
  Sektor_Puffer : Array [0..127] of Byte;
  Sektor_Puffer_Zeiger : Word;
  Sektor_Puffer_geaendert : Boolean;



  // STD
  SECTOR, TRACK_L, TRACK_H, DISKNO : Byte;


  Laufwerke_Verteiler : Array [0..15] of Byte;

  Serial_Device_connected,
  ITP3_DS34_nicht_genutzt,
  I2C_vorhanden : Boolean;

  // STD
  STD_Sektor_Nr : Word;
  STD_Spur_Nr : Word;

  DEVICE_VECTOR_Byte : Byte;

  Laufwerke_Verteiler_Byte : Byte;

CONST


// eingebundenen CONST DISK-Arrays
// -------------------------------

// BIOS - Z80-Code
{$I MEIC_TXT.INC}

// BDOS - Z80-Code
{$I BDOS_TXT.INC}

// CCP - Z80-Code
{$I CCP_TXT.INC}


// eingebundene Programmmodule
// ---------------------------
// einige elementare Routinen wie "wait_ms"
{$I SYSTEM.INC}

// hardwarenahe Routinen fuer die serielle Schnittstelle
{$I UART_oI.INC}

// globale Routinen fuer die serielle Schnittstelle (zu UART_oI.INC)
{$I UART_PRG.INC}

// hardwarenahe Routinen fuer die SPI-Schnittstelle und den FLASH-IC W25Q64
{$I SPI_W25Q64.INC}

// hardwarenahe Routinen fuer die I2C-Schnittstelle und den FLASH-IC AT24C512
{$I I2C_AT24C512.INC}

// Routinen fuer den lokalen Flash-Manager
// (globale Routinen zu SPI_W25Q64.INC und lokaler_FLASH_Manager.INC
{$I lokaler_FLASH_Manager.INC}

// alle Routinen zu den ITP3-Schnittstellen
{$I ITP3_SRV.INC}

{$I SRAM.INC}

// globale Routinen zum managen der Geräte
// (lokalen Flash-Manager, serielle Schnittstelle, ITP3-Schnittstellen)
{$I Geraete_Manager.INC}

{$I Z80.INC}

{$I CPM_IO.INC}




// *** INITIALISIERUNG ***


procedure InitPorts;
begin

{
A0 - DB0_ITP3 = E
A1 - DB1_ITP3 = E
A2 - DB2_ITP3 = E
A3 - DB3_ITP3 = E
A4 - DS0_ITP3 = A / H
A5 - DS1_ITP3 = A / H
A6 - DS2_ITP3 = A / H
A7 - G_RAM_SW = A / H
}

  DDRA  :=  %11110000;
  PortA :=  %11110000;


{
B0 - siehe ITP3_SRV_PORT.INC
B1 - Z80_IORQ = E
B2 - RAM_OE   = E
B3 - RAM_WE   = E
B4 - SPI_SS = A / H
B5 - MOSI = A / L
B6 - MISO = E / L
B7 - SCK  = A / L
}

  DDRB  :=  %10110000;
  PortB :=  %10010000;

{
C0..C7 - D0_Z80..D7_Z80
}
  DDRC  :=  %00000000;
  PortC :=  %00000000;

{
D0 - RXD0      = E
D1 - TXD0      = A / L
D2 - SCL - I2C = E
D3 - SDA - I2C = E
D4 - RD_Z80    = E
D5 - WR_Z80    = E
D6 - RESET_Z80 = A / H
D7 - CLK_Z80   = A / L
}

  DDRD  :=  %11000011;
  PortD :=  %01000011;


end InitPorts;




procedure LED_blinken;
begin

//  SetBit(LED_GN_D);
  SetBit(LED_GE1_D);
  SetBit(LED_GE2_D);

  SetBit(LED_DS0_D);
  SetBit(LED_DS1_D);
  SetBit(LED_DS2_D);
//    SetBit(LED_DS3_D);

  loop

//    SetBit(LED_GN_A);
    SetBit(LED_GE1_A);
    SetBit(LED_GE2_A);

    SetBit(LED_DS0_A);
    SetBit(LED_DS1_A);
    SetBit(LED_DS2_A);
//      SetBit(LED_DS3_A);

    wait_ms(300);

//    ClearBit(LED_GN_A);
    ClearBit(LED_GE1_A);
    ClearBit(LED_GE2_A);

    ClearBit(LED_DS0_A);
    ClearBit(LED_DS1_A);
    ClearBit(LED_DS2_A);
//      ClearBit(LED_DS3_A);

    wait_ms(300);

   endloop;

end LED_blinken;






procedure Serial_DEVICE_VECTOR_auswerten;
var
  b1 : Byte;
begin

//  DEVICE_VECTOR_Byte:=%11111000;


  // CONOUT
  b1:=DEVICE_VECTOR_Byte and %10000000;

  if b1>0 then

    if CONOUT_Device_NR1=no_Device then
      CONOUT_Device_NR1:=Device_Serial;
    else
      CONOUT_Device_NR2:=Device_Serial;
    endif;

  endif; // if b1>0 then



  // CONIN
  b1:=DEVICE_VECTOR_Byte and %01000000;

  if b1>0 then
    CONIN_Device:=Device_Serial;
  endif;



  // LIST
  b1:=DEVICE_VECTOR_Byte and %00100000;

  if b1>0 then
    LIST_Device:=Device_Serial;
  endif;


  // SOUND
  b1:=DEVICE_VECTOR_Byte and %00010000;

  if b1>0 then
    SOUND_Device:=Device_Serial;
  endif;



  // DRIVE
  b1:=DEVICE_VECTOR_Byte and %00001000;

  if b1>0 then

    Laufwerke_Verteiler_nach_oben_kopieren;
    Laufwerke_Verteiler[0]:=Device_Serial;
    Laufwerke_Verteiler_nach_unten_kopieren;

  endif;


  // READER
  b1:=DEVICE_VECTOR_Byte and %00000100;

  if b1>0 then
    READER_Device:=Device_Serial;
  endif;



end Serial_DEVICE_VECTOR_auswerten;






BEGIN


  InitPorts;


  Init_I2C;
  Init_SPI;

  if Test_I2C_vorhanden then

    INIT_FLASH_Manager;
    I2C_vorhanden:=true;

  else

    I2C_vorhanden:=false;

  endif;



  Init_ITP3;

  INIT_Laufwerke_Verteiler;


  ConsoleIn:=0;
  ConsoleOut:=0;
  SoundOut:=0;
  Steuer_String:='';
  ConsoleIn_gelesen:=false;

  DISKNO:=0;

  // Laden des Z80-Bios
  Z80_RESET_und_URLOAD;


  // einlesen der ITP3-Geraete und ihrer Konfiguraation
  ITP3_DS34_nicht_genutzt:=true;
  ITP3_pruefe_Anschluesse;


  if ITP3_DS34_nicht_genutzt then

    ClearBit(SERIAL_RXD_D);
    SetBit(SERIAL_TXD_D);

    INIT_SER0_PORT;
    Abfrage_Serial_Device_connected;
  else
    Serial_Device_connected:=false;
  endif;


  if Serial_Device_connected then


    // WHO_ARE_YOU Abfrage ueber DEVICE_VECTOR
    DEVICE_VECTOR_von_UART_lesen;

    Serial_DEVICE_VECTOR_auswerten;


               {
    ByteToHexString(DEVICE_VECTOR_Byte);
    SER0_String:='yDEVICE_VECTOR='+Byte_Hex_String;
    SER0_String:=SER0_String+'H';
    WriteLn_SER0;
              }


  endif; // if Serial_Device_connected then




  if I2C_vorhanden then

    // Device_lokal_Flash
    Laufwerke_Verteiler_nach_oben_kopieren;
    Laufwerke_Verteiler[0]:=Device_lokal_Flash;
    Laufwerke_Verteiler_nach_unten_kopieren;

  endif;




  // Fehlermeldungen bei fehlenden Geraeten/Devices

  if CONOUT_Device_NR1=no_Device then

    LED_blinken;

  endif; // if CONOUT_Device=no_Device then



  if CONIN_Device=no_Device then

    Anzeige_String:=' ';
    Anzeige_String_an_CONOUT;
    Anzeige_String_an_CONOUT;
    Anzeige_String:='*** Fehler: keine Tastatur angeschlossen!!! ***';
    Anzeige_String_an_CONOUT;

    LED_blinken;

  endif; //


  Laufwerke_Verteiler_Byte:=Laufwerke_Verteiler[0];
  if Laufwerke_Verteiler_Byte=no_Device then

    Anzeige_String:=' ';
    Anzeige_String_an_CONOUT;
    Anzeige_String_an_CONOUT;
    Anzeige_String:='*** Fehler: kein Laufwerk angeschlossen!!! ***';
    Anzeige_String_an_CONOUT;

    LED_blinken;

  endif; //


  // Endlosschleife fuer Takterzeugung
  // Taktfrequenz etwa 3 MHz
  LOOP

    ClearBit(CLK_Z80);    // 2 Takte

ASM;
    SBIS     PinB, 1
    CALL     AUSWERTEN_IORQ
ENDASM;

    SetBit(CLK_Z80);      // 2 Takte

  ENDLOOP;





END zmeic.
