; Assemblerquelltext des RONPAS-Compilers (c) by Ronald Daleske
; PROGRAM-NAME: ZMEIC.PAS
 
.nolist
.INCLUDE "m32def.inc"
.list
 
; *** Konstantentabelle ***
 
.equ        TAKTFREQUENZ  =  0x399A ; WORD
.equ        UBRR_VAL  =  0x0F ; BYTE
.equ        IORQ_CONOUT  =  0x01 ; BYTE
.equ        IORQ_CONIN  =  0x02 ; BYTE
.equ        IORQ_CONST  =  0x03 ; BYTE
.equ        IORQ_START_PROG  =  0x04 ; BYTE
.equ        IORQ_RAM2ARR  =  0x05 ; BYTE
.equ        IORQ_ARR2RAM  =  0x06 ; BYTE
.equ        IORQ_STD2UC  =  0x07 ; BYTE
.equ        IORQ_BDOS2RAM  =  0x08 ; BYTE
.equ        IORQ_CCP2RAM  =  0x09 ; BYTE
.equ        IORQ_LIST  =  0x0A ; BYTE
.equ        IORQ_SOUND  =  0x0B ; BYTE
.equ        IORQ_RD_DISK2ARR  =  0x0C ; BYTE
.equ        IORQ_WR_ARR2DISK  =  0x0E ; BYTE
.equ        IORQ_LW_OK  =  0x0F ; BYTE
.equ        IORQ_LW_CONOUT  =  0x10 ; BYTE
.equ        NO_DEVICE  =  0x00 ; BYTE
.equ        DEVICE_SERIAL  =  0x01 ; BYTE
.equ        DEVICE_ITP3_DS0  =  0x02 ; BYTE
.equ        DEVICE_ITP3_DS1  =  0x03 ; BYTE
.equ        DEVICE_ITP3_DS2  =  0x04 ; BYTE
.equ        DEVICE_ITP3_DS3  =  0x05 ; BYTE
.equ        DEVICE_ITP3_DS4  =  0x06 ; BYTE
.equ        DEVICE_LOKAL_FLASH  =  0x07 ; BYTE
.equ        NUL  =  0x00 ; BYTE
.equ        XON  =  0x11 ; BYTE
.equ        XOFF  =  0x13 ; BYTE
.equ        CR  =  0x0D ; BYTE
.equ        LF  =  0x0A ; BYTE
.equ        UART_WHO_AM_I  =  0x01 ; BYTE
.equ        UART_ERROR_CODE  =  0x02 ; BYTE
.equ        UART_CONOUT  =  0x03 ; BYTE
.equ        UART_CONST  =  0x04 ; BYTE
.equ        UART_CONIN  =  0x05 ; BYTE
.equ        UART_READ  =  0x06 ; BYTE
.equ        UART_WRITE  =  0x07 ; BYTE
.equ        UART_STD  =  0x08 ; BYTE
.equ        LAENGE_MEIC_ARRAY  =  0x0328 ; WORD
.equ        LAENGE_BDOS_ARRAY  =  0x0DFF ; WORD
.equ        LAENGE_CCP_ARRAY  =  0x07FF ; WORD
.equ        WAITKON  =  0x000E ; WORD
.equ        WAITKON2  =  0x0276 ; WORD
.equ        ADR_AT24C512  =  0x50 ; BYTE
.equ        CODE_01  =  0x08 ; BYTE
.equ        CODE_02  =  0x12 ; BYTE
.equ        CODE_03  =  0xAA ; BYTE
.equ        CODE_04  =  0x55 ; BYTE
.equ        ADR_TBL1_TYP_ZIEL_ZEIGER  =  0xE000 ; WORD
.equ        ADR_TBL2_ZEIGER_4K_SPUR_NR  =  0xE800 ; WORD
.equ        ADR_TBL3_4K_SPI_TMP_SPUR_NR  =  0xF800 ; WORD
.equ        ADR_AELTESTER_4K_SPEICHER_IM_I2C  =  0xFFFD ; WORD
.equ        ADR_TEST_BYTE  =  0xFFFD ; WORD
.equ        ADR_INIT_KENNUNG_01  =  0xFFFE ; WORD
.equ        ADR_INIT_KENNUNG_02  =  0xFFFF ; WORD
.equ        TZZ_AT24C512_DIR  =  0x01 ; BYTE
.equ        TZZ_AT24C512_READ_WRITE  =  0x02 ; BYTE
.equ        TZZ_W25Q64_READ  =  0x03 ; BYTE
.equ        ITP3_WHO_ARE_YOU  =  0x01 ; BYTE
.equ        ITP3_ERROR_CODE  =  0x02 ; BYTE
.equ        ITP3_CONOUT  =  0x03 ; BYTE
.equ        ITP3_CONST  =  0x04 ; BYTE
.equ        ITP3_CONIN  =  0x05 ; BYTE
.equ        ITP3_STD  =  0x06 ; BYTE
.equ        ITP3_RD_SEC  =  0x07 ; BYTE
.equ        ITP3_WR_SEC  =  0x08 ; BYTE
.equ        ITP3_SOUND  =  0x09 ; BYTE
.equ        ITP3_READER  =  0x0A ; BYTE
.equ        DEV_DS0  =  0x00 ; BYTE
.equ        DEV_DS1  =  0x01 ; BYTE
.equ        DEV_DS2  =  0x02 ; BYTE
.equ        DEV_DS3  =  0x03 ; BYTE
.equ        DEV_DS4  =  0x04 ; BYTE
 
; *** Variablentabelle ***
 
.dseg
 
DBG_ANFANG_VAR_TABELLE:
 
ARRAY_POS:   ; Word
.byte     2
CONSOLEIN:   ; Byte
.byte     1
CONSOLEOUT:   ; Byte
.byte     1
SOUNDOUT:   ; Byte
.byte     1
CONSOLEIN_GELESEN:   ; Boolean
.byte     1
DEVICE_VECTOR_GELESEN:   ; Boolean
.byte     1
STEUER_STRING:   ; String(50)
.byte     1     ; STRING-Laenge
.byte     50
ANZEIGE_STRING:   ; String(80)
.byte     1     ; STRING-Laenge
.byte     80
SEKTOR_PUFFER_ZEIGER:   ; Word
.byte     2
SEKTOR_PUFFER_GEAENDERT:   ; Boolean
.byte     1
SECTOR:   ; Byte
.byte     1
TRACK_L:   ; Byte
.byte     1
TRACK_H:   ; Byte
.byte     1
DISKNO:   ; Byte
.byte     1
SERIAL_DEVICE_CONNECTED:   ; Boolean
.byte     1
ITP3_DS34_NICHT_GENUTZT:   ; Boolean
.byte     1
I2C_VORHANDEN:   ; Boolean
.byte     1
STD_SEKTOR_NR:   ; Word
.byte     2
STD_SPUR_NR:   ; Word
.byte     2
DEVICE_VECTOR_BYTE:   ; Byte
.byte     1
LAUFWERKE_VERTEILER_BYTE:   ; Byte
.byte     1
BYTE_HEX_STRING:   ; String(2)
.byte     1     ; STRING-Laenge
.byte     2
BYTE_DEZ_STRING:   ; String(3)
.byte     1     ; STRING-Laenge
.byte     3
WORD_HEX_STRING:   ; String(4)
.byte     1     ; STRING-Laenge
.byte     4
DWORD_HEX_STRING:   ; String(8)
.byte     1     ; STRING-Laenge
.byte     8
SER0_ZEICHEN:   ; Byte
.byte     1
SER0_STRING:   ; String(60)
.byte     1     ; STRING-Laenge
.byte     60
ONE_BYTE:   ; Byte
.byte     1
SPI_BYTE:   ; Byte
.byte     1
ADR_BYTE_2:   ; Byte
.byte     1
ADR_BYTE_1:   ; Byte
.byte     1
ADR_BYTE_0:   ; Byte
.byte     1
LFD_NUMMER:   ; Byte
.byte     1
FLASH_ADDRESS:   ; Word
.byte     2
FM_TEMP_TBL1_TYP_ZIEL_ZEIGER:   ; Byte
.byte     1
DEV_NR:   ; Byte
.byte     1
CONOUT_DEVICE_NR1:   ; Byte
.byte     1
CONOUT_DEVICE_NR2:   ; Byte
.byte     1
CONIN_DEVICE:   ; Byte
.byte     1
LIST_DEVICE:   ; Byte
.byte     1
SOUND_DEVICE:   ; Byte
.byte     1
READER_DEVICE:   ; Byte
.byte     1
 
SEKTOR_PUFFER:
.byte     128
LAUFWERKE_VERTEILER:
.byte     16
SEKTOR_PUFFER_WR:
.byte     128
 
 
 
; *** Codesegment ***
.cseg
 
; *** Sprungtabelle ***
.ORG 0
 
; Sprung in das Hauptprogramm
        JMP       RESET
 
; FUNCTION - Anfang (BYTEPOSTOORMASKE)
BYTEPOSTOORMASKE:
 
; CASE OF - lokaler Uebergabeparameter (BYTEPOS)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (0)
        CPI        R16, 0x00
        BREQ       M_CASE_03
        RJMP       M_CASE_02
M_CASE_03:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x01
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_02:
 
; CASE OF - vergleiche Einzel-Element (1)
        CPI        R16, 0x01
        BREQ       M_CASE_05
        RJMP       M_CASE_04
M_CASE_05:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x02
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_04:
 
; CASE OF - vergleiche Einzel-Element (2)
        CPI        R16, 0x02
        BREQ       M_CASE_07
        RJMP       M_CASE_06
M_CASE_07:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x04
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_06:
 
; CASE OF - vergleiche Einzel-Element (3)
        CPI        R16, 0x03
        BREQ       M_CASE_09
        RJMP       M_CASE_08
M_CASE_09:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x08
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_08:
 
; CASE OF - vergleiche Einzel-Element (4)
        CPI        R16, 0x04
        BREQ       M_CASE_011
        RJMP       M_CASE_010
M_CASE_011:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x10
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_010:
 
; CASE OF - vergleiche Einzel-Element (5)
        CPI        R16, 0x05
        BREQ       M_CASE_013
        RJMP       M_CASE_012
M_CASE_013:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x20
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_012:
 
; CASE OF - vergleiche Einzel-Element (6)
        CPI        R16, 0x06
        BREQ       M_CASE_015
        RJMP       M_CASE_014
M_CASE_015:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x40
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
M_CASE_014:
 
; CASE OF - vergleiche Einzel-Element (7)
        CPI        R16, 0x07
        BREQ       M_CASE_017
        RJMP       M_CASE_016
M_CASE_017:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x80
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01
 
; CASE OF ELSE
M_CASE_016:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOORMASKE);
        LDI        R16, 0x01
        MOV        R1, R16
 
; ENDCASE;
M_CASE_01:
 
; Ende Byte - FUNCTION (BYTEPOSTOORMASKE)
        MOV        R16, R1
 
; FUNCTION - Ende (BYTEPOSTOORMASKE)
        RET
 
; FUNCTION - Anfang (BYTEPOSTOANDMASKE)
BYTEPOSTOANDMASKE:
 
; CASE OF - lokaler Uebergabeparameter (BYTEPOS)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (0)
        CPI        R16, 0x00
        BREQ       M_CASE_020
        RJMP       M_CASE_019
M_CASE_020:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFE
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_019:
 
; CASE OF - vergleiche Einzel-Element (1)
        CPI        R16, 0x01
        BREQ       M_CASE_022
        RJMP       M_CASE_021
M_CASE_022:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFD
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_021:
 
; CASE OF - vergleiche Einzel-Element (2)
        CPI        R16, 0x02
        BREQ       M_CASE_024
        RJMP       M_CASE_023
M_CASE_024:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFB
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_023:
 
; CASE OF - vergleiche Einzel-Element (3)
        CPI        R16, 0x03
        BREQ       M_CASE_026
        RJMP       M_CASE_025
M_CASE_026:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xF7
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_025:
 
; CASE OF - vergleiche Einzel-Element (4)
        CPI        R16, 0x04
        BREQ       M_CASE_028
        RJMP       M_CASE_027
M_CASE_028:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xEF
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_027:
 
; CASE OF - vergleiche Einzel-Element (5)
        CPI        R16, 0x05
        BREQ       M_CASE_030
        RJMP       M_CASE_029
M_CASE_030:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xDF
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_029:
 
; CASE OF - vergleiche Einzel-Element (6)
        CPI        R16, 0x06
        BREQ       M_CASE_032
        RJMP       M_CASE_031
M_CASE_032:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xBF
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
M_CASE_031:
 
; CASE OF - vergleiche Einzel-Element (7)
        CPI        R16, 0x07
        BREQ       M_CASE_034
        RJMP       M_CASE_033
M_CASE_034:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0x7F
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_018
 
; CASE OF ELSE
M_CASE_033:
 
; RESULT Byte-Konstante - FUNCTION (BYTEPOSTOANDMASKE);
        LDI        R16, 0xFE
        MOV        R1, R16
 
; ENDCASE;
M_CASE_018:
 
; Ende Byte - FUNCTION (BYTEPOSTOANDMASKE)
        MOV        R16, R1
 
; FUNCTION - Ende (BYTEPOSTOANDMASKE)
        RET
 
; FUNCTION - Anfang (READ_BIT_IN_BYTE)
READ_BIT_IN_BYTE:
 
; Retten der lokalen Parameter fuer PROCEDURE (READ_BIT_IN_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Parameter (BYTEPOS) retten
        MOV        R17, R1
 
; lokalen Parameter (BYTEPOS) an Funktion (BYTEPOSTOORMASKE)
        MOV        R0, R17
 
; Aufruf Funktion (BYTEPOSTOORMASKE)
        CALL       BYTEPOSTOORMASKE
 
; Retten der Parameter-Register fuer PROCEDURE (READ_BIT_IN_BYTE)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (MASKE)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (TESTBYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (MASKE)
        MOV        R18, R4
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (VERGLEICH)
        MOV        R3, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (VERGLEICH)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_038
        CLR        R16
        RJMP       M_VERGL_039
M_VERGL_038:
        SER        R16
M_VERGL_039:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_035
        RJMP       M_IF_036
M_IF_035:
 
; RESULT Byte-Konstante - FUNCTION (READ_BIT_IN_BYTE);
        LDI        R16, 0x00
        MOV        R2, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_037
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_036:
 
; RESULT Byte-Konstante - FUNCTION (READ_BIT_IN_BYTE);
        LDI        R16, 0xFF
        MOV        R2, R16
 
; IF_THEN_ELSE - Ende
M_IF_037:
 
; Ende Byte - FUNCTION (READ_BIT_IN_BYTE)
        MOV        R16, R2
 
; FUNCTION - Ende (READ_BIT_IN_BYTE)
        RET
 
; FUNCTION - Anfang (SET_BIT_IN_BYTE)
SET_BIT_IN_BYTE:
 
; Retten der lokalen Parameter fuer PROCEDURE (SET_BIT_IN_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Parameter (BYTEPOS) retten
        MOV        R17, R1
 
; lokalen Parameter (BYTEPOS) an Funktion (BYTEPOSTOORMASKE)
        MOV        R0, R17
 
; Aufruf Funktion (BYTEPOSTOORMASKE)
        CALL       BYTEPOSTOORMASKE
 
; Retten der Parameter-Register fuer PROCEDURE (SET_BIT_IN_BYTE)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (MASKE)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (TESTBYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (MASKE)
        MOV        R18, R4
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ERGEBNIS)
        MOV        R3, R16
 
; RESULT Byte-Variable - FUNCTION (SET_BIT_IN_BYTE)
        MOV        R2, R3
 
; Ende Byte - FUNCTION (SET_BIT_IN_BYTE)
        MOV        R16, R2
 
; FUNCTION - Ende (SET_BIT_IN_BYTE)
        RET
 
; FUNCTION - Anfang (CLEAR_BIT_IN_BYTE)
CLEAR_BIT_IN_BYTE:
 
; Retten der lokalen Parameter fuer PROCEDURE (CLEAR_BIT_IN_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Parameter (BYTEPOS) retten
        MOV        R17, R1
 
; lokalen Parameter (BYTEPOS) an Funktion (BYTEPOSTOANDMASKE)
        MOV        R0, R17
 
; Aufruf Funktion (BYTEPOSTOANDMASKE)
        CALL       BYTEPOSTOANDMASKE
 
; Retten der Parameter-Register fuer PROCEDURE (CLEAR_BIT_IN_BYTE)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (MASKE)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (TESTBYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (MASKE)
        MOV        R18, R4
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ERGEBNIS)
        MOV        R3, R16
 
; RESULT Byte-Variable - FUNCTION (CLEAR_BIT_IN_BYTE)
        MOV        R2, R3
 
; Ende Byte - FUNCTION (CLEAR_BIT_IN_BYTE)
        MOV        R16, R2
 
; FUNCTION - Ende (CLEAR_BIT_IN_BYTE)
        RET
 
; FUNCTION - Anfang (NEGATION_BYTE)
NEGATION_BYTE:
 
; ASM
COM    R0
 
 
; RESULT Byte-Variable - FUNCTION (NEGATION_BYTE)
        MOV        R1, R0
 
; Ende Byte - FUNCTION (NEGATION_BYTE)
        MOV        R16, R1
 
; FUNCTION - Ende (NEGATION_BYTE)
        RET
 
; PROCEDURE - Anfang (WAIT_MS)
WAIT_MS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / lokaler Uebergabeparameter (ZEIT)
        MOV        R16, R0
        MOV        R17, R1
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_040:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_041
        RJMP       M_FTD_042
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_041:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W2)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - Ausdruck / Konstante CONST (WAITKON2)
        LDI        R16, LOW(0x0276)
        LDI        R17, HIGH(0x0276)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R4
        MOV        R19, R5
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_043:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_044
        RJMP       M_FTD_045
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_044:
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R4
        MOV        R19, R5
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R4, R18
        MOV        R5, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_043
 
; FOR TO DO - Ende
M_FTD_045:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_040
 
; FOR TO DO - Ende
M_FTD_042:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; PROCEDURE - Ende (WAIT_MS)
        RET
 
; PROCEDURE - Anfang (BYTETOHEXSTRING)
BYTETOHEXSTRING:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (WERT_BYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0xF0)
        LDI        R18, 0xF0
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; SHR(HEXHIGH) - Byte
        LSR        R2
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_049
        CLR        R16
        RJMP       M_VERGL_050
M_VERGL_049:
        SER        R16
M_VERGL_050:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_046
        RJMP       M_IF_047
M_IF_046:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x37)
        LDI        R18, 0x37
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_048
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_047:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN_ELSE - Ende
M_IF_048:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToChar(HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (BYTE_HEX_STRING)=2
        LDI        R16, 2
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (C1)
        MOV        R19, R3
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_051
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_051:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (BYTE_HEX_STRING) - Laenge in R17
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_053
        MOV        R16, R17
M_PRG_CONST_STRING_052:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_052
M_PRG_CONST_STRING_053:
        ST         -Z, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (WERT_BYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0F)
        LDI        R18, 0x0F
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_057
        CLR        R16
        RJMP       M_VERGL_058
M_VERGL_057:
        SER        R16
M_VERGL_058:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_054
        RJMP       M_IF_055
M_IF_054:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x37)
        LDI        R18, 0x37
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_056
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_055:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN_ELSE - Ende
M_IF_056:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToChar(HEXLOW)
        MOV        R16, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (BYTE_HEX_STRING)=2
        LDI        R16, 2
        CLR        R17
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_059
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_059:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_061
M_PRG_CONST_STRING_060:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_060
M_PRG_CONST_STRING_061:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R3
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_062
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_062:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (BYTE_HEX_STRING) - Laenge in R17
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_064
        MOV        R16, R17
M_PRG_CONST_STRING_063:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_063
M_PRG_CONST_STRING_064:
        ST         -Z, R17
 
; PROCEDURE - Ende (BYTETOHEXSTRING)
        RET
 
; PROCEDURE - Anfang (BYTETODEZSTRING)
BYTETODEZSTRING:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; WHILE DO ...
M_WHILE_065:
 
; WHILE - Ausdruck erster Faktor / lokaler Uebergabeparameter (WERT_BYTE)
        MOV        R16, R0
 
; WHILE - Ausdruck zweiter Faktor / Zahlenwert (0x64)
        LDI        R18, 0x64
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_068
        CLR        R16
        RJMP       M_VERGL_069
M_VERGL_068:
        SER        R16
M_VERGL_069:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_066
        RJMP       M_WHILE_067
M_WHILE_066:
 
; WHILE DO ...
        RJMP       M_WHILE_065
M_WHILE_067:
 
; PROCEDURE - Ende (BYTETODEZSTRING)
        RET
 
; FUNCTION - Anfang (HEXSTRINGTOBYTE)
HEXSTRINGTOBYTE:
 
; ARRAY - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (BYTE_HEX_STRING)
        CLR        R17
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R4
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_073
        CLR        R16
        RJMP       M_VERGL_074
M_VERGL_073:
        SER        R16
M_VERGL_074:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_070
        RJMP       M_IF_071
M_IF_070:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x07)
        LDI        R18, 0x07
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R2, R16
 
; IF_THEN - Ende
M_IF_071:
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; SHL(HEXHIGH) - Byte
        LSL        R2
 
; ARRAY - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (BYTE_HEX_STRING)
        CLR        R17
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R4
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x30)
        LDI        R18, 0x30
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_078
        CLR        R16
        RJMP       M_VERGL_079
M_VERGL_078:
        SER        R16
M_VERGL_079:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_075
        RJMP       M_IF_076
M_IF_075:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x07)
        LDI        R18, 0x07
 
; Operator -
        SUB        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (HEXLOW)
        MOV        R1, R16
 
; IF_THEN - Ende
M_IF_076:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (HEXHIGH)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (HEXLOW)
        MOV        R18, R1
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2B)
        MOV        R3, R16
 
; RESULT Byte-Variable - FUNCTION (HEXSTRINGTOBYTE)
        MOV        R0, R3
 
; Ende Byte - FUNCTION (HEXSTRINGTOBYTE)
        MOV        R16, R0
 
; FUNCTION - Ende (HEXSTRINGTOBYTE)
        RET
 
; PROCEDURE - Anfang (WORDTOHEXSTRING)
WORDTOHEXSTRING:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(WERT_WORD)
        MOV        R16, R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (BYTE_LOW)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(WERT_WORD)
        MOV        R16, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (BYTE_HIGH)
        MOV        R3, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (WORDTOHEXSTRING)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (BYTE_HIGH) retten
        MOV        R19, R3
 
; lokalen Parameter (BYTE_HIGH) an Prozedur (BYTETOHEXSTRING)
        MOV        R0, R19
 
; Aufruf PROCEDURE (BYTETOHEXSTRING)
        CALL       BYTETOHEXSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (WORDTOHEXSTRING)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (WORD_HEX_STRING)=4
        LDI        R16, 4
        CLR        R17
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_080
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_080:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_082
M_PRG_CONST_STRING_081:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_081
M_PRG_CONST_STRING_082:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WORD_HEX_STRING) - Laenge in R17
        LDI        ZL, LOW(WORD_HEX_STRING)
        LDI        ZH, HIGH(WORD_HEX_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_084
        MOV        R16, R17
M_PRG_CONST_STRING_083:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_083
M_PRG_CONST_STRING_084:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (WORDTOHEXSTRING)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (BYTE_LOW) retten
        MOV        R18, R2
 
; lokalen Parameter (BYTE_LOW) an Prozedur (BYTETOHEXSTRING)
        MOV        R0, R18
 
; Aufruf PROCEDURE (BYTETOHEXSTRING)
        CALL       BYTETOHEXSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (WORDTOHEXSTRING)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (WORD_HEX_STRING)=4
        LDI        R16, 4
        CLR        R17
        LDI        ZL, LOW(WORD_HEX_STRING)
        LDI        ZH, HIGH(WORD_HEX_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_085
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_085:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_087
M_PRG_CONST_STRING_086:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_086
M_PRG_CONST_STRING_087:
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_088
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_088:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_090
M_PRG_CONST_STRING_089:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_089
M_PRG_CONST_STRING_090:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (WORD_HEX_STRING) - Laenge in R17
        LDI        ZL, LOW(WORD_HEX_STRING)
        LDI        ZH, HIGH(WORD_HEX_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_092
        MOV        R16, R17
M_PRG_CONST_STRING_091:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_091
M_PRG_CONST_STRING_092:
        ST         -Z, R17
 
; PROCEDURE - Ende (WORDTOHEXSTRING)
        RET
 
; FUNCTION - Anfang (HEXSTRINGTOWORD)
HEXSTRINGTOWORD:
 
; ARRAY - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WORD_HEX_STRING)
        CLR        R17
        LDI        ZL, LOW(WORD_HEX_STRING)
        LDI        ZH, HIGH(WORD_HEX_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (BYTE_HEX_STRING)=2
        LDI        R16, 2
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (C1)
        MOV        R19, R2
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_093
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_093:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (BYTE_HEX_STRING) - Laenge in R17
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_095
        MOV        R16, R17
M_PRG_CONST_STRING_094:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_094
M_PRG_CONST_STRING_095:
        ST         -Z, R17
 
; ARRAY - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WORD_HEX_STRING)
        CLR        R17
        LDI        ZL, LOW(WORD_HEX_STRING)
        LDI        ZH, HIGH(WORD_HEX_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (BYTE_HEX_STRING)=2
        LDI        R16, 2
        CLR        R17
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_096
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_096:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_098
M_PRG_CONST_STRING_097:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_097
M_PRG_CONST_STRING_098:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R2
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_099
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_099:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (BYTE_HEX_STRING) - Laenge in R17
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0101
        MOV        R16, R17
M_PRG_CONST_STRING_0100:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0100
M_PRG_CONST_STRING_0101:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (HEXSTRINGTOWORD)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Aufruf Funktion (HEXSTRINGTOBYTE)
        CALL       HEXSTRINGTOBYTE
 
; Retten der Parameter-Register fuer PROCEDURE (HEXSTRINGTOWORD)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2B)
        MOV        R5, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(S2B)
        MOV        R16, R5
        CLR        R17
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2W)
        MOV        R3, R16
        MOV        R4, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (S2W)
        MOV        R16, R3
        MOV        R17, R4
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0100)
        LDI        R18, LOW(0x0100)
        LDI        R19, HIGH(0x0100)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2W)
        MOV        R3, R16
        MOV        R4, R17
 
; ARRAY - Ausdruck / Zahlenwert (0x03)
        LDI        R16, 0x03
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WORD_HEX_STRING)
        CLR        R17
        LDI        ZL, LOW(WORD_HEX_STRING)
        LDI        ZH, HIGH(WORD_HEX_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (BYTE_HEX_STRING)=2
        LDI        R16, 2
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (C1)
        MOV        R19, R2
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0102
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0102:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (BYTE_HEX_STRING) - Laenge in R17
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0104
        MOV        R16, R17
M_PRG_CONST_STRING_0103:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0103
M_PRG_CONST_STRING_0104:
        ST         -Z, R17
 
; ARRAY - Ausdruck / Zahlenwert (0x04)
        LDI        R16, 0x04
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WORD_HEX_STRING)
        CLR        R17
        LDI        ZL, LOW(WORD_HEX_STRING)
        LDI        ZH, HIGH(WORD_HEX_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (BYTE_HEX_STRING)=2
        LDI        R16, 2
        CLR        R17
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0105
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0105:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0107
M_PRG_CONST_STRING_0106:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0106
M_PRG_CONST_STRING_0107:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R2
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0108
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0108:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (BYTE_HEX_STRING) - Laenge in R17
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0110
        MOV        R16, R17
M_PRG_CONST_STRING_0109:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0109
M_PRG_CONST_STRING_0110:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (HEXSTRINGTOWORD)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Aufruf Funktion (HEXSTRINGTOBYTE)
        CALL       HEXSTRINGTOBYTE
 
; Retten der Parameter-Register fuer PROCEDURE (HEXSTRINGTOWORD)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2B)
        MOV        R5, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(S2B)
        MOV        R16, R5
        CLR        R17
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2W2)
        MOV        R6, R16
        MOV        R7, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (S2W)
        MOV        R16, R3
        MOV        R17, R4
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (S2W2)
        MOV        R18, R6
        MOV        R19, R7
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (S2W)
        MOV        R3, R16
        MOV        R4, R17
 
; RESULT Word-Variable - FUNCTION (HEXSTRINGTOWORD)
        MOV        R0, R3
        MOV        R1, R4
 
; Ende Word - FUNCTION (HEXSTRINGTOWORD)
        MOV        R16, R0
        MOV        R17, R1
 
; FUNCTION - Ende (HEXSTRINGTOWORD)
        RET
 
; PROCEDURE - Anfang (DWORDTOHEXSTRING)
DWORDTOHEXSTRING:
 
; Zuweisung Quelle - Ausdruck / DWLow(WERT_DWORD)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (WORD_LOW)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck / DWHigh(WERT_DWORD)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (WORD_HIGH)
        MOV        R6, R16
        MOV        R7, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (DWORDTOHEXSTRING)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Parameter (WORD_HIGH) retten
        MOV        R22, R6
        MOV        R23, R7
 
; lokalen Parameter (WORD_HIGH) an Prozedur (WORDTOHEXSTRING)
        MOV        R0, R22
        MOV        R1, R23
 
; Aufruf PROCEDURE (WORDTOHEXSTRING)
        CALL       WORDTOHEXSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (DWORDTOHEXSTRING)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (DWORD_HEX_STRING)=8
        LDI        R16, 8
        CLR        R17
        LDI        ZL, LOW(WORD_HEX_STRING)
        LDI        ZH, HIGH(WORD_HEX_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0111
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0111:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0113
M_PRG_CONST_STRING_0112:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0112
M_PRG_CONST_STRING_0113:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (DWORD_HEX_STRING) - Laenge in R17
        LDI        ZL, LOW(DWORD_HEX_STRING)
        LDI        ZH, HIGH(DWORD_HEX_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0115
        MOV        R16, R17
M_PRG_CONST_STRING_0114:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0114
M_PRG_CONST_STRING_0115:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (DWORDTOHEXSTRING)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Parameter (WORD_LOW) retten
        MOV        R20, R4
        MOV        R21, R5
 
; lokalen Parameter (WORD_LOW) an Prozedur (WORDTOHEXSTRING)
        MOV        R0, R20
        MOV        R1, R21
 
; Aufruf PROCEDURE (WORDTOHEXSTRING)
        CALL       WORDTOHEXSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (DWORDTOHEXSTRING)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (DWORD_HEX_STRING)=8
        LDI        R16, 8
        CLR        R17
        LDI        ZL, LOW(DWORD_HEX_STRING)
        LDI        ZH, HIGH(DWORD_HEX_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0116
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0116:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0118
M_PRG_CONST_STRING_0117:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0117
M_PRG_CONST_STRING_0118:
        LDI        ZL, LOW(WORD_HEX_STRING)
        LDI        ZH, HIGH(WORD_HEX_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0119
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0119:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0121
M_PRG_CONST_STRING_0120:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0120
M_PRG_CONST_STRING_0121:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (DWORD_HEX_STRING) - Laenge in R17
        LDI        ZL, LOW(DWORD_HEX_STRING)
        LDI        ZH, HIGH(DWORD_HEX_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0123
        MOV        R16, R17
M_PRG_CONST_STRING_0122:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0122
M_PRG_CONST_STRING_0123:
        ST         -Z, R17
 
; PROCEDURE - Ende (DWORDTOHEXSTRING)
        RET
 
; PROCEDURE - Anfang (INIT_SER0_PORT)
INIT_SER0_PORT:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (UBRRH)
        OUT        UBRRH, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (UBRR_VAL)
        LDI        R16, 0x0F
 
; Zuweisung Ziel /  VAR (UBRRL)
        OUT        UBRRL, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x18)
        LDI        R16, 0x18
 
; Zuweisung Ziel /  VAR (UCSRB)
        OUT        UCSRB, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x86)
        LDI        R16, 0x86
 
; Zuweisung Ziel /  VAR (UCSRC)
        OUT        UCSRC, R16
 
; PROCEDURE - Ende (INIT_SER0_PORT)
        RET
 
; PROCEDURE - Anfang (RX0_PUFFER_ABFRAGEN)
RX0_PUFFER_ABFRAGEN:
 
; IF THEN - Ausdruck /; BitHigh(RXC)
        IN         R16, UCSRA
        BST        R16, 7
        BRTS       M_VERGL_0127
        CLR        R16
        RJMP       M_VERGL_0128
M_VERGL_0127:
        SER        R16
M_VERGL_0128:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0124
        RJMP       M_IF_0125
M_IF_0124:
 
; Zuweisung Quelle - Ausdruck / Byte-REG UDR
        IN         R16, UDR
 
; Zuweisung Ziel /  VAR (SER0_ZEICHEN)
        STS        SER0_ZEICHEN, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0126
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0125:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (SER0_ZEICHEN)
        STS        SER0_ZEICHEN, R16
 
; IF_THEN_ELSE - Ende
M_IF_0126:
 
; PROCEDURE - Ende (RX0_PUFFER_ABFRAGEN)
        RET
 
; PROCEDURE - Anfang (SENDE_ZEICHEN0)
SENDE_ZEICHEN0:
 
; WHILE DO ...
M_WHILE_0129:
 
; WHILE - Ausdruck /; BitLow(UDRE)
        IN         R16, UCSRA
        BST        R16, 5
        BRTC       M_VERGL_0132
        CLR        R16
        RJMP       M_VERGL_0133
M_VERGL_0132:
        SER        R16
M_VERGL_0133:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0130
        RJMP       M_WHILE_0131
M_WHILE_0130:
 
; WHILE DO ...
        RJMP       M_WHILE_0129
M_WHILE_0131:
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (S_ZEICHEN0)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (UDR)
        OUT        UDR, R16
 
; PROCEDURE - Ende (SENDE_ZEICHEN0)
        RET
 
; PROCEDURE - Anfang (ABFRAGE_SERIAL_DEVICE_CONNECTED)
ABFRAGE_SERIAL_DEVICE_CONNECTED:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (SERIAL_DEVICE_CONNECTED)
        STS        SERIAL_DEVICE_CONNECTED, R16
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN0)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN0)
        CALL       SENDE_ZEICHEN0
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x0064)
        MOV        R0, R16
        LDI        R17, HIGH(0x0064)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; Aufruf PROCEDURE (RX0_PUFFER_ABFRAGEN)
        CALL       RX0_PUFFER_ABFRAGEN
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (SER0_ZEICHEN)
        LDS        R16, SER0_ZEICHEN
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (XON)
        LDI        R18, 0x11
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0137
        CLR        R16
        RJMP       M_VERGL_0138
M_VERGL_0137:
        SER        R16
M_VERGL_0138:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0134
        RJMP       M_IF_0135
M_IF_0134:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (SERIAL_DEVICE_CONNECTED)
        STS        SERIAL_DEVICE_CONNECTED, R16
 
; IF_THEN - Ende
M_IF_0135:
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (SER0_ZEICHEN)
        LDS        R16, SER0_ZEICHEN
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (XOFF)
        LDI        R18, 0x13
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0142
        CLR        R16
        RJMP       M_VERGL_0143
M_VERGL_0142:
        SER        R16
M_VERGL_0143:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0139
        RJMP       M_IF_0140
M_IF_0139:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (SERIAL_DEVICE_CONNECTED)
        STS        SERIAL_DEVICE_CONNECTED, R16
 
; IF_THEN - Ende
M_IF_0140:
 
; PROCEDURE - Ende (ABFRAGE_SERIAL_DEVICE_CONNECTED)
        RET
 
; PROCEDURE - Anfang (WRITE_SER0)
WRITE_SER0:
 
; Zuweisung Quelle - Ausdruck / Length(SER0_STRING)
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LAENGE)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; FOR TO DO - Ausdruck / lokale, dynamische Variable VAR (LAENGE)
        MOV        R16, R1
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R2
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0144:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0145
        RJMP       M_FTD_0146
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0145:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (B1)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (SER0_STRING)
        CLR        R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B2)
        MOV        R3, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (WRITE_SER0)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (B2) retten
        MOV        R19, R3
 
; lokalen Parameter (B2) an Prozedur (SENDE_ZEICHEN0)
        MOV        R0, R19
 
; Aufruf PROCEDURE (SENDE_ZEICHEN0)
        CALL       SENDE_ZEICHEN0
 
; Retten der Parameter-Register fuer PROCEDURE (WRITE_SER0)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R2
        INC        R17
        MOV        R2, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0144
 
; FOR TO DO - Ende
M_FTD_0146:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; PROCEDURE - Ende (WRITE_SER0)
        RET
 
; PROCEDURE - Anfang (WRITELN_SER0)
WRITELN_SER0:
 
; Aufruf PROCEDURE (WRITE_SER0)
        CALL       WRITE_SER0
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN0)
        LDI        R16, 0x0D
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN0)
        CALL       SENDE_ZEICHEN0
 
; Byte-Parameter(1) fuer PROCEDURE (SENDE_ZEICHEN0)
        LDI        R16, 0x0A
        MOV        R0, R16
 
; Aufruf PROCEDURE (SENDE_ZEICHEN0)
        CALL       SENDE_ZEICHEN0
 
; PROCEDURE - Ende (WRITELN_SER0)
        RET
 
; PROCEDURE - Anfang (STD_AN_UART_SENDEN)
STD_AN_UART_SENDEN:
 
; Byte-Parameter(1) fuer PROCEDURE (BYTETOHEXSTRING)
        LDS        R0, SECTOR
 
; Aufruf PROCEDURE (BYTETOHEXSTRING)
        CALL       BYTETOHEXSTRING
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (ANZEIGE_STRING)=80
        LDI        R16, 80
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('s')
        LDI        ZL, LOW(2*M_CONST_STRING_0)
        LDI        ZH, HIGH(2*M_CONST_STRING_0)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0147
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0147:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0149
M_PRG_CONST_STRING_0148:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0148
M_PRG_CONST_STRING_0149:
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0150
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0150:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0152
M_PRG_CONST_STRING_0151:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0151
M_PRG_CONST_STRING_0152:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ANZEIGE_STRING) - Laenge in R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0154
        MOV        R16, R17
M_PRG_CONST_STRING_0153:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0153
M_PRG_CONST_STRING_0154:
        ST         -Z, R17
 
; Byte-Parameter(1) fuer PROCEDURE (BYTETOHEXSTRING)
        LDS        R0, TRACK_H
 
; Aufruf PROCEDURE (BYTETOHEXSTRING)
        CALL       BYTETOHEXSTRING
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (ANZEIGE_STRING)=80
        LDI        R16, 80
        CLR        R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0155
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0155:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0157
M_PRG_CONST_STRING_0156:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0156
M_PRG_CONST_STRING_0157:
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0158
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0158:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0160
M_PRG_CONST_STRING_0159:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0159
M_PRG_CONST_STRING_0160:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ANZEIGE_STRING) - Laenge in R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0162
        MOV        R16, R17
M_PRG_CONST_STRING_0161:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0161
M_PRG_CONST_STRING_0162:
        ST         -Z, R17
 
; Byte-Parameter(1) fuer PROCEDURE (BYTETOHEXSTRING)
        LDS        R0, TRACK_L
 
; Aufruf PROCEDURE (BYTETOHEXSTRING)
        CALL       BYTETOHEXSTRING
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (ANZEIGE_STRING)=80
        LDI        R16, 80
        CLR        R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0163
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0163:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0165
M_PRG_CONST_STRING_0164:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0164
M_PRG_CONST_STRING_0165:
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0166
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0166:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0168
M_PRG_CONST_STRING_0167:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0167
M_PRG_CONST_STRING_0168:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ANZEIGE_STRING) - Laenge in R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0170
        MOV        R16, R17
M_PRG_CONST_STRING_0169:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0169
M_PRG_CONST_STRING_0170:
        ST         -Z, R17
 
; Byte-Parameter(1) fuer PROCEDURE (BYTETOHEXSTRING)
        LDS        R0, DISKNO
 
; Aufruf PROCEDURE (BYTETOHEXSTRING)
        CALL       BYTETOHEXSTRING
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (SER0_STRING)=60
        LDI        R16, 60
        CLR        R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0171
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0171:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0173
M_PRG_CONST_STRING_0172:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0172
M_PRG_CONST_STRING_0173:
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0174
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0174:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0176
M_PRG_CONST_STRING_0175:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0175
M_PRG_CONST_STRING_0176:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0178
        MOV        R16, R17
M_PRG_CONST_STRING_0177:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0177
M_PRG_CONST_STRING_0178:
        ST         -Z, R17
 
; Aufruf PROCEDURE (WRITELN_SER0)
        CALL       WRITELN_SER0
 
; PROCEDURE - Ende (STD_AN_UART_SENDEN)
        RET
 
; PROCEDURE - Anfang (STEUER_STRING_TO_SECTOR)
STEUER_STRING_TO_SECTOR:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B2)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0F)
        LDI        R16, 0x0F
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R0
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0179:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0180
        RJMP       M_FTD_0181
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0180:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (B2)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (STEUER_STRING)
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R3, R16
 
; INC(B2) - Byte
        INC        R1
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (BYTE_HEX_STRING)=2
        LDI        R16, 2
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (C1)
        MOV        R19, R3
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0182
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0182:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (BYTE_HEX_STRING) - Laenge in R17
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0184
        MOV        R16, R17
M_PRG_CONST_STRING_0183:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0183
M_PRG_CONST_STRING_0184:
        ST         -Z, R17
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (B2)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (STEUER_STRING)
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R3, R16
 
; INC(B2) - Byte
        INC        R1
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (BYTE_HEX_STRING)=2
        LDI        R16, 2
        CLR        R17
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0185
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0185:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0187
M_PRG_CONST_STRING_0186:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0186
M_PRG_CONST_STRING_0187:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (C1)
        MOV        R19, R3
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0188
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0188:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (BYTE_HEX_STRING) - Laenge in R17
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0190
        MOV        R16, R17
M_PRG_CONST_STRING_0189:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0189
M_PRG_CONST_STRING_0190:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_TO_SECTOR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf Funktion (HEXSTRINGTOBYTE)
        CALL       HEXSTRINGTOBYTE
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_TO_SECTOR)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B3)
        MOV        R2, R16
 
; VAR ARRAY-1D POSITION - Ausdruck / Word-VAR (SEKTOR_PUFFER_ZEIGER)
        LDS        R16, SEKTOR_PUFFER_ZEIGER
        LDS        R17, SEKTOR_PUFFER_ZEIGER+1
 
; VAR ARRAY Ziel Zeiger berechnen (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B3)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR ARRAY-1D (SEKTOR_PUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; INC(SEKTOR_PUFFER_ZEIGER) - Word
        LDS        R24, SEKTOR_PUFFER_ZEIGER
        LDS        R25, SEKTOR_PUFFER_ZEIGER+1
        ADIW       R25:R24, 1
        STS        SEKTOR_PUFFER_ZEIGER, R24
        STS        SEKTOR_PUFFER_ZEIGER+1, R25
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R0
        INC        R17
        MOV        R0, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0179
 
; FOR TO DO - Ende
M_FTD_0181:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; PROCEDURE - Ende (STEUER_STRING_TO_SECTOR)
        RET
 
; PROCEDURE - Anfang (STEUER_STRING_TO_SECTOR_KOMP)
STEUER_STRING_TO_SECTOR_KOMP:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (BITPOS_DB8)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DB8)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (POS_SS)
        MOV        R6, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x26)
        LDI        R16, 0x26
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R6
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0191:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0192
        RJMP       M_FTD_0193
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0192:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (POS_SS)
        MOV        R16, R6
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (STEUER_STRING)
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R5, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R5
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DB7)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (BITPOS_DB7)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (X2)
        MOV        R0, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x06)
        LDI        R16, 0x06
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R0
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0194:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0195
        RJMP       M_FTD_0196
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0195:
 
; DEC(BITPOS_DB7) - Byte
        DEC        R4
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_TO_SECTOR_KOMP)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Parameter (DB7) retten
        MOV        R17, R1
 
; Parameter (BITPOS_DB7) retten
        MOV        R20, R4
 
; lokalen Parameter (DB7) an Funktion (READ_BIT_IN_BYTE)
        MOV        R0, R17
 
; lokalen Parameter (BITPOS_DB7) an Funktion (READ_BIT_IN_BYTE)
        MOV        R1, R20
 
; Aufruf Funktion (READ_BIT_IN_BYTE)
        CALL       READ_BIT_IN_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_TO_SECTOR_KOMP)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (EIN_BIT)
        MOV        R7, R16
 
; IF THEN - Ausdruck / lokale, dynamische Variable VAR (EIN_BIT)
        MOV        R16, R7
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0197
        RJMP       M_IF_0198
M_IF_0197:
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_TO_SECTOR_KOMP)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Parameter (DB8) retten
        MOV        R18, R2
 
; Parameter (BITPOS_DB8) retten
        MOV        R19, R3
 
; lokalen Parameter (DB8) an Funktion (SET_BIT_IN_BYTE)
        MOV        R0, R18
 
; lokalen Parameter (BITPOS_DB8) an Funktion (SET_BIT_IN_BYTE)
        MOV        R1, R19
 
; Aufruf Funktion (SET_BIT_IN_BYTE)
        CALL       SET_BIT_IN_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_TO_SECTOR_KOMP)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DB8)
        MOV        R2, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0199
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0198:
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_TO_SECTOR_KOMP)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Parameter (DB8) retten
        MOV        R18, R2
 
; Parameter (BITPOS_DB8) retten
        MOV        R19, R3
 
; lokalen Parameter (DB8) an Funktion (CLEAR_BIT_IN_BYTE)
        MOV        R0, R18
 
; lokalen Parameter (BITPOS_DB8) an Funktion (CLEAR_BIT_IN_BYTE)
        MOV        R1, R19
 
; Aufruf Funktion (CLEAR_BIT_IN_BYTE)
        CALL       CLEAR_BIT_IN_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_TO_SECTOR_KOMP)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DB8)
        MOV        R2, R16
 
; IF_THEN_ELSE - Ende
M_IF_0199:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (BITPOS_DB8)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0203
        CLR        R16
        RJMP       M_VERGL_0204
M_VERGL_0203:
        SER        R16
M_VERGL_0204:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0200
        RJMP       M_IF_0201
M_IF_0200:
 
; VAR ARRAY-1D POSITION - Ausdruck / Word-VAR (SEKTOR_PUFFER_ZEIGER)
        LDS        R16, SEKTOR_PUFFER_ZEIGER
        LDS        R17, SEKTOR_PUFFER_ZEIGER+1
 
; VAR ARRAY Ziel Zeiger berechnen (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (DB8)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR ARRAY-1D (SEKTOR_PUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; INC(SEKTOR_PUFFER_ZEIGER) - Word
        LDS        R24, SEKTOR_PUFFER_ZEIGER
        LDS        R25, SEKTOR_PUFFER_ZEIGER+1
        ADIW       R25:R24, 1
        STS        SEKTOR_PUFFER_ZEIGER, R24
        STS        SEKTOR_PUFFER_ZEIGER+1, R25
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (BITPOS_DB8)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DB8)
        MOV        R2, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0202
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0201:
 
; DEC(BITPOS_DB8) - Byte
        DEC        R3
 
; IF_THEN_ELSE - Ende
M_IF_0202:
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R0
        INC        R17
        MOV        R0, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0194
 
; FOR TO DO - Ende
M_FTD_0196:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R6
        INC        R17
        MOV        R6, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0191
 
; FOR TO DO - Ende
M_FTD_0193:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; PROCEDURE - Ende (STEUER_STRING_TO_SECTOR_KOMP)
        RET
 
; PROCEDURE - Anfang (STEUER_STRING_AUSWERTEN)
STEUER_STRING_AUSWERTEN:
 
; Zuweisung Quelle - Ausdruck / Length(STEUER_STRING)
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LAENGE)
        MOV        R3, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LAENGE)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_0208
        CLR        R16
        RJMP       M_VERGL_0209
M_VERGL_0208:
        SER        R16
M_VERGL_0209:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0205
        RJMP       M_IF_0206
M_IF_0205:
 
; ARRAY - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (STEUER_STRING)
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (BUCHSTABE)
        MOV        R0, R16
 
; CASE OF - lokale, dynamische Variable VAR (BUCHSTABE)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (H)
        CPI        R16, 'H'
        BREQ       M_CASE_0212
        RJMP       M_CASE_0211
M_CASE_0212:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LAENGE)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x03)
        LDI        R18, 0x03
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0216
        CLR        R16
        RJMP       M_VERGL_0217
M_VERGL_0216:
        SER        R16
M_VERGL_0217:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0213
        RJMP       M_IF_0214
M_IF_0213:
 
; ARRAY - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (STEUER_STRING)
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ZEICHEN_1)
        MOV        R1, R16
 
; ARRAY - Ausdruck / Zahlenwert (0x03)
        LDI        R16, 0x03
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (STEUER_STRING)
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ZEICHEN_2)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (BYTE_HEX_STRING)=2
        LDI        R16, 2
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ZEICHEN_1)
        MOV        R19, R1
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0218
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0218:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (ZEICHEN_2)
        MOV        R19, R2
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0219
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0219:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (BYTE_HEX_STRING) - Laenge in R17
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0221
        MOV        R16, R17
M_PRG_CONST_STRING_0220:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0220
M_PRG_CONST_STRING_0221:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf Funktion (HEXSTRINGTOBYTE)
        CALL       HEXSTRINGTOBYTE
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  VAR (DEVICE_VECTOR_BYTE)
        STS        DEVICE_VECTOR_BYTE, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DEVICE_VECTOR_GELESEN)
        STS        DEVICE_VECTOR_GELESEN, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0215
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0214:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (SER0_STRING)=60
        LDI        R16, 60
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('x21')
        LDI        ZL, LOW(2*M_CONST_STRING_1)
        LDI        ZH, HIGH(2*M_CONST_STRING_1)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0222
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0222:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0224
M_PRG_CONST_STRING_0223:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0223
M_PRG_CONST_STRING_0224:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0226
        MOV        R16, R17
M_PRG_CONST_STRING_0225:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0225
M_PRG_CONST_STRING_0226:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WRITELN_SER0)
        CALL       WRITELN_SER0
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Ende
M_IF_0215:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0210
M_CASE_0211:
 
; CASE OF - vergleiche Einzel-Element (T)
        CPI        R16, 'T'
        BREQ       M_CASE_0228
        RJMP       M_CASE_0227
M_CASE_0228:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LAENGE)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x03)
        LDI        R18, 0x03
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0232
        CLR        R16
        RJMP       M_VERGL_0233
M_VERGL_0232:
        SER        R16
M_VERGL_0233:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0229
        RJMP       M_IF_0230
M_IF_0229:
 
; ARRAY - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (STEUER_STRING)
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ZEICHEN_1)
        MOV        R1, R16
 
; ARRAY - Ausdruck / Zahlenwert (0x03)
        LDI        R16, 0x03
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (STEUER_STRING)
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ZEICHEN_2)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (BYTE_HEX_STRING)=2
        LDI        R16, 2
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ZEICHEN_1)
        MOV        R19, R1
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0234
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0234:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (ZEICHEN_2)
        MOV        R19, R2
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0235
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0235:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (BYTE_HEX_STRING) - Laenge in R17
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0237
        MOV        R16, R17
M_PRG_CONST_STRING_0236:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0236
M_PRG_CONST_STRING_0237:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf Funktion (HEXSTRINGTOBYTE)
        CALL       HEXSTRINGTOBYTE
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  VAR (CONSOLEIN)
        STS        CONSOLEIN, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (CONSOLEIN_GELESEN)
        STS        CONSOLEIN_GELESEN, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0231
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0230:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (SER0_STRING)=60
        LDI        R16, 60
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('x22')
        LDI        ZL, LOW(2*M_CONST_STRING_2)
        LDI        ZH, HIGH(2*M_CONST_STRING_2)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0238
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0238:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0240
M_PRG_CONST_STRING_0239:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0239
M_PRG_CONST_STRING_0240:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0242
        MOV        R16, R17
M_PRG_CONST_STRING_0241:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0241
M_PRG_CONST_STRING_0242:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WRITELN_SER0)
        CALL       WRITELN_SER0
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Ende
M_IF_0231:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0210
M_CASE_0227:
 
; CASE OF - vergleiche Einzel-Element (U)
        CPI        R16, 'U'
        BREQ       M_CASE_0244
        RJMP       M_CASE_0243
M_CASE_0244:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LAENGE)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x21)
        LDI        R18, 0x21
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0248
        CLR        R16
        RJMP       M_VERGL_0249
M_VERGL_0248:
        SER        R16
M_VERGL_0249:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0245
        RJMP       M_IF_0246
M_IF_0245:
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (STEUER_STRING_TO_SECTOR)
        CALL       STEUER_STRING_TO_SECTOR
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0247
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0246:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (SER0_STRING)=60
        LDI        R16, 60
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('x23')
        LDI        ZL, LOW(2*M_CONST_STRING_3)
        LDI        ZH, HIGH(2*M_CONST_STRING_3)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0250
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0250:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0252
M_PRG_CONST_STRING_0251:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0251
M_PRG_CONST_STRING_0252:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0254
        MOV        R16, R17
M_PRG_CONST_STRING_0253:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0253
M_PRG_CONST_STRING_0254:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WRITELN_SER0)
        CALL       WRITELN_SER0
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Ende
M_IF_0247:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0210
M_CASE_0243:
 
; CASE OF - vergleiche Einzel-Element (R)
        CPI        R16, 'R'
        BREQ       M_CASE_0256
        RJMP       M_CASE_0255
M_CASE_0256:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LAENGE)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x26)
        LDI        R18, 0x26
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0260
        CLR        R16
        RJMP       M_VERGL_0261
M_VERGL_0260:
        SER        R16
M_VERGL_0261:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0257
        RJMP       M_IF_0258
M_IF_0257:
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (STEUER_STRING_TO_SECTOR_KOMP)
        CALL       STEUER_STRING_TO_SECTOR_KOMP
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0259
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0258:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (SER0_STRING)=60
        LDI        R16, 60
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('x24')
        LDI        ZL, LOW(2*M_CONST_STRING_4)
        LDI        ZH, HIGH(2*M_CONST_STRING_4)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0262
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0262:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0264
M_PRG_CONST_STRING_0263:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0263
M_PRG_CONST_STRING_0264:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0266
        MOV        R16, R17
M_PRG_CONST_STRING_0265:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0265
M_PRG_CONST_STRING_0266:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WRITELN_SER0)
        CALL       WRITELN_SER0
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Ende
M_IF_0259:
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0210
 
; CASE OF ELSE
M_CASE_0255:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (SER0_STRING)=60
        LDI        R16, 60
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('x25')
        LDI        ZL, LOW(2*M_CONST_STRING_5)
        LDI        ZH, HIGH(2*M_CONST_STRING_5)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0267
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0267:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0269
M_PRG_CONST_STRING_0268:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0268
M_PRG_CONST_STRING_0269:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0271
        MOV        R16, R17
M_PRG_CONST_STRING_0270:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0270
M_PRG_CONST_STRING_0271:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WRITELN_SER0)
        CALL       WRITELN_SER0
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_AUSWERTEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; ENDCASE;
M_CASE_0210:
 
; IF_THEN - Ende
M_IF_0206:
 
; PROCEDURE - Ende (STEUER_STRING_AUSWERTEN)
        RET
 
; PROCEDURE - Anfang (STEUER_STRING_LESEN)
STEUER_STRING_LESEN:
 
; Zuweisung Quelle - Ausdruck / Byte-REG UDR
        IN         R16, UDR
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (EMPF_ZEICHEN)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (EMPF_ZEICHEN)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0D)
        LDI        R18, 0x0D
 
; Operator <>
        CP         R16, R18
        BRNE       M_VERGL_0275
        CLR        R16
        RJMP       M_VERGL_0276
M_VERGL_0275:
        SER        R16
M_VERGL_0276:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0272
        RJMP       M_IF_0273
M_IF_0272:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (EMPF_ZEICHEN)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0A)
        LDI        R18, 0x0A
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0280
        CLR        R16
        RJMP       M_VERGL_0281
M_VERGL_0280:
        SER        R16
M_VERGL_0281:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0277
        RJMP       M_IF_0278
M_IF_0277:
 
; Retten der lokalen Parameter fuer PROCEDURE (STEUER_STRING_LESEN)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (STEUER_STRING_AUSWERTEN)
        CALL       STEUER_STRING_AUSWERTEN
 
; Retten der Parameter-Register fuer PROCEDURE (STEUER_STRING_LESEN)
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (STEUER_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('')
        LDI        ZL, LOW(2*M_CONST_STRING_6)
        LDI        ZH, HIGH(2*M_CONST_STRING_6)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0282
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0282:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0284
M_PRG_CONST_STRING_0283:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0283
M_PRG_CONST_STRING_0284:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (STEUER_STRING) - Laenge in R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0286
        MOV        R16, R17
M_PRG_CONST_STRING_0285:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0285
M_PRG_CONST_STRING_0286:
        ST         -Z, R17
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0279
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0278:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToChar(EMPF_ZEICHEN)
        MOV        R16, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (AKT_ZEICHEN)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (STEUER_STRING)=50
        LDI        R16, 50
        CLR        R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0287
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0287:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0289
M_PRG_CONST_STRING_0288:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0288
M_PRG_CONST_STRING_0289:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (AKT_ZEICHEN)
        MOV        R19, R0
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_0290
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_0290:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (STEUER_STRING) - Laenge in R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0292
        MOV        R16, R17
M_PRG_CONST_STRING_0291:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0291
M_PRG_CONST_STRING_0292:
        ST         -Z, R17
 
; IF_THEN_ELSE - Ende
M_IF_0279:
 
; IF_THEN - Ende
M_IF_0273:
 
; PROCEDURE - Ende (STEUER_STRING_LESEN)
        RET
 
; PROCEDURE - Anfang (SEKTOR_VON_UART_LESEN)
SEKTOR_VON_UART_LESEN:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (SEKTOR_PUFFER_ZEIGER)
        STS        SEKTOR_PUFFER_ZEIGER, R16
        STS        SEKTOR_PUFFER_ZEIGER+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (SPZ)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R0
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0293:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0294
        RJMP       M_FTD_0295
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0294:
 
; Retten der lokalen Parameter fuer PROCEDURE (SEKTOR_VON_UART_LESEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (BYTETOHEXSTRING)
        CALL       BYTETOHEXSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (SEKTOR_VON_UART_LESEN)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (SER0_STRING)=60
        LDI        R16, 60
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('u')
        LDI        ZL, LOW(2*M_CONST_STRING_7)
        LDI        ZH, HIGH(2*M_CONST_STRING_7)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0296
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0296:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0298
M_PRG_CONST_STRING_0297:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0297
M_PRG_CONST_STRING_0298:
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0299
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0299:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0301
M_PRG_CONST_STRING_0300:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0300
M_PRG_CONST_STRING_0301:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0303
        MOV        R16, R17
M_PRG_CONST_STRING_0302:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0302
M_PRG_CONST_STRING_0303:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SEKTOR_VON_UART_LESEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (WRITELN_SER0)
        CALL       WRITELN_SER0
 
; Retten der Parameter-Register fuer PROCEDURE (SEKTOR_VON_UART_LESEN)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xEA60)
        LDI        R16, LOW(0xEA60)
        LDI        R17, HIGH(0xEA60)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R4, R16
        MOV        R5, R17
 
; WHILE DO ...
M_WHILE_0304:
 
; WHILE - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R16, R4
        MOV        R17, R5
 
; WHILE - Ausdruck zweiter Faktor / Zahlenwert (0x0005)
        LDI        R18, LOW(0x0005)
        LDI        R19, HIGH(0x0005)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0307
        CLR        R16
        RJMP       M_VERGL_0308
M_VERGL_0307:
        SER        R16
M_VERGL_0308:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0305
        RJMP       M_WHILE_0306
M_WHILE_0305:
 
; IF THEN - Ausdruck /; BitHigh(RXC)
        IN         R16, UCSRA
        BST        R16, 7
        BRTS       M_VERGL_0312
        CLR        R16
        RJMP       M_VERGL_0313
M_VERGL_0312:
        SER        R16
M_VERGL_0313:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0309
        RJMP       M_IF_0310
M_IF_0309:
 
; Retten der lokalen Parameter fuer PROCEDURE (SEKTOR_VON_UART_LESEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (STEUER_STRING_LESEN)
        CALL       STEUER_STRING_LESEN
 
; Retten der Parameter-Register fuer PROCEDURE (SEKTOR_VON_UART_LESEN)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (SPZ)
        MOV        R16, R2
        MOV        R17, R3
 
; IF THEN - Ausdruck zweiter Faktor / Word-VAR (SEKTOR_PUFFER_ZEIGER)
        LDS        R18, SEKTOR_PUFFER_ZEIGER
        LDS        R19, SEKTOR_PUFFER_ZEIGER+1
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0317
        CLR        R16
        CLR        R16
        RJMP       M_VERGL_0318
M_VERGL_0317:
        SER        R16
M_VERGL_0318:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0314
        RJMP       M_IF_0315
M_IF_0314:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xEA60)
        LDI        R16, LOW(0xEA60)
        LDI        R17, HIGH(0xEA60)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R4, R16
        MOV        R5, R17
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0316
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0315:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0002)
        LDI        R16, LOW(0x0002)
        LDI        R17, HIGH(0x0002)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (SEKTOR_PUFFER_ZEIGER)
        LDS        R16, SEKTOR_PUFFER_ZEIGER
        LDS        R17, SEKTOR_PUFFER_ZEIGER+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (SPZ)
        MOV        R2, R16
        MOV        R3, R17
 
; IF_THEN_ELSE - Ende
M_IF_0316:
 
; IF_THEN - Ende
M_IF_0310:
 
; DEC(LESESCHLEIFE) - Word
        MOV        R24, R4
        MOV        R25, R5
        SBIW       R25:R24, 1
        MOV        R4, R24
        MOV        R5, R25
 
; WHILE DO ...
        RJMP       M_WHILE_0304
M_WHILE_0306:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R16, R4
        MOV        R17, R5
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0002)
        LDI        R18, LOW(0x0002)
        LDI        R19, HIGH(0x0002)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0322
        CLR        R16
        RJMP       M_VERGL_0323
M_VERGL_0322:
        SER        R16
M_VERGL_0323:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0319
        RJMP       M_IF_0320
M_IF_0319:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (SER0_STRING)=60
        LDI        R16, 60
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('x04')
        LDI        ZL, LOW(2*M_CONST_STRING_8)
        LDI        ZH, HIGH(2*M_CONST_STRING_8)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0324
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0324:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0326
M_PRG_CONST_STRING_0325:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0325
M_PRG_CONST_STRING_0326:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0328
        MOV        R16, R17
M_PRG_CONST_STRING_0327:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0327
M_PRG_CONST_STRING_0328:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SEKTOR_VON_UART_LESEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (WRITELN_SER0)
        CALL       WRITELN_SER0
 
; Retten der Parameter-Register fuer PROCEDURE (SEKTOR_VON_UART_LESEN)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN - Ende
M_IF_0320:
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R0
        INC        R17
        MOV        R0, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0293
 
; FOR TO DO - Ende
M_FTD_0295:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; PROCEDURE - Ende (SEKTOR_VON_UART_LESEN)
        RET
 
; PROCEDURE - Anfang (SEKTOR_VON_UART_LESEN_KOMP)
SEKTOR_VON_UART_LESEN_KOMP:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (SEKTOR_PUFFER_ZEIGER)
        STS        SEKTOR_PUFFER_ZEIGER, R16
        STS        SEKTOR_PUFFER_ZEIGER+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (SPZ)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x03)
        LDI        R16, 0x03
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R0
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0329:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0330
        RJMP       M_FTD_0331
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0330:
 
; Retten der lokalen Parameter fuer PROCEDURE (SEKTOR_VON_UART_LESEN_KOMP)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (BYTETOHEXSTRING)
        CALL       BYTETOHEXSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (SEKTOR_VON_UART_LESEN_KOMP)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (SER0_STRING)=60
        LDI        R16, 60
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('r')
        LDI        ZL, LOW(2*M_CONST_STRING_9)
        LDI        ZH, HIGH(2*M_CONST_STRING_9)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0332
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0332:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0334
M_PRG_CONST_STRING_0333:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0333
M_PRG_CONST_STRING_0334:
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0335
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0335:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0337
M_PRG_CONST_STRING_0336:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0336
M_PRG_CONST_STRING_0337:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0339
        MOV        R16, R17
M_PRG_CONST_STRING_0338:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0338
M_PRG_CONST_STRING_0339:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SEKTOR_VON_UART_LESEN_KOMP)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (WRITELN_SER0)
        CALL       WRITELN_SER0
 
; Retten der Parameter-Register fuer PROCEDURE (SEKTOR_VON_UART_LESEN_KOMP)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xEA60)
        LDI        R16, LOW(0xEA60)
        LDI        R17, HIGH(0xEA60)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R4, R16
        MOV        R5, R17
 
; WHILE DO ...
M_WHILE_0340:
 
; WHILE - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R16, R4
        MOV        R17, R5
 
; WHILE - Ausdruck zweiter Faktor / Zahlenwert (0x0005)
        LDI        R18, LOW(0x0005)
        LDI        R19, HIGH(0x0005)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0343
        CLR        R16
        RJMP       M_VERGL_0344
M_VERGL_0343:
        SER        R16
M_VERGL_0344:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0341
        RJMP       M_WHILE_0342
M_WHILE_0341:
 
; IF THEN - Ausdruck /; BitHigh(RXC)
        IN         R16, UCSRA
        BST        R16, 7
        BRTS       M_VERGL_0348
        CLR        R16
        RJMP       M_VERGL_0349
M_VERGL_0348:
        SER        R16
M_VERGL_0349:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0345
        RJMP       M_IF_0346
M_IF_0345:
 
; Retten der lokalen Parameter fuer PROCEDURE (SEKTOR_VON_UART_LESEN_KOMP)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (STEUER_STRING_LESEN)
        CALL       STEUER_STRING_LESEN
 
; Retten der Parameter-Register fuer PROCEDURE (SEKTOR_VON_UART_LESEN_KOMP)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (SPZ)
        MOV        R16, R2
        MOV        R17, R3
 
; IF THEN - Ausdruck zweiter Faktor / Word-VAR (SEKTOR_PUFFER_ZEIGER)
        LDS        R18, SEKTOR_PUFFER_ZEIGER
        LDS        R19, SEKTOR_PUFFER_ZEIGER+1
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0353
        CLR        R16
        CLR        R16
        RJMP       M_VERGL_0354
M_VERGL_0353:
        SER        R16
M_VERGL_0354:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0350
        RJMP       M_IF_0351
M_IF_0350:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xEA60)
        LDI        R16, LOW(0xEA60)
        LDI        R17, HIGH(0xEA60)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R4, R16
        MOV        R5, R17
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0352
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0351:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0002)
        LDI        R16, LOW(0x0002)
        LDI        R17, HIGH(0x0002)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck / Word-VAR (SEKTOR_PUFFER_ZEIGER)
        LDS        R16, SEKTOR_PUFFER_ZEIGER
        LDS        R17, SEKTOR_PUFFER_ZEIGER+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (SPZ)
        MOV        R2, R16
        MOV        R3, R17
 
; IF_THEN_ELSE - Ende
M_IF_0352:
 
; IF_THEN - Ende
M_IF_0346:
 
; DEC(LESESCHLEIFE) - Word
        MOV        R24, R4
        MOV        R25, R5
        SBIW       R25:R24, 1
        MOV        R4, R24
        MOV        R5, R25
 
; WHILE DO ...
        RJMP       M_WHILE_0340
M_WHILE_0342:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R16, R4
        MOV        R17, R5
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0002)
        LDI        R18, LOW(0x0002)
        LDI        R19, HIGH(0x0002)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0358
        CLR        R16
        RJMP       M_VERGL_0359
M_VERGL_0358:
        SER        R16
M_VERGL_0359:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0355
        RJMP       M_IF_0356
M_IF_0355:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (SER0_STRING)=60
        LDI        R16, 60
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('x08')
        LDI        ZL, LOW(2*M_CONST_STRING_10)
        LDI        ZH, HIGH(2*M_CONST_STRING_10)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0360
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0360:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0362
M_PRG_CONST_STRING_0361:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0361
M_PRG_CONST_STRING_0362:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0364
        MOV        R16, R17
M_PRG_CONST_STRING_0363:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0363
M_PRG_CONST_STRING_0364:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SEKTOR_VON_UART_LESEN_KOMP)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (WRITELN_SER0)
        CALL       WRITELN_SER0
 
; Retten der Parameter-Register fuer PROCEDURE (SEKTOR_VON_UART_LESEN_KOMP)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN - Ende
M_IF_0356:
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R0
        INC        R17
        MOV        R0, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0329
 
; FOR TO DO - Ende
M_FTD_0331:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; PROCEDURE - Ende (SEKTOR_VON_UART_LESEN_KOMP)
        RET
 
; PROCEDURE - Anfang (SEKTOR_AN_UART_SENDEN)
SEKTOR_AN_UART_SENDEN:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (SEKTOR_PUFFER_ZEIGER)
        STS        SEKTOR_PUFFER_ZEIGER, R16
        STS        SEKTOR_PUFFER_ZEIGER+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R0
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0365:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0366
        RJMP       M_FTD_0367
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0366:
 
; Retten der lokalen Parameter fuer PROCEDURE (SEKTOR_AN_UART_SENDEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (BYTETOHEXSTRING)
        CALL       BYTETOHEXSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (SEKTOR_AN_UART_SENDEN)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (ANZEIGE_STRING)=80
        LDI        R16, 80
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('v')
        LDI        ZL, LOW(2*M_CONST_STRING_11)
        LDI        ZH, HIGH(2*M_CONST_STRING_11)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0368
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0368:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0370
M_PRG_CONST_STRING_0369:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0369
M_PRG_CONST_STRING_0370:
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0371
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0371:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0373
M_PRG_CONST_STRING_0372:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0372
M_PRG_CONST_STRING_0373:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ANZEIGE_STRING) - Laenge in R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0375
        MOV        R16, R17
M_PRG_CONST_STRING_0374:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0374
M_PRG_CONST_STRING_0375:
        ST         -Z, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B2)
        MOV        R1, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0F)
        LDI        R16, 0x0F
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R1
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0376:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0377
        RJMP       M_FTD_0378
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0377:
 
; ARRAY - Ausdruck / Word-VAR (SEKTOR_PUFFER_ZEIGER)
        LDS        R16, SEKTOR_PUFFER_ZEIGER
        LDS        R17, SEKTOR_PUFFER_ZEIGER+1
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B3)
        MOV        R2, R16
 
; INC(SEKTOR_PUFFER_ZEIGER) - Word
        LDS        R24, SEKTOR_PUFFER_ZEIGER
        LDS        R25, SEKTOR_PUFFER_ZEIGER+1
        ADIW       R25:R24, 1
        STS        SEKTOR_PUFFER_ZEIGER, R24
        STS        SEKTOR_PUFFER_ZEIGER+1, R25
 
; Retten der lokalen Parameter fuer PROCEDURE (SEKTOR_AN_UART_SENDEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Parameter (B3) retten
        MOV        R18, R2
 
; lokalen Parameter (B3) an Prozedur (BYTETOHEXSTRING)
        MOV        R0, R18
 
; Aufruf PROCEDURE (BYTETOHEXSTRING)
        CALL       BYTETOHEXSTRING
 
; Retten der Parameter-Register fuer PROCEDURE (SEKTOR_AN_UART_SENDEN)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (ANZEIGE_STRING)=80
        LDI        R16, 80
        CLR        R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0379
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0379:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0381
M_PRG_CONST_STRING_0380:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0380
M_PRG_CONST_STRING_0381:
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0382
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0382:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0384
M_PRG_CONST_STRING_0383:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0383
M_PRG_CONST_STRING_0384:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ANZEIGE_STRING) - Laenge in R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0386
        MOV        R16, R17
M_PRG_CONST_STRING_0385:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0385
M_PRG_CONST_STRING_0386:
        ST         -Z, R17
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R1
        INC        R17
        MOV        R1, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0376
 
; FOR TO DO - Ende
M_FTD_0378:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (SER0_STRING)=60
        LDI        R16, 60
        CLR        R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0387
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0387:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0389
M_PRG_CONST_STRING_0388:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0388
M_PRG_CONST_STRING_0389:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0391
        MOV        R16, R17
M_PRG_CONST_STRING_0390:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0390
M_PRG_CONST_STRING_0391:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (SEKTOR_AN_UART_SENDEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (WRITELN_SER0)
        CALL       WRITELN_SER0
 
; Retten der Parameter-Register fuer PROCEDURE (SEKTOR_AN_UART_SENDEN)
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R0
        INC        R17
        MOV        R0, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0365
 
; FOR TO DO - Ende
M_FTD_0367:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; PROCEDURE - Ende (SEKTOR_AN_UART_SENDEN)
        RET
 
; PROCEDURE - Anfang (DEVICE_VECTOR_VON_UART_LESEN)
DEVICE_VECTOR_VON_UART_LESEN:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (SER0_STRING)=60
        LDI        R16, 60
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('h')
        LDI        ZL, LOW(2*M_CONST_STRING_12)
        LDI        ZH, HIGH(2*M_CONST_STRING_12)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0392
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0392:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0394
M_PRG_CONST_STRING_0393:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0393
M_PRG_CONST_STRING_0394:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0396
        MOV        R16, R17
M_PRG_CONST_STRING_0395:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0395
M_PRG_CONST_STRING_0396:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (DEVICE_VECTOR_VON_UART_LESEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WRITELN_SER0)
        CALL       WRITELN_SER0
 
; Retten der Parameter-Register fuer PROCEDURE (DEVICE_VECTOR_VON_UART_LESEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (000186A0)
        LDI        R16, 0xA0
        LDI        R17, 0x86
        LDI        R18, 0x01
        LDI        R19, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R0, R16
        MOV        R1, R17
        MOV        R2, R18
        MOV        R3, R19
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DEVICE_VECTOR_GELESEN)
        STS        DEVICE_VECTOR_GELESEN, R16
 
; WHILE DO ...
M_WHILE_0397:
 
; WHILE - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R16, R0
        MOV        R17, R1
        MOV        R18, R2
        MOV        R19, R3
 
; WHILE - Ausdruck zweiter Faktor / Zahlenwert (00000005)
        LDI        R20, 0x05
        LDI        R21, 0x00
        LDI        R22, 0x00
        LDI        R23, 0x00
 
; Operator >
        CP         R20, R16
        CPC        R21, R17
        CPC        R22, R18
        CPC        R23, R19
        BRCS       M_VERGL_0400
        CLR        R16
        RJMP       M_VERGL_0401
M_VERGL_0400:
        SER        R16
M_VERGL_0401:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0398
        RJMP       M_WHILE_0399
M_WHILE_0398:
 
; IF THEN - Ausdruck /; BitHigh(RXC)
        IN         R16, UCSRA
        BST        R16, 7
        BRTS       M_VERGL_0405
        CLR        R16
        RJMP       M_VERGL_0406
M_VERGL_0405:
        SER        R16
M_VERGL_0406:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0402
        RJMP       M_IF_0403
M_IF_0402:
 
; Retten der lokalen Parameter fuer PROCEDURE (DEVICE_VECTOR_VON_UART_LESEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (STEUER_STRING_LESEN)
        CALL       STEUER_STRING_LESEN
 
; Retten der Parameter-Register fuer PROCEDURE (DEVICE_VECTOR_VON_UART_LESEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF THEN - Ausdruck / Byte-VAR (DEVICE_VECTOR_GELESEN)
        LDS        R16, DEVICE_VECTOR_GELESEN
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0407
        RJMP       M_IF_0408
M_IF_0407:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (00000002)
        LDI        R16, 0x02
        LDI        R17, 0x00
        LDI        R18, 0x00
        LDI        R19, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R0, R16
        MOV        R1, R17
        MOV        R2, R18
        MOV        R3, R19
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0409
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0408:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (000186A0)
        LDI        R16, 0xA0
        LDI        R17, 0x86
        LDI        R18, 0x01
        LDI        R19, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R0, R16
        MOV        R1, R17
        MOV        R2, R18
        MOV        R3, R19
 
; IF_THEN_ELSE - Ende
M_IF_0409:
 
; IF_THEN - Ende
M_IF_0403:
 
; DEC(LESESCHLEIFE) - DWord
        CLR        R24
        SEC
        SBC        R0, R24
        SBC        R1, R24
        SBC        R2, R24
        SBC        R3, R24
 
; WHILE DO ...
        RJMP       M_WHILE_0397
M_WHILE_0399:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R16, R0
        MOV        R17, R1
        MOV        R18, R2
        MOV        R19, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (00000002)
        LDI        R20, 0x02
        LDI        R21, 0x00
        LDI        R22, 0x00
        LDI        R23, 0x00
 
; Operator >
        CP         R20, R16
        CPC        R21, R17
        CPC        R22, R18
        CPC        R23, R19
        BRCS       M_VERGL_0413
        CLR        R16
        RJMP       M_VERGL_0414
M_VERGL_0413:
        SER        R16
M_VERGL_0414:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0410
        RJMP       M_IF_0411
M_IF_0410:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (SER0_STRING)=60
        LDI        R16, 60
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('x14')
        LDI        ZL, LOW(2*M_CONST_STRING_13)
        LDI        ZH, HIGH(2*M_CONST_STRING_13)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0415
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0415:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0417
M_PRG_CONST_STRING_0416:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0416
M_PRG_CONST_STRING_0417:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0419
        MOV        R16, R17
M_PRG_CONST_STRING_0418:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0418
M_PRG_CONST_STRING_0419:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (DEVICE_VECTOR_VON_UART_LESEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WRITELN_SER0)
        CALL       WRITELN_SER0
 
; Retten der Parameter-Register fuer PROCEDURE (DEVICE_VECTOR_VON_UART_LESEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN - Ende
M_IF_0411:
 
; PROCEDURE - Ende (DEVICE_VECTOR_VON_UART_LESEN)
        RET
 
; PROCEDURE - Anfang (CONST_VON_UART_LESEN)
CONST_VON_UART_LESEN:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (SER0_STRING)=60
        LDI        R16, 60
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('j')
        LDI        ZL, LOW(2*M_CONST_STRING_14)
        LDI        ZH, HIGH(2*M_CONST_STRING_14)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0420
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0420:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0422
M_PRG_CONST_STRING_0421:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0421
M_PRG_CONST_STRING_0422:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0424
        MOV        R16, R17
M_PRG_CONST_STRING_0423:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0423
M_PRG_CONST_STRING_0424:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (CONST_VON_UART_LESEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WRITELN_SER0)
        CALL       WRITELN_SER0
 
; Retten der Parameter-Register fuer PROCEDURE (CONST_VON_UART_LESEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (000186A0)
        LDI        R16, 0xA0
        LDI        R17, 0x86
        LDI        R18, 0x01
        LDI        R19, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R0, R16
        MOV        R1, R17
        MOV        R2, R18
        MOV        R3, R19
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (CONSOLEIN_GELESEN)
        STS        CONSOLEIN_GELESEN, R16
 
; WHILE DO ...
M_WHILE_0425:
 
; WHILE - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R16, R0
        MOV        R17, R1
        MOV        R18, R2
        MOV        R19, R3
 
; WHILE - Ausdruck zweiter Faktor / Zahlenwert (00000005)
        LDI        R20, 0x05
        LDI        R21, 0x00
        LDI        R22, 0x00
        LDI        R23, 0x00
 
; Operator >
        CP         R20, R16
        CPC        R21, R17
        CPC        R22, R18
        CPC        R23, R19
        BRCS       M_VERGL_0428
        CLR        R16
        RJMP       M_VERGL_0429
M_VERGL_0428:
        SER        R16
M_VERGL_0429:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0426
        RJMP       M_WHILE_0427
M_WHILE_0426:
 
; IF THEN - Ausdruck /; BitHigh(RXC)
        IN         R16, UCSRA
        BST        R16, 7
        BRTS       M_VERGL_0433
        CLR        R16
        RJMP       M_VERGL_0434
M_VERGL_0433:
        SER        R16
M_VERGL_0434:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0430
        RJMP       M_IF_0431
M_IF_0430:
 
; Retten der lokalen Parameter fuer PROCEDURE (CONST_VON_UART_LESEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (STEUER_STRING_LESEN)
        CALL       STEUER_STRING_LESEN
 
; Retten der Parameter-Register fuer PROCEDURE (CONST_VON_UART_LESEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF THEN - Ausdruck / Byte-VAR (CONSOLEIN_GELESEN)
        LDS        R16, CONSOLEIN_GELESEN
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0435
        RJMP       M_IF_0436
M_IF_0435:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (00000002)
        LDI        R16, 0x02
        LDI        R17, 0x00
        LDI        R18, 0x00
        LDI        R19, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R0, R16
        MOV        R1, R17
        MOV        R2, R18
        MOV        R3, R19
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0437
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0436:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (000186A0)
        LDI        R16, 0xA0
        LDI        R17, 0x86
        LDI        R18, 0x01
        LDI        R19, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R0, R16
        MOV        R1, R17
        MOV        R2, R18
        MOV        R3, R19
 
; IF_THEN_ELSE - Ende
M_IF_0437:
 
; IF_THEN - Ende
M_IF_0431:
 
; DEC(LESESCHLEIFE) - DWord
        CLR        R24
        SEC
        SBC        R0, R24
        SBC        R1, R24
        SBC        R2, R24
        SBC        R3, R24
 
; WHILE DO ...
        RJMP       M_WHILE_0425
M_WHILE_0427:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R16, R0
        MOV        R17, R1
        MOV        R18, R2
        MOV        R19, R3
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (00000002)
        LDI        R20, 0x02
        LDI        R21, 0x00
        LDI        R22, 0x00
        LDI        R23, 0x00
 
; Operator >
        CP         R20, R16
        CPC        R21, R17
        CPC        R22, R18
        CPC        R23, R19
        BRCS       M_VERGL_0441
        CLR        R16
        RJMP       M_VERGL_0442
M_VERGL_0441:
        SER        R16
M_VERGL_0442:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0438
        RJMP       M_IF_0439
M_IF_0438:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (SER0_STRING)=60
        LDI        R16, 60
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('x11')
        LDI        ZL, LOW(2*M_CONST_STRING_15)
        LDI        ZH, HIGH(2*M_CONST_STRING_15)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0443
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0443:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0445
M_PRG_CONST_STRING_0444:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0444
M_PRG_CONST_STRING_0445:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0447
        MOV        R16, R17
M_PRG_CONST_STRING_0446:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0446
M_PRG_CONST_STRING_0447:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (CONST_VON_UART_LESEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WRITELN_SER0)
        CALL       WRITELN_SER0
 
; Retten der Parameter-Register fuer PROCEDURE (CONST_VON_UART_LESEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN - Ende
M_IF_0439:
 
; PROCEDURE - Ende (CONST_VON_UART_LESEN)
        RET
 
; PROCEDURE - Anfang (CONIN_VON_UART_LESEN)
CONIN_VON_UART_LESEN:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (SER0_STRING)=60
        LDI        R16, 60
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('i')
        LDI        ZL, LOW(2*M_CONST_STRING_16)
        LDI        ZH, HIGH(2*M_CONST_STRING_16)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0448
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0448:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0450
M_PRG_CONST_STRING_0449:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0449
M_PRG_CONST_STRING_0450:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0452
        MOV        R16, R17
M_PRG_CONST_STRING_0451:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0451
M_PRG_CONST_STRING_0452:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (CONIN_VON_UART_LESEN)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (WRITELN_SER0)
        CALL       WRITELN_SER0
 
; Retten der Parameter-Register fuer PROCEDURE (CONIN_VON_UART_LESEN)
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xEA60)
        LDI        R16, LOW(0xEA60)
        LDI        R17, HIGH(0xEA60)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (CONSOLEIN_GELESEN)
        STS        CONSOLEIN_GELESEN, R16
 
; WHILE DO ...
M_WHILE_0453:
 
; WHILE - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R16, R0
        MOV        R17, R1
 
; WHILE - Ausdruck zweiter Faktor / Zahlenwert (0x0005)
        LDI        R18, LOW(0x0005)
        LDI        R19, HIGH(0x0005)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0456
        CLR        R16
        RJMP       M_VERGL_0457
M_VERGL_0456:
        SER        R16
M_VERGL_0457:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0454
        RJMP       M_WHILE_0455
M_WHILE_0454:
 
; IF THEN - Ausdruck /; BitHigh(RXC)
        IN         R16, UCSRA
        BST        R16, 7
        BRTS       M_VERGL_0461
        CLR        R16
        RJMP       M_VERGL_0462
M_VERGL_0461:
        SER        R16
M_VERGL_0462:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0458
        RJMP       M_IF_0459
M_IF_0458:
 
; Retten der lokalen Parameter fuer PROCEDURE (CONIN_VON_UART_LESEN)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (STEUER_STRING_LESEN)
        CALL       STEUER_STRING_LESEN
 
; Retten der Parameter-Register fuer PROCEDURE (CONIN_VON_UART_LESEN)
        POP        R1
        POP        R0
 
; IF THEN - Ausdruck / Byte-VAR (CONSOLEIN_GELESEN)
        LDS        R16, CONSOLEIN_GELESEN
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0463
        RJMP       M_IF_0464
M_IF_0463:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0002)
        LDI        R16, LOW(0x0002)
        LDI        R17, HIGH(0x0002)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R0, R16
        MOV        R1, R17
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0465
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0464:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xEA60)
        LDI        R16, LOW(0xEA60)
        LDI        R17, HIGH(0xEA60)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R0, R16
        MOV        R1, R17
 
; IF_THEN_ELSE - Ende
M_IF_0465:
 
; IF_THEN - Ende
M_IF_0459:
 
; DEC(LESESCHLEIFE) - Word
        MOV        R24, R0
        MOV        R25, R1
        SBIW       R25:R24, 1
        MOV        R0, R24
        MOV        R1, R25
 
; WHILE DO ...
        RJMP       M_WHILE_0453
M_WHILE_0455:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LESESCHLEIFE)
        MOV        R16, R0
        MOV        R17, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0002)
        LDI        R18, LOW(0x0002)
        LDI        R19, HIGH(0x0002)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0469
        CLR        R16
        RJMP       M_VERGL_0470
M_VERGL_0469:
        SER        R16
M_VERGL_0470:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0466
        RJMP       M_IF_0467
M_IF_0466:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (SER0_STRING)=60
        LDI        R16, 60
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('x12')
        LDI        ZL, LOW(2*M_CONST_STRING_17)
        LDI        ZH, HIGH(2*M_CONST_STRING_17)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0471
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0471:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0473
M_PRG_CONST_STRING_0472:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0472
M_PRG_CONST_STRING_0473:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0475
        MOV        R16, R17
M_PRG_CONST_STRING_0474:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0474
M_PRG_CONST_STRING_0475:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (CONIN_VON_UART_LESEN)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (WRITELN_SER0)
        CALL       WRITELN_SER0
 
; Retten der Parameter-Register fuer PROCEDURE (CONIN_VON_UART_LESEN)
        POP        R1
        POP        R0
 
; IF_THEN - Ende
M_IF_0467:
 
; PROCEDURE - Ende (CONIN_VON_UART_LESEN)
        RET
 
; PROCEDURE - Anfang (UART_CONIN_SCHLEIFE)
UART_CONIN_SCHLEIFE:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (CONSOLEIN)
        STS        CONSOLEIN, R16
 
; WHILE DO ...
M_WHILE_0476:
 
; WHILE - Ausdruck erster Faktor / Byte-VAR (CONSOLEIN)
        LDS        R16, CONSOLEIN
 
; WHILE - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0479
        CLR        R16
        RJMP       M_VERGL_0480
M_VERGL_0479:
        SER        R16
M_VERGL_0480:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0477
        RJMP       M_WHILE_0478
M_WHILE_0477:
 
; Aufruf PROCEDURE (CONST_VON_UART_LESEN)
        CALL       CONST_VON_UART_LESEN
 
; WHILE DO ...
        RJMP       M_WHILE_0476
M_WHILE_0478:
 
; Aufruf PROCEDURE (CONIN_VON_UART_LESEN)
        CALL       CONIN_VON_UART_LESEN
 
; PROCEDURE - Ende (UART_CONIN_SCHLEIFE)
        RET
 
; PROCEDURE - Anfang (UART_CONOUT_SENDEN)
UART_CONOUT_SENDEN:
 
; Byte-Parameter(1) fuer PROCEDURE (BYTETOHEXSTRING)
        LDS        R0, CONSOLEOUT
 
; Aufruf PROCEDURE (BYTETOHEXSTRING)
        CALL       BYTETOHEXSTRING
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (SER0_STRING)=60
        LDI        R16, 60
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Kopieren der String-Konstante in den Stack ('o')
        LDI        ZL, LOW(2*M_CONST_STRING_18)
        LDI        ZH, HIGH(2*M_CONST_STRING_18)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0481
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0481:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0483
M_PRG_CONST_STRING_0482:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0482
M_PRG_CONST_STRING_0483:
        LDI        ZL, LOW(BYTE_HEX_STRING)
        LDI        ZH, HIGH(BYTE_HEX_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_0484
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_0484:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_0486
M_PRG_CONST_STRING_0485:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_0485
M_PRG_CONST_STRING_0486:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_0488
        MOV        R16, R17
M_PRG_CONST_STRING_0487:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_0487
M_PRG_CONST_STRING_0488:
        ST         -Z, R17
 
; Aufruf PROCEDURE (WRITELN_SER0)
        CALL       WRITELN_SER0
 
; PROCEDURE - Ende (UART_CONOUT_SENDEN)
        RET
 
; PROCEDURE - Anfang (INIT_SPI)
INIT_SPI:
 
; SetBit(EEPROM_CS_D)
        SBI        DDRB, 4
 
; SetBit(EEPROM_MOSI_D)
        SBI        DDRB, 5
 
; SetBit(EEPROM_SCK_D)
        SBI        DDRB, 7
 
; ClearBit(EEPROM_MISO_D)
        CBI        DDRB, 6
 
; SetBit(EEPROM_CS_A)
        SBI        PORTB, 4
 
; ClearBit(EEPROM_MOSI_A)
        CBI        PORTB, 5
 
; SetBit(EEPROM_SCK_A)
        SBI        PORTB, 7
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x13)
        LDI        R16, 0x13
 
; Zuweisung Ziel /  VAR (LFD_NUMMER)
        STS        LFD_NUMMER, R16
 
; PROCEDURE - Ende (INIT_SPI)
        RET
 
; PROCEDURE - Anfang (SPI_WRITE_BYTE)
SPI_WRITE_BYTE:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (SPI_COUTER)
        MOV        R1, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R1
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0489:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0490
        RJMP       M_FTD_0491
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0490:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (SPI_BYTE)
        LDS        R16, SPI_BYTE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x80)
        LDI        R18, 0x80
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (MOSI_BYTE)
        MOV        R0, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (MOSI_BYTE)
        MOV        R16, R0
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0495
        CLR        R16
        RJMP       M_VERGL_0496
M_VERGL_0495:
        SER        R16
M_VERGL_0496:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0492
        RJMP       M_IF_0493
M_IF_0492:
 
; ClearBit(EEPROM_MOSI_A)
        CBI        PORTB, 5
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0494
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0493:
 
; SetBit(EEPROM_MOSI_A)
        SBI        PORTB, 5
 
; IF_THEN_ELSE - Ende
M_IF_0494:
 
; SHL(SPI_BYTE) - Byte
        LDS        R16, SPI_BYTE
        LSL        R16
        STS        SPI_BYTE, R16
 
; ClearBit(EEPROM_SCK_A)
        CBI        PORTB, 7
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; SetBit(EEPROM_SCK_A)
        SBI        PORTB, 7
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R1
        INC        R17
        MOV        R1, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0489
 
; FOR TO DO - Ende
M_FTD_0491:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; ClearBit(EEPROM_MOSI_A)
        CBI        PORTB, 5
 
; PROCEDURE - Ende (SPI_WRITE_BYTE)
        RET
 
; PROCEDURE - Anfang (SPI_READ_BYTE)
SPI_READ_BYTE:
 
; ClearBit(EEPROM_MOSI_A)
        CBI        PORTB, 5
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (SPI_BYTE)
        STS        SPI_BYTE, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (SPI_COUTER)
        MOV        R0, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R0
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0497:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0498
        RJMP       M_FTD_0499
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0498:
 
; ClearBit(EEPROM_SCK_A)
        CBI        PORTB, 7
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; SetBit(EEPROM_SCK_A)
        SBI        PORTB, 7
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; SHL(SPI_BYTE) - Byte
        LDS        R16, SPI_BYTE
        LSL        R16
        STS        SPI_BYTE, R16
 
; IF THEN - Ausdruck /; BitHigh(EEPROM_MISO_E)
        IN         R16, PINB
        BST        R16, 6
        BRTS       M_VERGL_0503
        CLR        R16
        RJMP       M_VERGL_0504
M_VERGL_0503:
        SER        R16
M_VERGL_0504:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0500
        RJMP       M_IF_0501
M_IF_0500:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (SPI_BYTE)
        LDS        R16, SPI_BYTE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  VAR (SPI_BYTE)
        STS        SPI_BYTE, R16
 
; IF_THEN - Ende
M_IF_0501:
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R0
        INC        R17
        MOV        R0, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0497
 
; FOR TO DO - Ende
M_FTD_0499:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; ClearBit(EEPROM_MOSI_A)
        CBI        PORTB, 5
 
; PROCEDURE - Ende (SPI_READ_BYTE)
        RET
 
; PROCEDURE - Anfang (W25Q64_READ_ONE_BYTE)
W25Q64_READ_ONE_BYTE:
 
; ClearBit(EEPROM_CS_A)
        CBI        PORTB, 4
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x03)
        LDI        R16, 0x03
 
; Zuweisung Ziel /  VAR (SPI_BYTE)
        STS        SPI_BYTE, R16
 
; Aufruf PROCEDURE (SPI_WRITE_BYTE)
        CALL       SPI_WRITE_BYTE
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (ADR_BYTE_2)
        LDS        R16, ADR_BYTE_2
 
; Zuweisung Ziel /  VAR (SPI_BYTE)
        STS        SPI_BYTE, R16
 
; Aufruf PROCEDURE (SPI_WRITE_BYTE)
        CALL       SPI_WRITE_BYTE
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (ADR_BYTE_1)
        LDS        R16, ADR_BYTE_1
 
; Zuweisung Ziel /  VAR (SPI_BYTE)
        STS        SPI_BYTE, R16
 
; Aufruf PROCEDURE (SPI_WRITE_BYTE)
        CALL       SPI_WRITE_BYTE
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (ADR_BYTE_0)
        LDS        R16, ADR_BYTE_0
 
; Zuweisung Ziel /  VAR (SPI_BYTE)
        STS        SPI_BYTE, R16
 
; Aufruf PROCEDURE (SPI_WRITE_BYTE)
        CALL       SPI_WRITE_BYTE
 
; Aufruf PROCEDURE (SPI_READ_BYTE)
        CALL       SPI_READ_BYTE
 
; SetBit(EEPROM_CS_A)
        SBI        PORTB, 4
 
; PROCEDURE - Ende (W25Q64_READ_ONE_BYTE)
        RET
 
; PROCEDURE - Anfang (W25Q64_READ_ONE_SECTOR)
W25Q64_READ_ONE_SECTOR:
 
; ClearBit(EEPROM_CS_A)
        CBI        PORTB, 4
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x03)
        LDI        R16, 0x03
 
; Zuweisung Ziel /  VAR (SPI_BYTE)
        STS        SPI_BYTE, R16
 
; Aufruf PROCEDURE (SPI_WRITE_BYTE)
        CALL       SPI_WRITE_BYTE
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (ADR_BYTE_2)
        LDS        R16, ADR_BYTE_2
 
; Zuweisung Ziel /  VAR (SPI_BYTE)
        STS        SPI_BYTE, R16
 
; Aufruf PROCEDURE (SPI_WRITE_BYTE)
        CALL       SPI_WRITE_BYTE
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (ADR_BYTE_1)
        LDS        R16, ADR_BYTE_1
 
; Zuweisung Ziel /  VAR (SPI_BYTE)
        STS        SPI_BYTE, R16
 
; Aufruf PROCEDURE (SPI_WRITE_BYTE)
        CALL       SPI_WRITE_BYTE
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (ADR_BYTE_0)
        LDS        R16, ADR_BYTE_0
 
; Zuweisung Ziel /  VAR (SPI_BYTE)
        STS        SPI_BYTE, R16
 
; Aufruf PROCEDURE (SPI_WRITE_BYTE)
        CALL       SPI_WRITE_BYTE
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (SEKTOR_PUFFER_ZEIGER)
        STS        SEKTOR_PUFFER_ZEIGER, R16
        STS        SEKTOR_PUFFER_ZEIGER+1, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x007F)
        LDI        R16, LOW(0x007F)
        LDI        R17, HIGH(0x007F)
 
; FOR TO DO - Laden des Word-Zaehlwertes
        LDS        R18, SEKTOR_PUFFER_ZEIGER
        LDS        R19, SEKTOR_PUFFER_ZEIGER+1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0505:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0506
        RJMP       M_FTD_0507
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0506:
 
; Aufruf PROCEDURE (SPI_READ_BYTE)
        CALL       SPI_READ_BYTE
 
; VAR ARRAY-1D POSITION - Ausdruck / Word-VAR (SEKTOR_PUFFER_ZEIGER)
        LDS        R16, SEKTOR_PUFFER_ZEIGER
        LDS        R17, SEKTOR_PUFFER_ZEIGER+1
 
; VAR ARRAY Ziel Zeiger berechnen (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (SPI_BYTE)
        LDS        R16, SPI_BYTE
 
; Zuweisung Ziel /  VAR ARRAY-1D (SEKTOR_PUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; FOR TO DO - (global)Word-INC-Zaehler
        LDS        R18, SEKTOR_PUFFER_ZEIGER
        LDS        R19, SEKTOR_PUFFER_ZEIGER+1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        STS        SEKTOR_PUFFER_ZEIGER, R18
        STS        SEKTOR_PUFFER_ZEIGER+1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0505
 
; FOR TO DO - Ende
M_FTD_0507:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; SetBit(EEPROM_CS_A)
        SBI        PORTB, 4
 
; PROCEDURE - Ende (W25Q64_READ_ONE_SECTOR)
        RET
 
; PROCEDURE - Anfang (W25Q64_WRITE_ONE_SECTOR)
W25Q64_WRITE_ONE_SECTOR:
 
; ClearBit(EEPROM_CS_A)
        CBI        PORTB, 4
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x06)
        LDI        R16, 0x06
 
; Zuweisung Ziel /  VAR (SPI_BYTE)
        STS        SPI_BYTE, R16
 
; Aufruf PROCEDURE (SPI_WRITE_BYTE)
        CALL       SPI_WRITE_BYTE
 
; SetBit(EEPROM_CS_A)
        SBI        PORTB, 4
 
; ClearBit(EEPROM_CS_A)
        CBI        PORTB, 4
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  VAR (SPI_BYTE)
        STS        SPI_BYTE, R16
 
; Aufruf PROCEDURE (SPI_WRITE_BYTE)
        CALL       SPI_WRITE_BYTE
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (ADR_BYTE_2)
        LDS        R16, ADR_BYTE_2
 
; Zuweisung Ziel /  VAR (SPI_BYTE)
        STS        SPI_BYTE, R16
 
; Aufruf PROCEDURE (SPI_WRITE_BYTE)
        CALL       SPI_WRITE_BYTE
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (ADR_BYTE_1)
        LDS        R16, ADR_BYTE_1
 
; Zuweisung Ziel /  VAR (SPI_BYTE)
        STS        SPI_BYTE, R16
 
; Aufruf PROCEDURE (SPI_WRITE_BYTE)
        CALL       SPI_WRITE_BYTE
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (ADR_BYTE_0)
        LDS        R16, ADR_BYTE_0
 
; Zuweisung Ziel /  VAR (SPI_BYTE)
        STS        SPI_BYTE, R16
 
; Aufruf PROCEDURE (SPI_WRITE_BYTE)
        CALL       SPI_WRITE_BYTE
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (SEKTOR_PUFFER_ZEIGER)
        STS        SEKTOR_PUFFER_ZEIGER, R16
        STS        SEKTOR_PUFFER_ZEIGER+1, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x007F)
        LDI        R16, LOW(0x007F)
        LDI        R17, HIGH(0x007F)
 
; FOR TO DO - Laden des Word-Zaehlwertes
        LDS        R18, SEKTOR_PUFFER_ZEIGER
        LDS        R19, SEKTOR_PUFFER_ZEIGER+1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0508:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0509
        RJMP       M_FTD_0510
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0509:
 
; ARRAY - Ausdruck / Word-VAR (SEKTOR_PUFFER_ZEIGER)
        LDS        R16, SEKTOR_PUFFER_ZEIGER
        LDS        R17, SEKTOR_PUFFER_ZEIGER+1
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  VAR (SPI_BYTE)
        STS        SPI_BYTE, R16
 
; Aufruf PROCEDURE (SPI_WRITE_BYTE)
        CALL       SPI_WRITE_BYTE
 
; FOR TO DO - (global)Word-INC-Zaehler
        LDS        R18, SEKTOR_PUFFER_ZEIGER
        LDS        R19, SEKTOR_PUFFER_ZEIGER+1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        STS        SEKTOR_PUFFER_ZEIGER, R18
        STS        SEKTOR_PUFFER_ZEIGER+1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0508
 
; FOR TO DO - Ende
M_FTD_0510:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; SetBit(EEPROM_CS_A)
        SBI        PORTB, 4
 
; PROCEDURE - Ende (W25Q64_WRITE_ONE_SECTOR)
        RET
 
; PROCEDURE - Anfang (FLASH_SECTOR_ERASE)
FLASH_SECTOR_ERASE:
 
; ClearBit(EEPROM_CS_A)
        CBI        PORTB, 4
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x06)
        LDI        R16, 0x06
 
; Zuweisung Ziel /  VAR (SPI_BYTE)
        STS        SPI_BYTE, R16
 
; Aufruf PROCEDURE (SPI_WRITE_BYTE)
        CALL       SPI_WRITE_BYTE
 
; SetBit(EEPROM_CS_A)
        SBI        PORTB, 4
 
; ClearBit(EEPROM_CS_A)
        CBI        PORTB, 4
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x20)
        LDI        R16, 0x20
 
; Zuweisung Ziel /  VAR (SPI_BYTE)
        STS        SPI_BYTE, R16
 
; Aufruf PROCEDURE (SPI_WRITE_BYTE)
        CALL       SPI_WRITE_BYTE
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (ADR_BYTE_2)
        LDS        R16, ADR_BYTE_2
 
; Zuweisung Ziel /  VAR (SPI_BYTE)
        STS        SPI_BYTE, R16
 
; Aufruf PROCEDURE (SPI_WRITE_BYTE)
        CALL       SPI_WRITE_BYTE
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (ADR_BYTE_1)
        LDS        R16, ADR_BYTE_1
 
; Zuweisung Ziel /  VAR (SPI_BYTE)
        STS        SPI_BYTE, R16
 
; Aufruf PROCEDURE (SPI_WRITE_BYTE)
        CALL       SPI_WRITE_BYTE
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (ADR_BYTE_0)
        LDS        R16, ADR_BYTE_0
 
; Zuweisung Ziel /  VAR (SPI_BYTE)
        STS        SPI_BYTE, R16
 
; Aufruf PROCEDURE (SPI_WRITE_BYTE)
        CALL       SPI_WRITE_BYTE
 
; SetBit(EEPROM_CS_A)
        SBI        PORTB, 4
 
; ClearBit(EEPROM_CS_A)
        CBI        PORTB, 4
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x05)
        LDI        R16, 0x05
 
; Zuweisung Ziel /  VAR (SPI_BYTE)
        STS        SPI_BYTE, R16
 
; Aufruf PROCEDURE (SPI_WRITE_BYTE)
        CALL       SPI_WRITE_BYTE
 
; Aufruf PROCEDURE (SPI_READ_BYTE)
        CALL       SPI_READ_BYTE
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (SPI_BYTE)
        LDS        R16, SPI_BYTE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  VAR (SPI_BYTE)
        STS        SPI_BYTE, R16
 
; WHILE DO ...
M_WHILE_0511:
 
; WHILE - Ausdruck erster Faktor / Byte-VAR (SPI_BYTE)
        LDS        R16, SPI_BYTE
 
; WHILE - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_0514
        CLR        R16
        RJMP       M_VERGL_0515
M_VERGL_0514:
        SER        R16
M_VERGL_0515:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0512
        RJMP       M_WHILE_0513
M_WHILE_0512:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x05)
        LDI        R16, 0x05
 
; Zuweisung Ziel /  VAR (SPI_BYTE)
        STS        SPI_BYTE, R16
 
; Aufruf PROCEDURE (SPI_WRITE_BYTE)
        CALL       SPI_WRITE_BYTE
 
; Aufruf PROCEDURE (SPI_READ_BYTE)
        CALL       SPI_READ_BYTE
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (SPI_BYTE)
        LDS        R16, SPI_BYTE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  VAR (SPI_BYTE)
        STS        SPI_BYTE, R16
 
; WHILE DO ...
        RJMP       M_WHILE_0511
M_WHILE_0513:
 
; SetBit(EEPROM_CS_A)
        SBI        PORTB, 4
 
; PROCEDURE - Ende (FLASH_SECTOR_ERASE)
        RET
 
; PROCEDURE - Anfang (FLASH_CHIP_ERASE)
FLASH_CHIP_ERASE:
 
; ClearBit(EEPROM_CS_A)
        CBI        PORTB, 4
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x06)
        LDI        R16, 0x06
 
; Zuweisung Ziel /  VAR (SPI_BYTE)
        STS        SPI_BYTE, R16
 
; Aufruf PROCEDURE (SPI_WRITE_BYTE)
        CALL       SPI_WRITE_BYTE
 
; SetBit(EEPROM_CS_A)
        SBI        PORTB, 4
 
; ClearBit(EEPROM_CS_A)
        CBI        PORTB, 4
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xC7)
        LDI        R16, 0xC7
 
; Zuweisung Ziel /  VAR (SPI_BYTE)
        STS        SPI_BYTE, R16
 
; Aufruf PROCEDURE (SPI_WRITE_BYTE)
        CALL       SPI_WRITE_BYTE
 
; SetBit(EEPROM_CS_A)
        SBI        PORTB, 4
 
; ClearBit(EEPROM_CS_A)
        CBI        PORTB, 4
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x05)
        LDI        R16, 0x05
 
; Zuweisung Ziel /  VAR (SPI_BYTE)
        STS        SPI_BYTE, R16
 
; Aufruf PROCEDURE (SPI_WRITE_BYTE)
        CALL       SPI_WRITE_BYTE
 
; Aufruf PROCEDURE (SPI_READ_BYTE)
        CALL       SPI_READ_BYTE
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (SPI_BYTE)
        LDS        R16, SPI_BYTE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  VAR (SPI_BYTE)
        STS        SPI_BYTE, R16
 
; WHILE DO ...
M_WHILE_0516:
 
; WHILE - Ausdruck erster Faktor / Byte-VAR (SPI_BYTE)
        LDS        R16, SPI_BYTE
 
; WHILE - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_0519
        CLR        R16
        RJMP       M_VERGL_0520
M_VERGL_0519:
        SER        R16
M_VERGL_0520:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0517
        RJMP       M_WHILE_0518
M_WHILE_0517:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x05)
        LDI        R16, 0x05
 
; Zuweisung Ziel /  VAR (SPI_BYTE)
        STS        SPI_BYTE, R16
 
; Aufruf PROCEDURE (SPI_WRITE_BYTE)
        CALL       SPI_WRITE_BYTE
 
; Aufruf PROCEDURE (SPI_READ_BYTE)
        CALL       SPI_READ_BYTE
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (SPI_BYTE)
        LDS        R16, SPI_BYTE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  VAR (SPI_BYTE)
        STS        SPI_BYTE, R16
 
; WHILE DO ...
        RJMP       M_WHILE_0516
M_WHILE_0518:
 
; SetBit(EEPROM_CS_A)
        SBI        PORTB, 4
 
; PROCEDURE - Ende (FLASH_CHIP_ERASE)
        RET
 
; PROCEDURE - Anfang (SDA_SET)
SDA_SET:
 
; SetBit(SDA_I2C_A)
        SBI        PORTD, 3
 
; PROCEDURE - Ende (SDA_SET)
        RET
 
; PROCEDURE - Anfang (SCL_SET)
SCL_SET:
 
; SetBit(SCL_I2C_A)
        SBI        PORTD, 2
 
; PROCEDURE - Ende (SCL_SET)
        RET
 
; PROCEDURE - Anfang (SDA_CLEAR)
SDA_CLEAR:
 
; ClearBit(SDA_I2C_A)
        CBI        PORTD, 3
 
; PROCEDURE - Ende (SDA_CLEAR)
        RET
 
; PROCEDURE - Anfang (SCL_CLEAR)
SCL_CLEAR:
 
; ClearBit(SCL_I2C_A)
        CBI        PORTD, 2
 
; PROCEDURE - Ende (SCL_CLEAR)
        RET
 
; PROCEDURE - Anfang (SDA_OUT)
SDA_OUT:
 
; SetBit(SDA_I2C_D)
        SBI        DDRD, 3
 
; PROCEDURE - Ende (SDA_OUT)
        RET
 
; PROCEDURE - Anfang (SDA_IN)
SDA_IN:
 
; ClearBit(SDA_I2C_D)
        CBI        DDRD, 3
 
; PROCEDURE - Ende (SDA_IN)
        RET
 
; PROCEDURE - Anfang (SCL_OUT)
SCL_OUT:
 
; SetBit(SCL_I2C_D)
        SBI        DDRD, 2
 
; PROCEDURE - Ende (SCL_OUT)
        RET
 
; FUNCTION - Anfang (SDA_READ)
SDA_READ:
 
; IF THEN - Ausdruck /; BitHigh(SDA_I2C_E)
        IN         R16, PIND
        BST        R16, 3
        BRTS       M_VERGL_0524
        CLR        R16
        RJMP       M_VERGL_0525
M_VERGL_0524:
        SER        R16
M_VERGL_0525:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0521
        RJMP       M_IF_0522
M_IF_0521:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0523
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0522:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF_THEN_ELSE - Ende
M_IF_0523:
 
; RESULT Byte-Variable - FUNCTION (SDA_READ)
        MOV        R0, R1
 
; Ende Byte - FUNCTION (SDA_READ)
        MOV        R16, R0
 
; FUNCTION - Ende (SDA_READ)
        RET
 
; PROCEDURE - Anfang (INIT_I2C)
INIT_I2C:
 
; Aufruf PROCEDURE (SDA_SET)
        CALL       SDA_SET
 
; Aufruf PROCEDURE (SCL_SET)
        CALL       SCL_SET
 
; Aufruf PROCEDURE (SDA_OUT)
        CALL       SDA_OUT
 
; Aufruf PROCEDURE (SCL_OUT)
        CALL       SCL_OUT
 
; Aufruf PROCEDURE (SDA_SET)
        CALL       SDA_SET
 
; Aufruf PROCEDURE (SCL_SET)
        CALL       SCL_SET
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (FLASH_ADDRESS)
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; PROCEDURE - Ende (INIT_I2C)
        RET
 
; FUNCTION - Anfang (DS_SHIFT_IN_NACK)
DS_SHIFT_IN_NACK:
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_IN_NACK)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SDA_IN)
        CALL       SDA_IN
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_IN_NACK)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DS_DATA)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DS_COUTER)
        MOV        R2, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R2
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0526:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0527
        RJMP       M_FTD_0528
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0527:
 
; SHL(DS_DATA) - Byte
        LSL        R1
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_IN_NACK)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf Funktion (SDA_READ)
        CALL       SDA_READ
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_IN_NACK)
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0529
        RJMP       M_IF_0530
M_IF_0529:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (DS_DATA)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DS_DATA)
        MOV        R1, R16
 
; IF_THEN - Ende
M_IF_0530:
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_IN_NACK)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SCL_SET)
        CALL       SCL_SET
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_IN_NACK)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_IN_NACK)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SCL_CLEAR)
        CALL       SCL_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_IN_NACK)
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R2
        INC        R17
        MOV        R2, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0526
 
; FOR TO DO - Ende
M_FTD_0528:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_IN_NACK)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SDA_OUT)
        CALL       SDA_OUT
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_IN_NACK)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_IN_NACK)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SDA_SET)
        CALL       SDA_SET
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_IN_NACK)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_IN_NACK)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SCL_SET)
        CALL       SCL_SET
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_IN_NACK)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_IN_NACK)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SCL_CLEAR)
        CALL       SCL_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_IN_NACK)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_IN_NACK)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SDA_CLEAR)
        CALL       SDA_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_IN_NACK)
        POP        R2
        POP        R1
        POP        R0
 
; RESULT Byte-Variable - FUNCTION (DS_SHIFT_IN_NACK)
        MOV        R0, R1
 
; Ende Byte - FUNCTION (DS_SHIFT_IN_NACK)
        MOV        R16, R0
 
; FUNCTION - Ende (DS_SHIFT_IN_NACK)
        RET
 
; FUNCTION - Anfang (DS_SHIFT_IN_ACK)
DS_SHIFT_IN_ACK:
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_IN_ACK)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SDA_IN)
        CALL       SDA_IN
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_IN_ACK)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DS_DATA)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DS_COUTER)
        MOV        R2, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R2
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0532:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0533
        RJMP       M_FTD_0534
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0533:
 
; SHL(DS_DATA) - Byte
        LSL        R1
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_IN_ACK)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf Funktion (SDA_READ)
        CALL       SDA_READ
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_IN_ACK)
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0535
        RJMP       M_IF_0536
M_IF_0535:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (DS_DATA)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DS_DATA)
        MOV        R1, R16
 
; IF_THEN - Ende
M_IF_0536:
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_IN_ACK)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SCL_SET)
        CALL       SCL_SET
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_IN_ACK)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_IN_ACK)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SCL_CLEAR)
        CALL       SCL_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_IN_ACK)
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R2
        INC        R17
        MOV        R2, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0532
 
; FOR TO DO - Ende
M_FTD_0534:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_IN_ACK)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SDA_CLEAR)
        CALL       SDA_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_IN_ACK)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_IN_ACK)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SDA_OUT)
        CALL       SDA_OUT
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_IN_ACK)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_IN_ACK)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SDA_CLEAR)
        CALL       SDA_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_IN_ACK)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_IN_ACK)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SCL_SET)
        CALL       SCL_SET
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_IN_ACK)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_IN_ACK)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SCL_CLEAR)
        CALL       SCL_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_IN_ACK)
        POP        R2
        POP        R1
        POP        R0
 
; RESULT Byte-Variable - FUNCTION (DS_SHIFT_IN_ACK)
        MOV        R0, R1
 
; Ende Byte - FUNCTION (DS_SHIFT_IN_ACK)
        MOV        R16, R0
 
; FUNCTION - Ende (DS_SHIFT_IN_ACK)
        RET
 
; FUNCTION - Anfang (DS_SHIFT_OUT)
DS_SHIFT_OUT:
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_OUT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Aufruf PROCEDURE (SDA_CLEAR)
        CALL       SDA_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_OUT)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_OUT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Aufruf PROCEDURE (SDA_OUT)
        CALL       SDA_OUT
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_OUT)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_OUT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Aufruf PROCEDURE (SDA_CLEAR)
        CALL       SDA_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_OUT)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DS_COUTER)
        MOV        R2, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x07)
        LDI        R16, 0x07
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R2
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0538:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0539
        RJMP       M_FTD_0540
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0539:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (DS_DATA)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x80)
        LDI        R18, 0x80
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DS_DATA_2)
        MOV        R4, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (DS_DATA_2)
        MOV        R16, R4
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0544
        CLR        R16
        RJMP       M_VERGL_0545
M_VERGL_0544:
        SER        R16
M_VERGL_0545:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0541
        RJMP       M_IF_0542
M_IF_0541:
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_OUT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Aufruf PROCEDURE (SDA_CLEAR)
        CALL       SDA_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_OUT)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0543
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0542:
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_OUT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Aufruf PROCEDURE (SDA_SET)
        CALL       SDA_SET
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_OUT)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Ende
M_IF_0543:
 
; SHL(DS_DATA) - Byte
        LSL        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_OUT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Aufruf PROCEDURE (SCL_SET)
        CALL       SCL_SET
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_OUT)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_OUT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Aufruf PROCEDURE (SCL_CLEAR)
        CALL       SCL_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_OUT)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R2
        INC        R17
        MOV        R2, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0538
 
; FOR TO DO - Ende
M_FTD_0540:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_OUT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Aufruf PROCEDURE (SDA_IN)
        CALL       SDA_IN
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_OUT)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_OUT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Aufruf PROCEDURE (SCL_SET)
        CALL       SCL_SET
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_OUT)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_OUT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Aufruf Funktion (SDA_READ)
        CALL       SDA_READ
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_OUT)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0546
        RJMP       M_IF_0547
M_IF_0546:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DS_RESULT)
        MOV        R3, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0548
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0547:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DS_RESULT)
        MOV        R3, R16
 
; IF_THEN_ELSE - Ende
M_IF_0548:
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_OUT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Aufruf PROCEDURE (SCL_CLEAR)
        CALL       SCL_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_OUT)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_OUT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Aufruf PROCEDURE (SDA_CLEAR)
        CALL       SDA_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_OUT)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_OUT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Aufruf PROCEDURE (SDA_OUT)
        CALL       SDA_OUT
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_OUT)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (DS_SHIFT_OUT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Aufruf PROCEDURE (SDA_CLEAR)
        CALL       SDA_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (DS_SHIFT_OUT)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; RESULT Byte-Variable - FUNCTION (DS_SHIFT_OUT)
        MOV        R1, R3
 
; Ende Byte - FUNCTION (DS_SHIFT_OUT)
        MOV        R16, R1
 
; FUNCTION - Ende (DS_SHIFT_OUT)
        RET
 
; FUNCTION - Anfang (I2C_DEVICE_ADDRESS_TO_WRITE)
I2C_DEVICE_ADDRESS_TO_WRITE:
 
; SHL(I2C_ADDRESS) - Byte
        LSL        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (I2C_DEVICE_ADDRESS_TO_WRITE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf Funktion (DS_SHIFT_OUT)
        CALL       DS_SHIFT_OUT
 
; Retten der Parameter-Register fuer PROCEDURE (I2C_DEVICE_ADDRESS_TO_WRITE)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DS_RESULT)
        MOV        R2, R16
 
; RESULT Byte-Variable - FUNCTION (I2C_DEVICE_ADDRESS_TO_WRITE)
        MOV        R1, R2
 
; Ende Byte - FUNCTION (I2C_DEVICE_ADDRESS_TO_WRITE)
        MOV        R16, R1
 
; FUNCTION - Ende (I2C_DEVICE_ADDRESS_TO_WRITE)
        RET
 
; FUNCTION - Anfang (I2C_DEVICE_ADDRESS_TO_READ)
I2C_DEVICE_ADDRESS_TO_READ:
 
; SHL(I2C_ADDRESS) - Byte
        LSL        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (I2C_ADDRESS)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokaler Uebergabeparameter (I2C_ADDRESS)
        MOV        R0, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (I2C_DEVICE_ADDRESS_TO_READ)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf Funktion (DS_SHIFT_OUT)
        CALL       DS_SHIFT_OUT
 
; Retten der Parameter-Register fuer PROCEDURE (I2C_DEVICE_ADDRESS_TO_READ)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DS_RESULT)
        MOV        R2, R16
 
; RESULT Byte-Variable - FUNCTION (I2C_DEVICE_ADDRESS_TO_READ)
        MOV        R1, R2
 
; Ende Byte - FUNCTION (I2C_DEVICE_ADDRESS_TO_READ)
        MOV        R16, R1
 
; FUNCTION - Ende (I2C_DEVICE_ADDRESS_TO_READ)
        RET
 
; PROCEDURE - Anfang (AT_DATA_WRITE_WORD_ADDRESS)
AT_DATA_WRITE_WORD_ADDRESS:
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_WORD_ADDRESS)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (SDA_CLEAR)
        CALL       SDA_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_WORD_ADDRESS)
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_WORD_ADDRESS)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (SCL_CLEAR)
        CALL       SCL_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_WORD_ADDRESS)
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_WORD_ADDRESS)
        PUSH       R0
        PUSH       R1
 
; Byte-Parameter(1) fuer FUNCTION (I2C_DEVICE_ADDRESS_TO_WRITE)
        LDI        R16, 0x50
        MOV        R0, R16
 
; Aufruf Funktion (I2C_DEVICE_ADDRESS_TO_WRITE)
        CALL       I2C_DEVICE_ADDRESS_TO_WRITE
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_WORD_ADDRESS)
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_ACK)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(FLASH_ADDRESS)
        LDS        R16, FLASH_ADDRESS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_WORD_ADDRESS)
        PUSH       R0
        PUSH       R1
 
; Aufruf Funktion (DS_SHIFT_OUT)
        CALL       DS_SHIFT_OUT
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_WORD_ADDRESS)
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_ACK)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(FLASH_ADDRESS)
        LDS        R16, FLASH_ADDRESS
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_WORD_ADDRESS)
        PUSH       R0
        PUSH       R1
 
; Aufruf Funktion (DS_SHIFT_OUT)
        CALL       DS_SHIFT_OUT
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_WORD_ADDRESS)
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_ACK)
        MOV        R1, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_WORD_ADDRESS)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (SCL_SET)
        CALL       SCL_SET
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_WORD_ADDRESS)
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_WORD_ADDRESS)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (SDA_SET)
        CALL       SDA_SET
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_WORD_ADDRESS)
        POP        R1
        POP        R0
 
; PROCEDURE - Ende (AT_DATA_WRITE_WORD_ADDRESS)
        RET
 
; FUNCTION - Anfang (AT_DATA_READ_ONE_BYTE)
AT_DATA_READ_ONE_BYTE:
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_READ_ONE_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (AT_DATA_WRITE_WORD_ADDRESS)
        CALL       AT_DATA_WRITE_WORD_ADDRESS
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_READ_ONE_BYTE)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_READ_ONE_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SDA_CLEAR)
        CALL       SDA_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_READ_ONE_BYTE)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_READ_ONE_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SCL_CLEAR)
        CALL       SCL_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_READ_ONE_BYTE)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_READ_ONE_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Byte-Parameter(1) fuer FUNCTION (I2C_DEVICE_ADDRESS_TO_READ)
        LDI        R16, 0x50
        MOV        R0, R16
 
; Aufruf Funktion (I2C_DEVICE_ADDRESS_TO_READ)
        CALL       I2C_DEVICE_ADDRESS_TO_READ
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_READ_ONE_BYTE)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_ACK)
        MOV        R2, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_READ_ONE_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf Funktion (DS_SHIFT_IN_NACK)
        CALL       DS_SHIFT_IN_NACK
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_READ_ONE_BYTE)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DS_DATA)
        MOV        R1, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_READ_ONE_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SCL_SET)
        CALL       SCL_SET
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_READ_ONE_BYTE)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_READ_ONE_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SDA_SET)
        CALL       SDA_SET
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_READ_ONE_BYTE)
        POP        R2
        POP        R1
        POP        R0
 
; RESULT Byte-Variable - FUNCTION (AT_DATA_READ_ONE_BYTE)
        MOV        R0, R1
 
; Ende Byte - FUNCTION (AT_DATA_READ_ONE_BYTE)
        MOV        R16, R0
 
; FUNCTION - Ende (AT_DATA_READ_ONE_BYTE)
        RET
 
; PROCEDURE - Anfang (AT_READ_DATA_ARRAY)
AT_READ_DATA_ARRAY:
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_READ_DATA_ARRAY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (AT_DATA_WRITE_WORD_ADDRESS)
        CALL       AT_DATA_WRITE_WORD_ADDRESS
 
; Retten der Parameter-Register fuer PROCEDURE (AT_READ_DATA_ARRAY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_READ_DATA_ARRAY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (SDA_CLEAR)
        CALL       SDA_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (AT_READ_DATA_ARRAY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_READ_DATA_ARRAY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (SCL_CLEAR)
        CALL       SCL_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (AT_READ_DATA_ARRAY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_READ_DATA_ARRAY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer FUNCTION (I2C_DEVICE_ADDRESS_TO_READ)
        LDI        R16, 0x50
        MOV        R0, R16
 
; Aufruf Funktion (I2C_DEVICE_ADDRESS_TO_READ)
        CALL       I2C_DEVICE_ADDRESS_TO_READ
 
; Retten der Parameter-Register fuer PROCEDURE (AT_READ_DATA_ARRAY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_ACK)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RBA_COUNTER)
        MOV        R2, R16
        MOV        R3, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x007E)
        LDI        R16, LOW(0x007E)
        LDI        R17, HIGH(0x007E)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R2
        MOV        R19, R3
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0549:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0550
        RJMP       M_FTD_0551
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0550:
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_READ_DATA_ARRAY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf Funktion (DS_SHIFT_IN_ACK)
        CALL       DS_SHIFT_IN_ACK
 
; Retten der Parameter-Register fuer PROCEDURE (AT_READ_DATA_ARRAY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RBA_DATA)
        MOV        R0, R16
 
; VAR ARRAY-1D POSITION - Ausdruck / lokale, dynamische Variable VAR (RBA_COUNTER)
        MOV        R16, R2
        MOV        R17, R3
 
; VAR ARRAY Ziel Zeiger berechnen (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (RBA_DATA)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR ARRAY-1D (SEKTOR_PUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R2
        MOV        R19, R3
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0549
 
; FOR TO DO - Ende
M_FTD_0551:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_READ_DATA_ARRAY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf Funktion (DS_SHIFT_IN_NACK)
        CALL       DS_SHIFT_IN_NACK
 
; Retten der Parameter-Register fuer PROCEDURE (AT_READ_DATA_ARRAY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RBA_DATA)
        MOV        R0, R16
 
; VAR ARRAY-1D POSITION - Ausdruck / Zahlenwert (0x007F)
        LDI        R16, LOW(0x007F)
        LDI        R17, HIGH(0x007F)
 
; VAR ARRAY Ziel Zeiger berechnen (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (RBA_DATA)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR ARRAY-1D (SEKTOR_PUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_READ_DATA_ARRAY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (SCL_SET)
        CALL       SCL_SET
 
; Retten der Parameter-Register fuer PROCEDURE (AT_READ_DATA_ARRAY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_READ_DATA_ARRAY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (SDA_SET)
        CALL       SDA_SET
 
; Retten der Parameter-Register fuer PROCEDURE (AT_READ_DATA_ARRAY)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; PROCEDURE - Ende (AT_READ_DATA_ARRAY)
        RET
 
; PROCEDURE - Anfang (AT_DATA_WRITE_ONE_BYTE_WAIT)
AT_DATA_WRITE_ONE_BYTE_WAIT:
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SDA_CLEAR)
        CALL       SDA_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SCL_CLEAR)
        CALL       SCL_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Byte-Parameter(1) fuer FUNCTION (I2C_DEVICE_ADDRESS_TO_WRITE)
        LDI        R16, 0x50
        MOV        R0, R16
 
; Aufruf Funktion (I2C_DEVICE_ADDRESS_TO_WRITE)
        CALL       I2C_DEVICE_ADDRESS_TO_WRITE
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_ACK)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(FLASH_ADDRESS)
        LDS        R16, FLASH_ADDRESS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Parameter (B1) retten
        MOV        R18, R2
 
; lokalen Parameter (B1) an Funktion (DS_SHIFT_OUT)
        MOV        R0, R18
 
; Aufruf Funktion (DS_SHIFT_OUT)
        CALL       DS_SHIFT_OUT
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_ACK)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(FLASH_ADDRESS)
        LDS        R16, FLASH_ADDRESS
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Parameter (B1) retten
        MOV        R18, R2
 
; lokalen Parameter (B1) an Funktion (DS_SHIFT_OUT)
        MOV        R0, R18
 
; Aufruf Funktion (DS_SHIFT_OUT)
        CALL       DS_SHIFT_OUT
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_ACK)
        MOV        R1, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf Funktion (DS_SHIFT_OUT)
        CALL       DS_SHIFT_OUT
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_ACK)
        MOV        R1, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SCL_SET)
        CALL       SCL_SET
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SDA_SET)
        CALL       SDA_SET
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SDA_CLEAR)
        CALL       SDA_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SCL_CLEAR)
        CALL       SCL_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Byte-Parameter(1) fuer FUNCTION (I2C_DEVICE_ADDRESS_TO_WRITE)
        LDI        R16, 0x50
        MOV        R0, R16
 
; Aufruf Funktion (I2C_DEVICE_ADDRESS_TO_WRITE)
        CALL       I2C_DEVICE_ADDRESS_TO_WRITE
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_ACK)
        MOV        R1, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SCL_SET)
        CALL       SCL_SET
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SDA_SET)
        CALL       SDA_SET
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        POP        R2
        POP        R1
        POP        R0
 
; WHILE DO ...
M_WHILE_0552:
 
; WHILE - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADDRESS_ACK)
        MOV        R16, R1
 
; WHILE - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0555
        CLR        R16
        RJMP       M_VERGL_0556
M_VERGL_0555:
        SER        R16
M_VERGL_0556:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0553
        RJMP       M_WHILE_0554
M_WHILE_0553:
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SDA_CLEAR)
        CALL       SDA_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SCL_CLEAR)
        CALL       SCL_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Byte-Parameter(1) fuer FUNCTION (I2C_DEVICE_ADDRESS_TO_WRITE)
        LDI        R16, 0x50
        MOV        R0, R16
 
; Aufruf Funktion (I2C_DEVICE_ADDRESS_TO_WRITE)
        CALL       I2C_DEVICE_ADDRESS_TO_WRITE
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_ACK)
        MOV        R1, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SCL_SET)
        CALL       SCL_SET
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SDA_SET)
        CALL       SDA_SET
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        POP        R2
        POP        R1
        POP        R0
 
; WHILE DO ...
        RJMP       M_WHILE_0552
M_WHILE_0554:
 
; PROCEDURE - Ende (AT_DATA_WRITE_ONE_BYTE_WAIT)
        RET
 
; PROCEDURE - Anfang (AT_DATA_WRITE_ONE_BYTE_NO_WAIT)
AT_DATA_WRITE_ONE_BYTE_NO_WAIT:
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_NO_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SDA_CLEAR)
        CALL       SDA_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_NO_WAIT)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_NO_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SCL_CLEAR)
        CALL       SCL_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_NO_WAIT)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_NO_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Byte-Parameter(1) fuer FUNCTION (I2C_DEVICE_ADDRESS_TO_WRITE)
        LDI        R16, 0x50
        MOV        R0, R16
 
; Aufruf Funktion (I2C_DEVICE_ADDRESS_TO_WRITE)
        CALL       I2C_DEVICE_ADDRESS_TO_WRITE
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_NO_WAIT)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_ACK)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(FLASH_ADDRESS)
        LDS        R16, FLASH_ADDRESS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_NO_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Parameter (B1) retten
        MOV        R18, R2
 
; lokalen Parameter (B1) an Funktion (DS_SHIFT_OUT)
        MOV        R0, R18
 
; Aufruf Funktion (DS_SHIFT_OUT)
        CALL       DS_SHIFT_OUT
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_NO_WAIT)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_ACK)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(FLASH_ADDRESS)
        LDS        R16, FLASH_ADDRESS
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_NO_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Parameter (B1) retten
        MOV        R18, R2
 
; lokalen Parameter (B1) an Funktion (DS_SHIFT_OUT)
        MOV        R0, R18
 
; Aufruf Funktion (DS_SHIFT_OUT)
        CALL       DS_SHIFT_OUT
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_NO_WAIT)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_ACK)
        MOV        R1, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_NO_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf Funktion (DS_SHIFT_OUT)
        CALL       DS_SHIFT_OUT
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_NO_WAIT)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_ACK)
        MOV        R1, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_NO_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SCL_SET)
        CALL       SCL_SET
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_NO_WAIT)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_NO_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SDA_SET)
        CALL       SDA_SET
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_NO_WAIT)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_NO_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SDA_CLEAR)
        CALL       SDA_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_NO_WAIT)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_NO_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SCL_CLEAR)
        CALL       SCL_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_NO_WAIT)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_NO_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Byte-Parameter(1) fuer FUNCTION (I2C_DEVICE_ADDRESS_TO_WRITE)
        LDI        R16, 0x50
        MOV        R0, R16
 
; Aufruf Funktion (I2C_DEVICE_ADDRESS_TO_WRITE)
        CALL       I2C_DEVICE_ADDRESS_TO_WRITE
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_NO_WAIT)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_ACK)
        MOV        R1, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_NO_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SCL_SET)
        CALL       SCL_SET
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_NO_WAIT)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_NO_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (SDA_SET)
        CALL       SDA_SET
 
; Retten der Parameter-Register fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_NO_WAIT)
        POP        R2
        POP        R1
        POP        R0
 
; PROCEDURE - Ende (AT_DATA_WRITE_ONE_BYTE_NO_WAIT)
        RET
 
; PROCEDURE - Anfang (AT_WRITE_DATA_ARRAY_WAIT)
AT_WRITE_DATA_ARRAY_WAIT:
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (SDA_CLEAR)
        CALL       SDA_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (SCL_CLEAR)
        CALL       SCL_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer FUNCTION (I2C_DEVICE_ADDRESS_TO_WRITE)
        LDI        R16, 0x50
        MOV        R0, R16
 
; Aufruf Funktion (I2C_DEVICE_ADDRESS_TO_WRITE)
        CALL       I2C_DEVICE_ADDRESS_TO_WRITE
 
; Retten der Parameter-Register fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_ACK)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(FLASH_ADDRESS)
        LDS        R16, FLASH_ADDRESS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DATA_BYTE)
        MOV        R3, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (DATA_BYTE) retten
        MOV        R19, R3
 
; lokalen Parameter (DATA_BYTE) an Funktion (DS_SHIFT_OUT)
        MOV        R0, R19
 
; Aufruf Funktion (DS_SHIFT_OUT)
        CALL       DS_SHIFT_OUT
 
; Retten der Parameter-Register fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_ACK)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(FLASH_ADDRESS)
        LDS        R16, FLASH_ADDRESS
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DATA_BYTE)
        MOV        R3, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (DATA_BYTE) retten
        MOV        R19, R3
 
; lokalen Parameter (DATA_BYTE) an Funktion (DS_SHIFT_OUT)
        MOV        R0, R19
 
; Aufruf Funktion (DS_SHIFT_OUT)
        CALL       DS_SHIFT_OUT
 
; Retten der Parameter-Register fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_ACK)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_COUNTER)
        MOV        R1, R16
        MOV        R2, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x007F)
        LDI        R16, LOW(0x007F)
        LDI        R17, HIGH(0x007F)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R1
        MOV        R19, R2
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0557:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0558
        RJMP       M_FTD_0559
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0558:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (ADDRESS_COUNTER)
        MOV        R16, R1
        MOV        R17, R2
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DATA_BYTE)
        MOV        R3, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (DATA_BYTE) retten
        MOV        R19, R3
 
; lokalen Parameter (DATA_BYTE) an Funktion (DS_SHIFT_OUT)
        MOV        R0, R19
 
; Aufruf Funktion (DS_SHIFT_OUT)
        CALL       DS_SHIFT_OUT
 
; Retten der Parameter-Register fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_ACK)
        MOV        R0, R16
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R1
        MOV        R19, R2
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R1, R18
        MOV        R2, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0557
 
; FOR TO DO - Ende
M_FTD_0559:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (SCL_SET)
        CALL       SCL_SET
 
; Retten der Parameter-Register fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (SDA_SET)
        CALL       SDA_SET
 
; Retten der Parameter-Register fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (SDA_CLEAR)
        CALL       SDA_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (SCL_CLEAR)
        CALL       SCL_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer FUNCTION (I2C_DEVICE_ADDRESS_TO_WRITE)
        LDI        R16, 0x50
        MOV        R0, R16
 
; Aufruf Funktion (I2C_DEVICE_ADDRESS_TO_WRITE)
        CALL       I2C_DEVICE_ADDRESS_TO_WRITE
 
; Retten der Parameter-Register fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_ACK)
        MOV        R0, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (SCL_SET)
        CALL       SCL_SET
 
; Retten der Parameter-Register fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (SDA_SET)
        CALL       SDA_SET
 
; Retten der Parameter-Register fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; WHILE DO ...
M_WHILE_0560:
 
; WHILE - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADDRESS_ACK)
        MOV        R16, R0
 
; WHILE - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0563
        CLR        R16
        RJMP       M_VERGL_0564
M_VERGL_0563:
        SER        R16
M_VERGL_0564:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0561
        RJMP       M_WHILE_0562
M_WHILE_0561:
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (SDA_CLEAR)
        CALL       SDA_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (SCL_CLEAR)
        CALL       SCL_CLEAR
 
; Retten der Parameter-Register fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer FUNCTION (I2C_DEVICE_ADDRESS_TO_WRITE)
        LDI        R16, 0x50
        MOV        R0, R16
 
; Aufruf Funktion (I2C_DEVICE_ADDRESS_TO_WRITE)
        CALL       I2C_DEVICE_ADDRESS_TO_WRITE
 
; Retten der Parameter-Register fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_ACK)
        MOV        R0, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (SCL_SET)
        CALL       SCL_SET
 
; Retten der Parameter-Register fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (SDA_SET)
        CALL       SDA_SET
 
; Retten der Parameter-Register fuer PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; WHILE DO ...
        RJMP       M_WHILE_0560
M_WHILE_0562:
 
; PROCEDURE - Ende (AT_WRITE_DATA_ARRAY_WAIT)
        RET
 
; PROCEDURE - Anfang (FORMAT_DIR)
FORMAT_DIR:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_COUNTER)
        MOV        R1, R16
        MOV        R2, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x007F)
        LDI        R16, LOW(0x007F)
        LDI        R17, HIGH(0x007F)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R1
        MOV        R19, R2
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0565:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0566
        RJMP       M_FTD_0567
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0566:
 
; VAR ARRAY-1D POSITION - Ausdruck / lokale, dynamische Variable VAR (ADDRESS_COUNTER)
        MOV        R16, R1
        MOV        R17, R2
 
; VAR ARRAY Ziel Zeiger berechnen (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xE5)
        LDI        R16, 0xE5
 
; Zuweisung Ziel /  VAR ARRAY-1D (SEKTOR_PUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R1
        MOV        R19, R2
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R1, R18
        MOV        R2, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0565
 
; FOR TO DO - Ende
M_FTD_0567:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_COUNTER)
        MOV        R1, R16
        MOV        R2, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x007F)
        LDI        R16, LOW(0x007F)
        LDI        R17, HIGH(0x007F)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R1
        MOV        R19, R2
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0568:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0569
        RJMP       M_FTD_0570
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0569:
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (ADDRESS_COUNTER)
        MOV        R16, R1
        MOV        R17, R2
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_WERT)
        MOV        R3, R16
        MOV        R4, R17
 
; SHL(ADDRESS_WERT) - Word
        LSL        R3
        ROL        R4
 
; SHL(ADDRESS_WERT) - Word
        LSL        R3
        ROL        R4
 
; SHL(ADDRESS_WERT) - Word
        LSL        R3
        ROL        R4
 
; SHL(ADDRESS_WERT) - Word
        LSL        R3
        ROL        R4
 
; SHL(ADDRESS_WERT) - Word
        LSL        R3
        ROL        R4
 
; SHL(ADDRESS_WERT) - Word
        LSL        R3
        ROL        R4
 
; SHL(ADDRESS_WERT) - Word
        LSL        R3
        ROL        R4
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (ADDRESS_WERT)
        MOV        R16, R3
        MOV        R17, R4
 
; Zuweisung Ziel /  VAR (FLASH_ADDRESS)
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (FORMAT_DIR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Aufruf PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        CALL       AT_WRITE_DATA_ARRAY_WAIT
 
; Retten der Parameter-Register fuer PROCEDURE (FORMAT_DIR)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R1
        MOV        R19, R2
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R1, R18
        MOV        R2, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0568
 
; FOR TO DO - Ende
M_FTD_0570:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; PROCEDURE - Ende (FORMAT_DIR)
        RET
 
; PROCEDURE - Anfang (INIT_TBL1_TYP_ZIEL_ZEIGER)
INIT_TBL1_TYP_ZIEL_ZEIGER:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_COUNTER)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0003)
        LDI        R16, LOW(0x0003)
        LDI        R17, HIGH(0x0003)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0571:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0572
        RJMP       M_FTD_0573
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0572:
 
; VAR ARRAY-1D POSITION - Ausdruck / lokale, dynamische Variable VAR (ADDRESS_COUNTER)
        MOV        R16, R0
        MOV        R17, R1
 
; VAR ARRAY Ziel Zeiger berechnen (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (TZZ_AT24C512_DIR)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR ARRAY-1D (SEKTOR_PUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0571
 
; FOR TO DO - Ende
M_FTD_0573:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0004)
        LDI        R16, LOW(0x0004)
        LDI        R17, HIGH(0x0004)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_COUNTER)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x000D)
        LDI        R16, LOW(0x000D)
        LDI        R17, HIGH(0x000D)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0574:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0575
        RJMP       M_FTD_0576
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0575:
 
; VAR ARRAY-1D POSITION - Ausdruck / lokale, dynamische Variable VAR (ADDRESS_COUNTER)
        MOV        R16, R0
        MOV        R17, R1
 
; VAR ARRAY Ziel Zeiger berechnen (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (TZZ_AT24C512_READ_WRITE)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  VAR ARRAY-1D (SEKTOR_PUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0574
 
; FOR TO DO - Ende
M_FTD_0576:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x000E)
        LDI        R16, LOW(0x000E)
        LDI        R17, HIGH(0x000E)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_COUNTER)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x007F)
        LDI        R16, LOW(0x007F)
        LDI        R17, HIGH(0x007F)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0577:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0578
        RJMP       M_FTD_0579
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0578:
 
; VAR ARRAY-1D POSITION - Ausdruck / lokale, dynamische Variable VAR (ADDRESS_COUNTER)
        MOV        R16, R0
        MOV        R17, R1
 
; VAR ARRAY Ziel Zeiger berechnen (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (TZZ_W25Q64_READ)
        LDI        R16, 0x03
 
; Zuweisung Ziel /  VAR ARRAY-1D (SEKTOR_PUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0577
 
; FOR TO DO - Ende
M_FTD_0579:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (ADR_TBL1_TYP_ZIEL_ZEIGER)
        LDI        R16, LOW(0xE000)
        LDI        R17, HIGH(0xE000)
 
; Zuweisung Ziel /  VAR (FLASH_ADDRESS)
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (INIT_TBL1_TYP_ZIEL_ZEIGER)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        CALL       AT_WRITE_DATA_ARRAY_WAIT
 
; Retten der Parameter-Register fuer PROCEDURE (INIT_TBL1_TYP_ZIEL_ZEIGER)
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_COUNTER)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x007F)
        LDI        R16, LOW(0x007F)
        LDI        R17, HIGH(0x007F)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0580:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0581
        RJMP       M_FTD_0582
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0581:
 
; VAR ARRAY-1D POSITION - Ausdruck / lokale, dynamische Variable VAR (ADDRESS_COUNTER)
        MOV        R16, R0
        MOV        R17, R1
 
; VAR ARRAY Ziel Zeiger berechnen (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (TZZ_W25Q64_READ)
        LDI        R16, 0x03
 
; Zuweisung Ziel /  VAR ARRAY-1D (SEKTOR_PUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0580
 
; FOR TO DO - Ende
M_FTD_0582:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_COUNTER)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x000F)
        LDI        R16, LOW(0x000F)
        LDI        R17, HIGH(0x000F)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0583:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0584
        RJMP       M_FTD_0585
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0584:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (FLASH_ADDRESS)
        LDS        R16, FLASH_ADDRESS
        LDS        R17, FLASH_ADDRESS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0080)
        LDI        R18, LOW(0x0080)
        LDI        R19, HIGH(0x0080)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (FLASH_ADDRESS)
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (INIT_TBL1_TYP_ZIEL_ZEIGER)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        CALL       AT_WRITE_DATA_ARRAY_WAIT
 
; Retten der Parameter-Register fuer PROCEDURE (INIT_TBL1_TYP_ZIEL_ZEIGER)
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0583
 
; FOR TO DO - Ende
M_FTD_0585:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; PROCEDURE - Ende (INIT_TBL1_TYP_ZIEL_ZEIGER)
        RET
 
; PROCEDURE - Anfang (INIT_TBL2_ZEIGER_4K_SPUR_NR)
INIT_TBL2_ZEIGER_4K_SPUR_NR:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_WERT)
        MOV        R6, R16
        MOV        R7, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_COUNTER2)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_COUNTER)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x000D)
        LDI        R16, LOW(0x000D)
        LDI        R17, HIGH(0x000D)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0586:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0587
        RJMP       M_FTD_0588
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0587:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADDRESS_WERT)
        MOV        R16, R6
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R8, R16
 
; VAR ARRAY-1D POSITION - Ausdruck / lokale, dynamische Variable VAR (ADDRESS_COUNTER2)
        MOV        R16, R2
        MOV        R17, R3
 
; VAR ARRAY Ziel Zeiger berechnen (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B1)
        MOV        R16, R8
 
; Zuweisung Ziel /  VAR ARRAY-1D (SEKTOR_PUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADDRESS_COUNTER2)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0001)
        LDI        R18, LOW(0x0001)
        LDI        R19, HIGH(0x0001)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_COUNTER2)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADDRESS_WERT)
        MOV        R16, R7
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R8, R16
 
; VAR ARRAY-1D POSITION - Ausdruck / lokale, dynamische Variable VAR (ADDRESS_COUNTER2)
        MOV        R16, R2
        MOV        R17, R3
 
; VAR ARRAY Ziel Zeiger berechnen (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B1)
        MOV        R16, R8
 
; Zuweisung Ziel /  VAR ARRAY-1D (SEKTOR_PUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADDRESS_COUNTER2)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0001)
        LDI        R18, LOW(0x0001)
        LDI        R19, HIGH(0x0001)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_COUNTER2)
        MOV        R2, R16
        MOV        R3, R17
 
; INC(ADDRESS_WERT) - Word
        MOV        R24, R6
        MOV        R25, R7
        ADIW       R25:R24, 1
        MOV        R6, R24
        MOV        R7, R25
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0586
 
; FOR TO DO - Ende
M_FTD_0588:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x000E)
        LDI        R16, LOW(0x000E)
        LDI        R17, HIGH(0x000E)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_COUNTER)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x007F)
        LDI        R16, LOW(0x007F)
        LDI        R17, HIGH(0x007F)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0589:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0590
        RJMP       M_FTD_0591
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0590:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADDRESS_WERT)
        MOV        R16, R6
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R8, R16
 
; VAR ARRAY-1D POSITION - Ausdruck / lokale, dynamische Variable VAR (ADDRESS_COUNTER2)
        MOV        R16, R2
        MOV        R17, R3
 
; VAR ARRAY Ziel Zeiger berechnen (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B1)
        MOV        R16, R8
 
; Zuweisung Ziel /  VAR ARRAY-1D (SEKTOR_PUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADDRESS_COUNTER2)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0001)
        LDI        R18, LOW(0x0001)
        LDI        R19, HIGH(0x0001)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_COUNTER2)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADDRESS_WERT)
        MOV        R16, R7
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R8, R16
 
; VAR ARRAY-1D POSITION - Ausdruck / lokale, dynamische Variable VAR (ADDRESS_COUNTER2)
        MOV        R16, R2
        MOV        R17, R3
 
; VAR ARRAY Ziel Zeiger berechnen (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B1)
        MOV        R16, R8
 
; Zuweisung Ziel /  VAR ARRAY-1D (SEKTOR_PUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADDRESS_COUNTER2)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0001)
        LDI        R18, LOW(0x0001)
        LDI        R19, HIGH(0x0001)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_COUNTER2)
        MOV        R2, R16
        MOV        R3, R17
 
; INC(ADDRESS_WERT) - Word
        MOV        R24, R6
        MOV        R25, R7
        ADIW       R25:R24, 1
        MOV        R6, R24
        MOV        R7, R25
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0589
 
; FOR TO DO - Ende
M_FTD_0591:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (ADR_TBL2_ZEIGER_4K_SPUR_NR)
        LDI        R16, LOW(0xE800)
        LDI        R17, HIGH(0xE800)
 
; Zuweisung Ziel /  VAR (FLASH_ADDRESS)
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (INIT_TBL2_ZEIGER_4K_SPUR_NR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
 
; Aufruf PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        CALL       AT_WRITE_DATA_ARRAY_WAIT
 
; Retten der Parameter-Register fuer PROCEDURE (INIT_TBL2_ZEIGER_4K_SPUR_NR)
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_COUNTER)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x001F)
        LDI        R16, LOW(0x001F)
        LDI        R17, HIGH(0x001F)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0592:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0593
        RJMP       M_FTD_0594
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0593:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_COUNTER2)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_COUNTER3)
        MOV        R4, R16
        MOV        R5, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x007F)
        LDI        R16, LOW(0x007F)
        LDI        R17, HIGH(0x007F)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R4
        MOV        R19, R5
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0595:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0596
        RJMP       M_FTD_0597
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0596:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(ADDRESS_WERT)
        MOV        R16, R6
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R8, R16
 
; VAR ARRAY-1D POSITION - Ausdruck / lokale, dynamische Variable VAR (ADDRESS_COUNTER2)
        MOV        R16, R2
        MOV        R17, R3
 
; VAR ARRAY Ziel Zeiger berechnen (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B1)
        MOV        R16, R8
 
; Zuweisung Ziel /  VAR ARRAY-1D (SEKTOR_PUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADDRESS_COUNTER2)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0001)
        LDI        R18, LOW(0x0001)
        LDI        R19, HIGH(0x0001)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_COUNTER2)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(ADDRESS_WERT)
        MOV        R16, R7
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R8, R16
 
; VAR ARRAY-1D POSITION - Ausdruck / lokale, dynamische Variable VAR (ADDRESS_COUNTER2)
        MOV        R16, R2
        MOV        R17, R3
 
; VAR ARRAY Ziel Zeiger berechnen (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B1)
        MOV        R16, R8
 
; Zuweisung Ziel /  VAR ARRAY-1D (SEKTOR_PUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ADDRESS_COUNTER2)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0001)
        LDI        R18, LOW(0x0001)
        LDI        R19, HIGH(0x0001)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_COUNTER2)
        MOV        R2, R16
        MOV        R3, R17
 
; INC(ADDRESS_WERT) - Word
        MOV        R24, R6
        MOV        R25, R7
        ADIW       R25:R24, 1
        MOV        R6, R24
        MOV        R7, R25
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R4
        MOV        R19, R5
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R4, R18
        MOV        R5, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0595
 
; FOR TO DO - Ende
M_FTD_0597:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (FLASH_ADDRESS)
        LDS        R16, FLASH_ADDRESS
        LDS        R17, FLASH_ADDRESS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0080)
        LDI        R18, LOW(0x0080)
        LDI        R19, HIGH(0x0080)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (FLASH_ADDRESS)
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (INIT_TBL2_ZEIGER_4K_SPUR_NR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
 
; Aufruf PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        CALL       AT_WRITE_DATA_ARRAY_WAIT
 
; Retten der Parameter-Register fuer PROCEDURE (INIT_TBL2_ZEIGER_4K_SPUR_NR)
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0592
 
; FOR TO DO - Ende
M_FTD_0594:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; PROCEDURE - Ende (INIT_TBL2_ZEIGER_4K_SPUR_NR)
        RET
 
; PROCEDURE - Anfang (INIT_TBL3_4K_SPI_TMP_SPUR_NR)
INIT_TBL3_4K_SPI_TMP_SPUR_NR:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (ADR_TBL3_4K_SPI_TMP_SPUR_NR)
        LDI        R16, LOW(0xF800)
        LDI        R17, HIGH(0xF800)
 
; Zuweisung Ziel /  VAR (FLASH_ADDRESS)
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x04)
        LDI        R16, 0x04
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ADDRESS_WERT)
        MOV        R0, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0D)
        LDI        R16, 0x0D
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R0
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0598:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0599
        RJMP       M_FTD_0600
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0599:
 
; Retten der lokalen Parameter fuer PROCEDURE (INIT_TBL3_4K_SPI_TMP_SPUR_NR)
        PUSH       R0
 
; Aufruf PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        CALL       AT_DATA_WRITE_ONE_BYTE_WAIT
 
; Retten der Parameter-Register fuer PROCEDURE (INIT_TBL3_4K_SPI_TMP_SPUR_NR)
        POP        R0
 
; INC(FLASH_ADDRESS) - Word
        LDS        R24, FLASH_ADDRESS
        LDS        R25, FLASH_ADDRESS+1
        ADIW       R25:R24, 1
        STS        FLASH_ADDRESS, R24
        STS        FLASH_ADDRESS+1, R25
 
; Retten der lokalen Parameter fuer PROCEDURE (INIT_TBL3_4K_SPI_TMP_SPUR_NR)
        PUSH       R0
 
; Byte-Parameter(1) fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Aufruf PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        CALL       AT_DATA_WRITE_ONE_BYTE_WAIT
 
; Retten der Parameter-Register fuer PROCEDURE (INIT_TBL3_4K_SPI_TMP_SPUR_NR)
        POP        R0
 
; INC(FLASH_ADDRESS) - Word
        LDS        R24, FLASH_ADDRESS
        LDS        R25, FLASH_ADDRESS+1
        ADIW       R25:R24, 1
        STS        FLASH_ADDRESS, R24
        STS        FLASH_ADDRESS+1, R25
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R0
        INC        R17
        MOV        R0, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0598
 
; FOR TO DO - Ende
M_FTD_0600:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (ADR_AELTESTER_4K_SPEICHER_IM_I2C)
        LDI        R16, LOW(0xFFFD)
        LDI        R17, HIGH(0xFFFD)
 
; Zuweisung Ziel /  VAR (FLASH_ADDRESS)
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (INIT_TBL3_4K_SPI_TMP_SPUR_NR)
        PUSH       R0
 
; Byte-Parameter(1) fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        LDI        R16, 0x00
        MOV        R0, R16
 
; Aufruf PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        CALL       AT_DATA_WRITE_ONE_BYTE_WAIT
 
; Retten der Parameter-Register fuer PROCEDURE (INIT_TBL3_4K_SPI_TMP_SPUR_NR)
        POP        R0
 
; PROCEDURE - Ende (INIT_TBL3_4K_SPI_TMP_SPUR_NR)
        RET
 
; FUNCTION - Anfang (TEST_I2C_VORHANDEN)
TEST_I2C_VORHANDEN:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (ADR_TEST_BYTE)
        LDI        R16, LOW(0xFFFD)
        LDI        R17, HIGH(0xFFFD)
 
; Zuweisung Ziel /  VAR (FLASH_ADDRESS)
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (TEST_I2C_VORHANDEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Byte-Parameter(1) fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_NO_WAIT)
        LDI        R16, 0xAA
        MOV        R0, R16
 
; Aufruf PROCEDURE (AT_DATA_WRITE_ONE_BYTE_NO_WAIT)
        CALL       AT_DATA_WRITE_ONE_BYTE_NO_WAIT
 
; Retten der Parameter-Register fuer PROCEDURE (TEST_I2C_VORHANDEN)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (TEST_I2C_VORHANDEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x0014)
        MOV        R0, R16
        LDI        R17, HIGH(0x0014)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; Retten der Parameter-Register fuer PROCEDURE (TEST_I2C_VORHANDEN)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (ADR_TEST_BYTE)
        LDI        R16, LOW(0xFFFD)
        LDI        R17, HIGH(0xFFFD)
 
; Zuweisung Ziel /  VAR (FLASH_ADDRESS)
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (TEST_I2C_VORHANDEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf Funktion (AT_DATA_READ_ONE_BYTE)
        CALL       AT_DATA_READ_ONE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (TEST_I2C_VORHANDEN)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (CODE_03)
        LDI        R18, 0xAA
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0604
        CLR        R16
        RJMP       M_VERGL_0605
M_VERGL_0604:
        SER        R16
M_VERGL_0605:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0601
        RJMP       M_IF_0602
M_IF_0601:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (TEST_I2C)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (ADR_TEST_BYTE)
        LDI        R16, LOW(0xFFFD)
        LDI        R17, HIGH(0xFFFD)
 
; Zuweisung Ziel /  VAR (FLASH_ADDRESS)
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (TEST_I2C_VORHANDEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Byte-Parameter(1) fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_NO_WAIT)
        LDI        R16, 0x55
        MOV        R0, R16
 
; Aufruf PROCEDURE (AT_DATA_WRITE_ONE_BYTE_NO_WAIT)
        CALL       AT_DATA_WRITE_ONE_BYTE_NO_WAIT
 
; Retten der Parameter-Register fuer PROCEDURE (TEST_I2C_VORHANDEN)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (TEST_I2C_VORHANDEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x0014)
        MOV        R0, R16
        LDI        R17, HIGH(0x0014)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; Retten der Parameter-Register fuer PROCEDURE (TEST_I2C_VORHANDEN)
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0603
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0602:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (TEST_I2C)
        MOV        R1, R16
 
; IF_THEN_ELSE - Ende
M_IF_0603:
 
; RESULT Byte-Variable - FUNCTION (TEST_I2C_VORHANDEN)
        MOV        R0, R1
 
; Ende Byte - FUNCTION (TEST_I2C_VORHANDEN)
        MOV        R16, R0
 
; FUNCTION - Ende (TEST_I2C_VORHANDEN)
        RET
 
; PROCEDURE - Anfang (INIT_LOESCHEN_UND_FORMATIEREN)
INIT_LOESCHEN_UND_FORMATIEREN:
 
; Aufruf PROCEDURE (FORMAT_DIR)
        CALL       FORMAT_DIR
 
; Aufruf PROCEDURE (INIT_TBL1_TYP_ZIEL_ZEIGER)
        CALL       INIT_TBL1_TYP_ZIEL_ZEIGER
 
; Aufruf PROCEDURE (INIT_TBL2_ZEIGER_4K_SPUR_NR)
        CALL       INIT_TBL2_ZEIGER_4K_SPUR_NR
 
; Aufruf PROCEDURE (INIT_TBL3_4K_SPI_TMP_SPUR_NR)
        CALL       INIT_TBL3_4K_SPI_TMP_SPUR_NR
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (ADR_INIT_KENNUNG_01)
        LDI        R16, LOW(0xFFFE)
        LDI        R17, HIGH(0xFFFE)
 
; Zuweisung Ziel /  VAR (FLASH_ADDRESS)
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; Byte-Parameter(1) fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        LDI        R16, 0x08
        MOV        R0, R16
 
; Aufruf PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        CALL       AT_DATA_WRITE_ONE_BYTE_WAIT
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (ADR_INIT_KENNUNG_02)
        LDI        R16, LOW(0xFFFF)
        LDI        R17, HIGH(0xFFFF)
 
; Zuweisung Ziel /  VAR (FLASH_ADDRESS)
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; Byte-Parameter(1) fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        LDI        R16, 0x12
        MOV        R0, R16
 
; Aufruf PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        CALL       AT_DATA_WRITE_ONE_BYTE_WAIT
 
; PROCEDURE - Ende (INIT_LOESCHEN_UND_FORMATIEREN)
        RET
 
; PROCEDURE - Anfang (INIT_FLASH_MANAGER)
INIT_FLASH_MANAGER:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (ADR_INIT_KENNUNG_01)
        LDI        R16, LOW(0xFFFE)
        LDI        R17, HIGH(0xFFFE)
 
; Zuweisung Ziel /  VAR (FLASH_ADDRESS)
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (INIT_FLASH_MANAGER)
        PUSH       R0
 
; Aufruf Funktion (AT_DATA_READ_ONE_BYTE)
        CALL       AT_DATA_READ_ONE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (INIT_FLASH_MANAGER)
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R0
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (CODE_01)
        LDI        R18, 0x08
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0609
        CLR        R16
        RJMP       M_VERGL_0610
M_VERGL_0609:
        SER        R16
M_VERGL_0610:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0606
        RJMP       M_IF_0607
M_IF_0606:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (ADR_INIT_KENNUNG_02)
        LDI        R16, LOW(0xFFFF)
        LDI        R17, HIGH(0xFFFF)
 
; Zuweisung Ziel /  VAR (FLASH_ADDRESS)
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (INIT_FLASH_MANAGER)
        PUSH       R0
 
; Aufruf Funktion (AT_DATA_READ_ONE_BYTE)
        CALL       AT_DATA_READ_ONE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (INIT_FLASH_MANAGER)
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R0
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (CODE_02)
        LDI        R18, 0x12
 
; Operator <>
        CP         R16, R18
        BRNE       M_VERGL_0614
        CLR        R16
        RJMP       M_VERGL_0615
M_VERGL_0614:
        SER        R16
M_VERGL_0615:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0611
        RJMP       M_IF_0612
M_IF_0611:
 
; Retten der lokalen Parameter fuer PROCEDURE (INIT_FLASH_MANAGER)
        PUSH       R0
 
; Aufruf PROCEDURE (INIT_LOESCHEN_UND_FORMATIEREN)
        CALL       INIT_LOESCHEN_UND_FORMATIEREN
 
; Retten der Parameter-Register fuer PROCEDURE (INIT_FLASH_MANAGER)
        POP        R0
 
; IF_THEN - Ende
M_IF_0612:
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0608
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0607:
 
; Retten der lokalen Parameter fuer PROCEDURE (INIT_FLASH_MANAGER)
        PUSH       R0
 
; Aufruf PROCEDURE (INIT_LOESCHEN_UND_FORMATIEREN)
        CALL       INIT_LOESCHEN_UND_FORMATIEREN
 
; Retten der Parameter-Register fuer PROCEDURE (INIT_FLASH_MANAGER)
        POP        R0
 
; IF_THEN_ELSE - Ende
M_IF_0608:
 
; PROCEDURE - Ende (INIT_FLASH_MANAGER)
        RET
 
; PROCEDURE - Anfang (FM_READ_TBL1_TYP_ZIEL_ZEIGER)
FM_READ_TBL1_TYP_ZIEL_ZEIGER:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Konstante CONST (ADR_TBL1_TYP_ZIEL_ZEIGER)
        LDI        R16, LOW(0xE000)
        LDI        R17, HIGH(0xE000)
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokaler Uebergabeparameter (RD_4K_SPUR)
        MOV        R18, R0
        MOV        R19, R1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (FLASH_ADDRESS)
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (FM_READ_TBL1_TYP_ZIEL_ZEIGER)
        PUSH       R0
        PUSH       R1
 
; Aufruf Funktion (AT_DATA_READ_ONE_BYTE)
        CALL       AT_DATA_READ_ONE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (FM_READ_TBL1_TYP_ZIEL_ZEIGER)
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  VAR (FM_TEMP_TBL1_TYP_ZIEL_ZEIGER)
        STS        FM_TEMP_TBL1_TYP_ZIEL_ZEIGER, R16
 
; PROCEDURE - Ende (FM_READ_TBL1_TYP_ZIEL_ZEIGER)
        RET
 
; PROCEDURE - Anfang (FM_WRITE_TBL1_TYP_ZIEL_ZEIGER)
FM_WRITE_TBL1_TYP_ZIEL_ZEIGER:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Konstante CONST (ADR_TBL1_TYP_ZIEL_ZEIGER)
        LDI        R16, LOW(0xE000)
        LDI        R17, HIGH(0xE000)
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokaler Uebergabeparameter (WR_4K_SPUR)
        MOV        R18, R0
        MOV        R19, R1
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (FLASH_ADDRESS)
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (FM_WRITE_TBL1_TYP_ZIEL_ZEIGER)
        PUSH       R0
        PUSH       R1
 
; Byte-Parameter(1) fuer PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        LDS        R0, FM_TEMP_TBL1_TYP_ZIEL_ZEIGER
 
; Aufruf PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        CALL       AT_DATA_WRITE_ONE_BYTE_WAIT
 
; Retten der Parameter-Register fuer PROCEDURE (FM_WRITE_TBL1_TYP_ZIEL_ZEIGER)
        POP        R1
        POP        R0
 
; PROCEDURE - Ende (FM_WRITE_TBL1_TYP_ZIEL_ZEIGER)
        RET
 
; FUNCTION - Anfang (FM_READ_TBL2_4K_SPUR_NR)
FM_READ_TBL2_4K_SPUR_NR:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (RD_4K_SPUR)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0002)
        LDI        R18, LOW(0x0002)
        LDI        R19, HIGH(0x0002)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  VAR (FLASH_ADDRESS)
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (FLASH_ADDRESS)
        LDS        R16, FLASH_ADDRESS
        LDS        R17, FLASH_ADDRESS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Konstante CONST (ADR_TBL2_ZEIGER_4K_SPUR_NR)
        LDI        R18, LOW(0xE800)
        LDI        R19, HIGH(0xE800)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (FLASH_ADDRESS)
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (FM_READ_TBL2_4K_SPUR_NR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
 
; Aufruf Funktion (AT_DATA_READ_ONE_BYTE)
        CALL       AT_DATA_READ_ONE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (FM_READ_TBL2_4K_SPUR_NR)
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RD_4K_BA_BYTE)
        MOV        R8, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(RD_4K_BA_BYTE)
        MOV        R16, R8
        CLR        R17
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RD_4K_BA_WORD_L)
        MOV        R4, R16
        MOV        R5, R17
 
; INC(FLASH_ADDRESS) - Word
        LDS        R24, FLASH_ADDRESS
        LDS        R25, FLASH_ADDRESS+1
        ADIW       R25:R24, 1
        STS        FLASH_ADDRESS, R24
        STS        FLASH_ADDRESS+1, R25
 
; Retten der lokalen Parameter fuer PROCEDURE (FM_READ_TBL2_4K_SPUR_NR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
 
; Aufruf Funktion (AT_DATA_READ_ONE_BYTE)
        CALL       AT_DATA_READ_ONE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (FM_READ_TBL2_4K_SPUR_NR)
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RD_4K_BA_BYTE)
        MOV        R8, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(RD_4K_BA_BYTE)
        MOV        R16, R8
        CLR        R17
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RD_4K_BA_WORD_H)
        MOV        R6, R16
        MOV        R7, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (RD_4K_BA_WORD_H)
        MOV        R16, R6
        MOV        R17, R7
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0100)
        LDI        R18, LOW(0x0100)
        LDI        R19, HIGH(0x0100)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RD_4K_BA_WORD_H)
        MOV        R6, R16
        MOV        R7, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (RD_4K_BA_WORD_H)
        MOV        R16, R6
        MOV        R17, R7
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (RD_4K_BA_WORD_L)
        MOV        R18, R4
        MOV        R19, R5
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RD_4K_BA_WORD_H)
        MOV        R6, R16
        MOV        R7, R17
 
; RESULT Word-Variable - FUNCTION (FM_READ_TBL2_4K_SPUR_NR)
        MOV        R2, R6
        MOV        R3, R7
 
; Ende Word - FUNCTION (FM_READ_TBL2_4K_SPUR_NR)
        MOV        R16, R2
        MOV        R17, R3
 
; FUNCTION - Ende (FM_READ_TBL2_4K_SPUR_NR)
        RET
 
; PROCEDURE - Anfang (FM_WRITE_TBL2_4K_SPUR_NR)
FM_WRITE_TBL2_4K_SPUR_NR:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (WR_4K_SPUR)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0002)
        LDI        R18, LOW(0x0002)
        LDI        R19, HIGH(0x0002)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  VAR (FLASH_ADDRESS)
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (FLASH_ADDRESS)
        LDS        R16, FLASH_ADDRESS
        LDS        R17, FLASH_ADDRESS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Konstante CONST (ADR_TBL2_ZEIGER_4K_SPUR_NR)
        LDI        R18, LOW(0xE800)
        LDI        R19, HIGH(0xE800)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (FLASH_ADDRESS)
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(WR_4K_INHALT)
        MOV        R16, R2
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R4, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (FM_WRITE_TBL2_4K_SPUR_NR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Parameter (B1) retten
        MOV        R20, R4
 
; lokalen Parameter (B1) an Prozedur (AT_DATA_WRITE_ONE_BYTE_WAIT)
        MOV        R0, R20
 
; Aufruf PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        CALL       AT_DATA_WRITE_ONE_BYTE_WAIT
 
; Retten der Parameter-Register fuer PROCEDURE (FM_WRITE_TBL2_4K_SPUR_NR)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; INC(FLASH_ADDRESS) - Word
        LDS        R24, FLASH_ADDRESS
        LDS        R25, FLASH_ADDRESS+1
        ADIW       R25:R24, 1
        STS        FLASH_ADDRESS, R24
        STS        FLASH_ADDRESS+1, R25
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(WR_4K_INHALT)
        MOV        R16, R3
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R4, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (FM_WRITE_TBL2_4K_SPUR_NR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Parameter (B1) retten
        MOV        R20, R4
 
; lokalen Parameter (B1) an Prozedur (AT_DATA_WRITE_ONE_BYTE_WAIT)
        MOV        R0, R20
 
; Aufruf PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        CALL       AT_DATA_WRITE_ONE_BYTE_WAIT
 
; Retten der Parameter-Register fuer PROCEDURE (FM_WRITE_TBL2_4K_SPUR_NR)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; PROCEDURE - Ende (FM_WRITE_TBL2_4K_SPUR_NR)
        RET
 
; FUNCTION - Anfang (FM_4K_SPUR_UND_SEKTOR_IN_FLASH_ZEIGER)
FM_4K_SPUR_UND_SEKTOR_IN_FLASH_ZEIGER:
 
; Zuweisung Quelle - Ausdruck / WordToDW(ZO_4K_SPUR)
        MOV        R16, R0
        MOV        R17, R1
        LDI        R18, 0x00
        LDI        R19, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ZO_4K_ZEIGER)
        MOV        R6, R16
        MOV        R7, R17
        MOV        R8, R18
        MOV        R9, R19
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ZO_4K_ZEIGER)
        MOV        R16, R6
        MOV        R17, R7
        MOV        R18, R8
        MOV        R19, R9
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (00000020)
        LDI        R20, 0x20
        LDI        R21, 0x00
        LDI        R22, 0x00
        LDI        R23, 0x00
 
; Operator *
        CALL       ASM_UP_MUL32
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ZO_4K_ZEIGER)
        MOV        R6, R16
        MOV        R7, R17
        MOV        R8, R18
        MOV        R9, R19
 
; Zuweisung Quelle - Ausdruck / WordToDW(STD_SEKTOR_NR)
        LDS        R16, STD_SEKTOR_NR
        LDS        R17, STD_SEKTOR_NR+1
        LDI        R18, 0x00
        LDI        R19, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ZO_4K_SEKTOR)
        MOV        R10, R16
        MOV        R11, R17
        MOV        R12, R18
        MOV        R13, R19
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ZO_4K_ZEIGER)
        MOV        R16, R6
        MOV        R17, R7
        MOV        R18, R8
        MOV        R19, R9
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (ZO_4K_SEKTOR)
        MOV        R20, R10
        MOV        R21, R11
        MOV        R22, R12
        MOV        R23, R13
 
; Operator +
        ADD        R16, R20
        ADC        R17, R21
        ADC        R18, R22
        ADC        R19, R23
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ZO_4K_ZEIGER)
        MOV        R6, R16
        MOV        R7, R17
        MOV        R8, R18
        MOV        R9, R19
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ZO_4K_ZEIGER)
        MOV        R16, R6
        MOV        R17, R7
        MOV        R18, R8
        MOV        R19, R9
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (00000080)
        LDI        R20, 0x80
        LDI        R21, 0x00
        LDI        R22, 0x00
        LDI        R23, 0x00
 
; Operator *
        CALL       ASM_UP_MUL32
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ZO_4K_ZEIGER)
        MOV        R6, R16
        MOV        R7, R17
        MOV        R8, R18
        MOV        R9, R19
 
; RESULT DWord-Variable - FUNCTION (FM_4K_SPUR_UND_SEKTOR_IN_FLASH_ZEIGER)
        MOV        R2, R6
        MOV        R3, R7
        MOV        R4, R8
        MOV        R5, R9
 
; Ende DWord - FUNCTION (FM_4K_SPUR_UND_SEKTOR_IN_FLASH_ZEIGER)
        MOV        R16, R2
        MOV        R17, R3
        MOV        R18, R4
        MOV        R19, R5
 
; FUNCTION - Ende (FM_4K_SPUR_UND_SEKTOR_IN_FLASH_ZEIGER)
        RET
 
; FUNCTION - Anfang (FM_READ_AELTESTER_4K_SPEICHER_IM_I2C)
FM_READ_AELTESTER_4K_SPEICHER_IM_I2C:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (ADR_AELTESTER_4K_SPEICHER_IM_I2C)
        LDI        R16, LOW(0xFFFD)
        LDI        R17, HIGH(0xFFFD)
 
; Zuweisung Ziel /  VAR (FLASH_ADDRESS)
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (FM_READ_AELTESTER_4K_SPEICHER_IM_I2C)
        PUSH       R0
        PUSH       R1
 
; Aufruf Funktion (AT_DATA_READ_ONE_BYTE)
        CALL       AT_DATA_READ_ONE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (FM_READ_AELTESTER_4K_SPEICHER_IM_I2C)
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RD_AELTESTER_4K_SPEICHER_IM_I2C)
        MOV        R1, R16
 
; RESULT Byte-Variable - FUNCTION (FM_READ_AELTESTER_4K_SPEICHER_IM_I2C)
        MOV        R0, R1
 
; Ende Byte - FUNCTION (FM_READ_AELTESTER_4K_SPEICHER_IM_I2C)
        MOV        R16, R0
 
; FUNCTION - Ende (FM_READ_AELTESTER_4K_SPEICHER_IM_I2C)
        RET
 
; PROCEDURE - Anfang (FM_WRITE_AELTESTER_4K_SPEICHER_IM_I2C)
FM_WRITE_AELTESTER_4K_SPEICHER_IM_I2C:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (ADR_AELTESTER_4K_SPEICHER_IM_I2C)
        LDI        R16, LOW(0xFFFD)
        LDI        R17, HIGH(0xFFFD)
 
; Zuweisung Ziel /  VAR (FLASH_ADDRESS)
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (FM_WRITE_AELTESTER_4K_SPEICHER_IM_I2C)
        PUSH       R0
 
; Aufruf PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        CALL       AT_DATA_WRITE_ONE_BYTE_WAIT
 
; Retten der Parameter-Register fuer PROCEDURE (FM_WRITE_AELTESTER_4K_SPEICHER_IM_I2C)
        POP        R0
 
; PROCEDURE - Ende (FM_WRITE_AELTESTER_4K_SPEICHER_IM_I2C)
        RET
 
; FUNCTION - Anfang (FM_READ_SPUR_NR_AUS_AELTESTER_4K_SPEICHER_IM_I2C)
FM_READ_SPUR_NR_AUS_AELTESTER_4K_SPEICHER_IM_I2C:
 
; Retten der lokalen Parameter fuer PROCEDURE (FM_READ_SPUR_NR_AUS_AELTESTER_4K_SPEICHER_IM_I2C)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Aufruf Funktion (FM_READ_AELTESTER_4K_SPEICHER_IM_I2C)
        CALL       FM_READ_AELTESTER_4K_SPEICHER_IM_I2C
 
; Retten der Parameter-Register fuer PROCEDURE (FM_READ_SPUR_NR_AUS_AELTESTER_4K_SPEICHER_IM_I2C)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ZEIGER_AELTESTER_4K_SPEICHER)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(ZEIGER_AELTESTER_4K_SPEICHER)
        MOV        R16, R4
        CLR        R17
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R5, R16
        MOV        R6, R17
 
; SHL(W1) - Word
        LSL        R5
        ROL        R6
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (ADR_TBL3_4K_SPI_TMP_SPUR_NR)
        LDI        R16, LOW(0xF800)
        LDI        R17, HIGH(0xF800)
 
; Zuweisung Ziel /  VAR (FLASH_ADDRESS)
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (FLASH_ADDRESS)
        LDS        R16, FLASH_ADDRESS
        LDS        R17, FLASH_ADDRESS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (W1)
        MOV        R18, R5
        MOV        R19, R6
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (FLASH_ADDRESS)
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (FM_READ_SPUR_NR_AUS_AELTESTER_4K_SPEICHER_IM_I2C)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Aufruf Funktion (AT_DATA_READ_ONE_BYTE)
        CALL       AT_DATA_READ_ONE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (FM_READ_SPUR_NR_AUS_AELTESTER_4K_SPEICHER_IM_I2C)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R7, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(B1)
        MOV        R16, R7
        CLR        R17
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R5, R16
        MOV        R6, R17
 
; INC(FLASH_ADDRESS) - Word
        LDS        R24, FLASH_ADDRESS
        LDS        R25, FLASH_ADDRESS+1
        ADIW       R25:R24, 1
        STS        FLASH_ADDRESS, R24
        STS        FLASH_ADDRESS+1, R25
 
; Retten der lokalen Parameter fuer PROCEDURE (FM_READ_SPUR_NR_AUS_AELTESTER_4K_SPEICHER_IM_I2C)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
 
; Aufruf Funktion (AT_DATA_READ_ONE_BYTE)
        CALL       AT_DATA_READ_ONE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (FM_READ_SPUR_NR_AUS_AELTESTER_4K_SPEICHER_IM_I2C)
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R7, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(B1)
        MOV        R16, R7
        CLR        R17
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (READ_SPUR_NR)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (READ_SPUR_NR)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0100)
        LDI        R18, LOW(0x0100)
        LDI        R19, HIGH(0x0100)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (READ_SPUR_NR)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (READ_SPUR_NR)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (W1)
        MOV        R18, R5
        MOV        R19, R6
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (READ_SPUR_NR)
        MOV        R2, R16
        MOV        R3, R17
 
; RESULT Word-Variable - FUNCTION (FM_READ_SPUR_NR_AUS_AELTESTER_4K_SPEICHER_IM_I2C)
        MOV        R0, R2
        MOV        R1, R3
 
; Ende Word - FUNCTION (FM_READ_SPUR_NR_AUS_AELTESTER_4K_SPEICHER_IM_I2C)
        MOV        R16, R0
        MOV        R17, R1
 
; FUNCTION - Ende (FM_READ_SPUR_NR_AUS_AELTESTER_4K_SPEICHER_IM_I2C)
        RET
 
; FUNCTION - Anfang (FM_SPI_ZIELADRESSE_AUS_AELTESTER_4K_SPEICHER)
FM_SPI_ZIELADRESSE_AUS_AELTESTER_4K_SPEICHER:
 
; Retten der lokalen Parameter fuer PROCEDURE (FM_SPI_ZIELADRESSE_AUS_AELTESTER_4K_SPEICHER)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
 
; Aufruf Funktion (FM_READ_SPUR_NR_AUS_AELTESTER_4K_SPEICHER_IM_I2C)
        CALL       FM_READ_SPUR_NR_AUS_AELTESTER_4K_SPEICHER_IM_I2C
 
; Retten der Parameter-Register fuer PROCEDURE (FM_SPI_ZIELADRESSE_AUS_AELTESTER_4K_SPEICHER)
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck / WordToDW(W1)
        MOV        R16, R4
        MOV        R17, R5
        LDI        R18, 0x00
        LDI        R19, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (SPI_ADRESSE_DWORD)
        MOV        R6, R16
        MOV        R7, R17
        MOV        R8, R18
        MOV        R9, R19
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (SPI_ADRESSE_DWORD)
        MOV        R16, R6
        MOV        R17, R7
        MOV        R18, R8
        MOV        R19, R9
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (00001000)
        LDI        R20, 0x00
        LDI        R21, 0x10
        LDI        R22, 0x00
        LDI        R23, 0x00
 
; Operator *
        CALL       ASM_UP_MUL32
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (SPI_ADRESSE_DWORD)
        MOV        R6, R16
        MOV        R7, R17
        MOV        R8, R18
        MOV        R9, R19
 
; RESULT DWord-Variable - FUNCTION (FM_SPI_ZIELADRESSE_AUS_AELTESTER_4K_SPEICHER)
        MOV        R0, R6
        MOV        R1, R7
        MOV        R2, R8
        MOV        R3, R9
 
; Ende DWord - FUNCTION (FM_SPI_ZIELADRESSE_AUS_AELTESTER_4K_SPEICHER)
        MOV        R16, R0
        MOV        R17, R1
        MOV        R18, R2
        MOV        R19, R3
 
; FUNCTION - Ende (FM_SPI_ZIELADRESSE_AUS_AELTESTER_4K_SPEICHER)
        RET
 
; PROCEDURE - Anfang (FM_FLASH_ADDRESS_I2C_QUELLADRESSE_AUS_AELTESTER_4K_SPEICHER)
FM_FLASH_ADDRESS_I2C_QUELLADRESSE_AUS_AELTESTER_4K_SPEICHER:
 
; Retten der lokalen Parameter fuer PROCEDURE (FM_FLASH_ADDRESS_I2C_QUELLADRESSE_AUS_AELTESTER_4K_SPEICHER)
        PUSH       R0
 
; Aufruf Funktion (FM_READ_AELTESTER_4K_SPEICHER_IM_I2C)
        CALL       FM_READ_AELTESTER_4K_SPEICHER_IM_I2C
 
; Retten der Parameter-Register fuer PROCEDURE (FM_FLASH_ADDRESS_I2C_QUELLADRESSE_AUS_AELTESTER_4K_SPEICHER)
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ZEIGER_AELTESTER_4K_SPEICHER)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ZEIGER_AELTESTER_4K_SPEICHER)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x04)
        LDI        R18, 0x04
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ZEIGER_AELTESTER_4K_SPEICHER)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(ZEIGER_AELTESTER_4K_SPEICHER)
        MOV        R16, R0
        CLR        R17
 
; Zuweisung Ziel /  VAR (FLASH_ADDRESS)
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (FLASH_ADDRESS)
        LDS        R16, FLASH_ADDRESS
        LDS        R17, FLASH_ADDRESS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x1000)
        LDI        R18, LOW(0x1000)
        LDI        R19, HIGH(0x1000)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  VAR (FLASH_ADDRESS)
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; PROCEDURE - Ende (FM_FLASH_ADDRESS_I2C_QUELLADRESSE_AUS_AELTESTER_4K_SPEICHER)
        RET
 
; PROCEDURE - Anfang (FM_READ_DATA_ARRAY)
FM_READ_DATA_ARRAY:
 
; Retten der lokalen Parameter fuer PROCEDURE (FM_READ_DATA_ARRAY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Word-Parameter(1) fuer PROCEDURE (FM_READ_TBL1_TYP_ZIEL_ZEIGER)
        LDS        R0, STD_SPUR_NR
        LDS        R1, STD_SPUR_NR+1
 
; Aufruf PROCEDURE (FM_READ_TBL1_TYP_ZIEL_ZEIGER)
        CALL       FM_READ_TBL1_TYP_ZIEL_ZEIGER
 
; Retten der Parameter-Register fuer PROCEDURE (FM_READ_DATA_ARRAY)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (FM_READ_DATA_ARRAY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Word-Parameter(1) fuer FUNCTION (FM_READ_TBL2_4K_SPUR_NR)
        LDS        R0, STD_SPUR_NR
        LDS        R1, STD_SPUR_NR+1
 
; Aufruf Funktion (FM_READ_TBL2_4K_SPUR_NR)
        CALL       FM_READ_TBL2_4K_SPUR_NR
 
; Retten der Parameter-Register fuer PROCEDURE (FM_READ_DATA_ARRAY)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FM_4K_ZEIGER)
        MOV        R0, R16
        MOV        R1, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (FM_READ_DATA_ARRAY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf Funktion (FM_4K_SPUR_UND_SEKTOR_IN_FLASH_ZEIGER)
        CALL       FM_4K_SPUR_UND_SEKTOR_IN_FLASH_ZEIGER
 
; Retten der Parameter-Register fuer PROCEDURE (FM_READ_DATA_ARRAY)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FLASH_ZEIGER)
        MOV        R2, R16
        MOV        R3, R17
        MOV        R4, R18
        MOV        R5, R19
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (FM_TEMP_TBL1_TYP_ZIEL_ZEIGER)
        LDS        R16, FM_TEMP_TBL1_TYP_ZIEL_ZEIGER
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (TZZ_W25Q64_READ)
        LDI        R18, 0x03
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0619
        CLR        R16
        RJMP       M_VERGL_0620
M_VERGL_0619:
        SER        R16
M_VERGL_0620:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0616
        RJMP       M_IF_0617
M_IF_0616:
 
; Zuweisung Quelle - Ausdruck / DWByte(0,FLASH_ZEIGER)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR (ADR_BYTE_0)
        STS        ADR_BYTE_0, R16
 
; Zuweisung Quelle - Ausdruck / DWByte(1,FLASH_ZEIGER)
        MOV        R16, R3
 
; Zuweisung Ziel /  VAR (ADR_BYTE_1)
        STS        ADR_BYTE_1, R16
 
; Zuweisung Quelle - Ausdruck / DWByte(2,FLASH_ZEIGER)
        MOV        R16, R4
 
; Zuweisung Ziel /  VAR (ADR_BYTE_2)
        STS        ADR_BYTE_2, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (FM_READ_DATA_ARRAY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (W25Q64_READ_ONE_SECTOR)
        CALL       W25Q64_READ_ONE_SECTOR
 
; Retten der Parameter-Register fuer PROCEDURE (FM_READ_DATA_ARRAY)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0618
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0617:
 
; Zuweisung Quelle - Ausdruck / DWLow(FLASH_ZEIGER)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Ziel /  VAR (FLASH_ADDRESS)
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (FM_READ_DATA_ARRAY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (AT_READ_DATA_ARRAY)
        CALL       AT_READ_DATA_ARRAY
 
; Retten der Parameter-Register fuer PROCEDURE (FM_READ_DATA_ARRAY)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN_ELSE - Ende
M_IF_0618:
 
; PROCEDURE - Ende (FM_READ_DATA_ARRAY)
        RET
 
; PROCEDURE - Anfang (FM_ZURUECKSCHREIBEN_4K_SEKTOR)
FM_ZURUECKSCHREIBEN_4K_SEKTOR:
 
; Retten der lokalen Parameter fuer PROCEDURE (FM_ZURUECKSCHREIBEN_4K_SEKTOR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
        PUSH       R10
 
; Aufruf PROCEDURE (FM_FLASH_ADDRESS_I2C_QUELLADRESSE_AUS_AELTESTER_4K_SPEICHER)
        CALL       FM_FLASH_ADDRESS_I2C_QUELLADRESSE_AUS_AELTESTER_4K_SPEICHER
 
; Retten der Parameter-Register fuer PROCEDURE (FM_ZURUECKSCHREIBEN_4K_SEKTOR)
        POP        R10
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Word-VAR (FLASH_ADDRESS)
        LDS        R16, FLASH_ADDRESS
        LDS        R17, FLASH_ADDRESS+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (Z_FLASH_ADDRESS)
        MOV        R5, R16
        MOV        R6, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (FM_ZURUECKSCHREIBEN_4K_SEKTOR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
        PUSH       R10
 
; Aufruf Funktion (FM_SPI_ZIELADRESSE_AUS_AELTESTER_4K_SPEICHER)
        CALL       FM_SPI_ZIELADRESSE_AUS_AELTESTER_4K_SPEICHER
 
; Retten der Parameter-Register fuer PROCEDURE (FM_ZURUECKSCHREIBEN_4K_SEKTOR)
        POP        R10
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (SPI_ADRESSE_DWORD)
        MOV        R0, R16
        MOV        R1, R17
        MOV        R2, R18
        MOV        R3, R19
 
; Zuweisung Quelle - Ausdruck / DWByte(0,SPI_ADRESSE_DWORD)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (ADR_BYTE_0)
        STS        ADR_BYTE_0, R16
 
; Zuweisung Quelle - Ausdruck / DWByte(1,SPI_ADRESSE_DWORD)
        MOV        R16, R1
 
; Zuweisung Ziel /  VAR (ADR_BYTE_1)
        STS        ADR_BYTE_1, R16
 
; Zuweisung Quelle - Ausdruck / DWByte(2,SPI_ADRESSE_DWORD)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR (ADR_BYTE_2)
        STS        ADR_BYTE_2, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (FM_ZURUECKSCHREIBEN_4K_SEKTOR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
        PUSH       R10
 
; Aufruf PROCEDURE (FLASH_SECTOR_ERASE)
        CALL       FLASH_SECTOR_ERASE
 
; Retten der Parameter-Register fuer PROCEDURE (FM_ZURUECKSCHREIBEN_4K_SEKTOR)
        POP        R10
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (Z_FLASH_ADDRESS)
        MOV        R16, R5
        MOV        R17, R6
 
; Zuweisung Ziel /  VAR (FLASH_ADDRESS)
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R4, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x1F)
        LDI        R16, 0x1F
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R4
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0621:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0622
        RJMP       M_FTD_0623
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0622:
 
; Retten der lokalen Parameter fuer PROCEDURE (FM_ZURUECKSCHREIBEN_4K_SEKTOR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
        PUSH       R10
 
; Aufruf PROCEDURE (AT_READ_DATA_ARRAY)
        CALL       AT_READ_DATA_ARRAY
 
; Retten der Parameter-Register fuer PROCEDURE (FM_ZURUECKSCHREIBEN_4K_SEKTOR)
        POP        R10
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (FLASH_ADDRESS)
        LDS        R16, FLASH_ADDRESS
        LDS        R17, FLASH_ADDRESS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0080)
        LDI        R18, LOW(0x0080)
        LDI        R19, HIGH(0x0080)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (FLASH_ADDRESS)
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; Zuweisung Quelle - Ausdruck / DWByte(0,SPI_ADRESSE_DWORD)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (ADR_BYTE_0)
        STS        ADR_BYTE_0, R16
 
; Zuweisung Quelle - Ausdruck / DWByte(1,SPI_ADRESSE_DWORD)
        MOV        R16, R1
 
; Zuweisung Ziel /  VAR (ADR_BYTE_1)
        STS        ADR_BYTE_1, R16
 
; Zuweisung Quelle - Ausdruck / DWByte(2,SPI_ADRESSE_DWORD)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR (ADR_BYTE_2)
        STS        ADR_BYTE_2, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (FM_ZURUECKSCHREIBEN_4K_SEKTOR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
        PUSH       R10
 
; Aufruf PROCEDURE (W25Q64_WRITE_ONE_SECTOR)
        CALL       W25Q64_WRITE_ONE_SECTOR
 
; Retten der Parameter-Register fuer PROCEDURE (FM_ZURUECKSCHREIBEN_4K_SEKTOR)
        POP        R10
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (SPI_ADRESSE_DWORD)
        MOV        R16, R0
        MOV        R17, R1
        MOV        R18, R2
        MOV        R19, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (00000080)
        LDI        R20, 0x80
        LDI        R21, 0x00
        LDI        R22, 0x00
        LDI        R23, 0x00
 
; Operator +
        ADD        R16, R20
        ADC        R17, R21
        ADC        R18, R22
        ADC        R19, R23
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (SPI_ADRESSE_DWORD)
        MOV        R0, R16
        MOV        R1, R17
        MOV        R2, R18
        MOV        R3, R19
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R4
        INC        R17
        MOV        R4, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0621
 
; FOR TO DO - Ende
M_FTD_0623:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; Retten der lokalen Parameter fuer PROCEDURE (FM_ZURUECKSCHREIBEN_4K_SEKTOR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
        PUSH       R10
 
; Aufruf Funktion (FM_READ_SPUR_NR_AUS_AELTESTER_4K_SPEICHER_IM_I2C)
        CALL       FM_READ_SPUR_NR_AUS_AELTESTER_4K_SPEICHER_IM_I2C
 
; Retten der Parameter-Register fuer PROCEDURE (FM_ZURUECKSCHREIBEN_4K_SEKTOR)
        POP        R10
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (READ_SPUR_NR)
        MOV        R7, R16
        MOV        R8, R17
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (TZZ_W25Q64_READ)
        LDI        R16, 0x03
 
; Zuweisung Ziel /  VAR (FM_TEMP_TBL1_TYP_ZIEL_ZEIGER)
        STS        FM_TEMP_TBL1_TYP_ZIEL_ZEIGER, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (FM_ZURUECKSCHREIBEN_4K_SEKTOR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
        PUSH       R10
 
; Parameter (READ_SPUR_NR) retten
        MOV        R23, R7
        MOV        R24, R8
 
; lokalen Parameter (READ_SPUR_NR) an Prozedur (FM_WRITE_TBL1_TYP_ZIEL_ZEIGER)
        MOV        R0, R23
        MOV        R1, R24
 
; Aufruf PROCEDURE (FM_WRITE_TBL1_TYP_ZIEL_ZEIGER)
        CALL       FM_WRITE_TBL1_TYP_ZIEL_ZEIGER
 
; Retten der Parameter-Register fuer PROCEDURE (FM_ZURUECKSCHREIBEN_4K_SEKTOR)
        POP        R10
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (READ_SPUR_NR)
        MOV        R16, R7
        MOV        R17, R8
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (READ_SPUR_NR2)
        MOV        R9, R16
        MOV        R10, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (FM_ZURUECKSCHREIBEN_4K_SEKTOR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
        PUSH       R10
 
; Parameter (READ_SPUR_NR) retten
        MOV        R23, R7
        MOV        R24, R8
 
; Parameter (READ_SPUR_NR2) retten
        MOV        R25, R9
        MOV        R26, R10
 
; lokalen Parameter (READ_SPUR_NR) an Prozedur (FM_WRITE_TBL2_4K_SPUR_NR)
        MOV        R0, R23
        MOV        R1, R24
 
; lokalen Parameter (READ_SPUR_NR2) an Prozedur (FM_WRITE_TBL2_4K_SPUR_NR)
        MOV        R2, R25
        MOV        R3, R26
 
; Aufruf PROCEDURE (FM_WRITE_TBL2_4K_SPUR_NR)
        CALL       FM_WRITE_TBL2_4K_SPUR_NR
 
; Retten der Parameter-Register fuer PROCEDURE (FM_ZURUECKSCHREIBEN_4K_SEKTOR)
        POP        R10
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; PROCEDURE - Ende (FM_ZURUECKSCHREIBEN_4K_SEKTOR)
        RET
 
; PROCEDURE - Anfang (FM_VERSCHIEBEN_4K_SEKTOR)
FM_VERSCHIEBEN_4K_SEKTOR:
 
; Retten der lokalen Parameter fuer PROCEDURE (FM_VERSCHIEBEN_4K_SEKTOR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
 
; Aufruf Funktion (FM_READ_AELTESTER_4K_SPEICHER_IM_I2C)
        CALL       FM_READ_AELTESTER_4K_SPEICHER_IM_I2C
 
; Retten der Parameter-Register fuer PROCEDURE (FM_VERSCHIEBEN_4K_SEKTOR)
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ZEIGER_AELTESTER_4K_SPEICHER)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ZEIGER_AELTESTER_4K_SPEICHER)
        MOV        R16, R4
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x04)
        LDI        R18, 0x04
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ZEIGER_AELTESTER_4K_SPEICHER)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(ZEIGER_AELTESTER_4K_SPEICHER)
        MOV        R16, R4
        CLR        R17
 
; Zuweisung Ziel /  VAR (FLASH_ADDRESS)
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (FLASH_ADDRESS)
        LDS        R16, FLASH_ADDRESS
        LDS        R17, FLASH_ADDRESS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x1000)
        LDI        R18, LOW(0x1000)
        LDI        R19, HIGH(0x1000)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  VAR (FLASH_ADDRESS)
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; Zuweisung Quelle - Ausdruck / WordToDW(STD_SPUR_NR)
        LDS        R16, STD_SPUR_NR
        LDS        R17, STD_SPUR_NR+1
        LDI        R18, 0x00
        LDI        R19, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (SPI_ADRESSE_DWORD)
        MOV        R0, R16
        MOV        R1, R17
        MOV        R2, R18
        MOV        R3, R19
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (SPI_ADRESSE_DWORD)
        MOV        R16, R0
        MOV        R17, R1
        MOV        R18, R2
        MOV        R19, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (00001000)
        LDI        R20, 0x00
        LDI        R21, 0x10
        LDI        R22, 0x00
        LDI        R23, 0x00
 
; Operator *
        CALL       ASM_UP_MUL32
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (SPI_ADRESSE_DWORD)
        MOV        R0, R16
        MOV        R1, R17
        MOV        R2, R18
        MOV        R3, R19
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R9, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x1F)
        LDI        R16, 0x1F
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R9
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0624:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0625
        RJMP       M_FTD_0626
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0625:
 
; Zuweisung Quelle - Ausdruck / DWByte(0,SPI_ADRESSE_DWORD)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (ADR_BYTE_0)
        STS        ADR_BYTE_0, R16
 
; Zuweisung Quelle - Ausdruck / DWByte(1,SPI_ADRESSE_DWORD)
        MOV        R16, R1
 
; Zuweisung Ziel /  VAR (ADR_BYTE_1)
        STS        ADR_BYTE_1, R16
 
; Zuweisung Quelle - Ausdruck / DWByte(2,SPI_ADRESSE_DWORD)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR (ADR_BYTE_2)
        STS        ADR_BYTE_2, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (FM_VERSCHIEBEN_4K_SEKTOR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
 
; Aufruf PROCEDURE (W25Q64_READ_ONE_SECTOR)
        CALL       W25Q64_READ_ONE_SECTOR
 
; Retten der Parameter-Register fuer PROCEDURE (FM_VERSCHIEBEN_4K_SEKTOR)
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (SPI_ADRESSE_DWORD)
        MOV        R16, R0
        MOV        R17, R1
        MOV        R18, R2
        MOV        R19, R3
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (00000080)
        LDI        R20, 0x80
        LDI        R21, 0x00
        LDI        R22, 0x00
        LDI        R23, 0x00
 
; Operator +
        ADD        R16, R20
        ADC        R17, R21
        ADC        R18, R22
        ADC        R19, R23
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (SPI_ADRESSE_DWORD)
        MOV        R0, R16
        MOV        R1, R17
        MOV        R2, R18
        MOV        R3, R19
 
; Retten der lokalen Parameter fuer PROCEDURE (FM_VERSCHIEBEN_4K_SEKTOR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
 
; Aufruf PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        CALL       AT_WRITE_DATA_ARRAY_WAIT
 
; Retten der Parameter-Register fuer PROCEDURE (FM_VERSCHIEBEN_4K_SEKTOR)
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (FLASH_ADDRESS)
        LDS        R16, FLASH_ADDRESS
        LDS        R17, FLASH_ADDRESS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0080)
        LDI        R18, LOW(0x0080)
        LDI        R19, HIGH(0x0080)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (FLASH_ADDRESS)
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R9
        INC        R17
        MOV        R9, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0624
 
; FOR TO DO - Ende
M_FTD_0626:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (TZZ_AT24C512_READ_WRITE)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  VAR (FM_TEMP_TBL1_TYP_ZIEL_ZEIGER)
        STS        FM_TEMP_TBL1_TYP_ZIEL_ZEIGER, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (FM_VERSCHIEBEN_4K_SEKTOR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
 
; Word-Parameter(1) fuer PROCEDURE (FM_WRITE_TBL1_TYP_ZIEL_ZEIGER)
        LDS        R0, STD_SPUR_NR
        LDS        R1, STD_SPUR_NR+1
 
; Aufruf PROCEDURE (FM_WRITE_TBL1_TYP_ZIEL_ZEIGER)
        CALL       FM_WRITE_TBL1_TYP_ZIEL_ZEIGER
 
; Retten der Parameter-Register fuer PROCEDURE (FM_VERSCHIEBEN_4K_SEKTOR)
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (FM_VERSCHIEBEN_4K_SEKTOR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
 
; Aufruf Funktion (FM_READ_AELTESTER_4K_SPEICHER_IM_I2C)
        CALL       FM_READ_AELTESTER_4K_SPEICHER_IM_I2C
 
; Retten der Parameter-Register fuer PROCEDURE (FM_VERSCHIEBEN_4K_SEKTOR)
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ZEIGER_AELTESTER_4K_SPEICHER)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(ZEIGER_AELTESTER_4K_SPEICHER)
        MOV        R16, R4
        CLR        R17
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R7, R16
        MOV        R8, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (W1)
        MOV        R16, R7
        MOV        R17, R8
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0004)
        LDI        R18, LOW(0x0004)
        LDI        R19, HIGH(0x0004)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R7, R16
        MOV        R8, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (FM_VERSCHIEBEN_4K_SEKTOR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
 
; Parameter (W1) retten
        MOV        R23, R7
        MOV        R24, R8
 
; lokalen Parameter (W1) an Prozedur (FM_WRITE_TBL2_4K_SPUR_NR)
        MOV        R2, R23
        MOV        R3, R24
 
; Word-Parameter(1) fuer PROCEDURE (FM_WRITE_TBL2_4K_SPUR_NR)
        LDS        R0, STD_SPUR_NR
        LDS        R1, STD_SPUR_NR+1
 
; Aufruf PROCEDURE (FM_WRITE_TBL2_4K_SPUR_NR)
        CALL       FM_WRITE_TBL2_4K_SPUR_NR
 
; Retten der Parameter-Register fuer PROCEDURE (FM_VERSCHIEBEN_4K_SEKTOR)
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(ZEIGER_AELTESTER_4K_SPEICHER)
        MOV        R16, R4
        CLR        R17
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R7, R16
        MOV        R8, R17
 
; SHL(W1) - Word
        LSL        R7
        ROL        R8
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (ADR_TBL3_4K_SPI_TMP_SPUR_NR)
        LDI        R16, LOW(0xF800)
        LDI        R17, HIGH(0xF800)
 
; Zuweisung Ziel /  VAR (FLASH_ADDRESS)
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (FLASH_ADDRESS)
        LDS        R16, FLASH_ADDRESS
        LDS        R17, FLASH_ADDRESS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (W1)
        MOV        R18, R7
        MOV        R19, R8
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (FLASH_ADDRESS)
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(STD_SPUR_NR)
        LDS        R16, STD_SPUR_NR
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R9, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (FM_VERSCHIEBEN_4K_SEKTOR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
 
; Parameter (B1) retten
        MOV        R25, R9
 
; lokalen Parameter (B1) an Prozedur (AT_DATA_WRITE_ONE_BYTE_WAIT)
        MOV        R0, R25
 
; Aufruf PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        CALL       AT_DATA_WRITE_ONE_BYTE_WAIT
 
; Retten der Parameter-Register fuer PROCEDURE (FM_VERSCHIEBEN_4K_SEKTOR)
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; INC(FLASH_ADDRESS) - Word
        LDS        R24, FLASH_ADDRESS
        LDS        R25, FLASH_ADDRESS+1
        ADIW       R25:R24, 1
        STS        FLASH_ADDRESS, R24
        STS        FLASH_ADDRESS+1, R25
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(STD_SPUR_NR)
        LDS        R16, STD_SPUR_NR+1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R9, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (FM_VERSCHIEBEN_4K_SEKTOR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
 
; Parameter (B1) retten
        MOV        R25, R9
 
; lokalen Parameter (B1) an Prozedur (AT_DATA_WRITE_ONE_BYTE_WAIT)
        MOV        R0, R25
 
; Aufruf PROCEDURE (AT_DATA_WRITE_ONE_BYTE_WAIT)
        CALL       AT_DATA_WRITE_ONE_BYTE_WAIT
 
; Retten der Parameter-Register fuer PROCEDURE (FM_VERSCHIEBEN_4K_SEKTOR)
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; INC(ZEIGER_AELTESTER_4K_SPEICHER) - Byte
        INC        R4
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (ZEIGER_AELTESTER_4K_SPEICHER)
        MOV        R16, R4
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x09)
        LDI        R18, 0x09
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_0630
        CLR        R16
        RJMP       M_VERGL_0631
M_VERGL_0630:
        SER        R16
M_VERGL_0631:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0627
        RJMP       M_IF_0628
M_IF_0627:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ZEIGER_AELTESTER_4K_SPEICHER)
        MOV        R4, R16
 
; IF_THEN - Ende
M_IF_0628:
 
; Retten der lokalen Parameter fuer PROCEDURE (FM_VERSCHIEBEN_4K_SEKTOR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
        PUSH       R6
        PUSH       R7
        PUSH       R8
        PUSH       R9
 
; Parameter (ZEIGER_AELTESTER_4K_SPEICHER) retten
        MOV        R20, R4
 
; lokalen Parameter (ZEIGER_AELTESTER_4K_SPEICHER) an Prozedur (FM_WRITE_AELTESTER_4K_SPEICHER_IM_I2C)
        MOV        R0, R20
 
; Aufruf PROCEDURE (FM_WRITE_AELTESTER_4K_SPEICHER_IM_I2C)
        CALL       FM_WRITE_AELTESTER_4K_SPEICHER_IM_I2C
 
; Retten der Parameter-Register fuer PROCEDURE (FM_VERSCHIEBEN_4K_SEKTOR)
        POP        R9
        POP        R8
        POP        R7
        POP        R6
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; PROCEDURE - Ende (FM_VERSCHIEBEN_4K_SEKTOR)
        RET
 
; PROCEDURE - Anfang (FM_PRUEFE_VERSCHIEBEN_SPUR_NOTWENDIG)
FM_PRUEFE_VERSCHIEBEN_SPUR_NOTWENDIG:
 
; Word-Parameter(1) fuer PROCEDURE (FM_READ_TBL1_TYP_ZIEL_ZEIGER)
        LDS        R0, STD_SPUR_NR
        LDS        R1, STD_SPUR_NR+1
 
; Aufruf PROCEDURE (FM_READ_TBL1_TYP_ZIEL_ZEIGER)
        CALL       FM_READ_TBL1_TYP_ZIEL_ZEIGER
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (FM_TEMP_TBL1_TYP_ZIEL_ZEIGER)
        LDS        R16, FM_TEMP_TBL1_TYP_ZIEL_ZEIGER
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (TZZ_W25Q64_READ)
        LDI        R18, 0x03
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0635
        CLR        R16
        RJMP       M_VERGL_0636
M_VERGL_0635:
        SER        R16
M_VERGL_0636:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0632
        RJMP       M_IF_0633
M_IF_0632:
 
; Aufruf PROCEDURE (FM_ZURUECKSCHREIBEN_4K_SEKTOR)
        CALL       FM_ZURUECKSCHREIBEN_4K_SEKTOR
 
; Aufruf PROCEDURE (FM_VERSCHIEBEN_4K_SEKTOR)
        CALL       FM_VERSCHIEBEN_4K_SEKTOR
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (SEKTOR_PUFFER_GEAENDERT)
        STS        SEKTOR_PUFFER_GEAENDERT, R16
 
; IF_THEN - Ende
M_IF_0633:
 
; PROCEDURE - Ende (FM_PRUEFE_VERSCHIEBEN_SPUR_NOTWENDIG)
        RET
 
; PROCEDURE - Anfang (FM_WRITE_DATA_ARRAY)
FM_WRITE_DATA_ARRAY:
 
; Retten der lokalen Parameter fuer PROCEDURE (FM_WRITE_DATA_ARRAY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Word-Parameter(1) fuer FUNCTION (FM_READ_TBL2_4K_SPUR_NR)
        LDS        R0, STD_SPUR_NR
        LDS        R1, STD_SPUR_NR+1
 
; Aufruf Funktion (FM_READ_TBL2_4K_SPUR_NR)
        CALL       FM_READ_TBL2_4K_SPUR_NR
 
; Retten der Parameter-Register fuer PROCEDURE (FM_WRITE_DATA_ARRAY)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FM_4K_SPUR)
        MOV        R0, R16
        MOV        R1, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (FM_WRITE_DATA_ARRAY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf Funktion (FM_4K_SPUR_UND_SEKTOR_IN_FLASH_ZEIGER)
        CALL       FM_4K_SPUR_UND_SEKTOR_IN_FLASH_ZEIGER
 
; Retten der Parameter-Register fuer PROCEDURE (FM_WRITE_DATA_ARRAY)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (FLASH_ZEIGER)
        MOV        R2, R16
        MOV        R3, R17
        MOV        R4, R18
        MOV        R5, R19
 
; Zuweisung Quelle - Ausdruck / DWLow(FLASH_ZEIGER)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Ziel /  VAR (FLASH_ADDRESS)
        STS        FLASH_ADDRESS, R16
        STS        FLASH_ADDRESS+1, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (FM_WRITE_DATA_ARRAY)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (AT_WRITE_DATA_ARRAY_WAIT)
        CALL       AT_WRITE_DATA_ARRAY_WAIT
 
; Retten der Parameter-Register fuer PROCEDURE (FM_WRITE_DATA_ARRAY)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; PROCEDURE - Ende (FM_WRITE_DATA_ARRAY)
        RET
 
; PROCEDURE - Anfang (STD_AN_LOKALEN_FLASH_MANAGER_SENDEN)
STD_AN_LOKALEN_FLASH_MANAGER_SENDEN:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(SECTOR)
        LDS        R16, SECTOR
        CLR        R17
 
; Zuweisung Ziel /  VAR (STD_SEKTOR_NR)
        STS        STD_SEKTOR_NR, R16
        STS        STD_SEKTOR_NR+1, R17
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(TRACK_L)
        LDS        R16, TRACK_L
        CLR        R17
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DATA_WORD)
        MOV        R1, R16
        MOV        R2, R17
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(TRACK_H)
        LDS        R16, TRACK_H
        CLR        R17
 
; Zuweisung Ziel /  VAR (STD_SPUR_NR)
        STS        STD_SPUR_NR, R16
        STS        STD_SPUR_NR+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (STD_SPUR_NR)
        LDS        R16, STD_SPUR_NR
        LDS        R17, STD_SPUR_NR+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0100)
        LDI        R18, LOW(0x0100)
        LDI        R19, HIGH(0x0100)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  VAR (STD_SPUR_NR)
        STS        STD_SPUR_NR, R16
        STS        STD_SPUR_NR+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (STD_SPUR_NR)
        LDS        R16, STD_SPUR_NR
        LDS        R17, STD_SPUR_NR+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (DATA_WORD)
        MOV        R18, R1
        MOV        R19, R2
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (STD_SPUR_NR)
        STS        STD_SPUR_NR, R16
        STS        STD_SPUR_NR+1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (STD_SEKTOR_NR)
        LDS        R16, STD_SEKTOR_NR
        LDS        R17, STD_SEKTOR_NR+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0040)
        LDI        R18, LOW(0x0040)
        LDI        R19, HIGH(0x0040)
 
; Operator AND
        AND        R16, R18
        AND        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DATA_WORD)
        MOV        R1, R16
        MOV        R2, R17
 
; SHL(STD_SPUR_NR) - Word
        LDS        R16, STD_SPUR_NR
        LDS        R17, STD_SPUR_NR+1
        LSL        R16
        ROL        R17
        STS        STD_SPUR_NR, R16
        STS        STD_SPUR_NR+1, R17
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (DATA_WORD)
        MOV        R16, R1
        MOV        R17, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0000)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0640
        CLR        R16
        RJMP       M_VERGL_0641
M_VERGL_0640:
        SER        R16
M_VERGL_0641:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0637
        RJMP       M_IF_0638
M_IF_0637:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (STD_SPUR_NR)
        LDS        R16, STD_SPUR_NR
        LDS        R17, STD_SPUR_NR+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0001)
        LDI        R18, LOW(0x0001)
        LDI        R19, HIGH(0x0001)
 
; Operator OR
        OR         R16, R18
        OR         R17, R19
 
; Zuweisung Ziel /  VAR (STD_SPUR_NR)
        STS        STD_SPUR_NR, R16
        STS        STD_SPUR_NR+1, R17
 
; IF_THEN - Ende
M_IF_0638:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (STD_SEKTOR_NR)
        LDS        R16, STD_SEKTOR_NR
        LDS        R17, STD_SEKTOR_NR+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0020)
        LDI        R18, LOW(0x0020)
        LDI        R19, HIGH(0x0020)
 
; Operator AND
        AND        R16, R18
        AND        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DATA_WORD)
        MOV        R1, R16
        MOV        R2, R17
 
; SHL(STD_SPUR_NR) - Word
        LDS        R16, STD_SPUR_NR
        LDS        R17, STD_SPUR_NR+1
        LSL        R16
        ROL        R17
        STS        STD_SPUR_NR, R16
        STS        STD_SPUR_NR+1, R17
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (DATA_WORD)
        MOV        R16, R1
        MOV        R17, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x0000)
        LDI        R18, LOW(0x0000)
        LDI        R19, HIGH(0x0000)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0645
        CLR        R16
        RJMP       M_VERGL_0646
M_VERGL_0645:
        SER        R16
M_VERGL_0646:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0642
        RJMP       M_IF_0643
M_IF_0642:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (STD_SPUR_NR)
        LDS        R16, STD_SPUR_NR
        LDS        R17, STD_SPUR_NR+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0001)
        LDI        R18, LOW(0x0001)
        LDI        R19, HIGH(0x0001)
 
; Operator OR
        OR         R16, R18
        OR         R17, R19
 
; Zuweisung Ziel /  VAR (STD_SPUR_NR)
        STS        STD_SPUR_NR, R16
        STS        STD_SPUR_NR+1, R17
 
; IF_THEN - Ende
M_IF_0643:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (STD_SEKTOR_NR)
        LDS        R16, STD_SEKTOR_NR
        LDS        R17, STD_SEKTOR_NR+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x001F)
        LDI        R18, LOW(0x001F)
        LDI        R19, HIGH(0x001F)
 
; Operator AND
        AND        R16, R18
        AND        R17, R19
 
; Zuweisung Ziel /  VAR (STD_SEKTOR_NR)
        STS        STD_SEKTOR_NR, R16
        STS        STD_SEKTOR_NR+1, R17
 
; PROCEDURE - Ende (STD_AN_LOKALEN_FLASH_MANAGER_SENDEN)
        RET
 
; PROCEDURE - Anfang (LOKALEN_FLASH_MANAGER_SEKTOR_LESEN)
LOKALEN_FLASH_MANAGER_SEKTOR_LESEN:
 
; Retten der lokalen Parameter fuer PROCEDURE (LOKALEN_FLASH_MANAGER_SEKTOR_LESEN)
        PUSH       R0
 
; Aufruf PROCEDURE (FM_READ_DATA_ARRAY)
        CALL       FM_READ_DATA_ARRAY
 
; Retten der Parameter-Register fuer PROCEDURE (LOKALEN_FLASH_MANAGER_SEKTOR_LESEN)
        POP        R0
 
; PROCEDURE - Ende (LOKALEN_FLASH_MANAGER_SEKTOR_LESEN)
        RET
 
; PROCEDURE - Anfang (LOKALEN_FLASH_MANAGER_SEKTOR_SCHREIBEN)
LOKALEN_FLASH_MANAGER_SEKTOR_SCHREIBEN:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (SEKTOR_PUFFER_ZEIGER)
        STS        SEKTOR_PUFFER_ZEIGER, R16
        STS        SEKTOR_PUFFER_ZEIGER+1, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x007F)
        LDI        R16, LOW(0x007F)
        LDI        R17, HIGH(0x007F)
 
; FOR TO DO - Laden des Word-Zaehlwertes
        LDS        R18, SEKTOR_PUFFER_ZEIGER
        LDS        R19, SEKTOR_PUFFER_ZEIGER+1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0647:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0648
        RJMP       M_FTD_0649
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0648:
 
; ARRAY - Ausdruck / Word-VAR (SEKTOR_PUFFER_ZEIGER)
        LDS        R16, SEKTOR_PUFFER_ZEIGER
        LDS        R17, SEKTOR_PUFFER_ZEIGER+1
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DATA_BYTE)
        MOV        R0, R16
 
; VAR ARRAY-1D POSITION - Ausdruck / Word-VAR (SEKTOR_PUFFER_ZEIGER)
        LDS        R16, SEKTOR_PUFFER_ZEIGER
        LDS        R17, SEKTOR_PUFFER_ZEIGER+1
 
; VAR ARRAY Ziel Zeiger berechnen (SEKTOR_PUFFER_WR)
        LDI        ZL, LOW(SEKTOR_PUFFER_WR)
        LDI        ZH, HIGH(SEKTOR_PUFFER_WR)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (DATA_BYTE)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR ARRAY-1D (SEKTOR_PUFFER_WR)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; FOR TO DO - (global)Word-INC-Zaehler
        LDS        R18, SEKTOR_PUFFER_ZEIGER
        LDS        R19, SEKTOR_PUFFER_ZEIGER+1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        STS        SEKTOR_PUFFER_ZEIGER, R18
        STS        SEKTOR_PUFFER_ZEIGER+1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0647
 
; FOR TO DO - Ende
M_FTD_0649:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Retten der lokalen Parameter fuer PROCEDURE (LOKALEN_FLASH_MANAGER_SEKTOR_SCHREIBEN)
        PUSH       R0
 
; Aufruf PROCEDURE (FM_PRUEFE_VERSCHIEBEN_SPUR_NOTWENDIG)
        CALL       FM_PRUEFE_VERSCHIEBEN_SPUR_NOTWENDIG
 
; Retten der Parameter-Register fuer PROCEDURE (LOKALEN_FLASH_MANAGER_SEKTOR_SCHREIBEN)
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (SEKTOR_PUFFER_ZEIGER)
        STS        SEKTOR_PUFFER_ZEIGER, R16
        STS        SEKTOR_PUFFER_ZEIGER+1, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x007F)
        LDI        R16, LOW(0x007F)
        LDI        R17, HIGH(0x007F)
 
; FOR TO DO - Laden des Word-Zaehlwertes
        LDS        R18, SEKTOR_PUFFER_ZEIGER
        LDS        R19, SEKTOR_PUFFER_ZEIGER+1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0650:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0651
        RJMP       M_FTD_0652
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0651:
 
; ARRAY - Ausdruck / Word-VAR (SEKTOR_PUFFER_ZEIGER)
        LDS        R16, SEKTOR_PUFFER_ZEIGER
        LDS        R17, SEKTOR_PUFFER_ZEIGER+1
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (SEKTOR_PUFFER_WR)
        LDI        ZL, LOW(SEKTOR_PUFFER_WR)
        LDI        ZH, HIGH(SEKTOR_PUFFER_WR)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DATA_BYTE)
        MOV        R0, R16
 
; VAR ARRAY-1D POSITION - Ausdruck / Word-VAR (SEKTOR_PUFFER_ZEIGER)
        LDS        R16, SEKTOR_PUFFER_ZEIGER
        LDS        R17, SEKTOR_PUFFER_ZEIGER+1
 
; VAR ARRAY Ziel Zeiger berechnen (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (DATA_BYTE)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR ARRAY-1D (SEKTOR_PUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; FOR TO DO - (global)Word-INC-Zaehler
        LDS        R18, SEKTOR_PUFFER_ZEIGER
        LDS        R19, SEKTOR_PUFFER_ZEIGER+1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        STS        SEKTOR_PUFFER_ZEIGER, R18
        STS        SEKTOR_PUFFER_ZEIGER+1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0650
 
; FOR TO DO - Ende
M_FTD_0652:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Retten der lokalen Parameter fuer PROCEDURE (LOKALEN_FLASH_MANAGER_SEKTOR_SCHREIBEN)
        PUSH       R0
 
; Aufruf PROCEDURE (FM_WRITE_DATA_ARRAY)
        CALL       FM_WRITE_DATA_ARRAY
 
; Retten der Parameter-Register fuer PROCEDURE (LOKALEN_FLASH_MANAGER_SEKTOR_SCHREIBEN)
        POP        R0
 
; PROCEDURE - Ende (LOKALEN_FLASH_MANAGER_SEKTOR_SCHREIBEN)
        RET
 
; PROCEDURE - Anfang (INIT_ITP3)
INIT_ITP3:
 
; ClearBit(ITP3_D0_D)
        CBI        DDRA, 0
 
; ClearBit(ITP3_D1_D)
        CBI        DDRA, 1
 
; ClearBit(ITP3_D2_D)
        CBI        DDRA, 2
 
; ClearBit(ITP3_D3_D)
        CBI        DDRA, 3
 
; SetBit(ITP3_DS0_D)
        SBI        DDRA, 4
 
; SetBit(ITP3_DS0_A)
        SBI        PORTA, 4
 
; SetBit(ITP3_DS1_D)
        SBI        DDRA, 5
 
; SetBit(ITP3_DS1_A)
        SBI        PORTA, 5
 
; SetBit(ITP3_DS2_D)
        SBI        DDRA, 6
 
; SetBit(ITP3_DS2_A)
        SBI        PORTA, 6
 
; SetBit(ITP3_DS3_D)
        SBI        DDRD, 0
 
; SetBit(ITP3_DS3_A)
        SBI        PORTD, 0
 
; SetBit(ITP3_DS4_D)
        SBI        DDRD, 1
 
; SetBit(ITP3_DS4_A)
        SBI        PORTD, 1
 
; ClearBit(ITP3_DR_D)
        CBI        DDRB, 0
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS0)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NO_DEVICE)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (CONOUT_DEVICE_NR1)
        STS        CONOUT_DEVICE_NR1, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NO_DEVICE)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (CONOUT_DEVICE_NR2)
        STS        CONOUT_DEVICE_NR2, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NO_DEVICE)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (CONIN_DEVICE)
        STS        CONIN_DEVICE, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NO_DEVICE)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (LIST_DEVICE)
        STS        LIST_DEVICE, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NO_DEVICE)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (SOUND_DEVICE)
        STS        SOUND_DEVICE, R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NO_DEVICE)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (READER_DEVICE)
        STS        READER_DEVICE, R16
 
; PROCEDURE - Ende (INIT_ITP3)
        RET
 
; PROCEDURE - Anfang (DEV_NR_CLEARBIT)
DEV_NR_CLEARBIT:
 
; CASE OF - Byte-VAR (DEV_NR)
        LDS        R16, DEV_NR
 
; CASE OF - vergleiche Einzel-Element (DEV_DS0)
        CPI        R16, 0x00
        BREQ       M_CASE_0655
        RJMP       M_CASE_0654
M_CASE_0655:
 
; ClearBit(ITP3_DS0_A)
        CBI        PORTA, 4
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0653
M_CASE_0654:
 
; CASE OF - vergleiche Einzel-Element (DEV_DS1)
        CPI        R16, 0x01
        BREQ       M_CASE_0657
        RJMP       M_CASE_0656
M_CASE_0657:
 
; ClearBit(ITP3_DS1_A)
        CBI        PORTA, 5
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0653
M_CASE_0656:
 
; CASE OF - vergleiche Einzel-Element (DEV_DS2)
        CPI        R16, 0x02
        BREQ       M_CASE_0659
        RJMP       M_CASE_0658
M_CASE_0659:
 
; ClearBit(ITP3_DS2_A)
        CBI        PORTA, 6
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0653
M_CASE_0658:
 
; CASE OF - vergleiche Einzel-Element (DEV_DS3)
        CPI        R16, 0x03
        BREQ       M_CASE_0661
        RJMP       M_CASE_0660
M_CASE_0661:
 
; ClearBit(ITP3_DS3_A)
        CBI        PORTD, 0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0653
M_CASE_0660:
 
; CASE OF - vergleiche Einzel-Element (DEV_DS4)
        CPI        R16, 0x04
        BREQ       M_CASE_0663
        RJMP       M_CASE_0662
M_CASE_0663:
 
; ClearBit(ITP3_DS4_A)
        CBI        PORTD, 1
 
; ENDCASE;
M_CASE_0662:
M_CASE_0653:
 
; PROCEDURE - Ende (DEV_NR_CLEARBIT)
        RET
 
; PROCEDURE - Anfang (DEV_NR_SETBIT)
DEV_NR_SETBIT:
 
; CASE OF - Byte-VAR (DEV_NR)
        LDS        R16, DEV_NR
 
; CASE OF - vergleiche Einzel-Element (DEV_DS0)
        CPI        R16, 0x00
        BREQ       M_CASE_0666
        RJMP       M_CASE_0665
M_CASE_0666:
 
; SetBit(ITP3_DS0_A)
        SBI        PORTA, 4
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0664
M_CASE_0665:
 
; CASE OF - vergleiche Einzel-Element (DEV_DS1)
        CPI        R16, 0x01
        BREQ       M_CASE_0668
        RJMP       M_CASE_0667
M_CASE_0668:
 
; SetBit(ITP3_DS1_A)
        SBI        PORTA, 5
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0664
M_CASE_0667:
 
; CASE OF - vergleiche Einzel-Element (DEV_DS2)
        CPI        R16, 0x02
        BREQ       M_CASE_0670
        RJMP       M_CASE_0669
M_CASE_0670:
 
; SetBit(ITP3_DS2_A)
        SBI        PORTA, 6
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0664
M_CASE_0669:
 
; CASE OF - vergleiche Einzel-Element (DEV_DS3)
        CPI        R16, 0x03
        BREQ       M_CASE_0672
        RJMP       M_CASE_0671
M_CASE_0672:
 
; SetBit(ITP3_DS3_A)
        SBI        PORTD, 0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0664
M_CASE_0671:
 
; CASE OF - vergleiche Einzel-Element (DEV_DS4)
        CPI        R16, 0x04
        BREQ       M_CASE_0674
        RJMP       M_CASE_0673
M_CASE_0674:
 
; SetBit(ITP3_DS4_A)
        SBI        PORTD, 1
 
; ENDCASE;
M_CASE_0673:
M_CASE_0664:
 
; PROCEDURE - Ende (DEV_NR_SETBIT)
        RET
 
; PROCEDURE - Anfang (ITP3_SENDE_HALBBYTE)
ITP3_SENDE_HALBBYTE:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (SB)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0678
        CLR        R16
        RJMP       M_VERGL_0679
M_VERGL_0678:
        SER        R16
M_VERGL_0679:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0675
        RJMP       M_IF_0676
M_IF_0675:
 
; ClearBit(ITP3_D0_A)
        CBI        PORTA, 0
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0677
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0676:
 
; SetBit(ITP3_D0_A)
        SBI        PORTA, 0
 
; IF_THEN_ELSE - Ende
M_IF_0677:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (SB)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x02)
        LDI        R18, 0x02
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0683
        CLR        R16
        RJMP       M_VERGL_0684
M_VERGL_0683:
        SER        R16
M_VERGL_0684:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0680
        RJMP       M_IF_0681
M_IF_0680:
 
; ClearBit(ITP3_D1_A)
        CBI        PORTA, 1
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0682
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0681:
 
; SetBit(ITP3_D1_A)
        SBI        PORTA, 1
 
; IF_THEN_ELSE - Ende
M_IF_0682:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (SB)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x04)
        LDI        R18, 0x04
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0688
        CLR        R16
        RJMP       M_VERGL_0689
M_VERGL_0688:
        SER        R16
M_VERGL_0689:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0685
        RJMP       M_IF_0686
M_IF_0685:
 
; ClearBit(ITP3_D2_A)
        CBI        PORTA, 2
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0687
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0686:
 
; SetBit(ITP3_D2_A)
        SBI        PORTA, 2
 
; IF_THEN_ELSE - Ende
M_IF_0687:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (SB)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x08)
        LDI        R18, 0x08
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0693
        CLR        R16
        RJMP       M_VERGL_0694
M_VERGL_0693:
        SER        R16
M_VERGL_0694:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0690
        RJMP       M_IF_0691
M_IF_0690:
 
; ClearBit(ITP3_D3_A)
        CBI        PORTA, 3
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0692
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0691:
 
; SetBit(ITP3_D3_A)
        SBI        PORTA, 3
 
; IF_THEN_ELSE - Ende
M_IF_0692:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SENDE_HALBBYTE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (DEV_NR_CLEARBIT)
        CALL       DEV_NR_CLEARBIT
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SENDE_HALBBYTE)
        POP        R1
        POP        R0
 
; WHILE DO ...
M_WHILE_0695:
 
; WHILE - Ausdruck /; BitHigh(ITP3_DR_E)
        IN         R16, PINB
        BST        R16, 0
        BRTS       M_VERGL_0698
        CLR        R16
        RJMP       M_VERGL_0699
M_VERGL_0698:
        SER        R16
M_VERGL_0699:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0696
        RJMP       M_WHILE_0697
M_WHILE_0696:
 
; WHILE DO ...
        RJMP       M_WHILE_0695
M_WHILE_0697:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SENDE_HALBBYTE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (DEV_NR_SETBIT)
        CALL       DEV_NR_SETBIT
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SENDE_HALBBYTE)
        POP        R1
        POP        R0
 
; WHILE DO ...
M_WHILE_0700:
 
; WHILE - Ausdruck /; BitLow(ITP3_DR_E)
        IN         R16, PINB
        BST        R16, 0
        BRTC       M_VERGL_0703
        CLR        R16
        RJMP       M_VERGL_0704
M_VERGL_0703:
        SER        R16
M_VERGL_0704:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0701
        RJMP       M_WHILE_0702
M_WHILE_0701:
 
; WHILE DO ...
        RJMP       M_WHILE_0700
M_WHILE_0702:
 
; PROCEDURE - Ende (ITP3_SENDE_HALBBYTE)
        RET
 
; PROCEDURE - Anfang (ITP3_SENDE_BYTE)
ITP3_SENDE_BYTE:
 
; SetBit(ITP3_D0_D)
        SBI        DDRA, 0
 
; SetBit(ITP3_D1_D)
        SBI        DDRA, 1
 
; SetBit(ITP3_D2_D)
        SBI        DDRA, 2
 
; SetBit(ITP3_D3_D)
        SBI        DDRA, 3
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SENDE_BYTE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (DEV_NR_SETBIT)
        CALL       DEV_NR_SETBIT
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SENDE_BYTE)
        POP        R1
        POP        R0
 
; ClearBit(ITP3_DR_D)
        CBI        DDRB, 0
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (SB)
        MOV        R16, R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0F)
        LDI        R18, 0x0F
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SENDE_BYTE)
        PUSH       R0
        PUSH       R1
 
; Parameter (B1) retten
        MOV        R17, R1
 
; lokalen Parameter (B1) an Prozedur (ITP3_SENDE_HALBBYTE)
        MOV        R0, R17
 
; Aufruf PROCEDURE (ITP3_SENDE_HALBBYTE)
        CALL       ITP3_SENDE_HALBBYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SENDE_BYTE)
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (SB)
        MOV        R16, R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; SHR(B1) - Byte
        LSR        R1
 
; SHR(B1) - Byte
        LSR        R1
 
; SHR(B1) - Byte
        LSR        R1
 
; SHR(B1) - Byte
        LSR        R1
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SENDE_BYTE)
        PUSH       R0
        PUSH       R1
 
; Parameter (B1) retten
        MOV        R17, R1
 
; lokalen Parameter (B1) an Prozedur (ITP3_SENDE_HALBBYTE)
        MOV        R0, R17
 
; Aufruf PROCEDURE (ITP3_SENDE_HALBBYTE)
        CALL       ITP3_SENDE_HALBBYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SENDE_BYTE)
        POP        R1
        POP        R0
 
; ClearBit(ITP3_D0_D)
        CBI        DDRA, 0
 
; ClearBit(ITP3_D1_D)
        CBI        DDRA, 1
 
; ClearBit(ITP3_D2_D)
        CBI        DDRA, 2
 
; ClearBit(ITP3_D3_D)
        CBI        DDRA, 3
 
; PROCEDURE - Ende (ITP3_SENDE_BYTE)
        RET
 
; FUNCTION - Anfang (ITP3_SENDE_TEST_HALBBYTE)
ITP3_SENDE_TEST_HALBBYTE:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (SB)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0708
        CLR        R16
        RJMP       M_VERGL_0709
M_VERGL_0708:
        SER        R16
M_VERGL_0709:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0705
        RJMP       M_IF_0706
M_IF_0705:
 
; ClearBit(ITP3_D0_A)
        CBI        PORTA, 0
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0707
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0706:
 
; SetBit(ITP3_D0_A)
        SBI        PORTA, 0
 
; IF_THEN_ELSE - Ende
M_IF_0707:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (SB)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x02)
        LDI        R18, 0x02
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0713
        CLR        R16
        RJMP       M_VERGL_0714
M_VERGL_0713:
        SER        R16
M_VERGL_0714:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0710
        RJMP       M_IF_0711
M_IF_0710:
 
; ClearBit(ITP3_D1_A)
        CBI        PORTA, 1
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0712
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0711:
 
; SetBit(ITP3_D1_A)
        SBI        PORTA, 1
 
; IF_THEN_ELSE - Ende
M_IF_0712:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (SB)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x04)
        LDI        R18, 0x04
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0718
        CLR        R16
        RJMP       M_VERGL_0719
M_VERGL_0718:
        SER        R16
M_VERGL_0719:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0715
        RJMP       M_IF_0716
M_IF_0715:
 
; ClearBit(ITP3_D2_A)
        CBI        PORTA, 2
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0717
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0716:
 
; SetBit(ITP3_D2_A)
        SBI        PORTA, 2
 
; IF_THEN_ELSE - Ende
M_IF_0717:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (SB)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x08)
        LDI        R18, 0x08
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0723
        CLR        R16
        RJMP       M_VERGL_0724
M_VERGL_0723:
        SER        R16
M_VERGL_0724:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0720
        RJMP       M_IF_0721
M_IF_0720:
 
; ClearBit(ITP3_D3_A)
        CBI        PORTA, 3
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0722
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0721:
 
; SetBit(ITP3_D3_A)
        SBI        PORTA, 3
 
; IF_THEN_ELSE - Ende
M_IF_0722:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SENDE_TEST_HALBBYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (DEV_NR_CLEARBIT)
        CALL       DEV_NR_CLEARBIT
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SENDE_TEST_HALBBYTE)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (WAIT_COUNTER)
        MOV        R3, R16
        MOV        R4, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R5, R16
 
; WHILE DO ...
M_WHILE_0725:
 
; WHILE - Ausdruck / lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R16, R5
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0726
        RJMP       M_WHILE_0727
M_WHILE_0726:
 
; IF THEN - Ausdruck /; BitLow(ITP3_DR_E)
        IN         R16, PINB
        BST        R16, 0
        BRTC       M_VERGL_0731
        CLR        R16
        RJMP       M_VERGL_0732
M_VERGL_0731:
        SER        R16
M_VERGL_0732:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0728
        RJMP       M_IF_0729
M_IF_0728:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R5, R16
 
; IF_THEN - Ende
M_IF_0729:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (WAIT_COUNTER)
        MOV        R16, R3
        MOV        R17, R4
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0xEA60)
        LDI        R18, LOW(0xEA60)
        LDI        R19, HIGH(0xEA60)
 
; Operator >
        CP         R18, R16
        CPC        R19, R17
        BRCS       M_VERGL_0736
        CLR        R16
        RJMP       M_VERGL_0737
M_VERGL_0736:
        SER        R16
M_VERGL_0737:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0733
        RJMP       M_IF_0734
M_IF_0733:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R5, R16
 
; IF_THEN - Ende
M_IF_0734:
 
; INC(WAIT_COUNTER) - Word
        MOV        R24, R3
        MOV        R25, R4
        ADIW       R25:R24, 1
        MOV        R3, R24
        MOV        R4, R25
 
; WHILE DO ...
        RJMP       M_WHILE_0725
M_WHILE_0727:
 
; IF THEN - Ausdruck /; BitLow(ITP3_DR_E)
        IN         R16, PINB
        BST        R16, 0
        BRTC       M_VERGL_0741
        CLR        R16
        RJMP       M_VERGL_0742
M_VERGL_0741:
        SER        R16
M_VERGL_0742:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0738
        RJMP       M_IF_0739
M_IF_0738:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SENDE_TEST_HALBBYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (DEV_NR_SETBIT)
        CALL       DEV_NR_SETBIT
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SENDE_TEST_HALBBYTE)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R5, R16
 
; WHILE DO ...
M_WHILE_0743:
 
; WHILE - Ausdruck /; BitLow(ITP3_DR_E)
        IN         R16, PINB
        BST        R16, 0
        BRTC       M_VERGL_0746
        CLR        R16
        RJMP       M_VERGL_0747
M_VERGL_0746:
        SER        R16
M_VERGL_0747:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0744
        RJMP       M_WHILE_0745
M_WHILE_0744:
 
; WHILE DO ...
        RJMP       M_WHILE_0743
M_WHILE_0745:
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0740
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0739:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SENDE_TEST_HALBBYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
        PUSH       R5
 
; Aufruf PROCEDURE (DEV_NR_SETBIT)
        CALL       DEV_NR_SETBIT
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SENDE_TEST_HALBBYTE)
        POP        R5
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R5, R16
 
; IF_THEN_ELSE - Ende
M_IF_0740:
 
; RESULT Byte-Variable - FUNCTION (ITP3_SENDE_TEST_HALBBYTE)
        MOV        R1, R5
 
; Ende Byte - FUNCTION (ITP3_SENDE_TEST_HALBBYTE)
        MOV        R16, R1
 
; FUNCTION - Ende (ITP3_SENDE_TEST_HALBBYTE)
        RET
 
; FUNCTION - Anfang (ITP3_SENDE_TEST_BYTE)
ITP3_SENDE_TEST_BYTE:
 
; SetBit(ITP3_D0_D)
        SBI        DDRA, 0
 
; SetBit(ITP3_D1_D)
        SBI        DDRA, 1
 
; SetBit(ITP3_D2_D)
        SBI        DDRA, 2
 
; SetBit(ITP3_D3_D)
        SBI        DDRA, 3
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SENDE_TEST_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (DEV_NR_SETBIT)
        CALL       DEV_NR_SETBIT
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SENDE_TEST_BYTE)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; ClearBit(ITP3_DR_D)
        CBI        DDRB, 0
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (SB)
        MOV        R16, R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0F)
        LDI        R18, 0x0F
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SENDE_TEST_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (B1) retten
        MOV        R17, R2
 
; lokalen Parameter (B1) an Funktion (ITP3_SENDE_TEST_HALBBYTE)
        MOV        R0, R17
 
; Aufruf Funktion (ITP3_SENDE_TEST_HALBBYTE)
        CALL       ITP3_SENDE_TEST_HALBBYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SENDE_TEST_BYTE)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R3, R16
 
; IF THEN - Ausdruck / lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R16, R3
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0748
        RJMP       M_IF_0749
M_IF_0748:
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (SB)
        MOV        R16, R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; SHR(B1) - Byte
        LSR        R2
 
; SHR(B1) - Byte
        LSR        R2
 
; SHR(B1) - Byte
        LSR        R2
 
; SHR(B1) - Byte
        LSR        R2
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SENDE_TEST_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (B1) retten
        MOV        R17, R2
 
; lokalen Parameter (B1) an Prozedur (ITP3_SENDE_HALBBYTE)
        MOV        R0, R17
 
; Aufruf PROCEDURE (ITP3_SENDE_HALBBYTE)
        CALL       ITP3_SENDE_HALBBYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SENDE_TEST_BYTE)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN - Ende
M_IF_0749:
 
; ClearBit(ITP3_D0_D)
        CBI        DDRA, 0
 
; ClearBit(ITP3_D1_D)
        CBI        DDRA, 1
 
; ClearBit(ITP3_D2_D)
        CBI        DDRA, 2
 
; ClearBit(ITP3_D3_D)
        CBI        DDRA, 3
 
; RESULT Byte-Variable - FUNCTION (ITP3_SENDE_TEST_BYTE)
        MOV        R1, R3
 
; Ende Byte - FUNCTION (ITP3_SENDE_TEST_BYTE)
        MOV        R16, R1
 
; FUNCTION - Ende (ITP3_SENDE_TEST_BYTE)
        RET
 
; FUNCTION - Anfang (ITP3_EMPFANGE_HALBBYTE)
ITP3_EMPFANGE_HALBBYTE:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_EMPFANGE_HALBBYTE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (DEV_NR_CLEARBIT)
        CALL       DEV_NR_CLEARBIT
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_EMPFANGE_HALBBYTE)
        POP        R1
        POP        R0
 
; WHILE DO ...
M_WHILE_0751:
 
; WHILE - Ausdruck /; BitHigh(ITP3_DR_E)
        IN         R16, PINB
        BST        R16, 0
        BRTS       M_VERGL_0754
        CLR        R16
        RJMP       M_VERGL_0755
M_VERGL_0754:
        SER        R16
M_VERGL_0755:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0752
        RJMP       M_WHILE_0753
M_WHILE_0752:
 
; WHILE DO ...
        RJMP       M_WHILE_0751
M_WHILE_0753:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R1, R16
 
; IF THEN - Ausdruck /; BitHigh(ITP3_D0_E)
        IN         R16, PINA
        BST        R16, 0
        BRTS       M_VERGL_0759
        CLR        R16
        RJMP       M_VERGL_0760
M_VERGL_0759:
        SER        R16
M_VERGL_0760:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0756
        RJMP       M_IF_0757
M_IF_0756:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R1, R16
 
; IF_THEN - Ende
M_IF_0757:
 
; IF THEN - Ausdruck /; BitHigh(ITP3_D1_E)
        IN         R16, PINA
        BST        R16, 1
        BRTS       M_VERGL_0764
        CLR        R16
        RJMP       M_VERGL_0765
M_VERGL_0764:
        SER        R16
M_VERGL_0765:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0761
        RJMP       M_IF_0762
M_IF_0761:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x02)
        LDI        R18, 0x02
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R1, R16
 
; IF_THEN - Ende
M_IF_0762:
 
; IF THEN - Ausdruck /; BitHigh(ITP3_D2_E)
        IN         R16, PINA
        BST        R16, 2
        BRTS       M_VERGL_0769
        CLR        R16
        RJMP       M_VERGL_0770
M_VERGL_0769:
        SER        R16
M_VERGL_0770:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0766
        RJMP       M_IF_0767
M_IF_0766:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x04)
        LDI        R18, 0x04
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R1, R16
 
; IF_THEN - Ende
M_IF_0767:
 
; IF THEN - Ausdruck /; BitHigh(ITP3_D3_E)
        IN         R16, PINA
        BST        R16, 3
        BRTS       M_VERGL_0774
        CLR        R16
        RJMP       M_VERGL_0775
M_VERGL_0774:
        SER        R16
M_VERGL_0775:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0771
        RJMP       M_IF_0772
M_IF_0771:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x08)
        LDI        R18, 0x08
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R1, R16
 
; IF_THEN - Ende
M_IF_0772:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_EMPFANGE_HALBBYTE)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (DEV_NR_SETBIT)
        CALL       DEV_NR_SETBIT
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_EMPFANGE_HALBBYTE)
        POP        R1
        POP        R0
 
; WHILE DO ...
M_WHILE_0776:
 
; WHILE - Ausdruck /; BitLow(ITP3_DR_E)
        IN         R16, PINB
        BST        R16, 0
        BRTC       M_VERGL_0779
        CLR        R16
        RJMP       M_VERGL_0780
M_VERGL_0779:
        SER        R16
M_VERGL_0780:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0777
        RJMP       M_WHILE_0778
M_WHILE_0777:
 
; WHILE DO ...
        RJMP       M_WHILE_0776
M_WHILE_0778:
 
; RESULT Byte-Variable - FUNCTION (ITP3_EMPFANGE_HALBBYTE)
        MOV        R0, R1
 
; Ende Byte - FUNCTION (ITP3_EMPFANGE_HALBBYTE)
        MOV        R16, R0
 
; FUNCTION - Ende (ITP3_EMPFANGE_HALBBYTE)
        RET
 
; FUNCTION - Anfang (ITP3_EMPFANGE_BYTE)
ITP3_EMPFANGE_BYTE:
 
; ClearBit(ITP3_D0_D)
        CBI        DDRA, 0
 
; ClearBit(ITP3_D1_D)
        CBI        DDRA, 1
 
; ClearBit(ITP3_D2_D)
        CBI        DDRA, 2
 
; ClearBit(ITP3_D3_D)
        CBI        DDRA, 3
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_EMPFANGE_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (DEV_NR_SETBIT)
        CALL       DEV_NR_SETBIT
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_EMPFANGE_BYTE)
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_EMPFANGE_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf Funktion (ITP3_EMPFANGE_HALBBYTE)
        CALL       ITP3_EMPFANGE_HALBBYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_EMPFANGE_BYTE)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE_01)
        MOV        R1, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_EMPFANGE_BYTE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf Funktion (ITP3_EMPFANGE_HALBBYTE)
        CALL       ITP3_EMPFANGE_HALBBYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_EMPFANGE_BYTE)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE_02)
        MOV        R2, R16
 
; SHL(RESULT_BYTE_02) - Byte
        LSL        R2
 
; SHL(RESULT_BYTE_02) - Byte
        LSL        R2
 
; SHL(RESULT_BYTE_02) - Byte
        LSL        R2
 
; SHL(RESULT_BYTE_02) - Byte
        LSL        R2
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (RESULT_BYTE_01)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (RESULT_BYTE_02)
        MOV        R18, R2
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE_01)
        MOV        R1, R16
 
; RESULT Byte-Variable - FUNCTION (ITP3_EMPFANGE_BYTE)
        MOV        R0, R1
 
; Ende Byte - FUNCTION (ITP3_EMPFANGE_BYTE)
        MOV        R16, R0
 
; FUNCTION - Ende (ITP3_EMPFANGE_BYTE)
        RET
 
; PROCEDURE - Anfang (ITP3_SENDE_CONOUT)
ITP3_SENDE_CONOUT:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SENDE_CONOUT)
        PUSH       R0
 
; Byte-Parameter(1) fuer PROCEDURE (ITP3_SENDE_BYTE)
        LDI        R16, 0x03
        MOV        R0, R16
 
; Aufruf PROCEDURE (ITP3_SENDE_BYTE)
        CALL       ITP3_SENDE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SENDE_CONOUT)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SENDE_CONOUT)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_SENDE_BYTE)
        CALL       ITP3_SENDE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SENDE_CONOUT)
        POP        R0
 
; PROCEDURE - Ende (ITP3_SENDE_CONOUT)
        RET
 
; PROCEDURE - Anfang (ITP3_SENDE_SOUND)
ITP3_SENDE_SOUND:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SENDE_SOUND)
        PUSH       R0
 
; Byte-Parameter(1) fuer PROCEDURE (ITP3_SENDE_BYTE)
        LDI        R16, 0x09
        MOV        R0, R16
 
; Aufruf PROCEDURE (ITP3_SENDE_BYTE)
        CALL       ITP3_SENDE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SENDE_SOUND)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SENDE_SOUND)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_SENDE_BYTE)
        CALL       ITP3_SENDE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SENDE_SOUND)
        POP        R0
 
; PROCEDURE - Ende (ITP3_SENDE_SOUND)
        RET
 
; FUNCTION - Anfang (ITP3_EMPFANGE_CONST)
ITP3_EMPFANGE_CONST:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_EMPFANGE_CONST)
        PUSH       R0
        PUSH       R1
 
; Byte-Parameter(1) fuer PROCEDURE (ITP3_SENDE_BYTE)
        LDI        R16, 0x04
        MOV        R0, R16
 
; Aufruf PROCEDURE (ITP3_SENDE_BYTE)
        CALL       ITP3_SENDE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_EMPFANGE_CONST)
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_EMPFANGE_CONST)
        PUSH       R0
        PUSH       R1
 
; Aufruf Funktion (ITP3_EMPFANGE_BYTE)
        CALL       ITP3_EMPFANGE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_EMPFANGE_CONST)
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R1, R16
 
; RESULT Byte-Variable - FUNCTION (ITP3_EMPFANGE_CONST)
        MOV        R0, R1
 
; Ende Byte - FUNCTION (ITP3_EMPFANGE_CONST)
        MOV        R16, R0
 
; FUNCTION - Ende (ITP3_EMPFANGE_CONST)
        RET
 
; FUNCTION - Anfang (ITP3_EMPFANGE_CONIN)
ITP3_EMPFANGE_CONIN:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_EMPFANGE_CONIN)
        PUSH       R0
        PUSH       R1
 
; Byte-Parameter(1) fuer PROCEDURE (ITP3_SENDE_BYTE)
        LDI        R16, 0x05
        MOV        R0, R16
 
; Aufruf PROCEDURE (ITP3_SENDE_BYTE)
        CALL       ITP3_SENDE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_EMPFANGE_CONIN)
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_EMPFANGE_CONIN)
        PUSH       R0
        PUSH       R1
 
; Aufruf Funktion (ITP3_EMPFANGE_BYTE)
        CALL       ITP3_EMPFANGE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_EMPFANGE_CONIN)
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R1, R16
 
; RESULT Byte-Variable - FUNCTION (ITP3_EMPFANGE_CONIN)
        MOV        R0, R1
 
; Ende Byte - FUNCTION (ITP3_EMPFANGE_CONIN)
        MOV        R16, R0
 
; FUNCTION - Ende (ITP3_EMPFANGE_CONIN)
        RET
 
; PROCEDURE - Anfang (ITP3_CONIN_SCHLEIFE)
ITP3_CONIN_SCHLEIFE:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (CONSOLEIN)
        STS        CONSOLEIN, R16
 
; WHILE DO ...
M_WHILE_0781:
 
; WHILE - Ausdruck erster Faktor / Byte-VAR (CONSOLEIN)
        LDS        R16, CONSOLEIN
 
; WHILE - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0784
        CLR        R16
        RJMP       M_VERGL_0785
M_VERGL_0784:
        SER        R16
M_VERGL_0785:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0782
        RJMP       M_WHILE_0783
M_WHILE_0782:
 
; Aufruf Funktion (ITP3_EMPFANGE_CONST)
        CALL       ITP3_EMPFANGE_CONST
 
; Zuweisung Ziel /  VAR (CONSOLEIN)
        STS        CONSOLEIN, R16
 
; WHILE DO ...
        RJMP       M_WHILE_0781
M_WHILE_0783:
 
; Aufruf Funktion (ITP3_EMPFANGE_CONIN)
        CALL       ITP3_EMPFANGE_CONIN
 
; Zuweisung Ziel /  VAR (CONSOLEIN)
        STS        CONSOLEIN, R16
 
; PROCEDURE - Ende (ITP3_CONIN_SCHLEIFE)
        RET
 
; PROCEDURE - Anfang (ITP3_SENDE_STD)
ITP3_SENDE_STD:
 
; Byte-Parameter(1) fuer PROCEDURE (ITP3_SENDE_BYTE)
        LDI        R16, 0x06
        MOV        R0, R16
 
; Aufruf PROCEDURE (ITP3_SENDE_BYTE)
        CALL       ITP3_SENDE_BYTE
 
; Byte-Parameter(1) fuer PROCEDURE (ITP3_SENDE_BYTE)
        LDS        R0, SECTOR
 
; Aufruf PROCEDURE (ITP3_SENDE_BYTE)
        CALL       ITP3_SENDE_BYTE
 
; Byte-Parameter(1) fuer PROCEDURE (ITP3_SENDE_BYTE)
        LDS        R0, TRACK_L
 
; Aufruf PROCEDURE (ITP3_SENDE_BYTE)
        CALL       ITP3_SENDE_BYTE
 
; Byte-Parameter(1) fuer PROCEDURE (ITP3_SENDE_BYTE)
        LDS        R0, TRACK_H
 
; Aufruf PROCEDURE (ITP3_SENDE_BYTE)
        CALL       ITP3_SENDE_BYTE
 
; Byte-Parameter(1) fuer PROCEDURE (ITP3_SENDE_BYTE)
        LDS        R0, DISKNO
 
; Aufruf PROCEDURE (ITP3_SENDE_BYTE)
        CALL       ITP3_SENDE_BYTE
 
; PROCEDURE - Ende (ITP3_SENDE_STD)
        RET
 
; PROCEDURE - Anfang (ITP3_SEKTOR_LESEN)
ITP3_SEKTOR_LESEN:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SEKTOR_LESEN)
        PUSH       R0
 
; Byte-Parameter(1) fuer PROCEDURE (ITP3_SENDE_BYTE)
        LDI        R16, 0x07
        MOV        R0, R16
 
; Aufruf PROCEDURE (ITP3_SENDE_BYTE)
        CALL       ITP3_SENDE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SEKTOR_LESEN)
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (SEKTOR_PUFFER_ZEIGER)
        STS        SEKTOR_PUFFER_ZEIGER, R16
        STS        SEKTOR_PUFFER_ZEIGER+1, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x007F)
        LDI        R16, LOW(0x007F)
        LDI        R17, HIGH(0x007F)
 
; FOR TO DO - Laden des Word-Zaehlwertes
        LDS        R18, SEKTOR_PUFFER_ZEIGER
        LDS        R19, SEKTOR_PUFFER_ZEIGER+1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0786:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0787
        RJMP       M_FTD_0788
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0787:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SEKTOR_LESEN)
        PUSH       R0
 
; Aufruf Funktion (ITP3_EMPFANGE_BYTE)
        CALL       ITP3_EMPFANGE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SEKTOR_LESEN)
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; VAR ARRAY-1D POSITION - Ausdruck / Word-VAR (SEKTOR_PUFFER_ZEIGER)
        LDS        R16, SEKTOR_PUFFER_ZEIGER
        LDS        R17, SEKTOR_PUFFER_ZEIGER+1
 
; VAR ARRAY Ziel Zeiger berechnen (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B1)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR ARRAY-1D (SEKTOR_PUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; FOR TO DO - (global)Word-INC-Zaehler
        LDS        R18, SEKTOR_PUFFER_ZEIGER
        LDS        R19, SEKTOR_PUFFER_ZEIGER+1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        STS        SEKTOR_PUFFER_ZEIGER, R18
        STS        SEKTOR_PUFFER_ZEIGER+1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0786
 
; FOR TO DO - Ende
M_FTD_0788:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; PROCEDURE - Ende (ITP3_SEKTOR_LESEN)
        RET
 
; PROCEDURE - Anfang (ITP3_SEKTOR_SCHREIBEN)
ITP3_SEKTOR_SCHREIBEN:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SEKTOR_SCHREIBEN)
        PUSH       R0
 
; Byte-Parameter(1) fuer PROCEDURE (ITP3_SENDE_BYTE)
        LDI        R16, 0x08
        MOV        R0, R16
 
; Aufruf PROCEDURE (ITP3_SENDE_BYTE)
        CALL       ITP3_SENDE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SEKTOR_SCHREIBEN)
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (SEKTOR_PUFFER_ZEIGER)
        STS        SEKTOR_PUFFER_ZEIGER, R16
        STS        SEKTOR_PUFFER_ZEIGER+1, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x007F)
        LDI        R16, LOW(0x007F)
        LDI        R17, HIGH(0x007F)
 
; FOR TO DO - Laden des Word-Zaehlwertes
        LDS        R18, SEKTOR_PUFFER_ZEIGER
        LDS        R19, SEKTOR_PUFFER_ZEIGER+1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0789:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0790
        RJMP       M_FTD_0791
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0790:
 
; ARRAY - Ausdruck / Word-VAR (SEKTOR_PUFFER_ZEIGER)
        LDS        R16, SEKTOR_PUFFER_ZEIGER
        LDS        R17, SEKTOR_PUFFER_ZEIGER+1
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SEKTOR_SCHREIBEN)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_SENDE_BYTE)
        CALL       ITP3_SENDE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SEKTOR_SCHREIBEN)
        POP        R0
 
; FOR TO DO - (global)Word-INC-Zaehler
        LDS        R18, SEKTOR_PUFFER_ZEIGER
        LDS        R19, SEKTOR_PUFFER_ZEIGER+1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        STS        SEKTOR_PUFFER_ZEIGER, R18
        STS        SEKTOR_PUFFER_ZEIGER+1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0789
 
; FOR TO DO - Ende
M_FTD_0791:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; PROCEDURE - Ende (ITP3_SEKTOR_SCHREIBEN)
        RET
 
; FUNCTION - Anfang (ITP3_DEV_ZU_DEVICE)
ITP3_DEV_ZU_DEVICE:
 
; CASE OF - Byte-VAR (DEV_NR)
        LDS        R16, DEV_NR
 
; CASE OF - vergleiche Einzel-Element (DEV_DS0)
        CPI        R16, 0x00
        BREQ       M_CASE_0794
        RJMP       M_CASE_0793
M_CASE_0794:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEVICE_ITP3_DS0)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (CON_DEVICE)
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0792
M_CASE_0793:
 
; CASE OF - vergleiche Einzel-Element (DEV_DS1)
        CPI        R16, 0x01
        BREQ       M_CASE_0796
        RJMP       M_CASE_0795
M_CASE_0796:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEVICE_ITP3_DS1)
        LDI        R16, 0x03
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (CON_DEVICE)
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0792
M_CASE_0795:
 
; CASE OF - vergleiche Einzel-Element (DEV_DS2)
        CPI        R16, 0x02
        BREQ       M_CASE_0798
        RJMP       M_CASE_0797
M_CASE_0798:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEVICE_ITP3_DS2)
        LDI        R16, 0x04
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (CON_DEVICE)
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0792
M_CASE_0797:
 
; CASE OF - vergleiche Einzel-Element (DEV_DS3)
        CPI        R16, 0x03
        BREQ       M_CASE_0800
        RJMP       M_CASE_0799
M_CASE_0800:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEVICE_ITP3_DS3)
        LDI        R16, 0x05
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (CON_DEVICE)
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0792
M_CASE_0799:
 
; CASE OF - vergleiche Einzel-Element (DEV_DS4)
        CPI        R16, 0x04
        BREQ       M_CASE_0802
        RJMP       M_CASE_0801
M_CASE_0802:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEVICE_ITP3_DS4)
        LDI        R16, 0x06
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (CON_DEVICE)
        MOV        R1, R16
 
; ENDCASE;
M_CASE_0801:
M_CASE_0792:
 
; RESULT Byte-Variable - FUNCTION (ITP3_DEV_ZU_DEVICE)
        MOV        R0, R1
 
; Ende Byte - FUNCTION (ITP3_DEV_ZU_DEVICE)
        MOV        R16, R0
 
; FUNCTION - Ende (ITP3_DEV_ZU_DEVICE)
        RET
 
; PROCEDURE - Anfang (ITP3_PRUEFE_EINEN_ANSCHLUSS)
ITP3_PRUEFE_EINEN_ANSCHLUSS:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_PRUEFE_EINEN_ANSCHLUSS)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Byte-Parameter(1) fuer FUNCTION (ITP3_SENDE_TEST_BYTE)
        LDI        R16, 0x01
        MOV        R0, R16
 
; Aufruf Funktion (ITP3_SENDE_TEST_BYTE)
        CALL       ITP3_SENDE_TEST_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_PRUEFE_EINEN_ANSCHLUSS)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (OK_BYTE)
        MOV        R0, R16
 
; IF THEN - Ausdruck / lokale, dynamische Variable VAR (OK_BYTE)
        MOV        R16, R0
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0803
        RJMP       M_IF_0804
M_IF_0803:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_PRUEFE_EINEN_ANSCHLUSS)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf Funktion (ITP3_EMPFANGE_BYTE)
        CALL       ITP3_EMPFANGE_BYTE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_PRUEFE_EINEN_ANSCHLUSS)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (WHO_ARE_YOU_BYTE)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (WHO_ARE_YOU_BYTE)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_0809
        CLR        R16
        RJMP       M_VERGL_0810
M_VERGL_0809:
        SER        R16
M_VERGL_0810:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0806
        RJMP       M_IF_0807
M_IF_0806:
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (DEV_NR)
        LDS        R16, DEV_NR
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (DEV_DS3)
        LDI        R18, 0x03
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0814
        CLR        R16
        RJMP       M_VERGL_0815
M_VERGL_0814:
        SER        R16
M_VERGL_0815:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0811
        RJMP       M_IF_0812
M_IF_0811:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (ITP3_DS34_NICHT_GENUTZT)
        STS        ITP3_DS34_NICHT_GENUTZT, R16
 
; IF_THEN - Ende
M_IF_0812:
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (DEV_NR)
        LDS        R16, DEV_NR
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (DEV_DS4)
        LDI        R18, 0x04
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0819
        CLR        R16
        RJMP       M_VERGL_0820
M_VERGL_0819:
        SER        R16
M_VERGL_0820:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0816
        RJMP       M_IF_0817
M_IF_0816:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (ITP3_DS34_NICHT_GENUTZT)
        STS        ITP3_DS34_NICHT_GENUTZT, R16
 
; IF_THEN - Ende
M_IF_0817:
 
; IF_THEN - Ende
M_IF_0807:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (WHO_ARE_YOU_BYTE)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x80)
        LDI        R18, 0x80
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_0824
        CLR        R16
        RJMP       M_VERGL_0825
M_VERGL_0824:
        SER        R16
M_VERGL_0825:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0821
        RJMP       M_IF_0822
M_IF_0821:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_PRUEFE_EINEN_ANSCHLUSS)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf Funktion (ITP3_DEV_ZU_DEVICE)
        CALL       ITP3_DEV_ZU_DEVICE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_PRUEFE_EINEN_ANSCHLUSS)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (CO_DEV)
        MOV        R3, R16
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (CONOUT_DEVICE_NR1)
        LDS        R16, CONOUT_DEVICE_NR1
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (NO_DEVICE)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0829
        CLR        R16
        RJMP       M_VERGL_0830
M_VERGL_0829:
        SER        R16
M_VERGL_0830:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0826
        RJMP       M_IF_0827
M_IF_0826:
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (CO_DEV)
        MOV        R16, R3
 
; Zuweisung Ziel /  VAR (CONOUT_DEVICE_NR1)
        STS        CONOUT_DEVICE_NR1, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_0828
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_0827:
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (CO_DEV)
        MOV        R16, R3
 
; IF THEN - Ausdruck zweiter Faktor / Byte-VAR (CONOUT_DEVICE_NR1)
        LDS        R18, CONOUT_DEVICE_NR1
 
; Operator <>
        CP         R16, R18
        BRNE       M_VERGL_0834
        CLR        R16
        RJMP       M_VERGL_0835
M_VERGL_0834:
        SER        R16
M_VERGL_0835:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0831
        RJMP       M_IF_0832
M_IF_0831:
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (CO_DEV)
        MOV        R16, R3
 
; Zuweisung Ziel /  VAR (CONOUT_DEVICE_NR2)
        STS        CONOUT_DEVICE_NR2, R16
 
; IF_THEN - Ende
M_IF_0832:
 
; IF_THEN_ELSE - Ende
M_IF_0828:
 
; IF_THEN - Ende
M_IF_0822:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (WHO_ARE_YOU_BYTE)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x40)
        LDI        R18, 0x40
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_0839
        CLR        R16
        RJMP       M_VERGL_0840
M_VERGL_0839:
        SER        R16
M_VERGL_0840:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0836
        RJMP       M_IF_0837
M_IF_0836:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_PRUEFE_EINEN_ANSCHLUSS)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf Funktion (ITP3_DEV_ZU_DEVICE)
        CALL       ITP3_DEV_ZU_DEVICE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_PRUEFE_EINEN_ANSCHLUSS)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  VAR (CONIN_DEVICE)
        STS        CONIN_DEVICE, R16
 
; IF_THEN - Ende
M_IF_0837:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (WHO_ARE_YOU_BYTE)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x20)
        LDI        R18, 0x20
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_0844
        CLR        R16
        RJMP       M_VERGL_0845
M_VERGL_0844:
        SER        R16
M_VERGL_0845:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0841
        RJMP       M_IF_0842
M_IF_0841:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (DEV_NR)
        LDS        R16, DEV_NR
 
; Zuweisung Ziel /  VAR (LIST_DEVICE)
        STS        LIST_DEVICE, R16
 
; IF_THEN - Ende
M_IF_0842:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (WHO_ARE_YOU_BYTE)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x10)
        LDI        R18, 0x10
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_0849
        CLR        R16
        RJMP       M_VERGL_0850
M_VERGL_0849:
        SER        R16
M_VERGL_0850:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0846
        RJMP       M_IF_0847
M_IF_0846:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_PRUEFE_EINEN_ANSCHLUSS)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf Funktion (ITP3_DEV_ZU_DEVICE)
        CALL       ITP3_DEV_ZU_DEVICE
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_PRUEFE_EINEN_ANSCHLUSS)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  VAR (SOUND_DEVICE)
        STS        SOUND_DEVICE, R16
 
; IF_THEN - Ende
M_IF_0847:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (WHO_ARE_YOU_BYTE)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x08)
        LDI        R18, 0x08
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_0854
        CLR        R16
        RJMP       M_VERGL_0855
M_VERGL_0854:
        SER        R16
M_VERGL_0855:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0851
        RJMP       M_IF_0852
M_IF_0851:
 
; CASE OF - Byte-VAR (DEV_NR)
        LDS        R16, DEV_NR
 
; CASE OF - vergleiche Einzel-Element (DEV_DS0)
        CPI        R16, 0x00
        BREQ       M_CASE_0858
        RJMP       M_CASE_0857
M_CASE_0858:
 
; VAR ARRAY-1D POSITION - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; VAR ARRAY Ziel Zeiger berechnen (LAUFWERKE_VERTEILER)
        LDI        ZL, LOW(LAUFWERKE_VERTEILER)
        LDI        ZH, HIGH(LAUFWERKE_VERTEILER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEVICE_ITP3_DS0)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  VAR ARRAY-1D (LAUFWERKE_VERTEILER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0856
M_CASE_0857:
 
; CASE OF - vergleiche Einzel-Element (DEV_DS1)
        CPI        R16, 0x01
        BREQ       M_CASE_0860
        RJMP       M_CASE_0859
M_CASE_0860:
 
; VAR ARRAY-1D POSITION - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; VAR ARRAY Ziel Zeiger berechnen (LAUFWERKE_VERTEILER)
        LDI        ZL, LOW(LAUFWERKE_VERTEILER)
        LDI        ZH, HIGH(LAUFWERKE_VERTEILER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEVICE_ITP3_DS1)
        LDI        R16, 0x03
 
; Zuweisung Ziel /  VAR ARRAY-1D (LAUFWERKE_VERTEILER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0856
M_CASE_0859:
 
; CASE OF - vergleiche Einzel-Element (DEV_DS2)
        CPI        R16, 0x02
        BREQ       M_CASE_0862
        RJMP       M_CASE_0861
M_CASE_0862:
 
; VAR ARRAY-1D POSITION - Ausdruck / Zahlenwert (0x0002)
        LDI        R16, LOW(0x0002)
        LDI        R17, HIGH(0x0002)
 
; VAR ARRAY Ziel Zeiger berechnen (LAUFWERKE_VERTEILER)
        LDI        ZL, LOW(LAUFWERKE_VERTEILER)
        LDI        ZH, HIGH(LAUFWERKE_VERTEILER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEVICE_ITP3_DS2)
        LDI        R16, 0x04
 
; Zuweisung Ziel /  VAR ARRAY-1D (LAUFWERKE_VERTEILER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0856
M_CASE_0861:
 
; CASE OF - vergleiche Einzel-Element (DEV_DS3)
        CPI        R16, 0x03
        BREQ       M_CASE_0864
        RJMP       M_CASE_0863
M_CASE_0864:
 
; VAR ARRAY-1D POSITION - Ausdruck / Zahlenwert (0x0003)
        LDI        R16, LOW(0x0003)
        LDI        R17, HIGH(0x0003)
 
; VAR ARRAY Ziel Zeiger berechnen (LAUFWERKE_VERTEILER)
        LDI        ZL, LOW(LAUFWERKE_VERTEILER)
        LDI        ZH, HIGH(LAUFWERKE_VERTEILER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEVICE_ITP3_DS3)
        LDI        R16, 0x05
 
; Zuweisung Ziel /  VAR ARRAY-1D (LAUFWERKE_VERTEILER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0856
M_CASE_0863:
 
; CASE OF - vergleiche Einzel-Element (DEV_DS4)
        CPI        R16, 0x04
        BREQ       M_CASE_0866
        RJMP       M_CASE_0865
M_CASE_0866:
 
; VAR ARRAY-1D POSITION - Ausdruck / Zahlenwert (0x0004)
        LDI        R16, LOW(0x0004)
        LDI        R17, HIGH(0x0004)
 
; VAR ARRAY Ziel Zeiger berechnen (LAUFWERKE_VERTEILER)
        LDI        ZL, LOW(LAUFWERKE_VERTEILER)
        LDI        ZH, HIGH(LAUFWERKE_VERTEILER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEVICE_ITP3_DS4)
        LDI        R16, 0x06
 
; Zuweisung Ziel /  VAR ARRAY-1D (LAUFWERKE_VERTEILER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; ENDCASE;
M_CASE_0865:
M_CASE_0856:
 
; IF_THEN - Ende
M_IF_0852:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (WHO_ARE_YOU_BYTE)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x04)
        LDI        R18, 0x04
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_0870
        CLR        R16
        RJMP       M_VERGL_0871
M_VERGL_0870:
        SER        R16
M_VERGL_0871:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0867
        RJMP       M_IF_0868
M_IF_0867:
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (DEV_NR)
        LDS        R16, DEV_NR
 
; Zuweisung Ziel /  VAR (READER_DEVICE)
        STS        READER_DEVICE, R16
 
; IF_THEN - Ende
M_IF_0868:
 
; IF_THEN - Ende
M_IF_0804:
 
; PROCEDURE - Ende (ITP3_PRUEFE_EINEN_ANSCHLUSS)
        RET
 
; PROCEDURE - Anfang (ITP3_PRUEFE_ANSCHLUESSE)
ITP3_PRUEFE_ANSCHLUESSE:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS0)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Aufruf PROCEDURE (ITP3_PRUEFE_EINEN_ANSCHLUSS)
        CALL       ITP3_PRUEFE_EINEN_ANSCHLUSS
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS1)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Aufruf PROCEDURE (ITP3_PRUEFE_EINEN_ANSCHLUSS)
        CALL       ITP3_PRUEFE_EINEN_ANSCHLUSS
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS2)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Aufruf PROCEDURE (ITP3_PRUEFE_EINEN_ANSCHLUSS)
        CALL       ITP3_PRUEFE_EINEN_ANSCHLUSS
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS3)
        LDI        R16, 0x03
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Aufruf PROCEDURE (ITP3_PRUEFE_EINEN_ANSCHLUSS)
        CALL       ITP3_PRUEFE_EINEN_ANSCHLUSS
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS4)
        LDI        R16, 0x04
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Aufruf PROCEDURE (ITP3_PRUEFE_EINEN_ANSCHLUSS)
        CALL       ITP3_PRUEFE_EINEN_ANSCHLUSS
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS0)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Aufruf PROCEDURE (ITP3_PRUEFE_EINEN_ANSCHLUSS)
        CALL       ITP3_PRUEFE_EINEN_ANSCHLUSS
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS1)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Aufruf PROCEDURE (ITP3_PRUEFE_EINEN_ANSCHLUSS)
        CALL       ITP3_PRUEFE_EINEN_ANSCHLUSS
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS2)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Aufruf PROCEDURE (ITP3_PRUEFE_EINEN_ANSCHLUSS)
        CALL       ITP3_PRUEFE_EINEN_ANSCHLUSS
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS3)
        LDI        R16, 0x03
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Aufruf PROCEDURE (ITP3_PRUEFE_EINEN_ANSCHLUSS)
        CALL       ITP3_PRUEFE_EINEN_ANSCHLUSS
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS4)
        LDI        R16, 0x04
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Aufruf PROCEDURE (ITP3_PRUEFE_EINEN_ANSCHLUSS)
        CALL       ITP3_PRUEFE_EINEN_ANSCHLUSS
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS0)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Aufruf PROCEDURE (ITP3_PRUEFE_EINEN_ANSCHLUSS)
        CALL       ITP3_PRUEFE_EINEN_ANSCHLUSS
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS1)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Aufruf PROCEDURE (ITP3_PRUEFE_EINEN_ANSCHLUSS)
        CALL       ITP3_PRUEFE_EINEN_ANSCHLUSS
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS2)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Aufruf PROCEDURE (ITP3_PRUEFE_EINEN_ANSCHLUSS)
        CALL       ITP3_PRUEFE_EINEN_ANSCHLUSS
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS3)
        LDI        R16, 0x03
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Aufruf PROCEDURE (ITP3_PRUEFE_EINEN_ANSCHLUSS)
        CALL       ITP3_PRUEFE_EINEN_ANSCHLUSS
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS4)
        LDI        R16, 0x04
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Aufruf PROCEDURE (ITP3_PRUEFE_EINEN_ANSCHLUSS)
        CALL       ITP3_PRUEFE_EINEN_ANSCHLUSS
 
; PROCEDURE - Ende (ITP3_PRUEFE_ANSCHLUESSE)
        RET
 
; PROCEDURE - Anfang (WARTE_SOLANGE_RD_HIGH)
WARTE_SOLANGE_RD_HIGH:
 
; WHILE DO ...
M_WHILE_0872:
 
; WHILE - Ausdruck /; BitHigh(RD_Z80_E)
        IN         R16, PIND
        BST        R16, 4
        BRTS       M_VERGL_0875
        CLR        R16
        RJMP       M_VERGL_0876
M_VERGL_0875:
        SER        R16
M_VERGL_0876:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0873
        RJMP       M_WHILE_0874
M_WHILE_0873:
 
; IF THEN - Ausdruck /; BitHigh(RD_Z80_E)
        IN         R16, PIND
        BST        R16, 4
        BRTS       M_VERGL_0880
        CLR        R16
        RJMP       M_VERGL_0881
M_VERGL_0880:
        SER        R16
M_VERGL_0881:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0877
        RJMP       M_IF_0878
M_IF_0877:
 
; SetBit(CLK_Z80)
        SBI        PORTD, 7
 
; IF_THEN - Ende
M_IF_0878:
 
; IF THEN - Ausdruck /; BitHigh(RD_Z80_E)
        IN         R16, PIND
        BST        R16, 4
        BRTS       M_VERGL_0885
        CLR        R16
        RJMP       M_VERGL_0886
M_VERGL_0885:
        SER        R16
M_VERGL_0886:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0882
        RJMP       M_IF_0883
M_IF_0882:
 
; ClearBit(CLK_Z80)
        CBI        PORTD, 7
 
; IF_THEN - Ende
M_IF_0883:
 
; WHILE DO ...
        RJMP       M_WHILE_0872
M_WHILE_0874:
 
; PROCEDURE - Ende (WARTE_SOLANGE_RD_HIGH)
        RET
 
; PROCEDURE - Anfang (WARTE_SOLANGE_RD_LOW)
WARTE_SOLANGE_RD_LOW:
 
; WHILE DO ...
M_WHILE_0887:
 
; WHILE - Ausdruck /; BitLow(RD_Z80_E)
        IN         R16, PIND
        BST        R16, 4
        BRTC       M_VERGL_0890
        CLR        R16
        RJMP       M_VERGL_0891
M_VERGL_0890:
        SER        R16
M_VERGL_0891:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0888
        RJMP       M_WHILE_0889
M_WHILE_0888:
 
; SetBit(CLK_Z80)
        SBI        PORTD, 7
 
; NOP
        NOP
 
; ClearBit(CLK_Z80)
        CBI        PORTD, 7
 
; WHILE DO ...
        RJMP       M_WHILE_0887
M_WHILE_0889:
 
; PROCEDURE - Ende (WARTE_SOLANGE_RD_LOW)
        RET
 
; PROCEDURE - Anfang (WARTE_SOLANGE_IORQ_HIGH)
WARTE_SOLANGE_IORQ_HIGH:
 
; WHILE DO ...
M_WHILE_0892:
 
; WHILE - Ausdruck /; BitHigh(IORQ_Z80_E)
        IN         R16, PINB
        BST        R16, 1
        BRTS       M_VERGL_0895
        CLR        R16
        RJMP       M_VERGL_0896
M_VERGL_0895:
        SER        R16
M_VERGL_0896:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0893
        RJMP       M_WHILE_0894
M_WHILE_0893:
 
; IF THEN - Ausdruck /; BitHigh(IORQ_Z80_E)
        IN         R16, PINB
        BST        R16, 1
        BRTS       M_VERGL_0900
        CLR        R16
        RJMP       M_VERGL_0901
M_VERGL_0900:
        SER        R16
M_VERGL_0901:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0897
        RJMP       M_IF_0898
M_IF_0897:
 
; SetBit(CLK_Z80)
        SBI        PORTD, 7
 
; IF_THEN - Ende
M_IF_0898:
 
; IF THEN - Ausdruck /; BitHigh(IORQ_Z80_E)
        IN         R16, PINB
        BST        R16, 1
        BRTS       M_VERGL_0905
        CLR        R16
        RJMP       M_VERGL_0906
M_VERGL_0905:
        SER        R16
M_VERGL_0906:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0902
        RJMP       M_IF_0903
M_IF_0902:
 
; ClearBit(CLK_Z80)
        CBI        PORTD, 7
 
; IF_THEN - Ende
M_IF_0903:
 
; WHILE DO ...
        RJMP       M_WHILE_0892
M_WHILE_0894:
 
; PROCEDURE - Ende (WARTE_SOLANGE_IORQ_HIGH)
        RET
 
; PROCEDURE - Anfang (WARTE_SOLANGE_IORQ_LOW)
WARTE_SOLANGE_IORQ_LOW:
 
; WHILE DO ...
M_WHILE_0907:
 
; WHILE - Ausdruck /; BitLow(IORQ_Z80_E)
        IN         R16, PINB
        BST        R16, 1
        BRTC       M_VERGL_0910
        CLR        R16
        RJMP       M_VERGL_0911
M_VERGL_0910:
        SER        R16
M_VERGL_0911:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0908
        RJMP       M_WHILE_0909
M_WHILE_0908:
 
; SetBit(CLK_Z80)
        SBI        PORTD, 7
 
; NOP
        NOP
 
; ClearBit(CLK_Z80)
        CBI        PORTD, 7
 
; WHILE DO ...
        RJMP       M_WHILE_0907
M_WHILE_0909:
 
; PROCEDURE - Ende (WARTE_SOLANGE_IORQ_LOW)
        RET
 
; PROCEDURE - Anfang (START_RAM2ARR)
START_RAM2ARR:
 
; Retten der lokalen Parameter fuer PROCEDURE (START_RAM2ARR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_LOW)
        CALL       WARTE_SOLANGE_IORQ_LOW
 
; Retten der Parameter-Register fuer PROCEDURE (START_RAM2ARR)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (START_RAM2ARR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_HIGH)
        CALL       WARTE_SOLANGE_IORQ_HIGH
 
; Retten der Parameter-Register fuer PROCEDURE (START_RAM2ARR)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Byte-REG PINC
        IN         R16, PINC
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RAM_ADR)
        MOV        R3, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (START_RAM2ARR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_LOW)
        CALL       WARTE_SOLANGE_IORQ_LOW
 
; Retten der Parameter-Register fuer PROCEDURE (START_RAM2ARR)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (START_RAM2ARR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_HIGH)
        CALL       WARTE_SOLANGE_RD_HIGH
 
; Retten der Parameter-Register fuer PROCEDURE (START_RAM2ARR)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (START_RAM2ARR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_LOW)
        CALL       WARTE_SOLANGE_RD_LOW
 
; Retten der Parameter-Register fuer PROCEDURE (START_RAM2ARR)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; SetBit(G_RAMSW)
        SBI        PORTA, 7
 
; SetBit(OE_RAM_A)
        SBI        PORTB, 2
 
; SetBit(WE_RAM_A)
        SBI        PORTB, 3
 
; SetBit(OE_RAM_D)
        SBI        DDRB, 2
 
; SetBit(WE_RAM_D)
        SBI        DDRB, 3
 
; SetBit(OE_RAM_A)
        SBI        PORTB, 2
 
; SetBit(WE_RAM_A)
        SBI        PORTB, 3
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (SP_ZAEHLER)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x007F)
        LDI        R16, LOW(0x007F)
        LDI        R17, HIGH(0x007F)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0912:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0913
        RJMP       M_FTD_0914
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0913:
 
; Retten der lokalen Parameter fuer PROCEDURE (START_RAM2ARR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_HIGH)
        CALL       WARTE_SOLANGE_RD_HIGH
 
; Retten der Parameter-Register fuer PROCEDURE (START_RAM2ARR)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; ClearBit(OE_RAM_A)
        CBI        PORTB, 2
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; Zuweisung Quelle - Ausdruck / Byte-REG PINC
        IN         R16, PINC
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RAM_WERT)
        MOV        R2, R16
 
; VAR ARRAY-1D POSITION - Ausdruck / lokale, dynamische Variable VAR (SP_ZAEHLER)
        MOV        R16, R0
        MOV        R17, R1
 
; VAR ARRAY Ziel Zeiger berechnen (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (RAM_WERT)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR ARRAY-1D (SEKTOR_PUFFER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; SetBit(OE_RAM_A)
        SBI        PORTB, 2
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (START_RAM2ARR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_LOW)
        CALL       WARTE_SOLANGE_RD_LOW
 
; Retten der Parameter-Register fuer PROCEDURE (START_RAM2ARR)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0912
 
; FOR TO DO - Ende
M_FTD_0914:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Retten der lokalen Parameter fuer PROCEDURE (START_RAM2ARR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_HIGH)
        CALL       WARTE_SOLANGE_RD_HIGH
 
; Retten der Parameter-Register fuer PROCEDURE (START_RAM2ARR)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xC9)
        LDI        R16, 0xC9
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (START_RAM2ARR)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_LOW)
        CALL       WARTE_SOLANGE_RD_LOW
 
; Retten der Parameter-Register fuer PROCEDURE (START_RAM2ARR)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; SetBit(OE_RAM_A)
        SBI        PORTB, 2
 
; SetBit(WE_RAM_A)
        SBI        PORTB, 3
 
; ClearBit(OE_RAM_D)
        CBI        DDRB, 2
 
; ClearBit(WE_RAM_D)
        CBI        DDRB, 3
 
; ClearBit(G_RAMSW)
        CBI        PORTA, 7
 
; PROCEDURE - Ende (START_RAM2ARR)
        RET
 
; PROCEDURE - Anfang (START_ARR2RAM)
START_ARR2RAM:
 
; Retten der lokalen Parameter fuer PROCEDURE (START_ARR2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_LOW)
        CALL       WARTE_SOLANGE_IORQ_LOW
 
; Retten der Parameter-Register fuer PROCEDURE (START_ARR2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (START_ARR2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_HIGH)
        CALL       WARTE_SOLANGE_IORQ_HIGH
 
; Retten der Parameter-Register fuer PROCEDURE (START_ARR2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Byte-REG PINC
        IN         R16, PINC
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RAM_ADR)
        MOV        R3, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (START_ARR2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_LOW)
        CALL       WARTE_SOLANGE_IORQ_LOW
 
; Retten der Parameter-Register fuer PROCEDURE (START_ARR2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (START_ARR2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_HIGH)
        CALL       WARTE_SOLANGE_RD_HIGH
 
; Retten der Parameter-Register fuer PROCEDURE (START_ARR2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (START_ARR2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_LOW)
        CALL       WARTE_SOLANGE_RD_LOW
 
; Retten der Parameter-Register fuer PROCEDURE (START_ARR2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; SetBit(G_RAMSW)
        SBI        PORTA, 7
 
; SetBit(OE_RAM_A)
        SBI        PORTB, 2
 
; SetBit(WE_RAM_A)
        SBI        PORTB, 3
 
; SetBit(OE_RAM_D)
        SBI        DDRB, 2
 
; SetBit(WE_RAM_D)
        SBI        DDRB, 3
 
; SetBit(OE_RAM_A)
        SBI        PORTB, 2
 
; SetBit(WE_RAM_A)
        SBI        PORTB, 3
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (SP_ZAEHLER)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x007F)
        LDI        R16, LOW(0x007F)
        LDI        R17, HIGH(0x007F)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0915:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0916
        RJMP       M_FTD_0917
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0916:
 
; Retten der lokalen Parameter fuer PROCEDURE (START_ARR2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_HIGH)
        CALL       WARTE_SOLANGE_RD_HIGH
 
; Retten der Parameter-Register fuer PROCEDURE (START_ARR2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (SP_ZAEHLER)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (SEKTOR_PUFFER)
        LDI        ZL, LOW(SEKTOR_PUFFER)
        LDI        ZH, HIGH(SEKTOR_PUFFER)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RAM_WERT)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (RAM_WERT)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(WE_RAM_A)
        CBI        PORTB, 3
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; SetBit(WE_RAM_A)
        SBI        PORTB, 3
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (START_ARR2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_LOW)
        CALL       WARTE_SOLANGE_RD_LOW
 
; Retten der Parameter-Register fuer PROCEDURE (START_ARR2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0915
 
; FOR TO DO - Ende
M_FTD_0917:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Retten der lokalen Parameter fuer PROCEDURE (START_ARR2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_HIGH)
        CALL       WARTE_SOLANGE_RD_HIGH
 
; Retten der Parameter-Register fuer PROCEDURE (START_ARR2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xC9)
        LDI        R16, 0xC9
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (START_ARR2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_LOW)
        CALL       WARTE_SOLANGE_RD_LOW
 
; Retten der Parameter-Register fuer PROCEDURE (START_ARR2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; SetBit(OE_RAM_A)
        SBI        PORTB, 2
 
; SetBit(WE_RAM_A)
        SBI        PORTB, 3
 
; ClearBit(OE_RAM_D)
        CBI        DDRB, 2
 
; ClearBit(WE_RAM_D)
        CBI        DDRB, 3
 
; ClearBit(G_RAMSW)
        CBI        PORTA, 7
 
; PROCEDURE - Ende (START_ARR2RAM)
        RET
 
; PROCEDURE - Anfang (START_BDOS2RAM)
START_BDOS2RAM:
 
; Retten der lokalen Parameter fuer PROCEDURE (START_BDOS2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_LOW)
        CALL       WARTE_SOLANGE_IORQ_LOW
 
; Retten der Parameter-Register fuer PROCEDURE (START_BDOS2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (START_BDOS2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_HIGH)
        CALL       WARTE_SOLANGE_RD_HIGH
 
; Retten der Parameter-Register fuer PROCEDURE (START_BDOS2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (START_BDOS2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_LOW)
        CALL       WARTE_SOLANGE_RD_LOW
 
; Retten der Parameter-Register fuer PROCEDURE (START_BDOS2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; SetBit(G_RAMSW)
        SBI        PORTA, 7
 
; SetBit(OE_RAM_A)
        SBI        PORTB, 2
 
; SetBit(WE_RAM_A)
        SBI        PORTB, 3
 
; SetBit(OE_RAM_D)
        SBI        DDRB, 2
 
; SetBit(WE_RAM_D)
        SBI        DDRB, 3
 
; SetBit(OE_RAM_A)
        SBI        PORTB, 2
 
; SetBit(WE_RAM_A)
        SBI        PORTB, 3
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (SP_ZAEHLER)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / Konstante CONST (LAENGE_BDOS_ARRAY)
        LDI        R16, LOW(0x0DFF)
        LDI        R17, HIGH(0x0DFF)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0918:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0919
        RJMP       M_FTD_0920
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0919:
 
; Retten der lokalen Parameter fuer PROCEDURE (START_BDOS2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_HIGH)
        CALL       WARTE_SOLANGE_RD_HIGH
 
; Retten der Parameter-Register fuer PROCEDURE (START_BDOS2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (SP_ZAEHLER)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (BDOS_ARR)
        LDI        ZL, LOW(2*BDOS_ARR)
        LDI        ZH, HIGH(2*BDOS_ARR)
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RAM_WERT)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (RAM_WERT)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(WE_RAM_A)
        CBI        PORTB, 3
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; SetBit(WE_RAM_A)
        SBI        PORTB, 3
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (START_BDOS2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_LOW)
        CALL       WARTE_SOLANGE_RD_LOW
 
; Retten der Parameter-Register fuer PROCEDURE (START_BDOS2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0918
 
; FOR TO DO - Ende
M_FTD_0920:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Retten der lokalen Parameter fuer PROCEDURE (START_BDOS2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_HIGH)
        CALL       WARTE_SOLANGE_RD_HIGH
 
; Retten der Parameter-Register fuer PROCEDURE (START_BDOS2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xC9)
        LDI        R16, 0xC9
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (START_BDOS2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_LOW)
        CALL       WARTE_SOLANGE_RD_LOW
 
; Retten der Parameter-Register fuer PROCEDURE (START_BDOS2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; SetBit(OE_RAM_A)
        SBI        PORTB, 2
 
; SetBit(WE_RAM_A)
        SBI        PORTB, 3
 
; ClearBit(OE_RAM_D)
        CBI        DDRB, 2
 
; ClearBit(WE_RAM_D)
        CBI        DDRB, 3
 
; ClearBit(G_RAMSW)
        CBI        PORTA, 7
 
; PROCEDURE - Ende (START_BDOS2RAM)
        RET
 
; PROCEDURE - Anfang (START_CCP2RAM)
START_CCP2RAM:
 
; Retten der lokalen Parameter fuer PROCEDURE (START_CCP2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_LOW)
        CALL       WARTE_SOLANGE_IORQ_LOW
 
; Retten der Parameter-Register fuer PROCEDURE (START_CCP2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (START_CCP2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_HIGH)
        CALL       WARTE_SOLANGE_RD_HIGH
 
; Retten der Parameter-Register fuer PROCEDURE (START_CCP2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (START_CCP2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_LOW)
        CALL       WARTE_SOLANGE_RD_LOW
 
; Retten der Parameter-Register fuer PROCEDURE (START_CCP2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; SetBit(G_RAMSW)
        SBI        PORTA, 7
 
; SetBit(OE_RAM_A)
        SBI        PORTB, 2
 
; SetBit(WE_RAM_A)
        SBI        PORTB, 3
 
; SetBit(OE_RAM_D)
        SBI        DDRB, 2
 
; SetBit(WE_RAM_D)
        SBI        DDRB, 3
 
; SetBit(OE_RAM_A)
        SBI        PORTB, 2
 
; SetBit(WE_RAM_A)
        SBI        PORTB, 3
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (SP_ZAEHLER)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / Konstante CONST (LAENGE_CCP_ARRAY)
        LDI        R16, LOW(0x07FF)
        LDI        R17, HIGH(0x07FF)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0921:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0922
        RJMP       M_FTD_0923
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0922:
 
; Retten der lokalen Parameter fuer PROCEDURE (START_CCP2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_HIGH)
        CALL       WARTE_SOLANGE_RD_HIGH
 
; Retten der Parameter-Register fuer PROCEDURE (START_CCP2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (SP_ZAEHLER)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (CCP_ARR)
        LDI        ZL, LOW(2*CCP_ARR)
        LDI        ZH, HIGH(2*CCP_ARR)
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RAM_WERT)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (RAM_WERT)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; ClearBit(WE_RAM_A)
        CBI        PORTB, 3
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; SetBit(WE_RAM_A)
        SBI        PORTB, 3
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (START_CCP2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_LOW)
        CALL       WARTE_SOLANGE_RD_LOW
 
; Retten der Parameter-Register fuer PROCEDURE (START_CCP2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0921
 
; FOR TO DO - Ende
M_FTD_0923:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Retten der lokalen Parameter fuer PROCEDURE (START_CCP2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_HIGH)
        CALL       WARTE_SOLANGE_RD_HIGH
 
; Retten der Parameter-Register fuer PROCEDURE (START_CCP2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xC9)
        LDI        R16, 0xC9
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (START_CCP2RAM)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_LOW)
        CALL       WARTE_SOLANGE_RD_LOW
 
; Retten der Parameter-Register fuer PROCEDURE (START_CCP2RAM)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; SetBit(OE_RAM_A)
        SBI        PORTB, 2
 
; SetBit(WE_RAM_A)
        SBI        PORTB, 3
 
; ClearBit(OE_RAM_D)
        CBI        DDRB, 2
 
; ClearBit(WE_RAM_D)
        CBI        DDRB, 3
 
; ClearBit(G_RAMSW)
        CBI        PORTA, 7
 
; PROCEDURE - Ende (START_CCP2RAM)
        RET
 
; PROCEDURE - Anfang (LADE_MEIC_ARRAY_IN_RAM)
LADE_MEIC_ARRAY_IN_RAM:
 
; SetBit(G_RAMSW)
        SBI        PORTA, 7
 
; SetBit(OE_RAM_A)
        SBI        PORTB, 2
 
; SetBit(WE_RAM_A)
        SBI        PORTB, 3
 
; SetBit(OE_RAM_D)
        SBI        DDRB, 2
 
; SetBit(WE_RAM_D)
        SBI        DDRB, 3
 
; SetBit(OE_RAM_A)
        SBI        PORTB, 2
 
; SetBit(WE_RAM_A)
        SBI        PORTB, 3
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (ARRAY_POS)
        STS        ARRAY_POS, R16
        STS        ARRAY_POS+1, R17
 
; FOR TO DO - Ausdruck / Konstante CONST (LAENGE_MEIC_ARRAY)
        LDI        R16, LOW(0x0328)
        LDI        R17, HIGH(0x0328)
 
; FOR TO DO - Laden des Word-Zaehlwertes
        LDS        R18, ARRAY_POS
        LDS        R19, ARRAY_POS+1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0924:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0925
        RJMP       M_FTD_0926
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0925:
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_HIGH)
        CALL       WARTE_SOLANGE_RD_HIGH
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; ARRAY - Ausdruck / Word-VAR (ARRAY_POS)
        LDS        R16, ARRAY_POS
        LDS        R17, ARRAY_POS+1
 
; Zuweisung Quelle - Ausdruck /; CONST ARRAY (MEIC_ARR)
        LDI        ZL, LOW(2*MEIC_ARR)
        LDI        ZH, HIGH(2*MEIC_ARR)
        ADD        ZL, R16
        ADC        ZH, R17
        LPM        R16, Z
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; ClearBit(WE_RAM_A)
        CBI        PORTB, 3
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; NOP
        NOP
 
; SetBit(WE_RAM_A)
        SBI        PORTB, 3
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; Aufruf PROCEDURE (WARTE_SOLANGE_RD_LOW)
        CALL       WARTE_SOLANGE_RD_LOW
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; FOR TO DO - (global)Word-INC-Zaehler
        LDS        R18, ARRAY_POS
        LDS        R19, ARRAY_POS+1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        STS        ARRAY_POS, R18
        STS        ARRAY_POS+1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0924
 
; FOR TO DO - Ende
M_FTD_0926:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; SetBit(OE_RAM_A)
        SBI        PORTB, 2
 
; SetBit(WE_RAM_A)
        SBI        PORTB, 3
 
; ClearBit(OE_RAM_D)
        CBI        DDRB, 2
 
; ClearBit(WE_RAM_D)
        CBI        DDRB, 3
 
; ClearBit(G_RAMSW)
        CBI        PORTA, 7
 
; PROCEDURE - Ende (LADE_MEIC_ARRAY_IN_RAM)
        RET
 
; PROCEDURE - Anfang (DIREKT_CONOUT_TO_DEVICE)
DIREKT_CONOUT_TO_DEVICE:
 
; CASE OF - Byte-VAR (CONOUT_DEVICE_NR1)
        LDS        R16, CONOUT_DEVICE_NR1
 
; CASE OF - vergleiche Einzel-Element (DEVICE_SERIAL)
        CPI        R16, 0x01
        BREQ       M_CASE_0929
        RJMP       M_CASE_0928
M_CASE_0929:
 
; Aufruf PROCEDURE (UART_CONOUT_SENDEN)
        CALL       UART_CONOUT_SENDEN
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0927
M_CASE_0928:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_ITP3_DS0)
        CPI        R16, 0x02
        BREQ       M_CASE_0931
        RJMP       M_CASE_0930
M_CASE_0931:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS0)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Byte-Parameter(1) fuer PROCEDURE (ITP3_SENDE_CONOUT)
        LDS        R0, CONSOLEOUT
 
; Aufruf PROCEDURE (ITP3_SENDE_CONOUT)
        CALL       ITP3_SENDE_CONOUT
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0927
M_CASE_0930:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_ITP3_DS1)
        CPI        R16, 0x03
        BREQ       M_CASE_0933
        RJMP       M_CASE_0932
M_CASE_0933:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS1)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Byte-Parameter(1) fuer PROCEDURE (ITP3_SENDE_CONOUT)
        LDS        R0, CONSOLEOUT
 
; Aufruf PROCEDURE (ITP3_SENDE_CONOUT)
        CALL       ITP3_SENDE_CONOUT
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0927
M_CASE_0932:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_ITP3_DS2)
        CPI        R16, 0x04
        BREQ       M_CASE_0935
        RJMP       M_CASE_0934
M_CASE_0935:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS2)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Byte-Parameter(1) fuer PROCEDURE (ITP3_SENDE_CONOUT)
        LDS        R0, CONSOLEOUT
 
; Aufruf PROCEDURE (ITP3_SENDE_CONOUT)
        CALL       ITP3_SENDE_CONOUT
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0927
M_CASE_0934:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_ITP3_DS3)
        CPI        R16, 0x05
        BREQ       M_CASE_0937
        RJMP       M_CASE_0936
M_CASE_0937:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS3)
        LDI        R16, 0x03
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Byte-Parameter(1) fuer PROCEDURE (ITP3_SENDE_CONOUT)
        LDS        R0, CONSOLEOUT
 
; Aufruf PROCEDURE (ITP3_SENDE_CONOUT)
        CALL       ITP3_SENDE_CONOUT
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0927
M_CASE_0936:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_ITP3_DS4)
        CPI        R16, 0x06
        BREQ       M_CASE_0939
        RJMP       M_CASE_0938
M_CASE_0939:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS4)
        LDI        R16, 0x04
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Byte-Parameter(1) fuer PROCEDURE (ITP3_SENDE_CONOUT)
        LDS        R0, CONSOLEOUT
 
; Aufruf PROCEDURE (ITP3_SENDE_CONOUT)
        CALL       ITP3_SENDE_CONOUT
 
; ENDCASE;
M_CASE_0938:
M_CASE_0927:
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (CONOUT_DEVICE_NR2)
        LDS        R16, CONOUT_DEVICE_NR2
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (NO_DEVICE)
        LDI        R18, 0x00
 
; Operator <>
        CP         R16, R18
        BRNE       M_VERGL_0943
        CLR        R16
        RJMP       M_VERGL_0944
M_VERGL_0943:
        SER        R16
M_VERGL_0944:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0940
        RJMP       M_IF_0941
M_IF_0940:
 
; CASE OF - Byte-VAR (CONOUT_DEVICE_NR2)
        LDS        R16, CONOUT_DEVICE_NR2
 
; CASE OF - vergleiche Einzel-Element (DEVICE_SERIAL)
        CPI        R16, 0x01
        BREQ       M_CASE_0947
        RJMP       M_CASE_0946
M_CASE_0947:
 
; Aufruf PROCEDURE (UART_CONOUT_SENDEN)
        CALL       UART_CONOUT_SENDEN
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0945
M_CASE_0946:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_ITP3_DS0)
        CPI        R16, 0x02
        BREQ       M_CASE_0949
        RJMP       M_CASE_0948
M_CASE_0949:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS0)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Byte-Parameter(1) fuer PROCEDURE (ITP3_SENDE_CONOUT)
        LDS        R0, CONSOLEOUT
 
; Aufruf PROCEDURE (ITP3_SENDE_CONOUT)
        CALL       ITP3_SENDE_CONOUT
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0945
M_CASE_0948:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_ITP3_DS1)
        CPI        R16, 0x03
        BREQ       M_CASE_0951
        RJMP       M_CASE_0950
M_CASE_0951:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS1)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Byte-Parameter(1) fuer PROCEDURE (ITP3_SENDE_CONOUT)
        LDS        R0, CONSOLEOUT
 
; Aufruf PROCEDURE (ITP3_SENDE_CONOUT)
        CALL       ITP3_SENDE_CONOUT
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0945
M_CASE_0950:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_ITP3_DS2)
        CPI        R16, 0x04
        BREQ       M_CASE_0953
        RJMP       M_CASE_0952
M_CASE_0953:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS2)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Byte-Parameter(1) fuer PROCEDURE (ITP3_SENDE_CONOUT)
        LDS        R0, CONSOLEOUT
 
; Aufruf PROCEDURE (ITP3_SENDE_CONOUT)
        CALL       ITP3_SENDE_CONOUT
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0945
M_CASE_0952:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_ITP3_DS3)
        CPI        R16, 0x05
        BREQ       M_CASE_0955
        RJMP       M_CASE_0954
M_CASE_0955:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS3)
        LDI        R16, 0x03
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Byte-Parameter(1) fuer PROCEDURE (ITP3_SENDE_CONOUT)
        LDS        R0, CONSOLEOUT
 
; Aufruf PROCEDURE (ITP3_SENDE_CONOUT)
        CALL       ITP3_SENDE_CONOUT
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0945
M_CASE_0954:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_ITP3_DS4)
        CPI        R16, 0x06
        BREQ       M_CASE_0957
        RJMP       M_CASE_0956
M_CASE_0957:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS4)
        LDI        R16, 0x04
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Byte-Parameter(1) fuer PROCEDURE (ITP3_SENDE_CONOUT)
        LDS        R0, CONSOLEOUT
 
; Aufruf PROCEDURE (ITP3_SENDE_CONOUT)
        CALL       ITP3_SENDE_CONOUT
 
; ENDCASE;
M_CASE_0956:
M_CASE_0945:
 
; IF_THEN - Ende
M_IF_0941:
 
; PROCEDURE - Ende (DIREKT_CONOUT_TO_DEVICE)
        RET
 
; PROCEDURE - Anfang (ANZEIGE_STRING_AN_CONOUT)
ANZEIGE_STRING_AN_CONOUT:
 
; Zuweisung Quelle - Ausdruck / Length(ANZEIGE_STRING)
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LAENGE)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; FOR TO DO - Ausdruck / lokale, dynamische Variable VAR (LAENGE)
        MOV        R16, R1
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R2
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_0958:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_0959
        RJMP       M_FTD_0960
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0959:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (B1)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (ANZEIGE_STRING)
        CLR        R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (CONSOLEOUT)
        STS        CONSOLEOUT, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (ANZEIGE_STRING_AN_CONOUT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (DIREKT_CONOUT_TO_DEVICE)
        CALL       DIREKT_CONOUT_TO_DEVICE
 
; Retten der Parameter-Register fuer PROCEDURE (ANZEIGE_STRING_AN_CONOUT)
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R2
        INC        R17
        MOV        R2, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0958
 
; FOR TO DO - Ende
M_FTD_0960:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (CR)
        LDI        R16, 0x0D
 
; Zuweisung Ziel /  VAR (CONSOLEOUT)
        STS        CONSOLEOUT, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (ANZEIGE_STRING_AN_CONOUT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (DIREKT_CONOUT_TO_DEVICE)
        CALL       DIREKT_CONOUT_TO_DEVICE
 
; Retten der Parameter-Register fuer PROCEDURE (ANZEIGE_STRING_AN_CONOUT)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (LF)
        LDI        R16, 0x0A
 
; Zuweisung Ziel /  VAR (CONSOLEOUT)
        STS        CONSOLEOUT, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (ANZEIGE_STRING_AN_CONOUT)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf PROCEDURE (DIREKT_CONOUT_TO_DEVICE)
        CALL       DIREKT_CONOUT_TO_DEVICE
 
; Retten der Parameter-Register fuer PROCEDURE (ANZEIGE_STRING_AN_CONOUT)
        POP        R2
        POP        R1
        POP        R0
 
; PROCEDURE - Ende (ANZEIGE_STRING_AN_CONOUT)
        RET
 
; PROCEDURE - Anfang (INIT_LAUFWERKE_VERTEILER)
INIT_LAUFWERKE_VERTEILER:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LV_ZEIGER)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x000F)
        LDI        R16, LOW(0x000F)
        LDI        R17, HIGH(0x000F)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0961:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0962
        RJMP       M_FTD_0963
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0962:
 
; VAR ARRAY-1D POSITION - Ausdruck / lokale, dynamische Variable VAR (LV_ZEIGER)
        MOV        R16, R0
        MOV        R17, R1
 
; VAR ARRAY Ziel Zeiger berechnen (LAUFWERKE_VERTEILER)
        LDI        ZL, LOW(LAUFWERKE_VERTEILER)
        LDI        ZH, HIGH(LAUFWERKE_VERTEILER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NO_DEVICE)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR ARRAY-1D (LAUFWERKE_VERTEILER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0961
 
; FOR TO DO - Ende
M_FTD_0963:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; PROCEDURE - Ende (INIT_LAUFWERKE_VERTEILER)
        RET
 
; PROCEDURE - Anfang (LAUFWERKE_VERTEILER_NACH_OBEN_KOPIEREN)
LAUFWERKE_VERTEILER_NACH_OBEN_KOPIEREN:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ES_WURDE_KOPIERT)
        MOV        R4, R16
 
; WHILE DO ...
M_WHILE_0964:
 
; WHILE - Ausdruck / lokale, dynamische Variable VAR (ES_WURDE_KOPIERT)
        MOV        R16, R4
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0965
        RJMP       M_WHILE_0966
M_WHILE_0965:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ES_WURDE_KOPIERT)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x000F)
        LDI        R16, LOW(0x000F)
        LDI        R17, HIGH(0x000F)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LV_ZEIGER)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x0001)
        LDI        R16, LOW(0x0001)
        LDI        R17, HIGH(0x0001)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0967:
 
; FOR TO DO - Word-Vergleichsteil (DOWNTO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R18, R16
        CPC        R19, R17
        BRCC       M_FTD_0968
        RJMP       M_FTD_0969
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0968:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (LV_ZEIGER)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (LAUFWERKE_VERTEILER)
        LDI        ZL, LOW(LAUFWERKE_VERTEILER)
        LDI        ZH, HIGH(LAUFWERKE_VERTEILER)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (EINTRAG_WERT)
        MOV        R5, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (EINTRAG_WERT)
        MOV        R16, R5
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (NO_DEVICE)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0973
        CLR        R16
        RJMP       M_VERGL_0974
M_VERGL_0973:
        SER        R16
M_VERGL_0974:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0970
        RJMP       M_IF_0971
M_IF_0970:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LV_ZEIGER)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0001)
        LDI        R18, LOW(0x0001)
        LDI        R19, HIGH(0x0001)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LV_ZEIGER_M1)
        MOV        R2, R16
        MOV        R3, R17
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (LV_ZEIGER_M1)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (LAUFWERKE_VERTEILER)
        LDI        ZL, LOW(LAUFWERKE_VERTEILER)
        LDI        ZH, HIGH(LAUFWERKE_VERTEILER)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (EINTRAG_WERT_M1)
        MOV        R6, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (EINTRAG_WERT_M1)
        MOV        R16, R6
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (NO_DEVICE)
        LDI        R18, 0x00
 
; Operator <>
        CP         R16, R18
        BRNE       M_VERGL_0978
        CLR        R16
        RJMP       M_VERGL_0979
M_VERGL_0978:
        SER        R16
M_VERGL_0979:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0975
        RJMP       M_IF_0976
M_IF_0975:
 
; VAR ARRAY-1D POSITION - Ausdruck / lokale, dynamische Variable VAR (LV_ZEIGER)
        MOV        R16, R0
        MOV        R17, R1
 
; VAR ARRAY Ziel Zeiger berechnen (LAUFWERKE_VERTEILER)
        LDI        ZL, LOW(LAUFWERKE_VERTEILER)
        LDI        ZH, HIGH(LAUFWERKE_VERTEILER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (EINTRAG_WERT_M1)
        MOV        R16, R6
 
; Zuweisung Ziel /  VAR ARRAY-1D (LAUFWERKE_VERTEILER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; VAR ARRAY-1D POSITION - Ausdruck / lokale, dynamische Variable VAR (LV_ZEIGER_M1)
        MOV        R16, R2
        MOV        R17, R3
 
; VAR ARRAY Ziel Zeiger berechnen (LAUFWERKE_VERTEILER)
        LDI        ZL, LOW(LAUFWERKE_VERTEILER)
        LDI        ZH, HIGH(LAUFWERKE_VERTEILER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NO_DEVICE)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR ARRAY-1D (LAUFWERKE_VERTEILER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ES_WURDE_KOPIERT)
        MOV        R4, R16
 
; IF_THEN - Ende
M_IF_0976:
 
; IF_THEN - Ende
M_IF_0971:
 
; FOR TO DO - (lokal)Word-DEC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        SUB        R18, R20
        CLR        R20
        SBC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0967
 
; FOR TO DO - Ende
M_FTD_0969:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; WHILE DO ...
        RJMP       M_WHILE_0964
M_WHILE_0966:
 
; PROCEDURE - Ende (LAUFWERKE_VERTEILER_NACH_OBEN_KOPIEREN)
        RET
 
; PROCEDURE - Anfang (LAUFWERKE_VERTEILER_NACH_UNTEN_KOPIEREN)
LAUFWERKE_VERTEILER_NACH_UNTEN_KOPIEREN:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ES_WURDE_KOPIERT)
        MOV        R4, R16
 
; WHILE DO ...
M_WHILE_0980:
 
; WHILE - Ausdruck / lokale, dynamische Variable VAR (ES_WURDE_KOPIERT)
        MOV        R16, R4
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0981
        RJMP       M_WHILE_0982
M_WHILE_0981:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ES_WURDE_KOPIERT)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LV_ZEIGER)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x000E)
        LDI        R16, LOW(0x000E)
        LDI        R17, HIGH(0x000E)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0983:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0984
        RJMP       M_FTD_0985
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0984:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (LV_ZEIGER)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (LAUFWERKE_VERTEILER)
        LDI        ZL, LOW(LAUFWERKE_VERTEILER)
        LDI        ZH, HIGH(LAUFWERKE_VERTEILER)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (EINTRAG_WERT)
        MOV        R5, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (EINTRAG_WERT)
        MOV        R16, R5
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (NO_DEVICE)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_0989
        CLR        R16
        RJMP       M_VERGL_0990
M_VERGL_0989:
        SER        R16
M_VERGL_0990:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0986
        RJMP       M_IF_0987
M_IF_0986:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LV_ZEIGER)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0001)
        LDI        R18, LOW(0x0001)
        LDI        R19, HIGH(0x0001)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LV_ZEIGER_P1)
        MOV        R2, R16
        MOV        R3, R17
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (LV_ZEIGER_P1)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (LAUFWERKE_VERTEILER)
        LDI        ZL, LOW(LAUFWERKE_VERTEILER)
        LDI        ZH, HIGH(LAUFWERKE_VERTEILER)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (EINTRAG_WERT_P1)
        MOV        R6, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (EINTRAG_WERT_P1)
        MOV        R16, R6
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (NO_DEVICE)
        LDI        R18, 0x00
 
; Operator <>
        CP         R16, R18
        BRNE       M_VERGL_0994
        CLR        R16
        RJMP       M_VERGL_0995
M_VERGL_0994:
        SER        R16
M_VERGL_0995:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0991
        RJMP       M_IF_0992
M_IF_0991:
 
; VAR ARRAY-1D POSITION - Ausdruck / lokale, dynamische Variable VAR (LV_ZEIGER)
        MOV        R16, R0
        MOV        R17, R1
 
; VAR ARRAY Ziel Zeiger berechnen (LAUFWERKE_VERTEILER)
        LDI        ZL, LOW(LAUFWERKE_VERTEILER)
        LDI        ZH, HIGH(LAUFWERKE_VERTEILER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (EINTRAG_WERT_P1)
        MOV        R16, R6
 
; Zuweisung Ziel /  VAR ARRAY-1D (LAUFWERKE_VERTEILER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; VAR ARRAY-1D POSITION - Ausdruck / lokale, dynamische Variable VAR (LV_ZEIGER_P1)
        MOV        R16, R2
        MOV        R17, R3
 
; VAR ARRAY Ziel Zeiger berechnen (LAUFWERKE_VERTEILER)
        LDI        ZL, LOW(LAUFWERKE_VERTEILER)
        LDI        ZH, HIGH(LAUFWERKE_VERTEILER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (NO_DEVICE)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR ARRAY-1D (LAUFWERKE_VERTEILER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ES_WURDE_KOPIERT)
        MOV        R4, R16
 
; IF_THEN - Ende
M_IF_0992:
 
; IF_THEN - Ende
M_IF_0987:
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0983
 
; FOR TO DO - Ende
M_FTD_0985:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; WHILE DO ...
        RJMP       M_WHILE_0980
M_WHILE_0982:
 
; PROCEDURE - Ende (LAUFWERKE_VERTEILER_NACH_UNTEN_KOPIEREN)
        RET
 
; PROCEDURE - Anfang (LAUFWERKE_VERTEILER_ANZEIGEN)
LAUFWERKE_VERTEILER_ANZEIGEN:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x41)
        LDI        R16, 0x41
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LW_BUCHSTABE_BYTE)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LV_ZEIGER)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / Zahlenwert (0x000F)
        LDI        R16, LOW(0x000F)
        LDI        R17, HIGH(0x000F)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_0996:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_0997
        RJMP       M_FTD_0998
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_0997:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (LV_ZEIGER)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (LAUFWERKE_VERTEILER)
        LDI        ZL, LOW(LAUFWERKE_VERTEILER)
        LDI        ZH, HIGH(LAUFWERKE_VERTEILER)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (EINTRAG_WERT)
        MOV        R2, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (EINTRAG_WERT)
        MOV        R16, R2
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (NO_DEVICE)
        LDI        R18, 0x00
 
; Operator <>
        CP         R16, R18
        BRNE       M_VERGL_01002
        CLR        R16
        RJMP       M_VERGL_01003
M_VERGL_01002:
        SER        R16
M_VERGL_01003:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0999
        RJMP       M_IF_01000
M_IF_0999:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToChar(LW_BUCHSTABE_BYTE)
        MOV        R16, R3
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LW_BUCHSTABE_CHAR)
        MOV        R4, R16
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (ANZEIGE_STRING)=80
        LDI        R16, 80
        CLR        R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (LW_BUCHSTABE_CHAR)
        MOV        R19, R4
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        CPI        R20, 1      ; Restlaenge < Lange der STRING
        BRCS       M_PRG_VAR_STRING_01004
        PUSH       R19
        INC        R17
M_PRG_VAR_STRING_01004:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Kopieren der String-Konstante in den Stack (': -> ')
        LDI        ZL, LOW(2*M_CONST_STRING_19)
        LDI        ZH, HIGH(2*M_CONST_STRING_19)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_01005
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_01005:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_01007
M_PRG_CONST_STRING_01006:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_01006
M_PRG_CONST_STRING_01007:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ANZEIGE_STRING) - Laenge in R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_01009
        MOV        R16, R17
M_PRG_CONST_STRING_01008:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_01008
M_PRG_CONST_STRING_01009:
        ST         -Z, R17
 
; CASE OF - lokale, dynamische Variable VAR (EINTRAG_WERT)
        MOV        R16, R2
 
; CASE OF - vergleiche Einzel-Element (DEVICE_LOKAL_FLASH)
        CPI        R16, 0x07
        BREQ       M_CASE_01012
        RJMP       M_CASE_01011
M_CASE_01012:
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (ANZEIGE_STRING)=80
        LDI        R16, 80
        CLR        R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_01013
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_01013:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_01015
M_PRG_CONST_STRING_01014:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_01014
M_PRG_CONST_STRING_01015:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Kopieren der String-Konstante in den Stack ('lokal Flash')
        LDI        ZL, LOW(2*M_CONST_STRING_20)
        LDI        ZH, HIGH(2*M_CONST_STRING_20)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_01016
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_01016:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_01018
M_PRG_CONST_STRING_01017:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_01017
M_PRG_CONST_STRING_01018:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ANZEIGE_STRING) - Laenge in R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_01020
        MOV        R16, R17
M_PRG_CONST_STRING_01019:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_01019
M_PRG_CONST_STRING_01020:
        ST         -Z, R17
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01010
M_CASE_01011:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_SERIAL)
        CPI        R16, 0x01
        BREQ       M_CASE_01022
        RJMP       M_CASE_01021
M_CASE_01022:
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (ANZEIGE_STRING)=80
        LDI        R16, 80
        CLR        R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_01023
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_01023:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_01025
M_PRG_CONST_STRING_01024:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_01024
M_PRG_CONST_STRING_01025:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Kopieren der String-Konstante in den Stack ('Serial')
        LDI        ZL, LOW(2*M_CONST_STRING_21)
        LDI        ZH, HIGH(2*M_CONST_STRING_21)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_01026
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_01026:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_01028
M_PRG_CONST_STRING_01027:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_01027
M_PRG_CONST_STRING_01028:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ANZEIGE_STRING) - Laenge in R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_01030
        MOV        R16, R17
M_PRG_CONST_STRING_01029:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_01029
M_PRG_CONST_STRING_01030:
        ST         -Z, R17
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01010
M_CASE_01021:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_ITP3_DS0)
        CPI        R16, 0x02
        BREQ       M_CASE_01032
        RJMP       M_CASE_01031
M_CASE_01032:
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (ANZEIGE_STRING)=80
        LDI        R16, 80
        CLR        R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_01033
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_01033:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_01035
M_PRG_CONST_STRING_01034:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_01034
M_PRG_CONST_STRING_01035:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Kopieren der String-Konstante in den Stack ('ITP3 DS0')
        LDI        ZL, LOW(2*M_CONST_STRING_22)
        LDI        ZH, HIGH(2*M_CONST_STRING_22)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_01036
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_01036:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_01038
M_PRG_CONST_STRING_01037:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_01037
M_PRG_CONST_STRING_01038:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ANZEIGE_STRING) - Laenge in R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_01040
        MOV        R16, R17
M_PRG_CONST_STRING_01039:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_01039
M_PRG_CONST_STRING_01040:
        ST         -Z, R17
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01010
M_CASE_01031:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_ITP3_DS1)
        CPI        R16, 0x03
        BREQ       M_CASE_01042
        RJMP       M_CASE_01041
M_CASE_01042:
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (ANZEIGE_STRING)=80
        LDI        R16, 80
        CLR        R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_01043
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_01043:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_01045
M_PRG_CONST_STRING_01044:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_01044
M_PRG_CONST_STRING_01045:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Kopieren der String-Konstante in den Stack ('ITP3 DS1')
        LDI        ZL, LOW(2*M_CONST_STRING_23)
        LDI        ZH, HIGH(2*M_CONST_STRING_23)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_01046
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_01046:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_01048
M_PRG_CONST_STRING_01047:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_01047
M_PRG_CONST_STRING_01048:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ANZEIGE_STRING) - Laenge in R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_01050
        MOV        R16, R17
M_PRG_CONST_STRING_01049:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_01049
M_PRG_CONST_STRING_01050:
        ST         -Z, R17
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01010
M_CASE_01041:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_ITP3_DS2)
        CPI        R16, 0x04
        BREQ       M_CASE_01052
        RJMP       M_CASE_01051
M_CASE_01052:
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (ANZEIGE_STRING)=80
        LDI        R16, 80
        CLR        R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_01053
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_01053:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_01055
M_PRG_CONST_STRING_01054:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_01054
M_PRG_CONST_STRING_01055:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Kopieren der String-Konstante in den Stack ('ITP3 DS2')
        LDI        ZL, LOW(2*M_CONST_STRING_24)
        LDI        ZH, HIGH(2*M_CONST_STRING_24)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_01056
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_01056:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_01058
M_PRG_CONST_STRING_01057:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_01057
M_PRG_CONST_STRING_01058:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ANZEIGE_STRING) - Laenge in R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_01060
        MOV        R16, R17
M_PRG_CONST_STRING_01059:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_01059
M_PRG_CONST_STRING_01060:
        ST         -Z, R17
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01010
M_CASE_01051:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_ITP3_DS3)
        CPI        R16, 0x05
        BREQ       M_CASE_01062
        RJMP       M_CASE_01061
M_CASE_01062:
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (ANZEIGE_STRING)=80
        LDI        R16, 80
        CLR        R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_01063
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_01063:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_01065
M_PRG_CONST_STRING_01064:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_01064
M_PRG_CONST_STRING_01065:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Kopieren der String-Konstante in den Stack ('ITP3 DS3')
        LDI        ZL, LOW(2*M_CONST_STRING_25)
        LDI        ZH, HIGH(2*M_CONST_STRING_25)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_01066
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_01066:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_01068
M_PRG_CONST_STRING_01067:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_01067
M_PRG_CONST_STRING_01068:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ANZEIGE_STRING) - Laenge in R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_01070
        MOV        R16, R17
M_PRG_CONST_STRING_01069:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_01069
M_PRG_CONST_STRING_01070:
        ST         -Z, R17
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01010
M_CASE_01061:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_ITP3_DS4)
        CPI        R16, 0x06
        BREQ       M_CASE_01072
        RJMP       M_CASE_01071
M_CASE_01072:
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (ANZEIGE_STRING)=80
        LDI        R16, 80
        CLR        R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_01073
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_01073:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_01075
M_PRG_CONST_STRING_01074:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_01074
M_PRG_CONST_STRING_01075:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Kopieren der String-Konstante in den Stack ('ITP3 DS4')
        LDI        ZL, LOW(2*M_CONST_STRING_26)
        LDI        ZH, HIGH(2*M_CONST_STRING_26)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_01076
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_01076:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_01078
M_PRG_CONST_STRING_01077:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_01077
M_PRG_CONST_STRING_01078:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ANZEIGE_STRING) - Laenge in R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_01080
        MOV        R16, R17
M_PRG_CONST_STRING_01079:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_01079
M_PRG_CONST_STRING_01080:
        ST         -Z, R17
 
; ENDCASE;
M_CASE_01071:
M_CASE_01010:
 
; Retten der lokalen Parameter fuer PROCEDURE (LAUFWERKE_VERTEILER_ANZEIGEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
        PUSH       R4
 
; Aufruf PROCEDURE (ANZEIGE_STRING_AN_CONOUT)
        CALL       ANZEIGE_STRING_AN_CONOUT
 
; Retten der Parameter-Register fuer PROCEDURE (LAUFWERKE_VERTEILER_ANZEIGEN)
        POP        R4
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; IF_THEN - Ende
M_IF_01000:
 
; INC(LW_BUCHSTABE_BYTE) - Byte
        INC        R3
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_0996
 
; FOR TO DO - Ende
M_FTD_0998:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; PROCEDURE - Ende (LAUFWERKE_VERTEILER_ANZEIGEN)
        RET
 
; PROCEDURE - Anfang (GERAETE_ANZEIGEN_DEVICE)
GERAETE_ANZEIGEN_DEVICE:
 
; CASE OF - lokaler Uebergabeparameter (CON_DEVICE)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (DEVICE_LOKAL_FLASH)
        CPI        R16, 0x07
        BREQ       M_CASE_01083
        RJMP       M_CASE_01082
M_CASE_01083:
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (ANZEIGE_STRING)=80
        LDI        R16, 80
        CLR        R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_01084
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_01084:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_01086
M_PRG_CONST_STRING_01085:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_01085
M_PRG_CONST_STRING_01086:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Kopieren der String-Konstante in den Stack ('lokal Flash')
        LDI        ZL, LOW(2*M_CONST_STRING_27)
        LDI        ZH, HIGH(2*M_CONST_STRING_27)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_01087
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_01087:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_01089
M_PRG_CONST_STRING_01088:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_01088
M_PRG_CONST_STRING_01089:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ANZEIGE_STRING) - Laenge in R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_01091
        MOV        R16, R17
M_PRG_CONST_STRING_01090:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_01090
M_PRG_CONST_STRING_01091:
        ST         -Z, R17
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01081
M_CASE_01082:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_SERIAL)
        CPI        R16, 0x01
        BREQ       M_CASE_01093
        RJMP       M_CASE_01092
M_CASE_01093:
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (ANZEIGE_STRING)=80
        LDI        R16, 80
        CLR        R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_01094
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_01094:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_01096
M_PRG_CONST_STRING_01095:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_01095
M_PRG_CONST_STRING_01096:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Kopieren der String-Konstante in den Stack ('Serial')
        LDI        ZL, LOW(2*M_CONST_STRING_28)
        LDI        ZH, HIGH(2*M_CONST_STRING_28)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_01097
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_01097:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_01099
M_PRG_CONST_STRING_01098:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_01098
M_PRG_CONST_STRING_01099:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ANZEIGE_STRING) - Laenge in R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_01101
        MOV        R16, R17
M_PRG_CONST_STRING_01100:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_01100
M_PRG_CONST_STRING_01101:
        ST         -Z, R17
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01081
M_CASE_01092:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_ITP3_DS0)
        CPI        R16, 0x02
        BREQ       M_CASE_01103
        RJMP       M_CASE_01102
M_CASE_01103:
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (ANZEIGE_STRING)=80
        LDI        R16, 80
        CLR        R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_01104
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_01104:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_01106
M_PRG_CONST_STRING_01105:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_01105
M_PRG_CONST_STRING_01106:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Kopieren der String-Konstante in den Stack ('ITP3 DS0')
        LDI        ZL, LOW(2*M_CONST_STRING_29)
        LDI        ZH, HIGH(2*M_CONST_STRING_29)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_01107
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_01107:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_01109
M_PRG_CONST_STRING_01108:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_01108
M_PRG_CONST_STRING_01109:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ANZEIGE_STRING) - Laenge in R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_01111
        MOV        R16, R17
M_PRG_CONST_STRING_01110:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_01110
M_PRG_CONST_STRING_01111:
        ST         -Z, R17
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01081
M_CASE_01102:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_ITP3_DS1)
        CPI        R16, 0x03
        BREQ       M_CASE_01113
        RJMP       M_CASE_01112
M_CASE_01113:
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (ANZEIGE_STRING)=80
        LDI        R16, 80
        CLR        R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_01114
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_01114:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_01116
M_PRG_CONST_STRING_01115:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_01115
M_PRG_CONST_STRING_01116:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Kopieren der String-Konstante in den Stack ('ITP3 DS1')
        LDI        ZL, LOW(2*M_CONST_STRING_30)
        LDI        ZH, HIGH(2*M_CONST_STRING_30)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_01117
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_01117:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_01119
M_PRG_CONST_STRING_01118:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_01118
M_PRG_CONST_STRING_01119:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ANZEIGE_STRING) - Laenge in R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_01121
        MOV        R16, R17
M_PRG_CONST_STRING_01120:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_01120
M_PRG_CONST_STRING_01121:
        ST         -Z, R17
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01081
M_CASE_01112:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_ITP3_DS2)
        CPI        R16, 0x04
        BREQ       M_CASE_01123
        RJMP       M_CASE_01122
M_CASE_01123:
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (ANZEIGE_STRING)=80
        LDI        R16, 80
        CLR        R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_01124
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_01124:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_01126
M_PRG_CONST_STRING_01125:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_01125
M_PRG_CONST_STRING_01126:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Kopieren der String-Konstante in den Stack ('ITP3 DS2')
        LDI        ZL, LOW(2*M_CONST_STRING_31)
        LDI        ZH, HIGH(2*M_CONST_STRING_31)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_01127
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_01127:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_01129
M_PRG_CONST_STRING_01128:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_01128
M_PRG_CONST_STRING_01129:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ANZEIGE_STRING) - Laenge in R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_01131
        MOV        R16, R17
M_PRG_CONST_STRING_01130:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_01130
M_PRG_CONST_STRING_01131:
        ST         -Z, R17
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01081
M_CASE_01122:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_ITP3_DS3)
        CPI        R16, 0x05
        BREQ       M_CASE_01133
        RJMP       M_CASE_01132
M_CASE_01133:
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (ANZEIGE_STRING)=80
        LDI        R16, 80
        CLR        R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_01134
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_01134:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_01136
M_PRG_CONST_STRING_01135:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_01135
M_PRG_CONST_STRING_01136:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Kopieren der String-Konstante in den Stack ('ITP3 DS3')
        LDI        ZL, LOW(2*M_CONST_STRING_32)
        LDI        ZH, HIGH(2*M_CONST_STRING_32)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_01137
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_01137:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_01139
M_PRG_CONST_STRING_01138:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_01138
M_PRG_CONST_STRING_01139:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ANZEIGE_STRING) - Laenge in R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_01141
        MOV        R16, R17
M_PRG_CONST_STRING_01140:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_01140
M_PRG_CONST_STRING_01141:
        ST         -Z, R17
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01081
M_CASE_01132:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_ITP3_DS4)
        CPI        R16, 0x06
        BREQ       M_CASE_01143
        RJMP       M_CASE_01142
M_CASE_01143:
 
; Zuweisung Quelle - Ausdruck erster Faktor Laenge Ziel-STRING (ANZEIGE_STRING)=80
        LDI        R16, 80
        CLR        R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LD         R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_01144
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_01144:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_01146
M_PRG_CONST_STRING_01145:
        LD         R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_01145
M_PRG_CONST_STRING_01146:
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Kopieren der String-Konstante in den Stack ('ITP3 DS4')
        LDI        ZL, LOW(2*M_CONST_STRING_33)
        LDI        ZH, HIGH(2*M_CONST_STRING_33)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_01147
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_01147:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_01149
M_PRG_CONST_STRING_01148:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_01148
M_PRG_CONST_STRING_01149:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ANZEIGE_STRING) - Laenge in R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_01151
        MOV        R16, R17
M_PRG_CONST_STRING_01150:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_01150
M_PRG_CONST_STRING_01151:
        ST         -Z, R17
 
; ENDCASE;
M_CASE_01142:
M_CASE_01081:
 
; PROCEDURE - Ende (GERAETE_ANZEIGEN_DEVICE)
        RET
 
; PROCEDURE - Anfang (GERAETE_ANZEIGEN)
GERAETE_ANZEIGEN:
 
; IF THEN - Ausdruck / Byte-VAR (I2C_VORHANDEN)
        LDS        R16, I2C_VORHANDEN
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_01152
        RJMP       M_IF_01153
M_IF_01152:
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_01154
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_01153:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (ANZEIGE_STRING)=80
        LDI        R16, 80
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('*** kein lokaler Flash (AT24C512) erkannt ***')
        LDI        ZL, LOW(2*M_CONST_STRING_34)
        LDI        ZH, HIGH(2*M_CONST_STRING_34)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_01155
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_01155:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_01157
M_PRG_CONST_STRING_01156:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_01156
M_PRG_CONST_STRING_01157:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ANZEIGE_STRING) - Laenge in R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_01159
        MOV        R16, R17
M_PRG_CONST_STRING_01158:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_01158
M_PRG_CONST_STRING_01159:
        ST         -Z, R17
 
; Aufruf PROCEDURE (ANZEIGE_STRING_AN_CONOUT)
        CALL       ANZEIGE_STRING_AN_CONOUT
 
; IF_THEN_ELSE - Ende
M_IF_01154:
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (CONOUT_DEVICE_NR2)
        LDS        R16, CONOUT_DEVICE_NR2
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (NO_DEVICE)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_01163
        CLR        R16
        RJMP       M_VERGL_01164
M_VERGL_01163:
        SER        R16
M_VERGL_01164:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_01160
        RJMP       M_IF_01161
M_IF_01160:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (ANZEIGE_STRING)=80
        LDI        R16, 80
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('CONOUT=')
        LDI        ZL, LOW(2*M_CONST_STRING_35)
        LDI        ZH, HIGH(2*M_CONST_STRING_35)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_01165
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_01165:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_01167
M_PRG_CONST_STRING_01166:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_01166
M_PRG_CONST_STRING_01167:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ANZEIGE_STRING) - Laenge in R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_01169
        MOV        R16, R17
M_PRG_CONST_STRING_01168:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_01168
M_PRG_CONST_STRING_01169:
        ST         -Z, R17
 
; Byte-Parameter(1) fuer PROCEDURE (GERAETE_ANZEIGEN_DEVICE)
        LDS        R0, CONOUT_DEVICE_NR1
 
; Aufruf PROCEDURE (GERAETE_ANZEIGEN_DEVICE)
        CALL       GERAETE_ANZEIGEN_DEVICE
 
; Aufruf PROCEDURE (ANZEIGE_STRING_AN_CONOUT)
        CALL       ANZEIGE_STRING_AN_CONOUT
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_01162
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_01161:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (ANZEIGE_STRING)=80
        LDI        R16, 80
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('CONOUT_NR1=')
        LDI        ZL, LOW(2*M_CONST_STRING_36)
        LDI        ZH, HIGH(2*M_CONST_STRING_36)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_01170
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_01170:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_01172
M_PRG_CONST_STRING_01171:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_01171
M_PRG_CONST_STRING_01172:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ANZEIGE_STRING) - Laenge in R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_01174
        MOV        R16, R17
M_PRG_CONST_STRING_01173:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_01173
M_PRG_CONST_STRING_01174:
        ST         -Z, R17
 
; Byte-Parameter(1) fuer PROCEDURE (GERAETE_ANZEIGEN_DEVICE)
        LDS        R0, CONOUT_DEVICE_NR1
 
; Aufruf PROCEDURE (GERAETE_ANZEIGEN_DEVICE)
        CALL       GERAETE_ANZEIGEN_DEVICE
 
; Aufruf PROCEDURE (ANZEIGE_STRING_AN_CONOUT)
        CALL       ANZEIGE_STRING_AN_CONOUT
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (ANZEIGE_STRING)=80
        LDI        R16, 80
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('CONOUT_NR2=')
        LDI        ZL, LOW(2*M_CONST_STRING_37)
        LDI        ZH, HIGH(2*M_CONST_STRING_37)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_01175
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_01175:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_01177
M_PRG_CONST_STRING_01176:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_01176
M_PRG_CONST_STRING_01177:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ANZEIGE_STRING) - Laenge in R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_01179
        MOV        R16, R17
M_PRG_CONST_STRING_01178:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_01178
M_PRG_CONST_STRING_01179:
        ST         -Z, R17
 
; Byte-Parameter(1) fuer PROCEDURE (GERAETE_ANZEIGEN_DEVICE)
        LDS        R0, CONOUT_DEVICE_NR2
 
; Aufruf PROCEDURE (GERAETE_ANZEIGEN_DEVICE)
        CALL       GERAETE_ANZEIGEN_DEVICE
 
; Aufruf PROCEDURE (ANZEIGE_STRING_AN_CONOUT)
        CALL       ANZEIGE_STRING_AN_CONOUT
 
; IF_THEN_ELSE - Ende
M_IF_01162:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (ANZEIGE_STRING)=80
        LDI        R16, 80
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('CONIN=')
        LDI        ZL, LOW(2*M_CONST_STRING_38)
        LDI        ZH, HIGH(2*M_CONST_STRING_38)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_01180
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_01180:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_01182
M_PRG_CONST_STRING_01181:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_01181
M_PRG_CONST_STRING_01182:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ANZEIGE_STRING) - Laenge in R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_01184
        MOV        R16, R17
M_PRG_CONST_STRING_01183:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_01183
M_PRG_CONST_STRING_01184:
        ST         -Z, R17
 
; Byte-Parameter(1) fuer PROCEDURE (GERAETE_ANZEIGEN_DEVICE)
        LDS        R0, CONIN_DEVICE
 
; Aufruf PROCEDURE (GERAETE_ANZEIGEN_DEVICE)
        CALL       GERAETE_ANZEIGEN_DEVICE
 
; Aufruf PROCEDURE (ANZEIGE_STRING_AN_CONOUT)
        CALL       ANZEIGE_STRING_AN_CONOUT
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (SOUND_DEVICE)
        LDS        R16, SOUND_DEVICE
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (NO_DEVICE)
        LDI        R18, 0x00
 
; Operator <>
        CP         R16, R18
        BRNE       M_VERGL_01188
        CLR        R16
        RJMP       M_VERGL_01189
M_VERGL_01188:
        SER        R16
M_VERGL_01189:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_01185
        RJMP       M_IF_01186
M_IF_01185:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (ANZEIGE_STRING)=80
        LDI        R16, 80
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('SOUND=')
        LDI        ZL, LOW(2*M_CONST_STRING_39)
        LDI        ZH, HIGH(2*M_CONST_STRING_39)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_01190
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_01190:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_01192
M_PRG_CONST_STRING_01191:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_01191
M_PRG_CONST_STRING_01192:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ANZEIGE_STRING) - Laenge in R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_01194
        MOV        R16, R17
M_PRG_CONST_STRING_01193:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_01193
M_PRG_CONST_STRING_01194:
        ST         -Z, R17
 
; Byte-Parameter(1) fuer PROCEDURE (GERAETE_ANZEIGEN_DEVICE)
        LDS        R0, SOUND_DEVICE
 
; Aufruf PROCEDURE (GERAETE_ANZEIGEN_DEVICE)
        CALL       GERAETE_ANZEIGEN_DEVICE
 
; Aufruf PROCEDURE (ANZEIGE_STRING_AN_CONOUT)
        CALL       ANZEIGE_STRING_AN_CONOUT
 
; IF_THEN - Ende
M_IF_01186:
 
; PROCEDURE - Ende (GERAETE_ANZEIGEN)
        RET
 
; FUNCTION - Anfang (DISKNO_IN_SCHNITTSTELLE)
DISKNO_IN_SCHNITTSTELLE:
 
; Zuweisung Quelle - Ausdruck /; Zuweisung ByteToWord(DISKNO)
        LDS        R16, DISKNO
        CLR        R17
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LAUFWERK_WORD)
        MOV        R2, R16
        MOV        R3, R17
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (LAUFWERK_WORD)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (LAUFWERKE_VERTEILER)
        LDI        ZL, LOW(LAUFWERKE_VERTEILER)
        LDI        ZH, HIGH(LAUFWERKE_VERTEILER)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (EINTRAG_WERT)
        MOV        R1, R16
 
; RESULT Byte-Variable - FUNCTION (DISKNO_IN_SCHNITTSTELLE)
        MOV        R0, R1
 
; Ende Byte - FUNCTION (DISKNO_IN_SCHNITTSTELLE)
        MOV        R16, R0
 
; FUNCTION - Ende (DISKNO_IN_SCHNITTSTELLE)
        RET
 
; PROCEDURE - Anfang (LAUFWERKE_VERTEILER_READ)
LAUFWERKE_VERTEILER_READ:
 
; Retten der lokalen Parameter fuer PROCEDURE (LAUFWERKE_VERTEILER_READ)
        PUSH       R0
 
; Aufruf Funktion (DISKNO_IN_SCHNITTSTELLE)
        CALL       DISKNO_IN_SCHNITTSTELLE
 
; Retten der Parameter-Register fuer PROCEDURE (LAUFWERKE_VERTEILER_READ)
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (EINTRAG_WERT)
        MOV        R0, R16
 
; CASE OF - lokale, dynamische Variable VAR (EINTRAG_WERT)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (DEVICE_LOKAL_FLASH)
        CPI        R16, 0x07
        BREQ       M_CASE_01197
        RJMP       M_CASE_01196
M_CASE_01197:
 
; Retten der lokalen Parameter fuer PROCEDURE (LAUFWERKE_VERTEILER_READ)
        PUSH       R0
 
; Aufruf PROCEDURE (STD_AN_LOKALEN_FLASH_MANAGER_SENDEN)
        CALL       STD_AN_LOKALEN_FLASH_MANAGER_SENDEN
 
; Retten der Parameter-Register fuer PROCEDURE (LAUFWERKE_VERTEILER_READ)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (LAUFWERKE_VERTEILER_READ)
        PUSH       R0
 
; Aufruf PROCEDURE (LOKALEN_FLASH_MANAGER_SEKTOR_LESEN)
        CALL       LOKALEN_FLASH_MANAGER_SEKTOR_LESEN
 
; Retten der Parameter-Register fuer PROCEDURE (LAUFWERKE_VERTEILER_READ)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01195
M_CASE_01196:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_SERIAL)
        CPI        R16, 0x01
        BREQ       M_CASE_01199
        RJMP       M_CASE_01198
M_CASE_01199:
 
; Retten der lokalen Parameter fuer PROCEDURE (LAUFWERKE_VERTEILER_READ)
        PUSH       R0
 
; Aufruf PROCEDURE (STD_AN_UART_SENDEN)
        CALL       STD_AN_UART_SENDEN
 
; Retten der Parameter-Register fuer PROCEDURE (LAUFWERKE_VERTEILER_READ)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (LAUFWERKE_VERTEILER_READ)
        PUSH       R0
 
; Aufruf PROCEDURE (SEKTOR_VON_UART_LESEN_KOMP)
        CALL       SEKTOR_VON_UART_LESEN_KOMP
 
; Retten der Parameter-Register fuer PROCEDURE (LAUFWERKE_VERTEILER_READ)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01195
M_CASE_01198:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_ITP3_DS0)
        CPI        R16, 0x02
        BREQ       M_CASE_01201
        RJMP       M_CASE_01200
M_CASE_01201:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS0)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (LAUFWERKE_VERTEILER_READ)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_SENDE_STD)
        CALL       ITP3_SENDE_STD
 
; Retten der Parameter-Register fuer PROCEDURE (LAUFWERKE_VERTEILER_READ)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (LAUFWERKE_VERTEILER_READ)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_SEKTOR_LESEN)
        CALL       ITP3_SEKTOR_LESEN
 
; Retten der Parameter-Register fuer PROCEDURE (LAUFWERKE_VERTEILER_READ)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01195
M_CASE_01200:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_ITP3_DS1)
        CPI        R16, 0x03
        BREQ       M_CASE_01203
        RJMP       M_CASE_01202
M_CASE_01203:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS1)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (LAUFWERKE_VERTEILER_READ)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_SENDE_STD)
        CALL       ITP3_SENDE_STD
 
; Retten der Parameter-Register fuer PROCEDURE (LAUFWERKE_VERTEILER_READ)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (LAUFWERKE_VERTEILER_READ)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_SEKTOR_LESEN)
        CALL       ITP3_SEKTOR_LESEN
 
; Retten der Parameter-Register fuer PROCEDURE (LAUFWERKE_VERTEILER_READ)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01195
M_CASE_01202:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_ITP3_DS2)
        CPI        R16, 0x04
        BREQ       M_CASE_01205
        RJMP       M_CASE_01204
M_CASE_01205:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS2)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (LAUFWERKE_VERTEILER_READ)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_SENDE_STD)
        CALL       ITP3_SENDE_STD
 
; Retten der Parameter-Register fuer PROCEDURE (LAUFWERKE_VERTEILER_READ)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (LAUFWERKE_VERTEILER_READ)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_SEKTOR_LESEN)
        CALL       ITP3_SEKTOR_LESEN
 
; Retten der Parameter-Register fuer PROCEDURE (LAUFWERKE_VERTEILER_READ)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01195
M_CASE_01204:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_ITP3_DS3)
        CPI        R16, 0x05
        BREQ       M_CASE_01207
        RJMP       M_CASE_01206
M_CASE_01207:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS3)
        LDI        R16, 0x03
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (LAUFWERKE_VERTEILER_READ)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_SENDE_STD)
        CALL       ITP3_SENDE_STD
 
; Retten der Parameter-Register fuer PROCEDURE (LAUFWERKE_VERTEILER_READ)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (LAUFWERKE_VERTEILER_READ)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_SEKTOR_LESEN)
        CALL       ITP3_SEKTOR_LESEN
 
; Retten der Parameter-Register fuer PROCEDURE (LAUFWERKE_VERTEILER_READ)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01195
M_CASE_01206:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_ITP3_DS4)
        CPI        R16, 0x06
        BREQ       M_CASE_01209
        RJMP       M_CASE_01208
M_CASE_01209:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS4)
        LDI        R16, 0x04
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (LAUFWERKE_VERTEILER_READ)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_SENDE_STD)
        CALL       ITP3_SENDE_STD
 
; Retten der Parameter-Register fuer PROCEDURE (LAUFWERKE_VERTEILER_READ)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (LAUFWERKE_VERTEILER_READ)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_SEKTOR_LESEN)
        CALL       ITP3_SEKTOR_LESEN
 
; Retten der Parameter-Register fuer PROCEDURE (LAUFWERKE_VERTEILER_READ)
        POP        R0
 
; ENDCASE;
M_CASE_01208:
M_CASE_01195:
 
; PROCEDURE - Ende (LAUFWERKE_VERTEILER_READ)
        RET
 
; PROCEDURE - Anfang (LAUFWERKE_VERTEILER_WRITE)
LAUFWERKE_VERTEILER_WRITE:
 
; Retten der lokalen Parameter fuer PROCEDURE (LAUFWERKE_VERTEILER_WRITE)
        PUSH       R0
 
; Aufruf Funktion (DISKNO_IN_SCHNITTSTELLE)
        CALL       DISKNO_IN_SCHNITTSTELLE
 
; Retten der Parameter-Register fuer PROCEDURE (LAUFWERKE_VERTEILER_WRITE)
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (EINTRAG_WERT)
        MOV        R0, R16
 
; CASE OF - lokale, dynamische Variable VAR (EINTRAG_WERT)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (DEVICE_LOKAL_FLASH)
        CPI        R16, 0x07
        BREQ       M_CASE_01212
        RJMP       M_CASE_01211
M_CASE_01212:
 
; Retten der lokalen Parameter fuer PROCEDURE (LAUFWERKE_VERTEILER_WRITE)
        PUSH       R0
 
; Aufruf PROCEDURE (STD_AN_LOKALEN_FLASH_MANAGER_SENDEN)
        CALL       STD_AN_LOKALEN_FLASH_MANAGER_SENDEN
 
; Retten der Parameter-Register fuer PROCEDURE (LAUFWERKE_VERTEILER_WRITE)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (LAUFWERKE_VERTEILER_WRITE)
        PUSH       R0
 
; Aufruf PROCEDURE (LOKALEN_FLASH_MANAGER_SEKTOR_SCHREIBEN)
        CALL       LOKALEN_FLASH_MANAGER_SEKTOR_SCHREIBEN
 
; Retten der Parameter-Register fuer PROCEDURE (LAUFWERKE_VERTEILER_WRITE)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01210
M_CASE_01211:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_SERIAL)
        CPI        R16, 0x01
        BREQ       M_CASE_01214
        RJMP       M_CASE_01213
M_CASE_01214:
 
; Retten der lokalen Parameter fuer PROCEDURE (LAUFWERKE_VERTEILER_WRITE)
        PUSH       R0
 
; Aufruf PROCEDURE (STD_AN_UART_SENDEN)
        CALL       STD_AN_UART_SENDEN
 
; Retten der Parameter-Register fuer PROCEDURE (LAUFWERKE_VERTEILER_WRITE)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (LAUFWERKE_VERTEILER_WRITE)
        PUSH       R0
 
; Aufruf PROCEDURE (SEKTOR_AN_UART_SENDEN)
        CALL       SEKTOR_AN_UART_SENDEN
 
; Retten der Parameter-Register fuer PROCEDURE (LAUFWERKE_VERTEILER_WRITE)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01210
M_CASE_01213:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_ITP3_DS0)
        CPI        R16, 0x02
        BREQ       M_CASE_01216
        RJMP       M_CASE_01215
M_CASE_01216:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS0)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (LAUFWERKE_VERTEILER_WRITE)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_SENDE_STD)
        CALL       ITP3_SENDE_STD
 
; Retten der Parameter-Register fuer PROCEDURE (LAUFWERKE_VERTEILER_WRITE)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (LAUFWERKE_VERTEILER_WRITE)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_SEKTOR_SCHREIBEN)
        CALL       ITP3_SEKTOR_SCHREIBEN
 
; Retten der Parameter-Register fuer PROCEDURE (LAUFWERKE_VERTEILER_WRITE)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01210
M_CASE_01215:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_ITP3_DS1)
        CPI        R16, 0x03
        BREQ       M_CASE_01218
        RJMP       M_CASE_01217
M_CASE_01218:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS1)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (LAUFWERKE_VERTEILER_WRITE)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_SENDE_STD)
        CALL       ITP3_SENDE_STD
 
; Retten der Parameter-Register fuer PROCEDURE (LAUFWERKE_VERTEILER_WRITE)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (LAUFWERKE_VERTEILER_WRITE)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_SEKTOR_SCHREIBEN)
        CALL       ITP3_SEKTOR_SCHREIBEN
 
; Retten der Parameter-Register fuer PROCEDURE (LAUFWERKE_VERTEILER_WRITE)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01210
M_CASE_01217:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_ITP3_DS2)
        CPI        R16, 0x04
        BREQ       M_CASE_01220
        RJMP       M_CASE_01219
M_CASE_01220:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS2)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (LAUFWERKE_VERTEILER_WRITE)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_SENDE_STD)
        CALL       ITP3_SENDE_STD
 
; Retten der Parameter-Register fuer PROCEDURE (LAUFWERKE_VERTEILER_WRITE)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (LAUFWERKE_VERTEILER_WRITE)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_SEKTOR_SCHREIBEN)
        CALL       ITP3_SEKTOR_SCHREIBEN
 
; Retten der Parameter-Register fuer PROCEDURE (LAUFWERKE_VERTEILER_WRITE)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01210
M_CASE_01219:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_ITP3_DS3)
        CPI        R16, 0x05
        BREQ       M_CASE_01222
        RJMP       M_CASE_01221
M_CASE_01222:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS3)
        LDI        R16, 0x03
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (LAUFWERKE_VERTEILER_WRITE)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_SENDE_STD)
        CALL       ITP3_SENDE_STD
 
; Retten der Parameter-Register fuer PROCEDURE (LAUFWERKE_VERTEILER_WRITE)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (LAUFWERKE_VERTEILER_WRITE)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_SEKTOR_SCHREIBEN)
        CALL       ITP3_SEKTOR_SCHREIBEN
 
; Retten der Parameter-Register fuer PROCEDURE (LAUFWERKE_VERTEILER_WRITE)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01210
M_CASE_01221:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_ITP3_DS4)
        CPI        R16, 0x06
        BREQ       M_CASE_01224
        RJMP       M_CASE_01223
M_CASE_01224:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS4)
        LDI        R16, 0x04
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (LAUFWERKE_VERTEILER_WRITE)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_SENDE_STD)
        CALL       ITP3_SENDE_STD
 
; Retten der Parameter-Register fuer PROCEDURE (LAUFWERKE_VERTEILER_WRITE)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (LAUFWERKE_VERTEILER_WRITE)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_SEKTOR_SCHREIBEN)
        CALL       ITP3_SEKTOR_SCHREIBEN
 
; Retten der Parameter-Register fuer PROCEDURE (LAUFWERKE_VERTEILER_WRITE)
        POP        R0
 
; ENDCASE;
M_CASE_01223:
M_CASE_01210:
 
; PROCEDURE - Ende (LAUFWERKE_VERTEILER_WRITE)
        RET
 
; PROCEDURE - Anfang (SENDE_50_TAKTE)
SENDE_50_TAKTE:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ZAEHLER)
        MOV        R0, R16
 
; FOR TO DO - Ausdruck / Zahlenwert (0x64)
        LDI        R16, 0x64
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R0
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_01225:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_01226
        RJMP       M_FTD_01227
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_01226:
 
; SetBit(CLK_Z80)
        SBI        PORTD, 7
 
; NOP
        NOP
 
; NOP
        NOP
 
; ClearBit(CLK_Z80)
        CBI        PORTD, 7
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R0
        INC        R17
        MOV        R0, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_01225
 
; FOR TO DO - Ende
M_FTD_01227:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; PROCEDURE - Ende (SENDE_50_TAKTE)
        RET
 
; PROCEDURE - Anfang (Z80_RESET_UND_URLOAD)
Z80_RESET_UND_URLOAD:
 
; SetBit(RESET_Z80)
        SBI        PORTD, 6
 
; Aufruf PROCEDURE (SENDE_50_TAKTE)
        CALL       SENDE_50_TAKTE
 
; ClearBit(RESET_Z80)
        CBI        PORTD, 6
 
; Aufruf PROCEDURE (SENDE_50_TAKTE)
        CALL       SENDE_50_TAKTE
 
; SetBit(RESET_Z80)
        SBI        PORTD, 6
 
; Aufruf PROCEDURE (LADE_MEIC_ARRAY_IN_RAM)
        CALL       LADE_MEIC_ARRAY_IN_RAM
 
; ClearBit(RESET_Z80)
        CBI        PORTD, 6
 
; Aufruf PROCEDURE (SENDE_50_TAKTE)
        CALL       SENDE_50_TAKTE
 
; SetBit(RESET_Z80)
        SBI        PORTD, 6
 
; PROCEDURE - Ende (Z80_RESET_UND_URLOAD)
        RET
 
; PROCEDURE - Anfang (IORQ_ENDE)
IORQ_ENDE:
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_LOW)
        CALL       WARTE_SOLANGE_IORQ_LOW
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; PROCEDURE - Ende (IORQ_ENDE)
        RET
 
; PROCEDURE - Anfang (Z80_CONOUT)
Z80_CONOUT:
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_LOW)
        CALL       WARTE_SOLANGE_IORQ_LOW
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_HIGH)
        CALL       WARTE_SOLANGE_IORQ_HIGH
 
; Zuweisung Quelle - Ausdruck / Byte-REG PINC
        IN         R16, PINC
 
; Zuweisung Ziel /  VAR (CONSOLEOUT)
        STS        CONSOLEOUT, R16
 
; Aufruf PROCEDURE (IORQ_ENDE)
        CALL       IORQ_ENDE
 
; PROCEDURE - Ende (Z80_CONOUT)
        RET
 
; PROCEDURE - Anfang (Z80_LIST)
Z80_LIST:
 
; Retten der lokalen Parameter fuer PROCEDURE (Z80_LIST)
        PUSH       R0
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_LOW)
        CALL       WARTE_SOLANGE_IORQ_LOW
 
; Retten der Parameter-Register fuer PROCEDURE (Z80_LIST)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (Z80_LIST)
        PUSH       R0
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_HIGH)
        CALL       WARTE_SOLANGE_IORQ_HIGH
 
; Retten der Parameter-Register fuer PROCEDURE (Z80_LIST)
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Byte-REG PINC
        IN         R16, PINC
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (IO_WERT)
        MOV        R0, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (Z80_LIST)
        PUSH       R0
 
; Aufruf PROCEDURE (IORQ_ENDE)
        CALL       IORQ_ENDE
 
; Retten der Parameter-Register fuer PROCEDURE (Z80_LIST)
        POP        R0
 
; PROCEDURE - Ende (Z80_LIST)
        RET
 
; PROCEDURE - Anfang (Z80_SOUND)
Z80_SOUND:
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_LOW)
        CALL       WARTE_SOLANGE_IORQ_LOW
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_HIGH)
        CALL       WARTE_SOLANGE_IORQ_HIGH
 
; Zuweisung Quelle - Ausdruck / Byte-REG PINC
        IN         R16, PINC
 
; Zuweisung Ziel /  VAR (SOUNDOUT)
        STS        SOUNDOUT, R16
 
; Aufruf PROCEDURE (IORQ_ENDE)
        CALL       IORQ_ENDE
 
; PROCEDURE - Ende (Z80_SOUND)
        RET
 
; PROCEDURE - Anfang (Z80_CONIN)
Z80_CONIN:
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_LOW)
        CALL       WARTE_SOLANGE_IORQ_LOW
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_HIGH)
        CALL       WARTE_SOLANGE_IORQ_HIGH
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (CONSOLEIN)
        LDS        R16, CONSOLEIN
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; Aufruf PROCEDURE (IORQ_ENDE)
        CALL       IORQ_ENDE
 
; PROCEDURE - Ende (Z80_CONIN)
        RET
 
; PROCEDURE - Anfang (STD_AN_UC)
STD_AN_UC:
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_LOW)
        CALL       WARTE_SOLANGE_IORQ_LOW
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_HIGH)
        CALL       WARTE_SOLANGE_IORQ_HIGH
 
; Zuweisung Quelle - Ausdruck / Byte-REG PINC
        IN         R16, PINC
 
; Zuweisung Ziel /  VAR (SECTOR)
        STS        SECTOR, R16
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_LOW)
        CALL       WARTE_SOLANGE_IORQ_LOW
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_HIGH)
        CALL       WARTE_SOLANGE_IORQ_HIGH
 
; Zuweisung Quelle - Ausdruck / Byte-REG PINC
        IN         R16, PINC
 
; Zuweisung Ziel /  VAR (TRACK_L)
        STS        TRACK_L, R16
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_LOW)
        CALL       WARTE_SOLANGE_IORQ_LOW
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_HIGH)
        CALL       WARTE_SOLANGE_IORQ_HIGH
 
; Zuweisung Quelle - Ausdruck / Byte-REG PINC
        IN         R16, PINC
 
; Zuweisung Ziel /  VAR (TRACK_H)
        STS        TRACK_H, R16
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_LOW)
        CALL       WARTE_SOLANGE_IORQ_LOW
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_HIGH)
        CALL       WARTE_SOLANGE_IORQ_HIGH
 
; Zuweisung Quelle - Ausdruck / Byte-REG PINC
        IN         R16, PINC
 
; Zuweisung Ziel /  VAR (DISKNO)
        STS        DISKNO, R16
 
; Aufruf PROCEDURE (IORQ_ENDE)
        CALL       IORQ_ENDE
 
; PROCEDURE - Ende (STD_AN_UC)
        RET
 
; PROCEDURE - Anfang (CONST_TO_DEVICE)
CONST_TO_DEVICE:
 
; CASE OF - Byte-VAR (CONIN_DEVICE)
        LDS        R16, CONIN_DEVICE
 
; CASE OF - vergleiche Einzel-Element (DEVICE_SERIAL)
        CPI        R16, 0x01
        BREQ       M_CASE_01230
        RJMP       M_CASE_01229
M_CASE_01230:
 
; Aufruf PROCEDURE (CONST_VON_UART_LESEN)
        CALL       CONST_VON_UART_LESEN
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01228
M_CASE_01229:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_ITP3_DS0)
        CPI        R16, 0x02
        BREQ       M_CASE_01232
        RJMP       M_CASE_01231
M_CASE_01232:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS0)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Aufruf Funktion (ITP3_EMPFANGE_CONST)
        CALL       ITP3_EMPFANGE_CONST
 
; Zuweisung Ziel /  VAR (CONSOLEIN)
        STS        CONSOLEIN, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01228
M_CASE_01231:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_ITP3_DS1)
        CPI        R16, 0x03
        BREQ       M_CASE_01234
        RJMP       M_CASE_01233
M_CASE_01234:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS1)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Aufruf Funktion (ITP3_EMPFANGE_CONST)
        CALL       ITP3_EMPFANGE_CONST
 
; Zuweisung Ziel /  VAR (CONSOLEIN)
        STS        CONSOLEIN, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01228
M_CASE_01233:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_ITP3_DS2)
        CPI        R16, 0x04
        BREQ       M_CASE_01236
        RJMP       M_CASE_01235
M_CASE_01236:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS2)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Aufruf Funktion (ITP3_EMPFANGE_CONST)
        CALL       ITP3_EMPFANGE_CONST
 
; Zuweisung Ziel /  VAR (CONSOLEIN)
        STS        CONSOLEIN, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01228
M_CASE_01235:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_ITP3_DS3)
        CPI        R16, 0x05
        BREQ       M_CASE_01238
        RJMP       M_CASE_01237
M_CASE_01238:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS3)
        LDI        R16, 0x03
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Aufruf Funktion (ITP3_EMPFANGE_CONST)
        CALL       ITP3_EMPFANGE_CONST
 
; Zuweisung Ziel /  VAR (CONSOLEIN)
        STS        CONSOLEIN, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01228
M_CASE_01237:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_ITP3_DS4)
        CPI        R16, 0x06
        BREQ       M_CASE_01240
        RJMP       M_CASE_01239
M_CASE_01240:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS4)
        LDI        R16, 0x04
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Aufruf Funktion (ITP3_EMPFANGE_CONST)
        CALL       ITP3_EMPFANGE_CONST
 
; Zuweisung Ziel /  VAR (CONSOLEIN)
        STS        CONSOLEIN, R16
 
; ENDCASE;
M_CASE_01239:
M_CASE_01228:
 
; Aufruf PROCEDURE (Z80_CONIN)
        CALL       Z80_CONIN
 
; PROCEDURE - Ende (CONST_TO_DEVICE)
        RET
 
; PROCEDURE - Anfang (CONIN_TO_DEVICE)
CONIN_TO_DEVICE:
 
; CASE OF - Byte-VAR (CONIN_DEVICE)
        LDS        R16, CONIN_DEVICE
 
; CASE OF - vergleiche Einzel-Element (DEVICE_SERIAL)
        CPI        R16, 0x01
        BREQ       M_CASE_01243
        RJMP       M_CASE_01242
M_CASE_01243:
 
; Aufruf PROCEDURE (UART_CONIN_SCHLEIFE)
        CALL       UART_CONIN_SCHLEIFE
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01241
M_CASE_01242:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_ITP3_DS0)
        CPI        R16, 0x02
        BREQ       M_CASE_01245
        RJMP       M_CASE_01244
M_CASE_01245:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS0)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Aufruf PROCEDURE (ITP3_CONIN_SCHLEIFE)
        CALL       ITP3_CONIN_SCHLEIFE
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01241
M_CASE_01244:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_ITP3_DS1)
        CPI        R16, 0x03
        BREQ       M_CASE_01247
        RJMP       M_CASE_01246
M_CASE_01247:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS1)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Aufruf PROCEDURE (ITP3_CONIN_SCHLEIFE)
        CALL       ITP3_CONIN_SCHLEIFE
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01241
M_CASE_01246:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_ITP3_DS2)
        CPI        R16, 0x04
        BREQ       M_CASE_01249
        RJMP       M_CASE_01248
M_CASE_01249:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS2)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Aufruf PROCEDURE (ITP3_CONIN_SCHLEIFE)
        CALL       ITP3_CONIN_SCHLEIFE
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01241
M_CASE_01248:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_ITP3_DS3)
        CPI        R16, 0x05
        BREQ       M_CASE_01251
        RJMP       M_CASE_01250
M_CASE_01251:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS3)
        LDI        R16, 0x03
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Aufruf PROCEDURE (ITP3_CONIN_SCHLEIFE)
        CALL       ITP3_CONIN_SCHLEIFE
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01241
M_CASE_01250:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_ITP3_DS4)
        CPI        R16, 0x06
        BREQ       M_CASE_01253
        RJMP       M_CASE_01252
M_CASE_01253:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS4)
        LDI        R16, 0x04
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Aufruf PROCEDURE (ITP3_CONIN_SCHLEIFE)
        CALL       ITP3_CONIN_SCHLEIFE
 
; ENDCASE;
M_CASE_01252:
M_CASE_01241:
 
; Aufruf PROCEDURE (Z80_CONIN)
        CALL       Z80_CONIN
 
; PROCEDURE - Ende (CONIN_TO_DEVICE)
        RET
 
; PROCEDURE - Anfang (CONOUT_TO_DEVICE)
CONOUT_TO_DEVICE:
 
; Aufruf PROCEDURE (Z80_CONOUT)
        CALL       Z80_CONOUT
 
; Aufruf PROCEDURE (DIREKT_CONOUT_TO_DEVICE)
        CALL       DIREKT_CONOUT_TO_DEVICE
 
; PROCEDURE - Ende (CONOUT_TO_DEVICE)
        RET
 
; PROCEDURE - Anfang (LIST_TO_DEVICE)
LIST_TO_DEVICE:
 
; Aufruf PROCEDURE (Z80_LIST)
        CALL       Z80_LIST
 
; PROCEDURE - Ende (LIST_TO_DEVICE)
        RET
 
; PROCEDURE - Anfang (SOUND_TO_DEVICE)
SOUND_TO_DEVICE:
 
; Aufruf PROCEDURE (Z80_SOUND)
        CALL       Z80_SOUND
 
; CASE OF - Byte-VAR (SOUND_DEVICE)
        LDS        R16, SOUND_DEVICE
 
; CASE OF - vergleiche Einzel-Element (DEVICE_ITP3_DS0)
        CPI        R16, 0x02
        BREQ       M_CASE_01256
        RJMP       M_CASE_01255
M_CASE_01256:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS0)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Byte-Parameter(1) fuer PROCEDURE (ITP3_SENDE_SOUND)
        LDS        R0, SOUNDOUT
 
; Aufruf PROCEDURE (ITP3_SENDE_SOUND)
        CALL       ITP3_SENDE_SOUND
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01254
M_CASE_01255:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_ITP3_DS1)
        CPI        R16, 0x03
        BREQ       M_CASE_01258
        RJMP       M_CASE_01257
M_CASE_01258:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS1)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Byte-Parameter(1) fuer PROCEDURE (ITP3_SENDE_SOUND)
        LDS        R0, SOUNDOUT
 
; Aufruf PROCEDURE (ITP3_SENDE_SOUND)
        CALL       ITP3_SENDE_SOUND
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01254
M_CASE_01257:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_ITP3_DS2)
        CPI        R16, 0x04
        BREQ       M_CASE_01260
        RJMP       M_CASE_01259
M_CASE_01260:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS2)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Byte-Parameter(1) fuer PROCEDURE (ITP3_SENDE_SOUND)
        LDS        R0, SOUNDOUT
 
; Aufruf PROCEDURE (ITP3_SENDE_SOUND)
        CALL       ITP3_SENDE_SOUND
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01254
M_CASE_01259:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_ITP3_DS3)
        CPI        R16, 0x05
        BREQ       M_CASE_01262
        RJMP       M_CASE_01261
M_CASE_01262:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS3)
        LDI        R16, 0x03
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Byte-Parameter(1) fuer PROCEDURE (ITP3_SENDE_SOUND)
        LDS        R0, SOUNDOUT
 
; Aufruf PROCEDURE (ITP3_SENDE_SOUND)
        CALL       ITP3_SENDE_SOUND
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01254
M_CASE_01261:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_ITP3_DS4)
        CPI        R16, 0x06
        BREQ       M_CASE_01264
        RJMP       M_CASE_01263
M_CASE_01264:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEV_DS4)
        LDI        R16, 0x04
 
; Zuweisung Ziel /  VAR (DEV_NR)
        STS        DEV_NR, R16
 
; Byte-Parameter(1) fuer PROCEDURE (ITP3_SENDE_SOUND)
        LDS        R0, SOUNDOUT
 
; Aufruf PROCEDURE (ITP3_SENDE_SOUND)
        CALL       ITP3_SENDE_SOUND
 
; ENDCASE;
M_CASE_01263:
M_CASE_01254:
 
; PROCEDURE - Ende (SOUND_TO_DEVICE)
        RET
 
; FUNCTION - Anfang (LAUFWERK_IST_VORHANDEN)
LAUFWERK_IST_VORHANDEN:
 
; Retten der lokalen Parameter fuer PROCEDURE (LAUFWERK_IST_VORHANDEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Aufruf Funktion (DISKNO_IN_SCHNITTSTELLE)
        CALL       DISKNO_IN_SCHNITTSTELLE
 
; Retten der Parameter-Register fuer PROCEDURE (LAUFWERK_IST_VORHANDEN)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (EINTRAG_WERT)
        MOV        R2, R16
 
; CASE OF - lokale, dynamische Variable VAR (EINTRAG_WERT)
        MOV        R16, R2
 
; CASE OF - vergleiche Einzel-Element (DEVICE_LOKAL_FLASH)
        CPI        R16, 0x07
        BREQ       M_CASE_01267
        RJMP       M_CASE_01266
M_CASE_01267:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LIV_BYTE)
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01265
M_CASE_01266:
 
; CASE OF - vergleiche Einzel-Element (DEVICE_SERIAL)
        CPI        R16, 0x01
        BREQ       M_CASE_01269
        RJMP       M_CASE_01268
M_CASE_01269:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LIV_BYTE)
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01265
M_CASE_01268:
 
; CASE OF - vergleiche Byte-Element-Bereich <von> (DEVICE_ITP3_DS0)
        CPI        R16, 0x02
        BRCC       M_CASE_01272
        RJMP       M_CASE_01270
M_CASE_01272:
 
; CASE OF - vergleiche Byte-Element-Bereich <bis> (DEVICE_ITP3_DS4)
        LDI        R17, 0x06
        CP         R17, R16
        BRCC       M_CASE_01271
        RJMP       M_CASE_01270
M_CASE_01271:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LIV_BYTE)
        MOV        R1, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01265
 
; CASE OF ELSE
M_CASE_01270:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LIV_BYTE)
        MOV        R1, R16
 
; ENDCASE;
M_CASE_01265:
 
; RESULT Byte-Variable - FUNCTION (LAUFWERK_IST_VORHANDEN)
        MOV        R0, R1
 
; Ende Byte - FUNCTION (LAUFWERK_IST_VORHANDEN)
        MOV        R16, R0
 
; FUNCTION - Ende (LAUFWERK_IST_VORHANDEN)
        RET
 
; PROCEDURE - Anfang (LW_VORHANDEN)
LW_VORHANDEN:
 
; Retten der lokalen Parameter fuer PROCEDURE (LW_VORHANDEN)
        PUSH       R0
 
; Aufruf Funktion (LAUFWERK_IST_VORHANDEN)
        CALL       LAUFWERK_IST_VORHANDEN
 
; Retten der Parameter-Register fuer PROCEDURE (LW_VORHANDEN)
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LW_OK)
        MOV        R0, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (LW_VORHANDEN)
        PUSH       R0
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_LOW)
        CALL       WARTE_SOLANGE_IORQ_LOW
 
; Retten der Parameter-Register fuer PROCEDURE (LW_VORHANDEN)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (LW_VORHANDEN)
        PUSH       R0
 
; Aufruf PROCEDURE (WARTE_SOLANGE_IORQ_HIGH)
        CALL       WARTE_SOLANGE_IORQ_HIGH
 
; Retten der Parameter-Register fuer PROCEDURE (LW_VORHANDEN)
        POP        R0
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (LW_OK)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (LW_VORHANDEN)
        PUSH       R0
 
; Aufruf PROCEDURE (IORQ_ENDE)
        CALL       IORQ_ENDE
 
; Retten der Parameter-Register fuer PROCEDURE (LW_VORHANDEN)
        POP        R0
 
; PROCEDURE - Ende (LW_VORHANDEN)
        RET
 
; PROCEDURE - Anfang (AUSWERTEN_IORQ)
AUSWERTEN_IORQ:
 
; IF THEN - Ausdruck /; BitLow(WR_Z80_E)
        IN         R16, PIND
        BST        R16, 5
        BRTC       M_VERGL_01276
        CLR        R16
        RJMP       M_VERGL_01277
M_VERGL_01276:
        SER        R16
M_VERGL_01277:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_01273
        RJMP       M_IF_01274
M_IF_01273:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; Zuweisung Quelle - Ausdruck / Byte-REG PINC
        IN         R16, PINC
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (IO_WERT)
        MOV        R0, R16
 
; CASE OF - lokale, dynamische Variable VAR (IO_WERT)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (IORQ_CONOUT)
        CPI        R16, 0x01
        BREQ       M_CASE_01280
        RJMP       M_CASE_01279
M_CASE_01280:
 
; Retten der lokalen Parameter fuer PROCEDURE (AUSWERTEN_IORQ)
        PUSH       R0
 
; Aufruf PROCEDURE (CONOUT_TO_DEVICE)
        CALL       CONOUT_TO_DEVICE
 
; Retten der Parameter-Register fuer PROCEDURE (AUSWERTEN_IORQ)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01278
M_CASE_01279:
 
; CASE OF - vergleiche Einzel-Element (IORQ_CONIN)
        CPI        R16, 0x02
        BREQ       M_CASE_01282
        RJMP       M_CASE_01281
M_CASE_01282:
 
; Retten der lokalen Parameter fuer PROCEDURE (AUSWERTEN_IORQ)
        PUSH       R0
 
; Aufruf PROCEDURE (CONIN_TO_DEVICE)
        CALL       CONIN_TO_DEVICE
 
; Retten der Parameter-Register fuer PROCEDURE (AUSWERTEN_IORQ)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01278
M_CASE_01281:
 
; CASE OF - vergleiche Einzel-Element (IORQ_CONST)
        CPI        R16, 0x03
        BREQ       M_CASE_01284
        RJMP       M_CASE_01283
M_CASE_01284:
 
; Retten der lokalen Parameter fuer PROCEDURE (AUSWERTEN_IORQ)
        PUSH       R0
 
; Aufruf PROCEDURE (CONST_TO_DEVICE)
        CALL       CONST_TO_DEVICE
 
; Retten der Parameter-Register fuer PROCEDURE (AUSWERTEN_IORQ)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01278
M_CASE_01283:
 
; CASE OF - vergleiche Einzel-Element (IORQ_LIST)
        CPI        R16, 0x0A
        BREQ       M_CASE_01286
        RJMP       M_CASE_01285
M_CASE_01286:
 
; Retten der lokalen Parameter fuer PROCEDURE (AUSWERTEN_IORQ)
        PUSH       R0
 
; Aufruf PROCEDURE (LIST_TO_DEVICE)
        CALL       LIST_TO_DEVICE
 
; Retten der Parameter-Register fuer PROCEDURE (AUSWERTEN_IORQ)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01278
M_CASE_01285:
 
; CASE OF - vergleiche Einzel-Element (IORQ_SOUND)
        CPI        R16, 0x0B
        BREQ       M_CASE_01288
        RJMP       M_CASE_01287
M_CASE_01288:
 
; Retten der lokalen Parameter fuer PROCEDURE (AUSWERTEN_IORQ)
        PUSH       R0
 
; Aufruf PROCEDURE (SOUND_TO_DEVICE)
        CALL       SOUND_TO_DEVICE
 
; Retten der Parameter-Register fuer PROCEDURE (AUSWERTEN_IORQ)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01278
M_CASE_01287:
 
; CASE OF - vergleiche Einzel-Element (IORQ_RAM2ARR)
        CPI        R16, 0x05
        BREQ       M_CASE_01290
        RJMP       M_CASE_01289
M_CASE_01290:
 
; Retten der lokalen Parameter fuer PROCEDURE (AUSWERTEN_IORQ)
        PUSH       R0
 
; Aufruf PROCEDURE (START_RAM2ARR)
        CALL       START_RAM2ARR
 
; Retten der Parameter-Register fuer PROCEDURE (AUSWERTEN_IORQ)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01278
M_CASE_01289:
 
; CASE OF - vergleiche Einzel-Element (IORQ_ARR2RAM)
        CPI        R16, 0x06
        BREQ       M_CASE_01292
        RJMP       M_CASE_01291
M_CASE_01292:
 
; Retten der lokalen Parameter fuer PROCEDURE (AUSWERTEN_IORQ)
        PUSH       R0
 
; Aufruf PROCEDURE (START_ARR2RAM)
        CALL       START_ARR2RAM
 
; Retten der Parameter-Register fuer PROCEDURE (AUSWERTEN_IORQ)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01278
M_CASE_01291:
 
; CASE OF - vergleiche Einzel-Element (IORQ_BDOS2RAM)
        CPI        R16, 0x08
        BREQ       M_CASE_01294
        RJMP       M_CASE_01293
M_CASE_01294:
 
; Retten der lokalen Parameter fuer PROCEDURE (AUSWERTEN_IORQ)
        PUSH       R0
 
; Aufruf PROCEDURE (START_BDOS2RAM)
        CALL       START_BDOS2RAM
 
; Retten der Parameter-Register fuer PROCEDURE (AUSWERTEN_IORQ)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01278
M_CASE_01293:
 
; CASE OF - vergleiche Einzel-Element (IORQ_CCP2RAM)
        CPI        R16, 0x09
        BREQ       M_CASE_01296
        RJMP       M_CASE_01295
M_CASE_01296:
 
; Retten der lokalen Parameter fuer PROCEDURE (AUSWERTEN_IORQ)
        PUSH       R0
 
; Aufruf PROCEDURE (START_CCP2RAM)
        CALL       START_CCP2RAM
 
; Retten der Parameter-Register fuer PROCEDURE (AUSWERTEN_IORQ)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01278
M_CASE_01295:
 
; CASE OF - vergleiche Einzel-Element (IORQ_STD2UC)
        CPI        R16, 0x07
        BREQ       M_CASE_01298
        RJMP       M_CASE_01297
M_CASE_01298:
 
; Retten der lokalen Parameter fuer PROCEDURE (AUSWERTEN_IORQ)
        PUSH       R0
 
; Aufruf PROCEDURE (STD_AN_UC)
        CALL       STD_AN_UC
 
; Retten der Parameter-Register fuer PROCEDURE (AUSWERTEN_IORQ)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01278
M_CASE_01297:
 
; CASE OF - vergleiche Einzel-Element (IORQ_LW_OK)
        CPI        R16, 0x0F
        BREQ       M_CASE_01300
        RJMP       M_CASE_01299
M_CASE_01300:
 
; Retten der lokalen Parameter fuer PROCEDURE (AUSWERTEN_IORQ)
        PUSH       R0
 
; Aufruf PROCEDURE (LW_VORHANDEN)
        CALL       LW_VORHANDEN
 
; Retten der Parameter-Register fuer PROCEDURE (AUSWERTEN_IORQ)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01278
M_CASE_01299:
 
; CASE OF - vergleiche Einzel-Element (IORQ_LW_CONOUT)
        CPI        R16, 0x10
        BREQ       M_CASE_01302
        RJMP       M_CASE_01301
M_CASE_01302:
 
; Retten der lokalen Parameter fuer PROCEDURE (AUSWERTEN_IORQ)
        PUSH       R0
 
; Aufruf PROCEDURE (GERAETE_ANZEIGEN)
        CALL       GERAETE_ANZEIGEN
 
; Retten der Parameter-Register fuer PROCEDURE (AUSWERTEN_IORQ)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AUSWERTEN_IORQ)
        PUSH       R0
 
; Aufruf PROCEDURE (LAUFWERKE_VERTEILER_ANZEIGEN)
        CALL       LAUFWERKE_VERTEILER_ANZEIGEN
 
; Retten der Parameter-Register fuer PROCEDURE (AUSWERTEN_IORQ)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (AUSWERTEN_IORQ)
        PUSH       R0
 
; Aufruf PROCEDURE (IORQ_ENDE)
        CALL       IORQ_ENDE
 
; Retten der Parameter-Register fuer PROCEDURE (AUSWERTEN_IORQ)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01278
M_CASE_01301:
 
; CASE OF - vergleiche Einzel-Element (IORQ_RD_DISK2ARR)
        CPI        R16, 0x0C
        BREQ       M_CASE_01304
        RJMP       M_CASE_01303
M_CASE_01304:
 
; Retten der lokalen Parameter fuer PROCEDURE (AUSWERTEN_IORQ)
        PUSH       R0
 
; Aufruf PROCEDURE (LAUFWERKE_VERTEILER_READ)
        CALL       LAUFWERKE_VERTEILER_READ
 
; Retten der Parameter-Register fuer PROCEDURE (AUSWERTEN_IORQ)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01278
M_CASE_01303:
 
; CASE OF - vergleiche Einzel-Element (IORQ_WR_ARR2DISK)
        CPI        R16, 0x0E
        BREQ       M_CASE_01306
        RJMP       M_CASE_01305
M_CASE_01306:
 
; Retten der lokalen Parameter fuer PROCEDURE (AUSWERTEN_IORQ)
        PUSH       R0
 
; Aufruf PROCEDURE (LAUFWERKE_VERTEILER_WRITE)
        CALL       LAUFWERKE_VERTEILER_WRITE
 
; Retten der Parameter-Register fuer PROCEDURE (AUSWERTEN_IORQ)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_01278
 
; CASE OF ELSE
M_CASE_01305:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (SER0_STRING)=60
        LDI        R16, 60
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('x80')
        LDI        ZL, LOW(2*M_CONST_STRING_40)
        LDI        ZH, HIGH(2*M_CONST_STRING_40)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_01307
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_01307:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_01309
M_PRG_CONST_STRING_01308:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_01308
M_PRG_CONST_STRING_01309:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (SER0_STRING) - Laenge in R17
        LDI        ZL, LOW(SER0_STRING)
        LDI        ZH, HIGH(SER0_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_01311
        MOV        R16, R17
M_PRG_CONST_STRING_01310:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_01310
M_PRG_CONST_STRING_01311:
        ST         -Z, R17
 
; Retten der lokalen Parameter fuer PROCEDURE (AUSWERTEN_IORQ)
        PUSH       R0
 
; Aufruf PROCEDURE (WRITELN_SER0)
        CALL       WRITELN_SER0
 
; Retten der Parameter-Register fuer PROCEDURE (AUSWERTEN_IORQ)
        POP        R0
 
; ENDCASE;
M_CASE_01278:
 
; IF_THEN - Ende
M_IF_01274:
 
; PROCEDURE - Ende (AUSWERTEN_IORQ)
        RET
 
; PROCEDURE - Anfang (INITPORTS)
INITPORTS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xF0)
        LDI        R16, 0xF0
 
; Zuweisung Ziel /  VAR (DDRA)
        OUT        DDRA, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xF0)
        LDI        R16, 0xF0
 
; Zuweisung Ziel /  VAR (PORTA)
        OUT        PORTA, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xB0)
        LDI        R16, 0xB0
 
; Zuweisung Ziel /  VAR (DDRB)
        OUT        DDRB, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x90)
        LDI        R16, 0x90
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xC3)
        LDI        R16, 0xC3
 
; Zuweisung Ziel /  VAR (DDRD)
        OUT        DDRD, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x43)
        LDI        R16, 0x43
 
; Zuweisung Ziel /  VAR (PORTD)
        OUT        PORTD, R16
 
; PROCEDURE - Ende (INITPORTS)
        RET
 
; PROCEDURE - Anfang (LED_BLINKEN)
LED_BLINKEN:
 
; SetBit(LED_GE1_D)
        SBI        DDRD, 3
 
; SetBit(LED_GE2_D)
        SBI        DDRB, 4
 
; SetBit(LED_DS0_D)
        SBI        DDRA, 4
 
; SetBit(LED_DS1_D)
        SBI        DDRA, 5
 
; SetBit(LED_DS2_D)
        SBI        DDRA, 6
 
; LOOP - Start_Marke
M_LOOP_01312:
 
; SetBit(LED_GE1_A)
        SBI        PORTD, 3
 
; SetBit(LED_GE2_A)
        SBI        PORTB, 4
 
; SetBit(LED_DS0_A)
        SBI        PORTA, 4
 
; SetBit(LED_DS1_A)
        SBI        PORTA, 5
 
; SetBit(LED_DS2_A)
        SBI        PORTA, 6
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x012C)
        MOV        R0, R16
        LDI        R17, HIGH(0x012C)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; ClearBit(LED_GE1_A)
        CBI        PORTD, 3
 
; ClearBit(LED_GE2_A)
        CBI        PORTB, 4
 
; ClearBit(LED_DS0_A)
        CBI        PORTA, 4
 
; ClearBit(LED_DS1_A)
        CBI        PORTA, 5
 
; ClearBit(LED_DS2_A)
        CBI        PORTA, 6
 
; Word-Parameter(1) fuer PROCEDURE (WAIT_MS)
        LDI        R16, LOW(0x012C)
        MOV        R0, R16
        LDI        R17, HIGH(0x012C)
        MOV        R1, R17
 
; Aufruf PROCEDURE (WAIT_MS)
        CALL       WAIT_MS
 
; LOOP - Ende
        RJMP       M_LOOP_01312
 
; PROCEDURE - Ende (LED_BLINKEN)
        RET
 
; PROCEDURE - Anfang (SERIAL_DEVICE_VECTOR_AUSWERTEN)
SERIAL_DEVICE_VECTOR_AUSWERTEN:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (DEVICE_VECTOR_BYTE)
        LDS        R16, DEVICE_VECTOR_BYTE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x80)
        LDI        R18, 0x80
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R0
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_01316
        CLR        R16
        RJMP       M_VERGL_01317
M_VERGL_01316:
        SER        R16
M_VERGL_01317:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_01313
        RJMP       M_IF_01314
M_IF_01313:
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (CONOUT_DEVICE_NR1)
        LDS        R16, CONOUT_DEVICE_NR1
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (NO_DEVICE)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_01321
        CLR        R16
        RJMP       M_VERGL_01322
M_VERGL_01321:
        SER        R16
M_VERGL_01322:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_01318
        RJMP       M_IF_01319
M_IF_01318:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEVICE_SERIAL)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (CONOUT_DEVICE_NR1)
        STS        CONOUT_DEVICE_NR1, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_01320
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_01319:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEVICE_SERIAL)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (CONOUT_DEVICE_NR2)
        STS        CONOUT_DEVICE_NR2, R16
 
; IF_THEN_ELSE - Ende
M_IF_01320:
 
; IF_THEN - Ende
M_IF_01314:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (DEVICE_VECTOR_BYTE)
        LDS        R16, DEVICE_VECTOR_BYTE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x40)
        LDI        R18, 0x40
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R0
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_01326
        CLR        R16
        RJMP       M_VERGL_01327
M_VERGL_01326:
        SER        R16
M_VERGL_01327:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_01323
        RJMP       M_IF_01324
M_IF_01323:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEVICE_SERIAL)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (CONIN_DEVICE)
        STS        CONIN_DEVICE, R16
 
; IF_THEN - Ende
M_IF_01324:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (DEVICE_VECTOR_BYTE)
        LDS        R16, DEVICE_VECTOR_BYTE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x20)
        LDI        R18, 0x20
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R0
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_01331
        CLR        R16
        RJMP       M_VERGL_01332
M_VERGL_01331:
        SER        R16
M_VERGL_01332:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_01328
        RJMP       M_IF_01329
M_IF_01328:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEVICE_SERIAL)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (LIST_DEVICE)
        STS        LIST_DEVICE, R16
 
; IF_THEN - Ende
M_IF_01329:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (DEVICE_VECTOR_BYTE)
        LDS        R16, DEVICE_VECTOR_BYTE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x10)
        LDI        R18, 0x10
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R0
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_01336
        CLR        R16
        RJMP       M_VERGL_01337
M_VERGL_01336:
        SER        R16
M_VERGL_01337:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_01333
        RJMP       M_IF_01334
M_IF_01333:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEVICE_SERIAL)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (SOUND_DEVICE)
        STS        SOUND_DEVICE, R16
 
; IF_THEN - Ende
M_IF_01334:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (DEVICE_VECTOR_BYTE)
        LDS        R16, DEVICE_VECTOR_BYTE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x08)
        LDI        R18, 0x08
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R0
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_01341
        CLR        R16
        RJMP       M_VERGL_01342
M_VERGL_01341:
        SER        R16
M_VERGL_01342:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_01338
        RJMP       M_IF_01339
M_IF_01338:
 
; Retten der lokalen Parameter fuer PROCEDURE (SERIAL_DEVICE_VECTOR_AUSWERTEN)
        PUSH       R0
 
; Aufruf PROCEDURE (LAUFWERKE_VERTEILER_NACH_OBEN_KOPIEREN)
        CALL       LAUFWERKE_VERTEILER_NACH_OBEN_KOPIEREN
 
; Retten der Parameter-Register fuer PROCEDURE (SERIAL_DEVICE_VECTOR_AUSWERTEN)
        POP        R0
 
; VAR ARRAY-1D POSITION - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; VAR ARRAY Ziel Zeiger berechnen (LAUFWERKE_VERTEILER)
        LDI        ZL, LOW(LAUFWERKE_VERTEILER)
        LDI        ZH, HIGH(LAUFWERKE_VERTEILER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEVICE_SERIAL)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR ARRAY-1D (LAUFWERKE_VERTEILER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (SERIAL_DEVICE_VECTOR_AUSWERTEN)
        PUSH       R0
 
; Aufruf PROCEDURE (LAUFWERKE_VERTEILER_NACH_UNTEN_KOPIEREN)
        CALL       LAUFWERKE_VERTEILER_NACH_UNTEN_KOPIEREN
 
; Retten der Parameter-Register fuer PROCEDURE (SERIAL_DEVICE_VECTOR_AUSWERTEN)
        POP        R0
 
; IF_THEN - Ende
M_IF_01339:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Byte-VAR (DEVICE_VECTOR_BYTE)
        LDS        R16, DEVICE_VECTOR_BYTE
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x04)
        LDI        R18, 0x04
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R0, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R0
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator >
        CP         R18, R16
        BRCS       M_VERGL_01346
        CLR        R16
        RJMP       M_VERGL_01347
M_VERGL_01346:
        SER        R16
M_VERGL_01347:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_01343
        RJMP       M_IF_01344
M_IF_01343:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEVICE_SERIAL)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (READER_DEVICE)
        STS        READER_DEVICE, R16
 
; IF_THEN - Ende
M_IF_01344:
 
; PROCEDURE - Ende (SERIAL_DEVICE_VECTOR_AUSWERTEN)
        RET
 
; Start des Hauptprogramms
RESET:
 
; Initialisieren des Stacks
        LDI        R16, LOW(RAMEND)
        OUT        SPL, R16
        LDI        R16, HIGH(RAMEND)
        OUT        SPH, R16
 
; Aufruf PROCEDURE (INITPORTS)
        CALL       INITPORTS
 
; Aufruf PROCEDURE (INIT_I2C)
        CALL       INIT_I2C
 
; Aufruf PROCEDURE (INIT_SPI)
        CALL       INIT_SPI
 
; Aufruf Funktion (TEST_I2C_VORHANDEN)
        CALL       TEST_I2C_VORHANDEN
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_01348
        RJMP       M_IF_01349
M_IF_01348:
 
; Aufruf PROCEDURE (INIT_FLASH_MANAGER)
        CALL       INIT_FLASH_MANAGER
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (I2C_VORHANDEN)
        STS        I2C_VORHANDEN, R16
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_01350
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_01349:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (I2C_VORHANDEN)
        STS        I2C_VORHANDEN, R16
 
; IF_THEN_ELSE - Ende
M_IF_01350:
 
; Aufruf PROCEDURE (INIT_ITP3)
        CALL       INIT_ITP3
 
; Aufruf PROCEDURE (INIT_LAUFWERKE_VERTEILER)
        CALL       INIT_LAUFWERKE_VERTEILER
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (CONSOLEIN)
        STS        CONSOLEIN, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (CONSOLEOUT)
        STS        CONSOLEOUT, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (SOUNDOUT)
        STS        SOUNDOUT, R16
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (STEUER_STRING)=50
        LDI        R16, 50
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('')
        LDI        ZL, LOW(2*M_CONST_STRING_41)
        LDI        ZH, HIGH(2*M_CONST_STRING_41)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_01351
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_01351:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_01353
M_PRG_CONST_STRING_01352:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_01352
M_PRG_CONST_STRING_01353:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (STEUER_STRING) - Laenge in R17
        LDI        ZL, LOW(STEUER_STRING)
        LDI        ZH, HIGH(STEUER_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_01355
        MOV        R16, R17
M_PRG_CONST_STRING_01354:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_01354
M_PRG_CONST_STRING_01355:
        ST         -Z, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (CONSOLEIN_GELESEN)
        STS        CONSOLEIN_GELESEN, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DISKNO)
        STS        DISKNO, R16
 
; Aufruf PROCEDURE (Z80_RESET_UND_URLOAD)
        CALL       Z80_RESET_UND_URLOAD
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (ITP3_DS34_NICHT_GENUTZT)
        STS        ITP3_DS34_NICHT_GENUTZT, R16
 
; Aufruf PROCEDURE (ITP3_PRUEFE_ANSCHLUESSE)
        CALL       ITP3_PRUEFE_ANSCHLUESSE
 
; IF THEN - Ausdruck / Byte-VAR (ITP3_DS34_NICHT_GENUTZT)
        LDS        R16, ITP3_DS34_NICHT_GENUTZT
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_01356
        RJMP       M_IF_01357
M_IF_01356:
 
; ClearBit(SERIAL_RXD_D)
        CBI        DDRD, 0
 
; SetBit(SERIAL_TXD_D)
        SBI        DDRD, 1
 
; Aufruf PROCEDURE (INIT_SER0_PORT)
        CALL       INIT_SER0_PORT
 
; Aufruf PROCEDURE (ABFRAGE_SERIAL_DEVICE_CONNECTED)
        CALL       ABFRAGE_SERIAL_DEVICE_CONNECTED
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_01358
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_01357:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (SERIAL_DEVICE_CONNECTED)
        STS        SERIAL_DEVICE_CONNECTED, R16
 
; IF_THEN_ELSE - Ende
M_IF_01358:
 
; IF THEN - Ausdruck / Byte-VAR (SERIAL_DEVICE_CONNECTED)
        LDS        R16, SERIAL_DEVICE_CONNECTED
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_01359
        RJMP       M_IF_01360
M_IF_01359:
 
; Aufruf PROCEDURE (DEVICE_VECTOR_VON_UART_LESEN)
        CALL       DEVICE_VECTOR_VON_UART_LESEN
 
; Aufruf PROCEDURE (SERIAL_DEVICE_VECTOR_AUSWERTEN)
        CALL       SERIAL_DEVICE_VECTOR_AUSWERTEN
 
; IF_THEN - Ende
M_IF_01360:
 
; IF THEN - Ausdruck / Byte-VAR (I2C_VORHANDEN)
        LDS        R16, I2C_VORHANDEN
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_01362
        RJMP       M_IF_01363
M_IF_01362:
 
; Aufruf PROCEDURE (LAUFWERKE_VERTEILER_NACH_OBEN_KOPIEREN)
        CALL       LAUFWERKE_VERTEILER_NACH_OBEN_KOPIEREN
 
; VAR ARRAY-1D POSITION - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; VAR ARRAY Ziel Zeiger berechnen (LAUFWERKE_VERTEILER)
        LDI        ZL, LOW(LAUFWERKE_VERTEILER)
        LDI        ZH, HIGH(LAUFWERKE_VERTEILER)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (DEVICE_LOKAL_FLASH)
        LDI        R16, 0x07
 
; Zuweisung Ziel /  VAR ARRAY-1D (LAUFWERKE_VERTEILER)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; Aufruf PROCEDURE (LAUFWERKE_VERTEILER_NACH_UNTEN_KOPIEREN)
        CALL       LAUFWERKE_VERTEILER_NACH_UNTEN_KOPIEREN
 
; IF_THEN - Ende
M_IF_01363:
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (CONOUT_DEVICE_NR1)
        LDS        R16, CONOUT_DEVICE_NR1
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (NO_DEVICE)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_01368
        CLR        R16
        RJMP       M_VERGL_01369
M_VERGL_01368:
        SER        R16
M_VERGL_01369:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_01365
        RJMP       M_IF_01366
M_IF_01365:
 
; Aufruf PROCEDURE (LED_BLINKEN)
        CALL       LED_BLINKEN
 
; IF_THEN - Ende
M_IF_01366:
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (CONIN_DEVICE)
        LDS        R16, CONIN_DEVICE
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (NO_DEVICE)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_01373
        CLR        R16
        RJMP       M_VERGL_01374
M_VERGL_01373:
        SER        R16
M_VERGL_01374:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_01370
        RJMP       M_IF_01371
M_IF_01370:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (ANZEIGE_STRING)=80
        LDI        R16, 80
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack (' ')
        LDI        ZL, LOW(2*M_CONST_STRING_42)
        LDI        ZH, HIGH(2*M_CONST_STRING_42)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_01375
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_01375:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_01377
M_PRG_CONST_STRING_01376:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_01376
M_PRG_CONST_STRING_01377:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ANZEIGE_STRING) - Laenge in R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_01379
        MOV        R16, R17
M_PRG_CONST_STRING_01378:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_01378
M_PRG_CONST_STRING_01379:
        ST         -Z, R17
 
; Aufruf PROCEDURE (ANZEIGE_STRING_AN_CONOUT)
        CALL       ANZEIGE_STRING_AN_CONOUT
 
; Aufruf PROCEDURE (ANZEIGE_STRING_AN_CONOUT)
        CALL       ANZEIGE_STRING_AN_CONOUT
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (ANZEIGE_STRING)=80
        LDI        R16, 80
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('*** Fehler: keine Tastatur angeschlossen!!! ***')
        LDI        ZL, LOW(2*M_CONST_STRING_43)
        LDI        ZH, HIGH(2*M_CONST_STRING_43)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_01380
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_01380:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_01382
M_PRG_CONST_STRING_01381:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_01381
M_PRG_CONST_STRING_01382:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ANZEIGE_STRING) - Laenge in R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_01384
        MOV        R16, R17
M_PRG_CONST_STRING_01383:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_01383
M_PRG_CONST_STRING_01384:
        ST         -Z, R17
 
; Aufruf PROCEDURE (ANZEIGE_STRING_AN_CONOUT)
        CALL       ANZEIGE_STRING_AN_CONOUT
 
; Aufruf PROCEDURE (LED_BLINKEN)
        CALL       LED_BLINKEN
 
; IF_THEN - Ende
M_IF_01371:
 
; ARRAY - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (LAUFWERKE_VERTEILER)
        LDI        ZL, LOW(LAUFWERKE_VERTEILER)
        LDI        ZH, HIGH(LAUFWERKE_VERTEILER)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  VAR (LAUFWERKE_VERTEILER_BYTE)
        STS        LAUFWERKE_VERTEILER_BYTE, R16
 
; IF THEN - Ausdruck erster Faktor / Byte-VAR (LAUFWERKE_VERTEILER_BYTE)
        LDS        R16, LAUFWERKE_VERTEILER_BYTE
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (NO_DEVICE)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_01388
        CLR        R16
        RJMP       M_VERGL_01389
M_VERGL_01388:
        SER        R16
M_VERGL_01389:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_01385
        RJMP       M_IF_01386
M_IF_01385:
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (ANZEIGE_STRING)=80
        LDI        R16, 80
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack (' ')
        LDI        ZL, LOW(2*M_CONST_STRING_44)
        LDI        ZH, HIGH(2*M_CONST_STRING_44)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_01390
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_01390:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_01392
M_PRG_CONST_STRING_01391:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_01391
M_PRG_CONST_STRING_01392:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ANZEIGE_STRING) - Laenge in R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_01394
        MOV        R16, R17
M_PRG_CONST_STRING_01393:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_01393
M_PRG_CONST_STRING_01394:
        ST         -Z, R17
 
; Aufruf PROCEDURE (ANZEIGE_STRING_AN_CONOUT)
        CALL       ANZEIGE_STRING_AN_CONOUT
 
; Aufruf PROCEDURE (ANZEIGE_STRING_AN_CONOUT)
        CALL       ANZEIGE_STRING_AN_CONOUT
 
; Zuweisung Quelle - Ausdruck Laenge Ziel-STRING (ANZEIGE_STRING)=80
        LDI        R16, 80
        CLR        R17
 
; Zuweisung Quelle - Ausdruck / Kopieren der String-Konstante in den Stack ('*** Fehler: kein Laufwerk angeschlossen!!! ***')
        LDI        ZL, LOW(2*M_CONST_STRING_45)
        LDI        ZH, HIGH(2*M_CONST_STRING_45)
        MOV        R20, R16    ; maximale Laenge
        SUB        R20, R17    ; noch maximal zu kopierende Laenge
        LPM        R18, Z+     ; R18 = Laenge der zu kopierenden STRING-Konstante
        CP         R20, R18    ; Restlaenge < Lange der STRING
        BRCC       M_PRG_CONST_STRING_01395
        MOV        R18, R20    ; ... wenn ja, wird die Restlaenge geladen
M_PRG_CONST_STRING_01395:
        CPI        R18, 0
        BREQ       M_PRG_CONST_STRING_01397
M_PRG_CONST_STRING_01396:
        LPM        R19, Z+      ; Einlesen des Zeichen in R19
        PUSH       R19
        INC        R17
        DEC        R18
        CPI        R18, 0
        BRNE       M_PRG_CONST_STRING_01396
M_PRG_CONST_STRING_01397:
 
; Zuweisung Ziel / Kopieren des Stacks in die Ziel-String (ANZEIGE_STRING) - Laenge in R17
        LDI        ZL, LOW(ANZEIGE_STRING)
        LDI        ZH, HIGH(ANZEIGE_STRING)
        CLR        R21
        MOV        R20, R17
        INC        R20
        ADD        ZL, R20      ; Z:=Z+R17+1
        ADC        ZH, R21
        CPI        R17, 0
        BREQ       M_PRG_CONST_STRING_01399
        MOV        R16, R17
M_PRG_CONST_STRING_01398:
        POP        R19
        ST         -Z, R19
        DEC        R16
        CPI        R16, 0 
        BRNE       M_PRG_CONST_STRING_01398
M_PRG_CONST_STRING_01399:
        ST         -Z, R17
 
; Aufruf PROCEDURE (ANZEIGE_STRING_AN_CONOUT)
        CALL       ANZEIGE_STRING_AN_CONOUT
 
; Aufruf PROCEDURE (LED_BLINKEN)
        CALL       LED_BLINKEN
 
; IF_THEN - Ende
M_IF_01386:
 
; LOOP - Start_Marke
M_LOOP_01400:
 
; ClearBit(CLK_Z80)
        CBI        PORTD, 7
 
; ASM
SBIS     PinB, 1
CALL     AUSWERTEN_IORQ
 
 
; SetBit(CLK_Z80)
        SBI        PORTD, 7
 
; LOOP - Ende
        RJMP       M_LOOP_01400
 
; *** Unterprogramm Bibliothek ***
; Multiplikation von 2 16-Bit Zahlen (WORD)
; Quelle: Mikrocomputertechnik mit Controllern der Atmel AVR-RISC-Familie
;         Guenter Schmitt, ISBN 978-3-486-58988-7
; Version 1.0, Stand 11.01.2013
;
; Uebergabe: R16:R17 erster Faktor
;            R18:R19 zweiter Faktor
; Temporaere Register: R20,R21,R22,R23,R24 
;                      R2 ,R3  R4  R5  R6
ASM_UP_MUL16:
 
        PUSH       R0
        PUSH       R1

        CLR        R24
        MUL        R19, R17
        MOVW       R23:R22, R1:R0
        MUL        R18, R16
        MOVW       R21:R20, R1:R0
        MUL        R19, R16
        ADD        R21, R0
        ADC        R22, R1
        ADC        R23, R24
        MUL        R17, R18
        ADD        R21, R0
        ADC        R22, R1
        ADC        R23, R24
        MOVW       R17:R16, R21:R20       ; Produkt Low
        MOVW       R19:R18, R23:R22       ; Produkt High

        POP        R1
        POP        R0		

        RET






; Multiplikation von 2 32-Bit Zahlen (DWORD)
; Quelle: Mikrocomputertechnik mit Controllern der Atmel AVR-RISC-Familie
;         Guenter Schmitt, ISBN 978-3-486-58988-7
; Version 1.0, Stand 11.01.2013
;
; Uebergabe: R16:R17:18:19 erster Faktor
;            R20:R21:22:23 zweiter Faktor
; Temporaere Register: R24,R25,R26,R27,R28
;                      R20,R21,R22,R23,R24
ASM_UP_MUL32:

        PUSH       R0
        PUSH       R1

        CLR        R28
        MUL        R21, R17
        MOVW       R27:R26, R1:R0
        MUL        R20, R16
        MOVW       R25:R24, R1:R0
        MUL        R21, R16
        ADD        R25, R0
        ADC        R26, R1
        ADC        R27, R28
        MUL        R17, R20
        ADD        R25, R0
        ADC        R26, R1
        ADC        R27, R28
        MOVW       R17:R16, R25:R24       ; Produkt Low
        MOVW       R19:R18, R27:R26       ; Produkt High

        POP        R1
        POP        R0		

        RET






 
; *** Namen-Liste ***
;
; SREG (V) BYTECONREG
; SPH (V) BYTECONREG
; SPL (V) BYTECONREG
; OCR0 (V) BYTECONREG
; OCR2 (V) BYTECONREG
; GICR (V) BYTECONREG
; GIFR (V) BYTECONREG
; TIMSK (V) BYTECONREG
; TIFR (V) BYTECONREG
; SPMCR (V) BYTECONREG
; TWCR (V) BYTECONREG
; MCUCR (V) BYTECONREG
; MCUCSR (V) BYTECONREG
; TCCR0 (V) BYTECONREG
; TCNT0 (V) BYTECONREG
; OSCCAL (V) BYTECONREG
; SFIOR (V) BYTECONREG
; OCDR (V) BYTECONREG
; TCCR1A (V) BYTECONREG
; TCCR1B (V) BYTECONREG
; TCNT1H (V) BYTECONREG
; TCNT1L (V) BYTECONREG
; OCR1AH (V) BYTECONREG
; OCR1AL (V) BYTECONREG
; OCR1BH (V) BYTECONREG
; OCR1BL (V) BYTECONREG
; ICR1H (V) BYTECONREG
; ICR1L (V) BYTECONREG
; TCCR2 (V) BYTECONREG
; TCNT2 (V) BYTECONREG
; ASSR (V) BYTECONREG
; WDTCR (V) BYTECONREG
; UBRRH (V) BYTECONREG
; UBRRL (V) BYTECONREG
; UCSRC (V) BYTECONREG
; UDR (V) BYTECONREG
; EEARH (V) BYTECONREG
; EEARL (V) BYTECONREG
; EEDR (V) BYTECONREG
; EECR (V) BYTECONREG
; SPDR (V) BYTECONREG
; SPSR (V) BYTECONREG
; SPCR (V) BYTECONREG
; UCSRA (V) BYTECONREG
; UCSRB (V) BYTECONREG
; ACSR (V) BYTECONREG
; ADMUX (V) BYTECONREG
; ADCSRA (V) BYTECONREG
; ADCH (V) BYTECONREG
; ADCL (V) BYTECONREG
; TWDR (V) BYTECONREG
; TWAR (V) BYTECONREG
; TWSR (V) BYTECONREG
; TWBR (V) BYTECONREG
; PORTA (V) BYTECONREG
; DDRA (V) BYTECONREG
; PINA (V) BYTECONREG
; PORTB (V) BYTECONREG
; DDRB (V) BYTECONREG
; PINB (V) BYTECONREG
; PORTC (V) BYTECONREG
; DDRC (V) BYTECONREG
; PINC (V) BYTECONREG
; PORTD (V) BYTECONREG
; DDRD (V) BYTECONREG
; PIND (V) BYTECONREG
; UBRR0 (V) WORDCONVAR
; RXC (B) BIT
; TXC (B) BIT
; UDRE (B) BIT
; TAKTFREQUENZ (C) WORD Wert=0x399A
; UBRR_VAL (C) BYTE Wert=0x0F
; IORQ_CONOUT (C) BYTE Wert=0x01
; IORQ_CONIN (C) BYTE Wert=0x02
; IORQ_CONST (C) BYTE Wert=0x03
; IORQ_START_PROG (C) BYTE Wert=0x04
; IORQ_RAM2ARR (C) BYTE Wert=0x05
; IORQ_ARR2RAM (C) BYTE Wert=0x06
; IORQ_STD2UC (C) BYTE Wert=0x07
; IORQ_BDOS2RAM (C) BYTE Wert=0x08
; IORQ_CCP2RAM (C) BYTE Wert=0x09
; IORQ_LIST (C) BYTE Wert=0x0A
; IORQ_SOUND (C) BYTE Wert=0x0B
; IORQ_RD_DISK2ARR (C) BYTE Wert=0x0C
; IORQ_WR_ARR2DISK (C) BYTE Wert=0x0E
; IORQ_LW_OK (C) BYTE Wert=0x0F
; IORQ_LW_CONOUT (C) BYTE Wert=0x10
; NO_DEVICE (C) BYTE Wert=0x00
; DEVICE_SERIAL (C) BYTE Wert=0x01
; DEVICE_ITP3_DS0 (C) BYTE Wert=0x02
; DEVICE_ITP3_DS1 (C) BYTE Wert=0x03
; DEVICE_ITP3_DS2 (C) BYTE Wert=0x04
; DEVICE_ITP3_DS3 (C) BYTE Wert=0x05
; DEVICE_ITP3_DS4 (C) BYTE Wert=0x06
; DEVICE_LOKAL_FLASH (C) BYTE Wert=0x07
; NUL (C) BYTE Wert=0x00
; XON (C) BYTE Wert=0x11
; XOFF (C) BYTE Wert=0x13
; CR (C) BYTE Wert=0x0D
; LF (C) BYTE Wert=0x0A
; UART_WHO_AM_I (C) BYTE Wert=0x01
; UART_ERROR_CODE (C) BYTE Wert=0x02
; UART_CONOUT (C) BYTE Wert=0x03
; UART_CONST (C) BYTE Wert=0x04
; UART_CONIN (C) BYTE Wert=0x05
; UART_READ (C) BYTE Wert=0x06
; UART_WRITE (C) BYTE Wert=0x07
; UART_STD (C) BYTE Wert=0x08
; IORQ_Z80_E (B) BIT
; OE_RAM_A (B) BIT
; OE_RAM_D (B) BIT
; WE_RAM_A (B) BIT
; WE_RAM_D (B) BIT
; G_RAMSW (B) BIT
; LED_GE1_D (B) BIT
; LED_GE2_D (B) BIT
; LED_GE1_A (B) BIT
; LED_GE2_A (B) BIT
; LED_DS0_D (B) BIT
; LED_DS1_D (B) BIT
; LED_DS2_D (B) BIT
; LED_DS0_A (B) BIT
; LED_DS1_A (B) BIT
; LED_DS2_A (B) BIT
; RD_Z80_E (B) BIT
; WR_Z80_E (B) BIT
; RESET_Z80 (B) BIT
; CLK_Z80 (B) BIT
; SERIAL_RXD_D (B) BIT
; SERIAL_TXD_D (B) BIT
; ARRAY_POS (V) WORD
; CONSOLEIN (V) BYTE
; CONSOLEOUT (V) BYTE
; SOUNDOUT (V) BYTE
; CONSOLEIN_GELESEN (V) BOOLEAN
; DEVICE_VECTOR_GELESEN (V) BOOLEAN
; STEUER_STRING (V) STRING
; ANZEIGE_STRING (V) STRING
; SEKTOR_PUFFER (Y) BYTE
; SEKTOR_PUFFER_ZEIGER (V) WORD
; SEKTOR_PUFFER_GEAENDERT (V) BOOLEAN
; SECTOR (V) BYTE
; TRACK_L (V) BYTE
; TRACK_H (V) BYTE
; DISKNO (V) BYTE
; LAUFWERKE_VERTEILER (Y) BYTE
; SERIAL_DEVICE_CONNECTED (V) BOOLEAN
; ITP3_DS34_NICHT_GENUTZT (V) BOOLEAN
; I2C_VORHANDEN (V) BOOLEAN
; STD_SEKTOR_NR (V) WORD
; STD_SPUR_NR (V) WORD
; DEVICE_VECTOR_BYTE (V) BYTE
; LAUFWERKE_VERTEILER_BYTE (V) BYTE
; LAENGE_MEIC_ARRAY (C) WORD Wert=0x0328
; MEIC_ARR (A) 
; LAENGE_BDOS_ARRAY (C) WORD Wert=0x0DFF
; BDOS_ARR (A) 
; LAENGE_CCP_ARRAY (C) WORD Wert=0x07FF
; CCP_ARR (A) 
; WAITKON (C) WORD Wert=0x000E
; WAITKON2 (C) WORD Wert=0x0276
; BYTE_HEX_STRING (V) STRING
; BYTE_DEZ_STRING (V) STRING
; WORD_HEX_STRING (V) STRING
; DWORD_HEX_STRING (V) STRING
; BYTEPOSTOORMASKE (F) 
; BYTEPOSTOANDMASKE (F) 
; READ_BIT_IN_BYTE (F) 
; SET_BIT_IN_BYTE (F) 
; CLEAR_BIT_IN_BYTE (F) 
; NEGATION_BYTE (F) 
; WAIT_MS (P) 
; BYTETOHEXSTRING (P) 
; BYTETODEZSTRING (P) 
; HEXSTRINGTOBYTE (F) 
; WORDTOHEXSTRING (P) 
; HEXSTRINGTOWORD (F) 
; DWORDTOHEXSTRING (P) 
; SER0_ZEICHEN (V) BYTE
; SER0_STRING (V) STRING
; INIT_SER0_PORT (P) 
; RX0_PUFFER_ABFRAGEN (P) 
; SENDE_ZEICHEN0 (P) 
; ABFRAGE_SERIAL_DEVICE_CONNECTED (P) 
; WRITE_SER0 (P) 
; WRITELN_SER0 (P) 
; STD_AN_UART_SENDEN (P) 
; STEUER_STRING_TO_SECTOR (P) 
; STEUER_STRING_TO_SECTOR_KOMP (P) 
; STEUER_STRING_AUSWERTEN (P) 
; STEUER_STRING_LESEN (P) 
; SEKTOR_VON_UART_LESEN (P) 
; SEKTOR_VON_UART_LESEN_KOMP (P) 
; SEKTOR_AN_UART_SENDEN (P) 
; DEVICE_VECTOR_VON_UART_LESEN (P) 
; CONST_VON_UART_LESEN (P) 
; CONIN_VON_UART_LESEN (P) 
; UART_CONIN_SCHLEIFE (P) 
; UART_CONOUT_SENDEN (P) 
; EEPROM_CS_A (B) BIT
; EEPROM_MISO_E (B) BIT
; EEPROM_MOSI_A (B) BIT
; EEPROM_SCK_A (B) BIT
; EEPROM_CS_D (B) BIT
; EEPROM_MISO_D (B) BIT
; EEPROM_MOSI_D (B) BIT
; EEPROM_SCK_D (B) BIT
; ONE_BYTE (V) BYTE
; SPI_BYTE (V) BYTE
; ADR_BYTE_2 (V) BYTE
; ADR_BYTE_1 (V) BYTE
; ADR_BYTE_0 (V) BYTE
; LFD_NUMMER (V) BYTE
; INIT_SPI (P) 
; SPI_WRITE_BYTE (P) 
; SPI_READ_BYTE (P) 
; W25Q64_READ_ONE_BYTE (P) 
; W25Q64_READ_ONE_SECTOR (P) 
; W25Q64_WRITE_ONE_SECTOR (P) 
; FLASH_SECTOR_ERASE (P) 
; FLASH_CHIP_ERASE (P) 
; ADR_AT24C512 (C) BYTE Wert=0x50
; SCL_I2C_A (B) BIT
; SCL_I2C_E (B) BIT
; SCL_I2C_D (B) BIT
; SDA_I2C_A (B) BIT
; SDA_I2C_E (B) BIT
; SDA_I2C_D (B) BIT
; FLASH_ADDRESS (V) WORD
; SDA_SET (P) 
; SCL_SET (P) 
; SDA_CLEAR (P) 
; SCL_CLEAR (P) 
; SDA_OUT (P) 
; SDA_IN (P) 
; SCL_OUT (P) 
; SDA_READ (F) 
; INIT_I2C (P) 
; DS_SHIFT_IN_NACK (F) 
; DS_SHIFT_IN_ACK (F) 
; DS_SHIFT_OUT (F) 
; I2C_DEVICE_ADDRESS_TO_WRITE (F) 
; I2C_DEVICE_ADDRESS_TO_READ (F) 
; AT_DATA_WRITE_WORD_ADDRESS (P) 
; AT_DATA_READ_ONE_BYTE (F) 
; AT_READ_DATA_ARRAY (P) 
; AT_DATA_WRITE_ONE_BYTE_WAIT (P) 
; AT_DATA_WRITE_ONE_BYTE_NO_WAIT (P) 
; AT_WRITE_DATA_ARRAY_WAIT (P) 
; FORMAT_DIR (P) 
; CODE_01 (C) BYTE Wert=0x08
; CODE_02 (C) BYTE Wert=0x12
; CODE_03 (C) BYTE Wert=0xAA
; CODE_04 (C) BYTE Wert=0x55
; ADR_TBL1_TYP_ZIEL_ZEIGER (C) WORD Wert=0xE000
; ADR_TBL2_ZEIGER_4K_SPUR_NR (C) WORD Wert=0xE800
; ADR_TBL3_4K_SPI_TMP_SPUR_NR (C) WORD Wert=0xF800
; ADR_AELTESTER_4K_SPEICHER_IM_I2C (C) WORD Wert=0xFFFD
; ADR_TEST_BYTE (C) WORD Wert=0xFFFD
; ADR_INIT_KENNUNG_01 (C) WORD Wert=0xFFFE
; ADR_INIT_KENNUNG_02 (C) WORD Wert=0xFFFF
; TZZ_AT24C512_DIR (C) BYTE Wert=0x01
; TZZ_AT24C512_READ_WRITE (C) BYTE Wert=0x02
; TZZ_W25Q64_READ (C) BYTE Wert=0x03
; FM_TEMP_TBL1_TYP_ZIEL_ZEIGER (V) BYTE
; SEKTOR_PUFFER_WR (Y) BYTE
; INIT_TBL1_TYP_ZIEL_ZEIGER (P) 
; INIT_TBL2_ZEIGER_4K_SPUR_NR (P) 
; INIT_TBL3_4K_SPI_TMP_SPUR_NR (P) 
; TEST_I2C_VORHANDEN (F) 
; INIT_LOESCHEN_UND_FORMATIEREN (P) 
; INIT_FLASH_MANAGER (P) 
; FM_READ_TBL1_TYP_ZIEL_ZEIGER (P) 
; FM_WRITE_TBL1_TYP_ZIEL_ZEIGER (P) 
; FM_READ_TBL2_4K_SPUR_NR (F) 
; FM_WRITE_TBL2_4K_SPUR_NR (P) 
; FM_4K_SPUR_UND_SEKTOR_IN_FLASH_ZEIGER (F) 
; FM_READ_AELTESTER_4K_SPEICHER_IM_I2C (F) 
; FM_WRITE_AELTESTER_4K_SPEICHER_IM_I2C (P) 
; FM_READ_SPUR_NR_AUS_AELTESTER_4K_SPEICHER_IM_I2C (F) 
; FM_SPI_ZIELADRESSE_AUS_AELTESTER_4K_SPEICHER (F) 
; FM_FLASH_ADDRESS_I2C_QUELLADRESSE_AUS_AELTESTER_4K_SPEICHER (P) 
; FM_READ_DATA_ARRAY (P) 
; FM_ZURUECKSCHREIBEN_4K_SEKTOR (P) 
; FM_VERSCHIEBEN_4K_SEKTOR (P) 
; FM_PRUEFE_VERSCHIEBEN_SPUR_NOTWENDIG (P) 
; FM_WRITE_DATA_ARRAY (P) 
; STD_AN_LOKALEN_FLASH_MANAGER_SENDEN (P) 
; LOKALEN_FLASH_MANAGER_SEKTOR_LESEN (P) 
; LOKALEN_FLASH_MANAGER_SEKTOR_SCHREIBEN (P) 
; ITP3_D0_A (B) BIT
; ITP3_D1_A (B) BIT
; ITP3_D2_A (B) BIT
; ITP3_D3_A (B) BIT
; ITP3_D0_D (B) BIT
; ITP3_D1_D (B) BIT
; ITP3_D2_D (B) BIT
; ITP3_D3_D (B) BIT
; ITP3_DR_D (B) BIT
; ITP3_D0_E (B) BIT
; ITP3_D1_E (B) BIT
; ITP3_D2_E (B) BIT
; ITP3_D3_E (B) BIT
; ITP3_DR_E (B) BIT
; ITP3_DS0_A (B) BIT
; ITP3_DS0_D (B) BIT
; ITP3_DS0_E (B) BIT
; ITP3_DS1_A (B) BIT
; ITP3_DS1_D (B) BIT
; ITP3_DS1_E (B) BIT
; ITP3_DS2_A (B) BIT
; ITP3_DS2_D (B) BIT
; ITP3_DS2_E (B) BIT
; ITP3_DS3_A (B) BIT
; ITP3_DS3_D (B) BIT
; ITP3_DS3_E (B) BIT
; ITP3_DS4_A (B) BIT
; ITP3_DS4_D (B) BIT
; ITP3_DS4_E (B) BIT
; ITP3_WHO_ARE_YOU (C) BYTE Wert=0x01
; ITP3_ERROR_CODE (C) BYTE Wert=0x02
; ITP3_CONOUT (C) BYTE Wert=0x03
; ITP3_CONST (C) BYTE Wert=0x04
; ITP3_CONIN (C) BYTE Wert=0x05
; ITP3_STD (C) BYTE Wert=0x06
; ITP3_RD_SEC (C) BYTE Wert=0x07
; ITP3_WR_SEC (C) BYTE Wert=0x08
; ITP3_SOUND (C) BYTE Wert=0x09
; ITP3_READER (C) BYTE Wert=0x0A
; DEV_DS0 (C) BYTE Wert=0x00
; DEV_DS1 (C) BYTE Wert=0x01
; DEV_DS2 (C) BYTE Wert=0x02
; DEV_DS3 (C) BYTE Wert=0x03
; DEV_DS4 (C) BYTE Wert=0x04
; DEV_NR (V) BYTE
; CONOUT_DEVICE_NR1 (V) BYTE
; CONOUT_DEVICE_NR2 (V) BYTE
; CONIN_DEVICE (V) BYTE
; LIST_DEVICE (V) BYTE
; SOUND_DEVICE (V) BYTE
; READER_DEVICE (V) BYTE
; INIT_ITP3 (P) 
; DEV_NR_CLEARBIT (P) 
; DEV_NR_SETBIT (P) 
; ITP3_SENDE_HALBBYTE (P) 
; ITP3_SENDE_BYTE (P) 
; ITP3_SENDE_TEST_HALBBYTE (F) 
; ITP3_SENDE_TEST_BYTE (F) 
; ITP3_EMPFANGE_HALBBYTE (F) 
; ITP3_EMPFANGE_BYTE (F) 
; ITP3_SENDE_CONOUT (P) 
; ITP3_SENDE_SOUND (P) 
; ITP3_EMPFANGE_CONST (F) 
; ITP3_EMPFANGE_CONIN (F) 
; ITP3_CONIN_SCHLEIFE (P) 
; ITP3_SENDE_STD (P) 
; ITP3_SEKTOR_LESEN (P) 
; ITP3_SEKTOR_SCHREIBEN (P) 
; ITP3_DEV_ZU_DEVICE (F) 
; ITP3_PRUEFE_EINEN_ANSCHLUSS (P) 
; ITP3_PRUEFE_ANSCHLUESSE (P) 
; WARTE_SOLANGE_RD_HIGH (P) 
; WARTE_SOLANGE_RD_LOW (P) 
; WARTE_SOLANGE_IORQ_HIGH (P) 
; WARTE_SOLANGE_IORQ_LOW (P) 
; START_RAM2ARR (P) 
; START_ARR2RAM (P) 
; START_BDOS2RAM (P) 
; START_CCP2RAM (P) 
; LADE_MEIC_ARRAY_IN_RAM (P) 
; DIREKT_CONOUT_TO_DEVICE (P) 
; ANZEIGE_STRING_AN_CONOUT (P) 
; INIT_LAUFWERKE_VERTEILER (P) 
; LAUFWERKE_VERTEILER_NACH_OBEN_KOPIEREN (P) 
; LAUFWERKE_VERTEILER_NACH_UNTEN_KOPIEREN (P) 
; LAUFWERKE_VERTEILER_ANZEIGEN (P) 
; GERAETE_ANZEIGEN_DEVICE (P) 
; GERAETE_ANZEIGEN (P) 
; DISKNO_IN_SCHNITTSTELLE (F) 
; LAUFWERKE_VERTEILER_READ (P) 
; LAUFWERKE_VERTEILER_WRITE (P) 
; SENDE_50_TAKTE (P) 
; Z80_RESET_UND_URLOAD (P) 
; IORQ_ENDE (P) 
; Z80_CONOUT (P) 
; Z80_LIST (P) 
; Z80_SOUND (P) 
; Z80_CONIN (P) 
; STD_AN_UC (P) 
; CONST_TO_DEVICE (P) 
; CONIN_TO_DEVICE (P) 
; CONOUT_TO_DEVICE (P) 
; LIST_TO_DEVICE (P) 
; SOUND_TO_DEVICE (P) 
; LAUFWERK_IST_VORHANDEN (F) 
; LW_VORHANDEN (P) 
; AUSWERTEN_IORQ (P) 
; INITPORTS (P) 
; LED_BLINKEN (P) 
; SERIAL_DEVICE_VECTOR_AUSWERTEN (P) 
 
; *** Prozedur/Function-Liste ***
;
; FUNCTION BYTEPOSTOORMASKE (BYTEPOS : BYTE) : BYTE;
; FUNCTION BYTEPOSTOANDMASKE (BYTEPOS : BYTE) : BYTE;
; FUNCTION READ_BIT_IN_BYTE (TESTBYTE : BYTE) (BYTEPOS : BYTE) (VERGLEICH : BYTE) (MASKE : BYTE) : BOOLEAN;
; FUNCTION SET_BIT_IN_BYTE (TESTBYTE : BYTE) (BYTEPOS : BYTE) (ERGEBNIS : BYTE) (MASKE : BYTE) : BYTE;
; FUNCTION CLEAR_BIT_IN_BYTE (TESTBYTE : BYTE) (BYTEPOS : BYTE) (ERGEBNIS : BYTE) (MASKE : BYTE) : BYTE;
; FUNCTION NEGATION_BYTE (DAS_BYTE : BYTE) : BYTE;
; PROCEDURE WAIT_MS (ZEIT : WORD) (W1 : WORD) (W2 : WORD);
; PROCEDURE BYTETOHEXSTRING (WERT_BYTE : BYTE) (HEXLOW : BYTE) (HEXHIGH : BYTE) (C1 : CHAR);
; PROCEDURE BYTETODEZSTRING (WERT_BYTE : BYTE) (B1 : BYTE) (B2 : BYTE) (C1 : CHAR);
; FUNCTION HEXSTRINGTOBYTE (HEXLOW : BYTE) (HEXHIGH : BYTE) (S2B : BYTE) (C1 : CHAR) : BYTE;
; PROCEDURE WORDTOHEXSTRING (WERT_WORD : WORD) (BYTE_LOW : BYTE) (BYTE_HIGH : BYTE);
; FUNCTION HEXSTRINGTOWORD (C1 : CHAR) (S2W : WORD) (S2B : BYTE) (S2W2 : WORD) : WORD;
; PROCEDURE DWORDTOHEXSTRING (WERT_DWORD : DWORD) (WORD_LOW : WORD) (WORD_HIGH : WORD);
; PROCEDURE INIT_SER0_PORT;
; PROCEDURE RX0_PUFFER_ABFRAGEN;
; PROCEDURE SENDE_ZEICHEN0 (S_ZEICHEN0 : BYTE);
; PROCEDURE ABFRAGE_SERIAL_DEVICE_CONNECTED;
; PROCEDURE WRITE_SER0 (C1 : CHAR) (LAENGE : BYTE) (B1 : BYTE) (B2 : BYTE);
; PROCEDURE WRITELN_SER0;
; PROCEDURE STD_AN_UART_SENDEN;
; PROCEDURE STEUER_STRING_TO_SECTOR (B1 : BYTE) (B2 : BYTE) (B3 : BYTE) (C1 : CHAR);
; PROCEDURE STEUER_STRING_TO_SECTOR_KOMP (X2 : BYTE) (DB7 : BYTE) (DB8 : BYTE) (BITPOS_DB8 : BYTE) (BITPOS_DB7 : BYTE) (C1 : CHAR) (POS_SS : BYTE) (EIN_BIT : BOOLEAN);
; PROCEDURE STEUER_STRING_AUSWERTEN (BUCHSTABE : CHAR) (ZEICHEN_1 : CHAR) (ZEICHEN_2 : CHAR) (LAENGE : BYTE);
; PROCEDURE STEUER_STRING_LESEN (AKT_ZEICHEN : CHAR) (EMPF_ZEICHEN : BYTE);
; PROCEDURE SEKTOR_VON_UART_LESEN (B1 : BYTE) (B2 : BYTE) (SPZ : WORD) (LESESCHLEIFE : WORD);
; PROCEDURE SEKTOR_VON_UART_LESEN_KOMP (B1 : BYTE) (B2 : BYTE) (SPZ : WORD) (LESESCHLEIFE : WORD);
; PROCEDURE SEKTOR_AN_UART_SENDEN (B1 : BYTE) (B2 : BYTE) (B3 : BYTE);
; PROCEDURE DEVICE_VECTOR_VON_UART_LESEN (LESESCHLEIFE : DWORD);
; PROCEDURE CONST_VON_UART_LESEN (LESESCHLEIFE : DWORD);
; PROCEDURE CONIN_VON_UART_LESEN (LESESCHLEIFE : WORD);
; PROCEDURE UART_CONIN_SCHLEIFE;
; PROCEDURE UART_CONOUT_SENDEN;
; PROCEDURE INIT_SPI;
; PROCEDURE SPI_WRITE_BYTE (MOSI_BYTE : BYTE) (SPI_COUTER : BYTE);
; PROCEDURE SPI_READ_BYTE (SPI_COUTER : BYTE);
; PROCEDURE W25Q64_READ_ONE_BYTE;
; PROCEDURE W25Q64_READ_ONE_SECTOR;
; PROCEDURE W25Q64_WRITE_ONE_SECTOR;
; PROCEDURE FLASH_SECTOR_ERASE;
; PROCEDURE FLASH_CHIP_ERASE;
; PROCEDURE SDA_SET;
; PROCEDURE SCL_SET;
; PROCEDURE SDA_CLEAR;
; PROCEDURE SCL_CLEAR;
; PROCEDURE SDA_OUT;
; PROCEDURE SDA_IN;
; PROCEDURE SCL_OUT;
; FUNCTION SDA_READ (B1 : BOOLEAN) : BOOLEAN;
; PROCEDURE INIT_I2C;
; FUNCTION DS_SHIFT_IN_NACK (DS_DATA : BYTE) (DS_COUTER : BYTE) : BYTE;
; FUNCTION DS_SHIFT_IN_ACK (DS_DATA : BYTE) (DS_COUTER : BYTE) : BYTE;
; FUNCTION DS_SHIFT_OUT (DS_DATA : BYTE) (DS_COUTER : BYTE) (DS_RESULT : BOOLEAN) (DS_DATA_2 : BYTE) : BOOLEAN;
; FUNCTION I2C_DEVICE_ADDRESS_TO_WRITE (I2C_ADDRESS : BYTE) (DS_RESULT : BOOLEAN) : BOOLEAN;
; FUNCTION I2C_DEVICE_ADDRESS_TO_READ (I2C_ADDRESS : BYTE) (DS_RESULT : BOOLEAN) : BOOLEAN;
; PROCEDURE AT_DATA_WRITE_WORD_ADDRESS (B1 : BYTE) (ADDRESS_ACK : BOOLEAN);
; FUNCTION AT_DATA_READ_ONE_BYTE (DS_DATA : BYTE) (ADDRESS_ACK : BOOLEAN) : BYTE;
; PROCEDURE AT_READ_DATA_ARRAY (RBA_DATA : BYTE) (ADDRESS_ACK : BOOLEAN) (RBA_COUNTER : WORD);
; PROCEDURE AT_DATA_WRITE_ONE_BYTE_WAIT (DATA_BYTE : BYTE) (ADDRESS_ACK : BOOLEAN) (B1 : BYTE);
; PROCEDURE AT_DATA_WRITE_ONE_BYTE_NO_WAIT (DATA_BYTE : BYTE) (ADDRESS_ACK : BOOLEAN) (B1 : BYTE);
; PROCEDURE AT_WRITE_DATA_ARRAY_WAIT (ADDRESS_ACK : BOOLEAN) (ADDRESS_COUNTER : WORD) (DATA_BYTE : BYTE);
; PROCEDURE FORMAT_DIR (B1 : BYTE) (ADDRESS_COUNTER : WORD) (ADDRESS_WERT : WORD);
; PROCEDURE INIT_TBL1_TYP_ZIEL_ZEIGER (ADDRESS_COUNTER : WORD);
; PROCEDURE INIT_TBL2_ZEIGER_4K_SPUR_NR (ADDRESS_COUNTER : WORD) (ADDRESS_COUNTER2 : WORD) (ADDRESS_COUNTER3 : WORD) (ADDRESS_WERT : WORD) (B1 : BYTE);
; PROCEDURE INIT_TBL3_4K_SPI_TMP_SPUR_NR (ADDRESS_WERT : BYTE);
; FUNCTION TEST_I2C_VORHANDEN (TEST_I2C : BOOLEAN) (B1 : BYTE) : BOOLEAN;
; PROCEDURE INIT_LOESCHEN_UND_FORMATIEREN;
; PROCEDURE INIT_FLASH_MANAGER (B1 : BYTE);
; PROCEDURE FM_READ_TBL1_TYP_ZIEL_ZEIGER (RD_4K_SPUR : WORD);
; PROCEDURE FM_WRITE_TBL1_TYP_ZIEL_ZEIGER (WR_4K_SPUR : WORD);
; FUNCTION FM_READ_TBL2_4K_SPUR_NR (RD_4K_SPUR : WORD) (RD_4K_BA_WORD_L : WORD) (RD_4K_BA_WORD_H : WORD) (RD_4K_BA_BYTE : BYTE) : WORD;
; PROCEDURE FM_WRITE_TBL2_4K_SPUR_NR (WR_4K_SPUR : WORD) (WR_4K_INHALT : WORD) (B1 : BYTE);
; FUNCTION FM_4K_SPUR_UND_SEKTOR_IN_FLASH_ZEIGER (ZO_4K_SPUR : WORD) (ZO_4K_ZEIGER : DWORD) (ZO_4K_SEKTOR : DWORD) : DWORD;
; FUNCTION FM_READ_AELTESTER_4K_SPEICHER_IM_I2C (RD_AELTESTER_4K_SPEICHER_IM_I2C : BYTE) : BYTE;
; PROCEDURE FM_WRITE_AELTESTER_4K_SPEICHER_IM_I2C (WR_AELTESTER_4K_SPEICHER_IM_I2C : BYTE);
; FUNCTION FM_READ_SPUR_NR_AUS_AELTESTER_4K_SPEICHER_IM_I2C (READ_SPUR_NR : WORD) (ZEIGER_AELTESTER_4K_SPEICHER : BYTE) (W1 : WORD) (B1 : BYTE) : WORD;
; FUNCTION FM_SPI_ZIELADRESSE_AUS_AELTESTER_4K_SPEICHER (W1 : WORD) (SPI_ADRESSE_DWORD : DWORD) : DWORD;
; PROCEDURE FM_FLASH_ADDRESS_I2C_QUELLADRESSE_AUS_AELTESTER_4K_SPEICHER (ZEIGER_AELTESTER_4K_SPEICHER : BYTE);
; PROCEDURE FM_READ_DATA_ARRAY (FM_4K_ZEIGER : WORD) (FLASH_ZEIGER : DWORD);
; PROCEDURE FM_ZURUECKSCHREIBEN_4K_SEKTOR (SPI_ADRESSE_DWORD : DWORD) (B1 : BYTE) (Z_FLASH_ADDRESS : WORD) (READ_SPUR_NR : WORD) (READ_SPUR_NR2 : WORD);
; PROCEDURE FM_VERSCHIEBEN_4K_SEKTOR (SPI_ADRESSE_DWORD : DWORD) (ZEIGER_AELTESTER_4K_SPEICHER : BYTE) (ZEIGER_AELTESTER_4K_SPEICHER_WORD : WORD) (W1 : WORD) (B1 : BYTE);
; PROCEDURE FM_PRUEFE_VERSCHIEBEN_SPUR_NOTWENDIG;
; PROCEDURE FM_WRITE_DATA_ARRAY (FM_4K_SPUR : WORD) (FLASH_ZEIGER : DWORD);
; PROCEDURE STD_AN_LOKALEN_FLASH_MANAGER_SENDEN (DATA_BYTE : BYTE) (DATA_WORD : WORD);
; PROCEDURE LOKALEN_FLASH_MANAGER_SEKTOR_LESEN (DATA_BYTE : BYTE);
; PROCEDURE LOKALEN_FLASH_MANAGER_SEKTOR_SCHREIBEN (DATA_BYTE : BYTE);
; PROCEDURE INIT_ITP3;
; PROCEDURE DEV_NR_CLEARBIT;
; PROCEDURE DEV_NR_SETBIT;
; PROCEDURE ITP3_SENDE_HALBBYTE (SB : BYTE) (B1 : BYTE);
; PROCEDURE ITP3_SENDE_BYTE (SB : BYTE) (B1 : BYTE);
; FUNCTION ITP3_SENDE_TEST_HALBBYTE (SB : BYTE) (B1 : BYTE) (WAIT_COUNTER : WORD) (RESULT_BYTE : BOOLEAN) : BOOLEAN;
; FUNCTION ITP3_SENDE_TEST_BYTE (SB : BYTE) (B1 : BYTE) (RESULT_BYTE : BOOLEAN) : BOOLEAN;
; FUNCTION ITP3_EMPFANGE_HALBBYTE (RESULT_BYTE : BYTE) : BYTE;
; FUNCTION ITP3_EMPFANGE_BYTE (RESULT_BYTE_01 : BYTE) (RESULT_BYTE_02 : BYTE) : BYTE;
; PROCEDURE ITP3_SENDE_CONOUT (CO_BYTE : BYTE);
; PROCEDURE ITP3_SENDE_SOUND (SND_BYTE : BYTE);
; FUNCTION ITP3_EMPFANGE_CONST (RESULT_BYTE : BYTE) : BYTE;
; FUNCTION ITP3_EMPFANGE_CONIN (RESULT_BYTE : BYTE) : BYTE;
; PROCEDURE ITP3_CONIN_SCHLEIFE;
; PROCEDURE ITP3_SENDE_STD;
; PROCEDURE ITP3_SEKTOR_LESEN (B1 : BYTE);
; PROCEDURE ITP3_SEKTOR_SCHREIBEN (B1 : BYTE);
; FUNCTION ITP3_DEV_ZU_DEVICE (CON_DEVICE : BYTE) : BYTE;
; PROCEDURE ITP3_PRUEFE_EINEN_ANSCHLUSS (OK_BYTE : BOOLEAN) (WHO_ARE_YOU_BYTE : BYTE) (B1 : BYTE) (CO_DEV : BYTE);
; PROCEDURE ITP3_PRUEFE_ANSCHLUESSE;
; PROCEDURE WARTE_SOLANGE_RD_HIGH;
; PROCEDURE WARTE_SOLANGE_RD_LOW;
; PROCEDURE WARTE_SOLANGE_IORQ_HIGH;
; PROCEDURE WARTE_SOLANGE_IORQ_LOW;
; PROCEDURE START_RAM2ARR (SP_ZAEHLER : WORD) (RAM_WERT : BYTE) (RAM_ADR : BYTE);
; PROCEDURE START_ARR2RAM (SP_ZAEHLER : WORD) (RAM_WERT : BYTE) (RAM_ADR : BYTE);
; PROCEDURE START_BDOS2RAM (SP_ZAEHLER : WORD) (RAM_WERT : BYTE) (RAM_ADR : BYTE);
; PROCEDURE START_CCP2RAM (SP_ZAEHLER : WORD) (RAM_WERT : BYTE) (RAM_ADR : BYTE);
; PROCEDURE LADE_MEIC_ARRAY_IN_RAM;
; PROCEDURE DIREKT_CONOUT_TO_DEVICE;
; PROCEDURE ANZEIGE_STRING_AN_CONOUT (C1 : CHAR) (LAENGE : BYTE) (B1 : BYTE);
; PROCEDURE INIT_LAUFWERKE_VERTEILER (LV_ZEIGER : WORD);
; PROCEDURE LAUFWERKE_VERTEILER_NACH_OBEN_KOPIEREN (LV_ZEIGER : WORD) (LV_ZEIGER_M1 : WORD) (ES_WURDE_KOPIERT : BOOLEAN) (EINTRAG_WERT : BYTE) (EINTRAG_WERT_M1 : BYTE);
; PROCEDURE LAUFWERKE_VERTEILER_NACH_UNTEN_KOPIEREN (LV_ZEIGER : WORD) (LV_ZEIGER_P1 : WORD) (ES_WURDE_KOPIERT : BOOLEAN) (EINTRAG_WERT : BYTE) (EINTRAG_WERT_P1 : BYTE);
; PROCEDURE LAUFWERKE_VERTEILER_ANZEIGEN (LV_ZEIGER : WORD) (EINTRAG_WERT : BYTE) (LW_BUCHSTABE_BYTE : BYTE) (LW_BUCHSTABE_CHAR : CHAR);
; PROCEDURE GERAETE_ANZEIGEN_DEVICE (CON_DEVICE : BYTE);
; PROCEDURE GERAETE_ANZEIGEN;
; FUNCTION DISKNO_IN_SCHNITTSTELLE (EINTRAG_WERT : BYTE) (LAUFWERK_WORD : WORD) : BYTE;
; PROCEDURE LAUFWERKE_VERTEILER_READ (EINTRAG_WERT : BYTE);
; PROCEDURE LAUFWERKE_VERTEILER_WRITE (EINTRAG_WERT : BYTE);
; PROCEDURE SENDE_50_TAKTE (ZAEHLER : BYTE);
; PROCEDURE Z80_RESET_UND_URLOAD;
; PROCEDURE IORQ_ENDE;
; PROCEDURE Z80_CONOUT;
; PROCEDURE Z80_LIST (IO_WERT : BYTE);
; PROCEDURE Z80_SOUND;
; PROCEDURE Z80_CONIN;
; PROCEDURE STD_AN_UC;
; PROCEDURE CONST_TO_DEVICE;
; PROCEDURE CONIN_TO_DEVICE;
; PROCEDURE CONOUT_TO_DEVICE;
; PROCEDURE LIST_TO_DEVICE;
; PROCEDURE SOUND_TO_DEVICE;
; FUNCTION LAUFWERK_IST_VORHANDEN (LIV_BYTE : BYTE) (EINTRAG_WERT : BYTE) (LW_NUMMER : BYTE) : BYTE;
; PROCEDURE LW_VORHANDEN (LW_OK : BYTE);
; PROCEDURE AUSWERTEN_IORQ (IO_WERT : BYTE);
; PROCEDURE INITPORTS;
; PROCEDURE LED_BLINKEN;
; PROCEDURE SERIAL_DEVICE_VECTOR_AUSWERTEN (B1 : BYTE);
 
; *** Konstanten-ARRAYs ***
;
 
MEIC_ARR:
.db    0xF3,0x31
.db    0x80,0xFE
.db    0x21,0x12
.db    0x00,0x11
.db    0x00,0xF0
.db    0x01,0x9D
.db    0x08,0xED
.db    0xB0,0xC3
.db    0x00,0xF0
.db    0xC3,0x5B
.db    0xF1,0xC3
.db    0x7D,0xF1
.db    0xC3,0xA7
.db    0xF1,0xC3
.db    0xB4,0xF1
.db    0xC3,0xBF
.db    0xF1,0xC3
.db    0xC7,0xF1
.db    0xC3,0xCF
.db    0xF1,0xC3
.db    0xD7,0xF1
.db    0xC3,0xD8
.db    0xF1,0xC3
.db    0xDE,0xF1
.db    0xC3,0xF4
.db    0xF1,0xC3
.db    0xF9,0xF1
.db    0xC3,0xFE
.db    0xF1,0xC3
.db    0x03,0xF2
.db    0xC3,0x27
.db    0xF2,0xC3
.db    0x4B,0xF2
.db    0xC3,0x4E
.db    0xF2,0x00
.db    0x02,0x00
.db    0x00,0x80
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x0C
.db    0x43,0x50
.db    0x2F,0x4D
.db    0x20,0x32
.db    0x2E,0x32
.db    0x20,0x43
.db    0x6F,0x70
.db    0x79,0x72
.db    0x69,0x67
.db    0x68,0x74
.db    0x20,0x31
.db    0x39,0x37
.db    0x39,0x20
.db    0x28,0x63
.db    0x29,0x20
.db    0x62,0x79
.db    0x20,0x44
.db    0x69,0x67
.db    0x69,0x74
.db    0x61,0x6C
.db    0x20,0x52
.db    0x65,0x73
.db    0x65,0x61
.db    0x72,0x63
.db    0x68,0x0D
.db    0x0A,0x42
.db    0x49,0x4F
.db    0x53,0x2D
.db    0x4D,0x6F
.db    0x6E,0x69
.db    0x74,0x6F
.db    0x72,0x20
.db    0x32,0x30
.db    0x32,0x32
.db    0x20,0x77
.db    0x72,0x69
.db    0x74,0x74
.db    0x65,0x6E
.db    0x20,0x62
.db    0x79,0x20
.db    0x52,0x6F
.db    0x6E,0x61
.db    0x6C,0x64
.db    0x20,0x44
.db    0x61,0x6C
.db    0x65,0x73
.db    0x6B,0x65
.db    0x0D,0x0A
.db    0x0D,0x0A
.db    0x00,0x53
.db    0x55,0x42
.db    0x4D,0x49
.db    0x54,0x20
.db    0x41,0x55
.db    0x54,0x4F
.db    0x45,0x58
.db    0x45,0x43
.db    0x00,0x0D
.db    0x0A,0x42
.db    0x49,0x4F
.db    0x53,0x20
.db    0x46,0x65
.db    0x68,0x6C
.db    0x65,0x72
.db    0x20,0x2D
.db    0x20,0x4C
.db    0x61,0x75
.db    0x66,0x77
.db    0x65,0x72
.db    0x6B,0x20
.db    0x6E,0x69
.db    0x63,0x68
.db    0x74,0x20
.db    0x76,0x6F
.db    0x72,0x68
.db    0x61,0x6E
.db    0x64,0x65
.db    0x6E,0x20
.db    0x2E,0x2E
.db    0x2E,0x0D
.db    0x0A,0x00
.db    0x00,0x31
.db    0x80,0xFE
.db    0x21,0xB9
.db    0xF0,0xCD
.db    0x51,0xF2
.db    0x3E,0x10
.db    0xD3,0x00
.db    0x3E,0x01
.db    0x4F,0xCD
.db    0xCF,0xF1
.db    0xAF,0x32
.db    0x03,0x00
.db    0x32,0x04
.db    0x00,0xCD
.db    0x02,0xF3
.db    0xCD,0x0C
.db    0xF3,0x18
.db    0x09,0x31
.db    0x80,0xFE
.db    0xCD,0x02
.db    0xF3,0xCD
.db    0x0C,0xF3
.db    0x3E,0xC3
.db    0x32,0x00
.db    0x00,0x21
.db    0x03,0xF0
.db    0x22,0x01
.db    0x00,0x32
.db    0x05,0x00
.db    0x21,0x06
.db    0xE2,0x22
.db    0x06,0x00
.db    0x01,0x80
.db    0x00,0xCD
.db    0xFE,0xF1
.db    0x3A,0x04
.db    0x00,0x4F
.db    0xC3,0x03
.db    0xDA,0x3E
.db    0x03,0xD3
.db    0x00,0xDB
.db    0x00,0xFE
.db    0x00,0x28
.db    0x02,0x3E
.db    0xFF,0xC9
.db    0x3E,0x02
.db    0xD3,0x00
.db    0xDB,0x00
.db    0xFE,0x00
.db    0x28,0xF6
.db    0xC9,0x3E
.db    0x01,0xD3
.db    0x00,0x79
.db    0xD3,0x00
.db    0xC9,0x3E
.db    0x0A,0xD3
.db    0x00,0x79
.db    0xD3,0x00
.db    0xC9,0x3E
.db    0x0B,0xD3
.db    0x00,0x79
.db    0xD3,0x00
.db    0xC9,0xC9
.db    0x0E,0x00
.db    0xCD,0xF4
.db    0xF1,0xC9
.db    0x21,0x00
.db    0x00,0x79
.db    0xFE,0x05
.db    0xD0,0x32
.db    0x36,0xF0
.db    0x6F,0x26
.db    0x00,0x29
.db    0x29,0x29
.db    0x29,0x11
.db    0x76,0xF2
.db    0x19,0xC9
.db    0xED,0x43
.db    0x34,0xF0
.db    0xC9,0x79
.db    0x32,0x33
.db    0xF0,0xC9
.db    0xED,0x43
.db    0x37,0xF0
.db    0xC9,0xCD
.db    0xE9,0xF2
.db    0x3E,0x0F
.db    0xD3,0x00
.db    0xDB,0x00
.db    0xFE,0x00
.db    0x20,0x0E
.db    0x3E,0x0C
.db    0xD3,0x00
.db    0x0E,0x00
.db    0x2A,0x37
.db    0xF0,0xCD
.db    0xDF,0xF2
.db    0xAF,0xC9
.db    0x21,0x2B
.db    0xF1,0xCD
.db    0x51,0xF2
.db    0x3E,0xFF
.db    0xC9,0x0E
.db    0x00,0x2A
.db    0x37,0xF0
.db    0xCD,0xD5
.db    0xF2,0xCD
.db    0xE9,0xF2
.db    0x3E,0x0F
.db    0xD3,0x00
.db    0xDB,0x00
.db    0xFE,0x00
.db    0x20,0x06
.db    0x3E,0x0E
.db    0xD3,0x00
.db    0xAF,0xC9
.db    0x21,0x2B
.db    0xF1,0xCD
.db    0x51,0xF2
.db    0x3E,0xFF
.db    0xC9,0x3E
.db    0xFF,0xC9
.db    0x60,0x69
.db    0xC9,0x7E
.db    0xB7,0xC8
.db    0x4F,0xE5
.db    0xCD,0xBF
.db    0xF1,0xE1
.db    0x23,0x18
.db    0xF4,0x0E
.db    0x0D,0xCD
.db    0xBF,0xF1
.db    0x0E,0x0A
.db    0xCD,0xBF
.db    0xF1,0xC9
.db    0x0E,0xD4
.db    0x06,0xFE
.db    0x05,0x20
.db    0xFD,0x0D
.db    0x20,0xF8
.db    0x3D,0x20
.db    0xF3,0xC9
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x17,0xF3
.db    0xC6,0xF2
.db    0x00,0x00
.db    0x97,0xF3
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x17,0xF3
.db    0xC6,0xF2
.db    0x00,0x00
.db    0x98,0xF4
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x17,0xF3
.db    0xC6,0xF2
.db    0x00,0x00
.db    0x99,0xF5
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x17,0xF3
.db    0xC6,0xF2
.db    0x00,0x00
.db    0x9A,0xF6
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x17,0xF3
.db    0xC6,0xF2
.db    0x00,0x00
.db    0x9B,0xF7
.db    0x80,0x00
.db    0x05,0x1F
.db    0x01,0xFF
.db    0x07,0xFF
.db    0x01,0xF0
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x3E
.db    0x05,0xD3
.db    0x00,0x79
.db    0xD3,0x00
.db    0xE9,0x00
.db    0x00,0x3E
.db    0x06,0xD3
.db    0x00,0x79
.db    0xD3,0x00
.db    0xE9,0x00
.db    0x00,0x3E
.db    0x07,0xD3
.db    0x00,0x3A
.db    0x33,0xF0
.db    0xD3,0x00
.db    0x3A,0x34
.db    0xF0,0xD3
.db    0x00,0x3A
.db    0x35,0xF0
.db    0xD3,0x00
.db    0x3A,0x36
.db    0xF0,0xD3
.db    0x00,0xC9
.db    0x21,0x00
.db    0xE2,0x3E
.db    0x08,0xD3
.db    0x00,0xE9
.db    0x00,0x00
.db    0x21,0x00
.db    0xDA,0x3E
.db    0x09,0xD3
.db    0x00,0xE9
.db    0x00,0x00
.db    0xFF,0x00
 
BDOS_ARR:
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0xC3,0x11
.db    0xE2,0x99
.db    0xE2,0xA5
.db    0xE2,0xAB
.db    0xE2,0xB1
.db    0xE2,0xEB
.db    0x22,0x43
.db    0xE5,0xEB
.db    0x7B,0x32
.db    0xD6,0xEF
.db    0x21,0x00
.db    0x00,0x22
.db    0x45,0xE5
.db    0x39,0x22
.db    0x0F,0xE5
.db    0x31,0x41
.db    0xE5,0xAF
.db    0x32,0xE0
.db    0xEF,0x32
.db    0xDE,0xEF
.db    0x21,0x74
.db    0xEF,0xE5
.db    0x79,0xFE
.db    0x29,0xD0
.db    0x4B,0x21
.db    0x47,0xE2
.db    0x5F,0x16
.db    0x00,0x19
.db    0x19,0x5E
.db    0x23,0x56
.db    0x2A,0x43
.db    0xE5,0xEB
.db    0xE9,0x03
.db    0xF0,0xC8
.db    0xE4,0x90
.db    0xE3,0xCE
.db    0xE4,0x12
.db    0xF0,0x0F
.db    0xF0,0xD4
.db    0xE4,0xED
.db    0xE4,0xF3
.db    0xE4,0xF8
.db    0xE4,0xE1
.db    0xE3,0xFE
.db    0xE4,0x7E
.db    0xEE,0x83
.db    0xEE,0x45
.db    0xEE,0x9C
.db    0xEE,0xA5
.db    0xEE,0xAB
.db    0xEE,0xC8
.db    0xEE,0xD7
.db    0xEE,0xE0
.db    0xEE,0xE6
.db    0xEE,0xEC
.db    0xEE,0xF5
.db    0xEE,0xFE
.db    0xEE,0x04
.db    0xEF,0x0A
.db    0xEF,0x11
.db    0xEF,0x2C
.db    0xE7,0x17
.db    0xEF,0x1D
.db    0xEF,0x26
.db    0xEF,0x2D
.db    0xEF,0x41
.db    0xEF,0x47
.db    0xEF,0x4D
.db    0xEF,0x0E
.db    0xEE,0x53
.db    0xEF,0x04
.db    0xE5,0x04
.db    0xE5,0x9B
.db    0xEF,0x21
.db    0xCA,0xE2
.db    0xCD,0xE5
.db    0xE2,0xFE
.db    0x03,0xCA
.db    0x00,0x00
.db    0xC9,0x21
.db    0xD5,0xE2
.db    0xC3,0xB4
.db    0xE2,0x21
.db    0xE1,0xE2
.db    0xC3,0xB4
.db    0xE2,0x21
.db    0xDC,0xE2
.db    0xCD,0xE5
.db    0xE2,0xC3
.db    0x00,0x00
.db    0x42,0x64
.db    0x6F,0x73
.db    0x20,0x45
.db    0x72,0x72
.db    0x20,0x4F
.db    0x6E,0x20
.db    0x20,0x3A
.db    0x20,0x24
.db    0x42,0x61
.db    0x64,0x20
.db    0x53,0x65
.db    0x63,0x74
.db    0x6F,0x72
.db    0x24,0x53
.db    0x65,0x6C
.db    0x65,0x63
.db    0x74,0x24
.db    0x46,0x69
.db    0x6C,0x65
.db    0x20,0x52
.db    0x2F,0x4F
.db    0x24,0xE5
.db    0xCD,0xC9
.db    0xE3,0x3A
.db    0x42,0xE5
.db    0xC6,0x41
.db    0x32,0xC6
.db    0xE2,0x01
.db    0xBA,0xE2
.db    0xCD,0xD3
.db    0xE3,0xC1
.db    0xCD,0xD3
.db    0xE3,0x21
.db    0x0E,0xE5
.db    0x7E,0x36
.db    0x00,0xB7
.db    0xC0,0xC3
.db    0x09,0xF0
.db    0xCD,0xFB
.db    0xE2,0xCD
.db    0x14,0xE3
.db    0xD8,0xF5
.db    0x4F,0xCD
.db    0x90,0xE3
.db    0xF1,0xC9
.db    0xFE,0x0D
.db    0xC8,0xFE
.db    0x0A,0xC8
.db    0xFE,0x09
.db    0xC8,0xFE
.db    0x08,0xC8
.db    0xFE,0x20
.db    0xC9,0x3A
.db    0x0E,0xE5
.db    0xB7,0xC2
.db    0x45,0xE3
.db    0xCD,0x06
.db    0xF0,0xE6
.db    0x01,0xC8
.db    0xCD,0x09
.db    0xF0,0xFE
.db    0x13,0xC2
.db    0x42,0xE3
.db    0xCD,0x09
.db    0xF0,0xFE
.db    0x03,0xCA
.db    0x00,0x00
.db    0xAF,0xC9
.db    0x32,0x0E
.db    0xE5,0x3E
.db    0x01,0xC9
.db    0x3A,0x0A
.db    0xE5,0xB7
.db    0xC2,0x62
.db    0xE3,0xC5
.db    0xCD,0x23
.db    0xE3,0xC1
.db    0xC5,0xCD
.db    0x0C,0xF0
.db    0xC1,0xC5
.db    0x3A,0x0D
.db    0xE5,0xB7
.db    0xC4,0x0F
.db    0xF0,0xC1
.db    0x79,0x21
.db    0x0C,0xE5
.db    0xFE,0x7F
.db    0xC8,0x34
.db    0xFE,0x20
.db    0xD0,0x35
.db    0x7E,0xB7
.db    0xC8,0x79
.db    0xFE,0x08
.db    0xC2,0x79
.db    0xE3,0x35
.db    0xC9,0xFE
.db    0x0A,0xC0
.db    0x36,0x00
.db    0xC9,0x79
.db    0xCD,0x14
.db    0xE3,0xD2
.db    0x90,0xE3
.db    0xF5,0x0E
.db    0x5E,0xCD
.db    0x48,0xE3
.db    0xF1,0xF6
.db    0x40,0x4F
.db    0x79,0xFE
.db    0x09,0xC2
.db    0x48,0xE3
.db    0x0E,0x20
.db    0xCD,0x48
.db    0xE3,0x3A
.db    0x0C,0xE5
.db    0xE6,0x07
.db    0xC2,0x96
.db    0xE3,0xC9
.db    0xCD,0xAC
.db    0xE3,0x0E
.db    0x20,0xCD
.db    0x0C,0xF0
.db    0x0E,0x08
.db    0xC3,0x0C
.db    0xF0,0x0E
.db    0x23,0xCD
.db    0x48,0xE3
.db    0xCD,0xC9
.db    0xE3,0x3A
.db    0x0C,0xE5
.db    0x21,0x0B
.db    0xE5,0xBE
.db    0xD0,0x0E
.db    0x20,0xCD
.db    0x48,0xE3
.db    0xC3,0xB9
.db    0xE3,0x0E
.db    0x0D,0xCD
.db    0x48,0xE3
.db    0x0E,0x0A
.db    0xC3,0x48
.db    0xE3,0x0A
.db    0xFE,0x24
.db    0xC8,0x03
.db    0xC5,0x4F
.db    0xCD,0x90
.db    0xE3,0xC1
.db    0xC3,0xD3
.db    0xE3,0x3A
.db    0x0C,0xE5
.db    0x32,0x0B
.db    0xE5,0x2A
.db    0x43,0xE5
.db    0x4E,0x23
.db    0xE5,0x06
.db    0x00,0xC5
.db    0xE5,0xCD
.db    0xFB,0xE2
.db    0xE6,0x7F
.db    0xE1,0xC1
.db    0xFE,0x0D
.db    0xCA,0xC1
.db    0xE4,0xFE
.db    0x0A,0xCA
.db    0xC1,0xE4
.db    0xFE,0x08
.db    0xC2,0x16
.db    0xE4,0x78
.db    0xB7,0xCA
.db    0xEF,0xE3
.db    0x05,0x3A
.db    0x0C,0xE5
.db    0x32,0x0A
.db    0xE5,0xC3
.db    0x70,0xE4
.db    0xFE,0x7F
.db    0xC2,0x26
.db    0xE4,0x78
.db    0xB7,0xCA
.db    0xEF,0xE3
.db    0x7E,0x05
.db    0x2B,0xC3
.db    0xA9,0xE4
.db    0xFE,0x05
.db    0xC2,0x37
.db    0xE4,0xC5
.db    0xE5,0xCD
.db    0xC9,0xE3
.db    0xAF,0x32
.db    0x0B,0xE5
.db    0xC3,0xF1
.db    0xE3,0xFE
.db    0x10,0xC2
.db    0x48,0xE4
.db    0xE5,0x21
.db    0x0D,0xE5
.db    0x3E,0x01
.db    0x96,0x77
.db    0xE1,0xC3
.db    0xEF,0xE3
.db    0xFE,0x18
.db    0xC2,0x5F
.db    0xE4,0xE1
.db    0x3A,0x0B
.db    0xE5,0x21
.db    0x0C,0xE5
.db    0xBE,0xD2
.db    0xE1,0xE3
.db    0x35,0xCD
.db    0xA4,0xE3
.db    0xC3,0x4E
.db    0xE4,0xFE
.db    0x15,0xC2
.db    0x6B,0xE4
.db    0xCD,0xB1
.db    0xE3,0xE1
.db    0xC3,0xE1
.db    0xE3,0xFE
.db    0x12,0xC2
.db    0xA6,0xE4
.db    0xC5,0xCD
.db    0xB1,0xE3
.db    0xC1,0xE1
.db    0xE5,0xC5
.db    0x78,0xB7
.db    0xCA,0x8A
.db    0xE4,0x23
.db    0x4E,0x05
.db    0xC5,0xE5
.db    0xCD,0x7F
.db    0xE3,0xE1
.db    0xC1,0xC3
.db    0x78,0xE4
.db    0xE5,0x3A
.db    0x0A,0xE5
.db    0xB7,0xCA
.db    0xF1,0xE3
.db    0x21,0x0C
.db    0xE5,0x96
.db    0x32,0x0A
.db    0xE5,0xCD
.db    0xA4,0xE3
.db    0x21,0x0A
.db    0xE5,0x35
.db    0xC2,0x99
.db    0xE4,0xC3
.db    0xF1,0xE3
.db    0x23,0x77
.db    0x04,0xC5
.db    0xE5,0x4F
.db    0xCD,0x7F
.db    0xE3,0xE1
.db    0xC1,0x7E
.db    0xFE,0x03
.db    0x78,0xC2
.db    0xBD,0xE4
.db    0xFE,0x01
.db    0xCA,0x00
.db    0x00,0xB9
.db    0xDA,0xEF
.db    0xE3,0xE1
.db    0x70,0x0E
.db    0x0D,0xC3
.db    0x48,0xE3
.db    0xCD,0x06
.db    0xE3,0xC3
.db    0x01,0xE5
.db    0xCD,0x15
.db    0xF0,0xC3
.db    0x01,0xE5
.db    0x79,0x3C
.db    0xCA,0xE0
.db    0xE4,0x3C
.db    0xCA,0x06
.db    0xF0,0xC3
.db    0x0C,0xF0
.db    0xCD,0x06
.db    0xF0,0xB7
.db    0xCA,0x91
.db    0xEF,0xCD
.db    0x09,0xF0
.db    0xC3,0x01
.db    0xE5,0x3A
.db    0x03,0x00
.db    0xC3,0x01
.db    0xE5,0x21
.db    0x03,0x00
.db    0x71,0xC9
.db    0xEB,0x4D
.db    0x44,0xC3
.db    0xD3,0xE3
.db    0xCD,0x23
.db    0xE3,0x32
.db    0x45,0xE5
.db    0xC9,0x3E
.db    0x01,0xC3
.db    0x01,0xE5
.db    0x00,0x02
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x21
.db    0x0B,0xE2
.db    0x5E,0x23
.db    0x56,0xEB
.db    0xE9,0x0C
.db    0x0D,0xC8
.db    0x1A,0x77
.db    0x13,0x23
.db    0xC3,0x50
.db    0xE5,0x3A
.db    0x42,0xE5
.db    0x4F,0xCD
.db    0x1B,0xF0
.db    0x7C,0xB5
.db    0xC8,0x5E
.db    0x23,0x56
.db    0x23,0x22
.db    0xB3,0xEF
.db    0x23,0x23
.db    0x22,0xB5
.db    0xEF,0x23
.db    0x23,0x22
.db    0xB7,0xEF
.db    0x23,0x23
.db    0xEB,0x22
.db    0xD0,0xEF
.db    0x21,0xB9
.db    0xEF,0x0E
.db    0x08,0xCD
.db    0x4F,0xE5
.db    0x2A,0xBB
.db    0xEF,0xEB
.db    0x21,0xC1
.db    0xEF,0x0E
.db    0x0F,0xCD
.db    0x4F,0xE5
.db    0x2A,0xC6
.db    0xEF,0x7C
.db    0x21,0xDD
.db    0xEF,0x36
.db    0xFF,0xB7
.db    0xCA,0x9D
.db    0xE5,0x36
.db    0x00,0x3E
.db    0xFF,0xB7
.db    0xC9,0xCD
.db    0x18,0xF0
.db    0xAF,0x2A
.db    0xB5,0xEF
.db    0x77,0x23
.db    0x77,0x2A
.db    0xB7,0xEF
.db    0x77,0x23
.db    0x77,0xC9
.db    0xCD,0x27
.db    0xF0,0xC3
.db    0xBB,0xE5
.db    0xCD,0x2A
.db    0xF0,0xB7
.db    0xC8,0x21
.db    0x09,0xE2
.db    0xC3,0x4A
.db    0xE5,0x2A
.db    0xEA,0xEF
.db    0x0E,0x02
.db    0xCD,0xEA
.db    0xE6,0x22
.db    0xE5,0xEF
.db    0x22,0xEC
.db    0xEF,0x21
.db    0xE5,0xEF
.db    0x4E,0x23
.db    0x46,0x2A
.db    0xB7,0xEF
.db    0x5E,0x23
.db    0x56,0x2A
.db    0xB5,0xEF
.db    0x7E,0x23
.db    0x66,0x6F
.db    0x79,0x93
.db    0x78,0x9A
.db    0xD2,0xFA
.db    0xE5,0xE5
.db    0x2A,0xC1
.db    0xEF,0x7B
.db    0x95,0x5F
.db    0x7A,0x9C
.db    0x57,0xE1
.db    0x2B,0xC3
.db    0xE4,0xE5
.db    0xE5,0x2A
.db    0xC1,0xEF
.db    0x19,0xDA
.db    0x0F,0xE6
.db    0x79,0x95
.db    0x78,0x9C
.db    0xDA,0x0F
.db    0xE6,0xEB
.db    0xE1,0x23
.db    0xC3,0xFA
.db    0xE5,0xE1
.db    0xC5,0xD5
.db    0xE5,0xEB
.db    0x2A,0xCE
.db    0xEF,0x19
.db    0x44,0x4D
.db    0xCD,0x1E
.db    0xF0,0xD1
.db    0x2A,0xB5
.db    0xEF,0x73
.db    0x23,0x72
.db    0xD1,0x2A
.db    0xB7,0xEF
.db    0x73,0x23
.db    0x72,0xC1
.db    0x79,0x93
.db    0x4F,0x78
.db    0x9A,0x47
.db    0x2A,0xD0
.db    0xEF,0xEB
.db    0xCD,0x30
.db    0xF0,0x4D
.db    0x44,0xC3
.db    0x21,0xF0
.db    0x21,0xC3
.db    0xEF,0x4E
.db    0x3A,0xE3
.db    0xEF,0xB7
.db    0x1F,0x0D
.db    0xC2,0x45
.db    0xE6,0x47
.db    0x3E,0x08
.db    0x96,0x4F
.db    0x3A,0xE2
.db    0xEF,0x0D
.db    0xCA,0x5C
.db    0xE6,0xB7
.db    0x17,0xC3
.db    0x53,0xE6
.db    0x80,0xC9
.db    0x2A,0x43
.db    0xE5,0x11
.db    0x10,0x00
.db    0x19,0x09
.db    0x3A,0xDD
.db    0xEF,0xB7
.db    0xCA,0x71
.db    0xE6,0x6E
.db    0x26,0x00
.db    0xC9,0x09
.db    0x5E,0x23
.db    0x56,0xEB
.db    0xC9,0xCD
.db    0x3E,0xE6
.db    0x4F,0x06
.db    0x00,0xCD
.db    0x5E,0xE6
.db    0x22,0xE5
.db    0xEF,0xC9
.db    0x2A,0xE5
.db    0xEF,0x7D
.db    0xB4,0xC9
.db    0x3A,0xC3
.db    0xEF,0x2A
.db    0xE5,0xEF
.db    0x29,0x3D
.db    0xC2,0x90
.db    0xE6,0x22
.db    0xE7,0xEF
.db    0x3A,0xC4
.db    0xEF,0x4F
.db    0x3A,0xE3
.db    0xEF,0xA1
.db    0xB5,0x6F
.db    0x22,0xE5
.db    0xEF,0xC9
.db    0x2A,0x43
.db    0xE5,0x11
.db    0x0C,0x00
.db    0x19,0xC9
.db    0x2A,0x43
.db    0xE5,0x11
.db    0x0F,0x00
.db    0x19,0xEB
.db    0x21,0x11
.db    0x00,0x19
.db    0xC9,0xCD
.db    0xAE,0xE6
.db    0x7E,0x32
.db    0xE3,0xEF
.db    0xEB,0x7E
.db    0x32,0xE1
.db    0xEF,0xCD
.db    0xA6,0xE6
.db    0x3A,0xC5
.db    0xEF,0xA6
.db    0x32,0xE2
.db    0xEF,0xC9
.db    0xCD,0xAE
.db    0xE6,0x3A
.db    0xD5,0xEF
.db    0xFE,0x02
.db    0xC2,0xDE
.db    0xE6,0xAF
.db    0x4F,0x3A
.db    0xE3,0xEF
.db    0x81,0x77
.db    0xEB,0x3A
.db    0xE1,0xEF
.db    0x77,0xC9
.db    0x0C,0x0D
.db    0xC8,0x7C
.db    0xB7,0x1F
.db    0x67,0x7D
.db    0x1F,0x6F
.db    0xC3,0xEB
.db    0xE6,0x0E
.db    0x80,0x2A
.db    0xB9,0xEF
.db    0xAF,0x86
.db    0x23,0x0D
.db    0xC2,0xFD
.db    0xE6,0xC9
.db    0x0C,0x0D
.db    0xC8,0x29
.db    0xC3,0x05
.db    0xE7,0xC5
.db    0x3A,0x42
.db    0xE5,0x4F
.db    0x21,0x01
.db    0x00,0xCD
.db    0x04,0xE7
.db    0xC1,0x79
.db    0xB5,0x6F
.db    0x78,0xB4
.db    0x67,0xC9
.db    0x2A,0xAD
.db    0xEF,0x3A
.db    0x42,0xE5
.db    0x4F,0xCD
.db    0xEA,0xE6
.db    0x7D,0xE6
.db    0x01,0xC9
.db    0x21,0xAD
.db    0xEF,0x4E
.db    0x23,0x46
.db    0xCD,0x0B
.db    0xE7,0x22
.db    0xAD,0xEF
.db    0x2A,0xC8
.db    0xEF,0x23
.db    0xEB,0x2A
.db    0xB3,0xEF
.db    0x73,0x23
.db    0x72,0xC9
.db    0xCD,0x5E
.db    0xE7,0x11
.db    0x09,0x00
.db    0x19,0x7E
.db    0x17,0xD0
.db    0x21,0x0F
.db    0xE2,0xC3
.db    0x4A,0xE5
.db    0xCD,0x1E
.db    0xE7,0xC8
.db    0x21,0x0D
.db    0xE2,0xC3
.db    0x4A,0xE5
.db    0x2A,0xB9
.db    0xEF,0x3A
.db    0xE9,0xEF
.db    0x85,0x6F
.db    0xD0,0x24
.db    0xC9,0x2A
.db    0x43,0xE5
.db    0x11,0x0E
.db    0x00,0x19
.db    0x7E,0xC9
.db    0xCD,0x69
.db    0xE7,0x36
.db    0x00,0xC9
.db    0xCD,0x69
.db    0xE7,0xF6
.db    0x80,0x77
.db    0xC9,0x2A
.db    0xEA,0xEF
.db    0xEB,0x2A
.db    0xB3,0xEF
.db    0x7B,0x96
.db    0x23,0x7A
.db    0x9E,0xC9
.db    0xCD,0x7F
.db    0xE7,0xD8
.db    0x13,0x72
.db    0x2B,0x73
.db    0xC9,0x7B
.db    0x95,0x6F
.db    0x7A,0x9C
.db    0x67,0xC9
.db    0x0E,0xFF
.db    0x2A,0xEC
.db    0xEF,0xEB
.db    0x2A,0xCC
.db    0xEF,0xCD
.db    0x95,0xE7
.db    0xD0,0xC5
.db    0xCD,0xF7
.db    0xE6,0x2A
.db    0xBD,0xEF
.db    0xEB,0x2A
.db    0xEC,0xEF
.db    0x19,0xC1
.db    0x0C,0xCA
.db    0xC4,0xE7
.db    0xBE,0xC8
.db    0xCD,0x7F
.db    0xE7,0xD0
.db    0xCD,0x2C
.db    0xE7,0xC9
.db    0x77,0xC9
.db    0xCD,0x9C
.db    0xE7,0xCD
.db    0xE0,0xE7
.db    0x0E,0x01
.db    0xCD,0xB8
.db    0xE5,0xC3
.db    0xDA,0xE7
.db    0xCD,0xE0
.db    0xE7,0xCD
.db    0xB2,0xE5
.db    0x21,0xB1
.db    0xEF,0xC3
.db    0xE3,0xE7
.db    0x21,0xB9
.db    0xEF,0x4E
.db    0x23,0x46
.db    0xC3,0x24
.db    0xF0,0x2A
.db    0xB9,0xEF
.db    0xEB,0x2A
.db    0xB1,0xEF
.db    0x0E,0x80
.db    0xC3,0x4F
.db    0xE5,0x21
.db    0xEA,0xEF
.db    0x7E,0x23
.db    0xBE,0xC0
.db    0x3C,0xC9
.db    0x21,0xFF
.db    0xFF,0x22
.db    0xEA,0xEF
.db    0xC9,0x2A
.db    0xC8,0xEF
.db    0xEB,0x2A
.db    0xEA,0xEF
.db    0x23,0x22
.db    0xEA,0xEF
.db    0xCD,0x95
.db    0xE7,0xD2
.db    0x19,0xE8
.db    0xC3,0xFE
.db    0xE7,0x3A
.db    0xEA,0xEF
.db    0xE6,0x03
.db    0x06,0x05
.db    0x87,0x05
.db    0xC2,0x20
.db    0xE8,0x32
.db    0xE9,0xEF
.db    0xB7,0xC0
.db    0xC5,0xCD
.db    0xC3,0xE5
.db    0xCD,0xD4
.db    0xE7,0xC1
.db    0xC3,0x9E
.db    0xE7,0x79
.db    0xE6,0x07
.db    0x3C,0x5F
.db    0x57,0x79
.db    0x0F,0x0F
.db    0x0F,0xE6
.db    0x1F,0x4F
.db    0x78,0x87
.db    0x87,0x87
.db    0x87,0x87
.db    0xB1,0x4F
.db    0x78,0x0F
.db    0x0F,0x0F
.db    0xE6,0x1F
.db    0x47,0x2A
.db    0xBF,0xEF
.db    0x09,0x7E
.db    0x07,0x1D
.db    0xC2,0x56
.db    0xE8,0xC9
.db    0xD5,0xCD
.db    0x35,0xE8
.db    0xE6,0xFE
.db    0xC1,0xB1
.db    0x0F,0x15
.db    0xC2,0x64
.db    0xE8,0x77
.db    0xC9,0xCD
.db    0x5E,0xE7
.db    0x11,0x10
.db    0x00,0x19
.db    0xC5,0x0E
.db    0x11,0xD1
.db    0x0D,0xC8
.db    0xD5,0x3A
.db    0xDD,0xEF
.db    0xB7,0xCA
.db    0x88,0xE8
.db    0xC5,0xE5
.db    0x4E,0x06
.db    0x00,0xC3
.db    0x8E,0xE8
.db    0x0D,0xC5
.db    0x4E,0x23
.db    0x46,0xE5
.db    0x79,0xB0
.db    0xCA,0x9D
.db    0xE8,0x2A
.db    0xC6,0xEF
.db    0x7D,0x91
.db    0x7C,0x98
.db    0xD4,0x5C
.db    0xE8,0xE1
.db    0x23,0xC1
.db    0xC3,0x75
.db    0xE8,0x2A
.db    0xC6,0xEF
.db    0x0E,0x03
.db    0xCD,0xEA
.db    0xE6,0x23
.db    0x44,0x4D
.db    0x2A,0xBF
.db    0xEF,0x36
.db    0x00,0x23
.db    0x0B,0x78
.db    0xB1,0xC2
.db    0xB1,0xE8
.db    0x2A,0xCA
.db    0xEF,0xEB
.db    0x2A,0xBF
.db    0xEF,0x73
.db    0x23,0x72
.db    0xCD,0xA1
.db    0xE5,0x2A
.db    0xB3,0xEF
.db    0x36,0x03
.db    0x23,0x36
.db    0x00,0xCD
.db    0xFE,0xE7
.db    0x0E,0xFF
.db    0xCD,0x05
.db    0xE8,0xCD
.db    0xF5,0xE7
.db    0xC8,0xCD
.db    0x5E,0xE7
.db    0x3E,0xE5
.db    0xBE,0xCA
.db    0xD2,0xE8
.db    0x3A,0x41
.db    0xE5,0xBE
.db    0xC2,0xF6
.db    0xE8,0x23
.db    0x7E,0xD6
.db    0x24,0xC2
.db    0xF6,0xE8
.db    0x3D,0x32
.db    0x45,0xE5
.db    0x0E,0x01
.db    0xCD,0x6B
.db    0xE8,0xCD
.db    0x8C,0xE7
.db    0xC3,0xD2
.db    0xE8,0x3A
.db    0xD4,0xEF
.db    0xC3,0x01
.db    0xE5,0xC5
.db    0xF5,0x3A
.db    0xC5,0xEF
.db    0x2F,0x47
.db    0x79,0xA0
.db    0x4F,0xF1
.db    0xA0,0x91
.db    0xE6,0x1F
.db    0xC1,0xC9
.db    0x3E,0xFF
.db    0x32,0xD4
.db    0xEF,0x21
.db    0xD8,0xEF
.db    0x71,0x2A
.db    0x43,0xE5
.db    0x22,0xD9
.db    0xEF,0xCD
.db    0xFE,0xE7
.db    0xCD,0xA1
.db    0xE5,0x0E
.db    0x00,0xCD
.db    0x05,0xE8
.db    0xCD,0xF5
.db    0xE7,0xCA
.db    0x94,0xE9
.db    0x2A,0xD9
.db    0xEF,0xEB
.db    0x1A,0xFE
.db    0xE5,0xCA
.db    0x4A,0xE9
.db    0xD5,0xCD
.db    0x7F,0xE7
.db    0xD1,0xD2
.db    0x94,0xE9
.db    0xCD,0x5E
.db    0xE7,0x3A
.db    0xD8,0xEF
.db    0x4F,0x06
.db    0x00,0x79
.db    0xB7,0xCA
.db    0x83,0xE9
.db    0x1A,0xFE
.db    0x3F,0xCA
.db    0x7C,0xE9
.db    0x78,0xFE
.db    0x0D,0xCA
.db    0x7C,0xE9
.db    0xFE,0x0C
.db    0x1A,0xCA
.db    0x73,0xE9
.db    0x96,0xE6
.db    0x7F,0xC2
.db    0x2D,0xE9
.db    0xC3,0x7C
.db    0xE9,0xC5
.db    0x4E,0xCD
.db    0x07,0xE9
.db    0xC1,0xC2
.db    0x2D,0xE9
.db    0x13,0x23
.db    0x04,0x0D
.db    0xC3,0x53
.db    0xE9,0x3A
.db    0xEA,0xEF
.db    0xE6,0x03
.db    0x32,0x45
.db    0xE5,0x21
.db    0xD4,0xEF
.db    0x7E,0x17
.db    0xD0,0xAF
.db    0x77,0xC9
.db    0xCD,0xFE
.db    0xE7,0x3E
.db    0xFF,0xC3
.db    0x01,0xE5
.db    0xCD,0x54
.db    0xE7,0x0E
.db    0x0C,0xCD
.db    0x18,0xE9
.db    0xCD,0xF5
.db    0xE7,0xC8
.db    0xCD,0x44
.db    0xE7,0xCD
.db    0x5E,0xE7
.db    0x36,0xE5
.db    0x0E,0x00
.db    0xCD,0x6B
.db    0xE8,0xCD
.db    0xC6,0xE7
.db    0xCD,0x2D
.db    0xE9,0xC3
.db    0xA4,0xE9
.db    0x50,0x59
.db    0x79,0xB0
.db    0xCA,0xD1
.db    0xE9,0x0B
.db    0xD5,0xC5
.db    0xCD,0x35
.db    0xE8,0x1F
.db    0xD2,0xEC
.db    0xE9,0xC1
.db    0xD1,0x2A
.db    0xC6,0xEF
.db    0x7B,0x95
.db    0x7A,0x9C
.db    0xD2,0xF4
.db    0xE9,0x13
.db    0xC5,0xD5
.db    0x42,0x4B
.db    0xCD,0x35
.db    0xE8,0x1F
.db    0xD2,0xEC
.db    0xE9,0xD1
.db    0xC1,0xC3
.db    0xC0,0xE9
.db    0x17,0x3C
.db    0xCD,0x64
.db    0xE8,0xE1
.db    0xD1,0xC9
.db    0x79,0xB0
.db    0xC2,0xC0
.db    0xE9,0x21
.db    0x00,0x00
.db    0xC9,0x0E
.db    0x00,0x1E
.db    0x20,0xD5
.db    0x06,0x00
.db    0x2A,0x43
.db    0xE5,0x09
.db    0xEB,0xCD
.db    0x5E,0xE7
.db    0xC1,0xCD
.db    0x4F,0xE5
.db    0xCD,0xC3
.db    0xE5,0xC3
.db    0xC6,0xE7
.db    0xCD,0x54
.db    0xE7,0x0E
.db    0x0C,0xCD
.db    0x18,0xE9
.db    0x2A,0x43
.db    0xE5,0x7E
.db    0x11,0x10
.db    0x00,0x19
.db    0x77,0xCD
.db    0xF5,0xE7
.db    0xC8,0xCD
.db    0x44,0xE7
.db    0x0E,0x10
.db    0x1E,0x0C
.db    0xCD,0x01
.db    0xEA,0xCD
.db    0x2D,0xE9
.db    0xC3,0x27
.db    0xEA,0x0E
.db    0x0C,0xCD
.db    0x18,0xE9
.db    0xCD,0xF5
.db    0xE7,0xC8
.db    0x0E,0x00
.db    0x1E,0x0C
.db    0xCD,0x01
.db    0xEA,0xCD
.db    0x2D,0xE9
.db    0xC3,0x40
.db    0xEA,0x0E
.db    0x0F,0xCD
.db    0x18,0xE9
.db    0xCD,0xF5
.db    0xE7,0xC8
.db    0xCD,0xA6
.db    0xE6,0x7E
.db    0xF5,0xE5
.db    0xCD,0x5E
.db    0xE7,0xEB
.db    0x2A,0x43
.db    0xE5,0x0E
.db    0x20,0xD5
.db    0xCD,0x4F
.db    0xE5,0xCD
.db    0x78,0xE7
.db    0xD1,0x21
.db    0x0C,0x00
.db    0x19,0x4E
.db    0x21,0x0F
.db    0x00,0x19
.db    0x46,0xE1
.db    0xF1,0x77
.db    0x79,0xBE
.db    0x78,0xCA
.db    0x8B,0xEA
.db    0x3E,0x00
.db    0xDA,0x8B
.db    0xEA,0x3E
.db    0x80,0x2A
.db    0x43,0xE5
.db    0x11,0x0F
.db    0x00,0x19
.db    0x77,0xC9
.db    0x7E,0x23
.db    0xB6,0x2B
.db    0xC0,0x1A
.db    0x77,0x13
.db    0x23,0x1A
.db    0x77,0x1B
.db    0x2B,0xC9
.db    0xAF,0x32
.db    0x45,0xE5
.db    0x32,0xEA
.db    0xEF,0x32
.db    0xEB,0xEF
.db    0xCD,0x1E
.db    0xE7,0xC0
.db    0xCD,0x69
.db    0xE7,0xE6
.db    0x80,0xC0
.db    0x0E,0x0F
.db    0xCD,0x18
.db    0xE9,0xCD
.db    0xF5,0xE7
.db    0xC8,0x01
.db    0x10,0x00
.db    0xCD,0x5E
.db    0xE7,0x09
.db    0xEB,0x2A
.db    0x43,0xE5
.db    0x09,0x0E
.db    0x10,0x3A
.db    0xDD,0xEF
.db    0xB7,0xCA
.db    0xE8,0xEA
.db    0x7E,0xB7
.db    0x1A,0xC2
.db    0xDB,0xEA
.db    0x77,0xB7
.db    0xC2,0xE1
.db    0xEA,0x7E
.db    0x12,0xBE
.db    0xC2,0x1F
.db    0xEB,0xC3
.db    0xFD,0xEA
.db    0xCD,0x94
.db    0xEA,0xEB
.db    0xCD,0x94
.db    0xEA,0xEB
.db    0x1A,0xBE
.db    0xC2,0x1F
.db    0xEB,0x13
.db    0x23,0x1A
.db    0xBE,0xC2
.db    0x1F,0xEB
.db    0x0D,0x13
.db    0x23,0x0D
.db    0xC2,0xCD
.db    0xEA,0x01
.db    0xEC,0xFF
.db    0x09,0xEB
.db    0x09,0x1A
.db    0xBE,0xDA
.db    0x17,0xEB
.db    0x77,0x01
.db    0x03,0x00
.db    0x09,0xEB
.db    0x09,0x7E
.db    0x12,0x3E
.db    0xFF,0x32
.db    0xD2,0xEF
.db    0xC3,0x10
.db    0xEA,0x21
.db    0x45,0xE5
.db    0x35,0xC9
.db    0xCD,0x54
.db    0xE7,0x2A
.db    0x43,0xE5
.db    0xE5,0x21
.db    0xAC,0xEF
.db    0x22,0x43
.db    0xE5,0x0E
.db    0x01,0xCD
.db    0x18,0xE9
.db    0xCD,0xF5
.db    0xE7,0xE1
.db    0x22,0x43
.db    0xE5,0xC8
.db    0xEB,0x21
.db    0x0F,0x00
.db    0x19,0x0E
.db    0x11,0xAF
.db    0x77,0x23
.db    0x0D,0xC2
.db    0x46,0xEB
.db    0x21,0x0D
.db    0x00,0x19
.db    0x77,0xCD
.db    0x8C,0xE7
.db    0xCD,0xFD
.db    0xE9,0xC3
.db    0x78,0xE7
.db    0xAF,0x32
.db    0xD2,0xEF
.db    0xCD,0xA2
.db    0xEA,0xCD
.db    0xF5,0xE7
.db    0xC8,0x2A
.db    0x43,0xE5
.db    0x01,0x0C
.db    0x00,0x09
.db    0x7E,0x3C
.db    0xE6,0x1F
.db    0x77,0xCA
.db    0x83,0xEB
.db    0x47,0x3A
.db    0xC5,0xEF
.db    0xA0,0x21
.db    0xD2,0xEF
.db    0xA6,0xCA
.db    0x8E,0xEB
.db    0xC3,0xAC
.db    0xEB,0x01
.db    0x02,0x00
.db    0x09,0x34
.db    0x7E,0xE6
.db    0x0F,0xCA
.db    0xB6,0xEB
.db    0x0E,0x0F
.db    0xCD,0x18
.db    0xE9,0xCD
.db    0xF5,0xE7
.db    0xC2,0xAC
.db    0xEB,0x3A
.db    0xD3,0xEF
.db    0x3C,0xCA
.db    0xB6,0xEB
.db    0xCD,0x24
.db    0xEB,0xCD
.db    0xF5,0xE7
.db    0xCA,0xB6
.db    0xEB,0xC3
.db    0xAF,0xEB
.db    0xCD,0x5A
.db    0xEA,0xCD
.db    0xBB,0xE6
.db    0xAF,0xC3
.db    0x01,0xE5
.db    0xCD,0x05
.db    0xE5,0xC3
.db    0x78,0xE7
.db    0x3E,0x01
.db    0x32,0xD5
.db    0xEF,0x3E
.db    0xFF,0x32
.db    0xD3,0xEF
.db    0xCD,0xBB
.db    0xE6,0x3A
.db    0xE3,0xEF
.db    0x21,0xE1
.db    0xEF,0xBE
.db    0xDA,0xE6
.db    0xEB,0xFE
.db    0x80,0xC2
.db    0xFB,0xEB
.db    0xCD,0x5A
.db    0xEB,0xAF
.db    0x32,0xE3
.db    0xEF,0x3A
.db    0x45,0xE5
.db    0xB7,0xC2
.db    0xFB,0xEB
.db    0xCD,0x77
.db    0xE6,0xCD
.db    0x84,0xE6
.db    0xCA,0xFB
.db    0xEB,0xCD
.db    0x8A,0xE6
.db    0xCD,0xD1
.db    0xE5,0xCD
.db    0xB2,0xE5
.db    0xC3,0xD2
.db    0xE6,0xC3
.db    0x05,0xE5
.db    0x3E,0x01
.db    0x32,0xD5
.db    0xEF,0x3E
.db    0x00,0x32
.db    0xD3,0xEF
.db    0xCD,0x54
.db    0xE7,0x2A
.db    0x43,0xE5
.db    0xCD,0x47
.db    0xE7,0xCD
.db    0xBB,0xE6
.db    0x3A,0xE3
.db    0xEF,0xFE
.db    0x80,0xD2
.db    0x05,0xE5
.db    0xCD,0x77
.db    0xE6,0xCD
.db    0x84,0xE6
.db    0x0E,0x00
.db    0xC2,0x6E
.db    0xEC,0xCD
.db    0x3E,0xE6
.db    0x32,0xD7
.db    0xEF,0x01
.db    0x00,0x00
.db    0xB7,0xCA
.db    0x3B,0xEC
.db    0x4F,0x0B
.db    0xCD,0x5E
.db    0xE6,0x44
.db    0x4D,0xCD
.db    0xBE,0xE9
.db    0x7D,0xB4
.db    0xC2,0x48
.db    0xEC,0x3E
.db    0x02,0xC3
.db    0x01,0xE5
.db    0x22,0xE5
.db    0xEF,0xEB
.db    0x2A,0x43
.db    0xE5,0x01
.db    0x10,0x00
.db    0x09,0x3A
.db    0xDD,0xEF
.db    0xB7,0x3A
.db    0xD7,0xEF
.db    0xCA,0x64
.db    0xEC,0xCD
.db    0x64,0xE7
.db    0x73,0xC3
.db    0x6C,0xEC
.db    0x4F,0x06
.db    0x00,0x09
.db    0x09,0x73
.db    0x23,0x72
.db    0x0E,0x02
.db    0x3A,0x45
.db    0xE5,0xB7
.db    0xC0,0xC5
.db    0xCD,0x8A
.db    0xE6,0x3A
.db    0xD5,0xEF
.db    0x3D,0x3D
.db    0xC2,0xBB
.db    0xEC,0xC1
.db    0xC5,0x79
.db    0x3D,0x3D
.db    0xC2,0xBB
.db    0xEC,0xE5
.db    0x2A,0xB9
.db    0xEF,0x57
.db    0x77,0x23
.db    0x14,0xF2
.db    0x8C,0xEC
.db    0xCD,0xE0
.db    0xE7,0x2A
.db    0xE7,0xEF
.db    0x0E,0x02
.db    0x22,0xE5
.db    0xEF,0xC5
.db    0xCD,0xD1
.db    0xE5,0xC1
.db    0xCD,0xB8
.db    0xE5,0x2A
.db    0xE5,0xEF
.db    0x0E,0x00
.db    0x3A,0xC4
.db    0xEF,0x47
.db    0xA5,0xB8
.db    0x23,0xC2
.db    0x9A,0xEC
.db    0xE1,0x22
.db    0xE5,0xEF
.db    0xCD,0xDA
.db    0xE7,0xCD
.db    0xD1,0xE5
.db    0xC1,0xC5
.db    0xCD,0xB8
.db    0xE5,0xC1
.db    0x3A,0xE3
.db    0xEF,0x21
.db    0xE1,0xEF
.db    0xBE,0xDA
.db    0xD2,0xEC
.db    0x77,0x34
.db    0x0E,0x02
.db    0x00,0x00
.db    0x21,0x00
.db    0xDA,0xF5
.db    0xCD,0x69
.db    0xE7,0xE6
.db    0x7F,0x77
.db    0xF1,0xFE
.db    0x7F,0xC2
.db    0x00,0xED
.db    0x3A,0xD5
.db    0xEF,0xFE
.db    0x01,0xC2
.db    0x00,0xED
.db    0xCD,0xD2
.db    0xE6,0xCD
.db    0x5A,0xEB
.db    0x21,0x45
.db    0xE5,0x7E
.db    0xB7,0xC2
.db    0xFE,0xEC
.db    0x3D,0x32
.db    0xE3,0xEF
.db    0x36,0x00
.db    0xC3,0xD2
.db    0xE6,0xAF
.db    0x32,0xD5
.db    0xEF,0xC5
.db    0x2A,0x43
.db    0xE5,0xEB
.db    0x21,0x21
.db    0x00,0x19
.db    0x7E,0xE6
.db    0x7F,0xF5
.db    0x7E,0x17
.db    0x23,0x7E
.db    0x17,0xE6
.db    0x1F,0x4F
.db    0x7E,0x1F
.db    0x1F,0x1F
.db    0x1F,0xE6
.db    0x0F,0x47
.db    0xF1,0x23
.db    0x6E,0x2C
.db    0x2D,0x2E
.db    0x06,0xC2
.db    0x8B,0xED
.db    0x21,0x20
.db    0x00,0x19
.db    0x77,0x21
.db    0x0C,0x00
.db    0x19,0x79
.db    0x96,0xC2
.db    0x47,0xED
.db    0x21,0x0E
.db    0x00,0x19
.db    0x78,0x96
.db    0xE6,0x7F
.db    0xCA,0x7F
.db    0xED,0xC5
.db    0xD5,0xCD
.db    0xA2,0xEA
.db    0xD1,0xC1
.db    0x2E,0x03
.db    0x3A,0x45
.db    0xE5,0x3C
.db    0xCA,0x84
.db    0xED,0x21
.db    0x0C,0x00
.db    0x19,0x71
.db    0x21,0x0E
.db    0x00,0x19
.db    0x70,0xCD
.db    0x51,0xEA
.db    0x3A,0x45
.db    0xE5,0x3C
.db    0xC2,0x7F
.db    0xED,0xC1
.db    0xC5,0x2E
.db    0x04,0x0C
.db    0xCA,0x84
.db    0xED,0xCD
.db    0x24,0xEB
.db    0x2E,0x05
.db    0x3A,0x45
.db    0xE5,0x3C
.db    0xCA,0x84
.db    0xED,0xC1
.db    0xAF,0xC3
.db    0x01,0xE5
.db    0xE5,0xCD
.db    0x69,0xE7
.db    0x36,0xC0
.db    0xE1,0xC1
.db    0x7D,0x32
.db    0x45,0xE5
.db    0xC3,0x78
.db    0xE7,0x0E
.db    0xFF,0xCD
.db    0x03,0xED
.db    0xCC,0xC1
.db    0xEB,0xC9
.db    0x0E,0x00
.db    0xCD,0x03
.db    0xED,0xCC
.db    0x03,0xEC
.db    0xC9,0xEB
.db    0x19,0x4E
.db    0x06,0x00
.db    0x21,0x0C
.db    0x00,0x19
.db    0x7E,0x0F
.db    0xE6,0x80
.db    0x81,0x4F
.db    0x3E,0x00
.db    0x88,0x47
.db    0x7E,0x0F
.db    0xE6,0x0F
.db    0x80,0x47
.db    0x21,0x0E
.db    0x00,0x19
.db    0x7E,0x87
.db    0x87,0x87
.db    0x87,0xF5
.db    0x80,0x47
.db    0xF5,0xE1
.db    0x7D,0xE1
.db    0xB5,0xE6
.db    0x01,0xC9
.db    0x0E,0x0C
.db    0xCD,0x18
.db    0xE9,0x2A
.db    0x43,0xE5
.db    0x11,0x21
.db    0x00,0x19
.db    0xE5,0x72
.db    0x23,0x72
.db    0x23,0x72
.db    0xCD,0xF5
.db    0xE7,0xCA
.db    0x0C,0xEE
.db    0xCD,0x5E
.db    0xE7,0x11
.db    0x0F,0x00
.db    0xCD,0xA5
.db    0xED,0xE1
.db    0xE5,0x5F
.db    0x79,0x96
.db    0x23,0x78
.db    0x9E,0x23
.db    0x7B,0x9E
.db    0xDA,0x06
.db    0xEE,0x73
.db    0x2B,0x70
.db    0x2B,0x71
.db    0xCD,0x2D
.db    0xE9,0xC3
.db    0xE4,0xED
.db    0xE1,0xC9
.db    0x2A,0x43
.db    0xE5,0x11
.db    0x20,0x00
.db    0xCD,0xA5
.db    0xED,0x21
.db    0x21,0x00
.db    0x19,0x71
.db    0x23,0x70
.db    0x23,0x77
.db    0xC9,0x2A
.db    0xAF,0xEF
.db    0x3A,0x42
.db    0xE5,0x4F
.db    0xCD,0xEA
.db    0xE6,0xE5
.db    0xEB,0xCD
.db    0x59,0xE5
.db    0xE1,0xCC
.db    0x47,0xE5
.db    0x7D,0x1F
.db    0xD8,0x2A
.db    0xAF,0xEF
.db    0x4D,0x44
.db    0xCD,0x0B
.db    0xE7,0x22
.db    0xAF,0xEF
.db    0xC3,0xA3
.db    0xE8,0x3A
.db    0xD6,0xEF
.db    0x21,0x42
.db    0xE5,0xBE
.db    0xC8,0x77
.db    0xC3,0x21
.db    0xEE,0x3E
.db    0xFF,0x32
.db    0xDE,0xEF
.db    0x2A,0x43
.db    0xE5,0x7E
.db    0xE6,0x1F
.db    0x3D,0x32
.db    0xD6,0xEF
.db    0xFE,0x1E
.db    0xD2,0x75
.db    0xEE,0x3A
.db    0x42,0xE5
.db    0x32,0xDF
.db    0xEF,0x7E
.db    0x32,0xE0
.db    0xEF,0xE6
.db    0xE0,0x77
.db    0xCD,0x45
.db    0xEE,0x3A
.db    0x41,0xE5
.db    0x2A,0x43
.db    0xE5,0xB6
.db    0x77,0xC9
.db    0x3E,0x22
.db    0xC3,0x01
.db    0xE5,0x21
.db    0x00,0x00
.db    0x22,0xAD
.db    0xEF,0x22
.db    0xAF,0xEF
.db    0xAF,0x32
.db    0x42,0xE5
.db    0x21,0x80
.db    0x00,0x22
.db    0xB1,0xEF
.db    0xCD,0xDA
.db    0xE7,0xC3
.db    0x21,0xEE
.db    0xCD,0x72
.db    0xE7,0xCD
.db    0x51,0xEE
.db    0xC3,0x51
.db    0xEA,0xCD
.db    0x51,0xEE
.db    0xC3,0xA2
.db    0xEA,0x0E
.db    0x00,0xEB
.db    0x7E,0xFE
.db    0x3F,0xCA
.db    0xC2,0xEE
.db    0xCD,0xA6
.db    0xE6,0x7E
.db    0xFE,0x3F
.db    0xC4,0x72
.db    0xE7,0xCD
.db    0x51,0xEE
.db    0x0E,0x0F
.db    0xCD,0x18
.db    0xE9,0xC3
.db    0xE9,0xE7
.db    0x2A,0xD9
.db    0xEF,0x22
.db    0x43,0xE5
.db    0xCD,0x51
.db    0xEE,0xCD
.db    0x2D,0xE9
.db    0xC3,0xE9
.db    0xE7,0xCD
.db    0x51,0xEE
.db    0xCD,0x9C
.db    0xE9,0xC3
.db    0x01,0xE9
.db    0xCD,0x51
.db    0xEE,0xC3
.db    0xBC,0xEB
.db    0xCD,0x51
.db    0xEE,0xC3
.db    0xFE,0xEB
.db    0xCD,0x72
.db    0xE7,0xCD
.db    0x51,0xEE
.db    0xC3,0x24
.db    0xEB,0xCD
.db    0x51,0xEE
.db    0xCD,0x16
.db    0xEA,0xC3
.db    0x01,0xE9
.db    0x2A,0xAF
.db    0xEF,0xC3
.db    0x29,0xEF
.db    0x3A,0x42
.db    0xE5,0xC3
.db    0x01,0xE5
.db    0xEB,0x22
.db    0xB1,0xEF
.db    0xC3,0xDA
.db    0xE7,0x2A
.db    0xBF,0xEF
.db    0xC3,0x29
.db    0xEF,0x2A
.db    0xAD,0xEF
.db    0xC3,0x29
.db    0xEF,0xCD
.db    0x51,0xEE
.db    0xCD,0x3B
.db    0xEA,0xC3
.db    0x01,0xE9
.db    0x2A,0xBB
.db    0xEF,0x22
.db    0x45,0xE5
.db    0xC9,0x3A
.db    0xD6,0xEF
.db    0xFE,0xFF
.db    0xC2,0x3B
.db    0xEF,0x3A
.db    0x41,0xE5
.db    0xC3,0x01
.db    0xE5,0xE6
.db    0x1F,0x32
.db    0x41,0xE5
.db    0xC9,0xCD
.db    0x51,0xEE
.db    0xC3,0x93
.db    0xED,0xCD
.db    0x51,0xEE
.db    0xC3,0x9C
.db    0xED,0xCD
.db    0x51,0xEE
.db    0xC3,0xD2
.db    0xED,0x2A
.db    0x43,0xE5
.db    0x7D,0x2F
.db    0x5F,0x7C
.db    0x2F,0x2A
.db    0xAF,0xEF
.db    0xA4,0x57
.db    0x7D,0xA3
.db    0x5F,0x2A
.db    0xAD,0xEF
.db    0xEB,0x22
.db    0xAF,0xEF
.db    0x7D,0xA3
.db    0x6F,0x7C
.db    0xA2,0x67
.db    0x22,0xAD
.db    0xEF,0xC9
.db    0x3A,0xDE
.db    0xEF,0xB7
.db    0xCA,0x91
.db    0xEF,0x2A
.db    0x43,0xE5
.db    0x36,0x00
.db    0x3A,0xE0
.db    0xEF,0xB7
.db    0xCA,0x91
.db    0xEF,0x77
.db    0x3A,0xDF
.db    0xEF,0x32
.db    0xD6,0xEF
.db    0xCD,0x45
.db    0xEE,0x2A
.db    0x0F,0xE5
.db    0xF9,0x2A
.db    0x45,0xE5
.db    0x7D,0x44
.db    0xC9,0xCD
.db    0x51,0xEE
.db    0x3E,0x02
.db    0x32,0xD5
.db    0xEF,0x0E
.db    0x00,0xCD
.db    0x07,0xED
.db    0xCC,0x03
.db    0xEC,0xC9
.db    0xE5,0x00
.db    0x00,0x00
.db    0x00,0x80
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
 
CCP_ARR:
.db    0xC3,0x5C
.db    0xDD,0xC3
.db    0x58,0xDD
.db    0x7F,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x20,0x20
.db    0x43,0x4F
.db    0x50,0x59
.db    0x52,0x49
.db    0x47,0x48
.db    0x54,0x20
.db    0x28,0x43
.db    0x29,0x20
.db    0x31,0x39
.db    0x37,0x39
.db    0x2C,0x20
.db    0x44,0x49
.db    0x47,0x49
.db    0x54,0x41
.db    0x4C,0x20
.db    0x52,0x45
.db    0x53,0x45
.db    0x41,0x52
.db    0x43,0x48
.db    0x20,0x20
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x08,0xDA
.db    0x08,0xDA
.db    0x5F,0x0E
.db    0x02,0xC3
.db    0x05,0x00
.db    0xC5,0xCD
.db    0x8C,0xDA
.db    0xC1,0xC9
.db    0x3E,0x0D
.db    0xCD,0x92
.db    0xDA,0x3E
.db    0x0A,0xC3
.db    0x92,0xDA
.db    0x3E,0x20
.db    0xC3,0x92
.db    0xDA,0xC5
.db    0xCD,0x98
.db    0xDA,0xE1
.db    0x7E,0xB7
.db    0xC8,0x23
.db    0xE5,0xCD
.db    0x8C,0xDA
.db    0xE1,0xC3
.db    0xAC,0xDA
.db    0x0E,0x0D
.db    0xC3,0x05
.db    0x00,0x5F
.db    0x0E,0x0E
.db    0xC3,0x05
.db    0x00,0xCD
.db    0x05,0x00
.db    0x32,0xEE
.db    0xE1,0x3C
.db    0xC9,0x0E
.db    0x0F,0xC3
.db    0xC3,0xDA
.db    0xAF,0x32
.db    0xED,0xE1
.db    0x11,0xCD
.db    0xE1,0xC3
.db    0xCB,0xDA
.db    0x0E,0x10
.db    0xC3,0xC3
.db    0xDA,0x0E
.db    0x11,0xC3
.db    0xC3,0xDA
.db    0x0E,0x12
.db    0xC3,0xC3
.db    0xDA,0x11
.db    0xCD,0xE1
.db    0xC3,0xDF
.db    0xDA,0x0E
.db    0x13,0xC3
.db    0x05,0x00
.db    0xCD,0x05
.db    0x00,0xB7
.db    0xC9,0x0E
.db    0x14,0xC3
.db    0xF4,0xDA
.db    0x11,0xCD
.db    0xE1,0xC3
.db    0xF9,0xDA
.db    0x0E,0x15
.db    0xC3,0xF4
.db    0xDA,0x0E
.db    0x16,0xC3
.db    0xC3,0xDA
.db    0x0E,0x17
.db    0xC3,0x05
.db    0x00,0x1E
.db    0xFF,0x0E
.db    0x20,0xC3
.db    0x05,0x00
.db    0xCD,0x13
.db    0xDB,0x87
.db    0x87,0x87
.db    0x87,0x21
.db    0xEF,0xE1
.db    0xB6,0x32
.db    0x04,0x00
.db    0xC9,0x3A
.db    0xEF,0xE1
.db    0x32,0x04
.db    0x00,0xC9
.db    0xFE,0x61
.db    0xD8,0xFE
.db    0x7B,0xD0
.db    0xE6,0x5F
.db    0xC9,0x3A
.db    0xAB,0xE1
.db    0xB7,0xCA
.db    0x96,0xDB
.db    0x3A,0xEF
.db    0xE1,0xB7
.db    0x3E,0x00
.db    0xC4,0xBD
.db    0xDA,0x11
.db    0xAC,0xE1
.db    0xCD,0xCB
.db    0xDA,0xCA
.db    0x96,0xDB
.db    0x3A,0xBB
.db    0xE1,0x3D
.db    0x32,0xCC
.db    0xE1,0x11
.db    0xAC,0xE1
.db    0xCD,0xF9
.db    0xDA,0xC2
.db    0x96,0xDB
.db    0x11,0x07
.db    0xDA,0x21
.db    0x80,0x00
.db    0x06,0x80
.db    0xCD,0x42
.db    0xDE,0x21
.db    0xBA,0xE1
.db    0x36,0x00
.db    0x23,0x35
.db    0x11,0xAC
.db    0xE1,0xCD
.db    0xDA,0xDA
.db    0xCA,0x96
.db    0xDB,0x3A
.db    0xEF,0xE1
.db    0xB7,0xC4
.db    0xBD,0xDA
.db    0x21,0x08
.db    0xDA,0xCD
.db    0xAC,0xDA
.db    0xCD,0xC2
.db    0xDB,0xCA
.db    0xA7,0xDB
.db    0xCD,0xDD
.db    0xDB,0xC3
.db    0x82,0xDD
.db    0xCD,0xDD
.db    0xDB,0xCD
.db    0x1A,0xDB
.db    0x0E,0x0A
.db    0x11,0x06
.db    0xDA,0xCD
.db    0x05,0x00
.db    0xCD,0x29
.db    0xDB,0x21
.db    0x07,0xDA
.db    0x46,0x23
.db    0x78,0xB7
.db    0xCA,0xBA
.db    0xDB,0x7E
.db    0xCD,0x30
.db    0xDB,0x77
.db    0x05,0xC3
.db    0xAB,0xDB
.db    0x77,0x21
.db    0x08,0xDA
.db    0x22,0x88
.db    0xDA,0xC9
.db    0x0E,0x0B
.db    0xCD,0x05
.db    0x00,0xB7
.db    0xC8,0x0E
.db    0x01,0xCD
.db    0x05,0x00
.db    0xB7,0xC9
.db    0x0E,0x19
.db    0xC3,0x05
.db    0x00,0x11
.db    0x80,0x00
.db    0x0E,0x1A
.db    0xC3,0x05
.db    0x00,0x21
.db    0xAB,0xE1
.db    0x7E,0xB7
.db    0xC8,0x36
.db    0x00,0xAF
.db    0xCD,0xBD
.db    0xDA,0x11
.db    0xAC,0xE1
.db    0xCD,0xEF
.db    0xDA,0x3A
.db    0xEF,0xE1
.db    0xC3,0xBD
.db    0xDA,0x11
.db    0x28,0xDD
.db    0x21,0x00
.db    0xE2,0x06
.db    0x06,0x1A
.db    0xBE,0xC2
.db    0xCF,0xDD
.db    0x13,0x23
.db    0x05,0xC2
.db    0xFD,0xDB
.db    0xC9,0xCD
.db    0x98,0xDA
.db    0x2A,0x8A
.db    0xDA,0x7E
.db    0xFE,0x20
.db    0xCA,0x22
.db    0xDC,0xB7
.db    0xCA,0x22
.db    0xDC,0xE5
.db    0xCD,0x8C
.db    0xDA,0xE1
.db    0x23,0xC3
.db    0x0F,0xDC
.db    0x3E,0x3F
.db    0xCD,0x8C
.db    0xDA,0xCD
.db    0x98,0xDA
.db    0xCD,0xDD
.db    0xDB,0xC3
.db    0x82,0xDD
.db    0x1A,0xB7
.db    0xC8,0xFE
.db    0x20,0xDA
.db    0x09,0xDC
.db    0xC8,0xFE
.db    0x3D,0xC8
.db    0xFE,0x5F
.db    0xC8,0xFE
.db    0x2E,0xC8
.db    0xFE,0x3A
.db    0xC8,0xFE
.db    0x3B,0xC8
.db    0xFE,0x3C
.db    0xC8,0xFE
.db    0x3E,0xC8
.db    0xC9,0x1A
.db    0xB7,0xC8
.db    0xFE,0x20
.db    0xC0,0x13
.db    0xC3,0x4F
.db    0xDC,0x85
.db    0x6F,0xD0
.db    0x24,0xC9
.db    0x3E,0x00
.db    0x21,0xCD
.db    0xE1,0xCD
.db    0x59,0xDC
.db    0xE5,0xE5
.db    0xAF,0x32
.db    0xF0,0xE1
.db    0x2A,0x88
.db    0xDA,0xEB
.db    0xCD,0x4F
.db    0xDC,0xEB
.db    0x22,0x8A
.db    0xDA,0xEB
.db    0xE1,0x1A
.db    0xB7,0xCA
.db    0x89,0xDC
.db    0xDE,0x40
.db    0x47,0x13
.db    0x1A,0xFE
.db    0x3A,0xCA
.db    0x90,0xDC
.db    0x1B,0x3A
.db    0xEF,0xE1
.db    0x77,0xC3
.db    0x96,0xDC
.db    0x78,0x32
.db    0xF0,0xE1
.db    0x70,0x13
.db    0x06,0x08
.db    0xCD,0x30
.db    0xDC,0xCA
.db    0xB9,0xDC
.db    0x23,0xFE
.db    0x2A,0xC2
.db    0xA9,0xDC
.db    0x36,0x3F
.db    0xC3,0xAB
.db    0xDC,0x77
.db    0x13,0x05
.db    0xC2,0x98
.db    0xDC,0xCD
.db    0x30,0xDC
.db    0xCA,0xC0
.db    0xDC,0x13
.db    0xC3,0xAF
.db    0xDC,0x23
.db    0x36,0x20
.db    0x05,0xC2
.db    0xB9,0xDC
.db    0x06,0x03
.db    0xFE,0x2E
.db    0xC2,0xE9
.db    0xDC,0x13
.db    0xCD,0x30
.db    0xDC,0xCA
.db    0xE9,0xDC
.db    0x23,0xFE
.db    0x2A,0xC2
.db    0xD9,0xDC
.db    0x36,0x3F
.db    0xC3,0xDB
.db    0xDC,0x77
.db    0x13,0x05
.db    0xC2,0xC8
.db    0xDC,0xCD
.db    0x30,0xDC
.db    0xCA,0xF0
.db    0xDC,0x13
.db    0xC3,0xDF
.db    0xDC,0x23
.db    0x36,0x20
.db    0x05,0xC2
.db    0xE9,0xDC
.db    0x06,0x03
.db    0x23,0x36
.db    0x00,0x05
.db    0xC2,0xF2
.db    0xDC,0xEB
.db    0x22,0x88
.db    0xDA,0xE1
.db    0x01,0x0B
.db    0x00,0x23
.db    0x7E,0xFE
.db    0x3F,0xC2
.db    0x09,0xDD
.db    0x04,0x0D
.db    0xC2,0x01
.db    0xDD,0x78
.db    0xB7,0xC9
.db    0x44,0x49
.db    0x52,0x20
.db    0x45,0x52
.db    0x41,0x20
.db    0x54,0x59
.db    0x50,0x45
.db    0x53,0x41
.db    0x56,0x45
.db    0x52,0x45
.db    0x4E,0x20
.db    0x55,0x53
.db    0x45,0x52
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x21,0x10
.db    0xDD,0x0E
.db    0x00,0x79
.db    0xFE,0x06
.db    0xD0,0x11
.db    0xCE,0xE1
.db    0x06,0x04
.db    0x1A,0xBE
.db    0xC2,0x4F
.db    0xDD,0x13
.db    0x23,0x05
.db    0xC2,0x3C
.db    0xDD,0x1A
.db    0xFE,0x20
.db    0xC2,0x54
.db    0xDD,0x79
.db    0xC9,0x23
.db    0x05,0xC2
.db    0x4F,0xDD
.db    0x0C,0xC3
.db    0x33,0xDD
.db    0xAF,0x32
.db    0x07,0xDA
.db    0x31,0xAB
.db    0xE1,0xC5
.db    0x79,0x1F
.db    0x1F,0x1F
.db    0x1F,0xE6
.db    0x0F,0x5F
.db    0xCD,0x15
.db    0xDB,0xCD
.db    0xB8,0xDA
.db    0x32,0xAB
.db    0xE1,0xC1
.db    0x79,0xE6
.db    0x0F,0x32
.db    0xEF,0xE1
.db    0xCD,0xBD
.db    0xDA,0x3A
.db    0x07,0xDA
.db    0xB7,0xC2
.db    0x98,0xDD
.db    0x31,0xAB
.db    0xE1,0xCD
.db    0x98,0xDA
.db    0xCD,0xD0
.db    0xDB,0xC6
.db    0x41,0xCD
.db    0x8C,0xDA
.db    0x3E,0x3E
.db    0xCD,0x8C
.db    0xDA,0xCD
.db    0x39,0xDB
.db    0x11,0x80
.db    0x00,0xCD
.db    0xD8,0xDB
.db    0xCD,0xD0
.db    0xDB,0x32
.db    0xEF,0xE1
.db    0xCD,0x5E
.db    0xDC,0xC4
.db    0x09,0xDC
.db    0x3A,0xF0
.db    0xE1,0xB7
.db    0xC2,0xA5
.db    0xE0,0xCD
.db    0x2E,0xDD
.db    0x21,0xC1
.db    0xDD,0x5F
.db    0x16,0x00
.db    0x19,0x19
.db    0x7E,0x23
.db    0x66,0x6F
.db    0xE9,0x77
.db    0xDE,0x1F
.db    0xDF,0x5D
.db    0xDF,0xAD
.db    0xDF,0x10
.db    0xE0,0x8E
.db    0xE0,0xA5
.db    0xE0,0x3E
.db    0x43,0xCD
.db    0x8C,0xDA
.db    0x3E,0x58
.db    0x00,0x18
.db    0xF8,0x01
.db    0xDF,0xDD
.db    0xC3,0xA7
.db    0xDA,0x52
.db    0x45,0x41
.db    0x44,0x20
.db    0x45,0x52
.db    0x52,0x4F
.db    0x52,0x00
.db    0x01,0xF0
.db    0xDD,0xC3
.db    0xA7,0xDA
.db    0x4E,0x4F
.db    0x20,0x46
.db    0x49,0x4C
.db    0x45,0x00
.db    0xCD,0x5E
.db    0xDC,0x3A
.db    0xF0,0xE1
.db    0xB7,0xC2
.db    0x09,0xDC
.db    0x21,0xCE
.db    0xE1,0x01
.db    0x0B,0x00
.db    0x7E,0xFE
.db    0x20,0xCA
.db    0x33,0xDE
.db    0x23,0xD6
.db    0x30,0xFE
.db    0x0A,0xD2
.db    0x09,0xDC
.db    0x57,0x78
.db    0xE6,0xE0
.db    0xC2,0x09
.db    0xDC,0x78
.db    0x07,0x07
.db    0x07,0x80
.db    0xDA,0x09
.db    0xDC,0x80
.db    0xDA,0x09
.db    0xDC,0x82
.db    0xDA,0x09
.db    0xDC,0x47
.db    0x0D,0xC2
.db    0x08,0xDE
.db    0xC9,0x7E
.db    0xFE,0x20
.db    0xC2,0x09
.db    0xDC,0x23
.db    0x0D,0xC2
.db    0x33,0xDE
.db    0x78,0xC9
.db    0x06,0x03
.db    0x7E,0x12
.db    0x23,0x13
.db    0x05,0xC2
.db    0x42,0xDE
.db    0xC9,0x21
.db    0x80,0x00
.db    0x81,0xCD
.db    0x59,0xDC
.db    0x7E,0xC9
.db    0xAF,0x32
.db    0xCD,0xE1
.db    0x3A,0xF0
.db    0xE1,0xB7
.db    0xC8,0x3D
.db    0x21,0xEF
.db    0xE1,0xBE
.db    0xC8,0xC3
.db    0xBD,0xDA
.db    0x3A,0xF0
.db    0xE1,0xB7
.db    0xC8,0x3D
.db    0x21,0xEF
.db    0xE1,0xBE
.db    0xC8,0x3A
.db    0xEF,0xE1
.db    0xC3,0xBD
.db    0xDA,0xCD
.db    0x5E,0xDC
.db    0xCD,0x54
.db    0xDE,0x21
.db    0xCE,0xE1
.db    0x7E,0xFE
.db    0x20,0xC2
.db    0x8F,0xDE
.db    0x06,0x0B
.db    0x36,0x3F
.db    0x23,0x05
.db    0xC2,0x88
.db    0xDE,0x1E
.db    0x00,0xD5
.db    0xCD,0xE9
.db    0xDA,0xCC
.db    0xEA,0xDD
.db    0xCA,0x1B
.db    0xDF,0x3A
.db    0xEE,0xE1
.db    0x0F,0x0F
.db    0x0F,0xE6
.db    0x60,0x4F
.db    0x3E,0x0A
.db    0xCD,0x4B
.db    0xDE,0x17
.db    0xDA,0x0F
.db    0xDF,0xD1
.db    0x7B,0x1C
.db    0xD5,0xE6
.db    0x03,0xF5
.db    0xC2,0xCC
.db    0xDE,0xCD
.db    0x98,0xDA
.db    0xC5,0xCD
.db    0xD0,0xDB
.db    0xC1,0xC6
.db    0x41,0xCD
.db    0x92,0xDA
.db    0x3E,0x3A
.db    0xCD,0x92
.db    0xDA,0xC3
.db    0xD4,0xDE
.db    0xCD,0xA2
.db    0xDA,0x3E
.db    0x3A,0xCD
.db    0x92,0xDA
.db    0xCD,0xA2
.db    0xDA,0x06
.db    0x01,0x78
.db    0xCD,0x4B
.db    0xDE,0xE6
.db    0x7F,0xFE
.db    0x20,0xC2
.db    0xF9,0xDE
.db    0xF1,0xF5
.db    0xFE,0x03
.db    0xC2,0xF7
.db    0xDE,0x3E
.db    0x09,0xCD
.db    0x4B,0xDE
.db    0xE6,0x7F
.db    0xFE,0x20
.db    0xCA,0x0E
.db    0xDF,0x3E
.db    0x20,0xCD
.db    0x92,0xDA
.db    0x04,0x78
.db    0xFE,0x0C
.db    0xD2,0x0E
.db    0xDF,0xFE
.db    0x09,0xC2
.db    0xD9,0xDE
.db    0xCD,0xA2
.db    0xDA,0xC3
.db    0xD9,0xDE
.db    0xF1,0xCD
.db    0xC2,0xDB
.db    0xC2,0x1B
.db    0xDF,0xCD
.db    0xE4,0xDA
.db    0xC3,0x98
.db    0xDE,0xD1
.db    0xC3,0x86
.db    0xE1,0xCD
.db    0x5E,0xDC
.db    0xFE,0x0B
.db    0xC2,0x42
.db    0xDF,0x01
.db    0x52,0xDF
.db    0xCD,0xA7
.db    0xDA,0xCD
.db    0x39,0xDB
.db    0x21,0x07
.db    0xDA,0x35
.db    0xC2,0x82
.db    0xDD,0x23
.db    0x7E,0xFE
.db    0x59,0xC2
.db    0x82,0xDD
.db    0x23,0x22
.db    0x88,0xDA
.db    0xCD,0x54
.db    0xDE,0x11
.db    0xCD,0xE1
.db    0xCD,0xEF
.db    0xDA,0x3C
.db    0xCC,0xEA
.db    0xDD,0xC3
.db    0x86,0xE1
.db    0x41,0x4C
.db    0x4C,0x20
.db    0x28,0x59
.db    0x2F,0x4E
.db    0x29,0x3F
.db    0x00,0xCD
.db    0x5E,0xDC
.db    0xC2,0x09
.db    0xDC,0xCD
.db    0x54,0xDE
.db    0xCD,0xD0
.db    0xDA,0xCA
.db    0xA7,0xDF
.db    0xCD,0x98
.db    0xDA,0x21
.db    0xF1,0xE1
.db    0x36,0xFF
.db    0x21,0xF1
.db    0xE1,0x7E
.db    0xFE,0x80
.db    0xDA,0x87
.db    0xDF,0xE5
.db    0xCD,0xFE
.db    0xDA,0xE1
.db    0xC2,0xA0
.db    0xDF,0xAF
.db    0x77,0x34
.db    0x21,0x80
.db    0x00,0xCD
.db    0x59,0xDC
.db    0x7E,0xFE
.db    0x1A,0xCA
.db    0x86,0xE1
.db    0xCD,0x8C
.db    0xDA,0xCD
.db    0xC2,0xDB
.db    0xC2,0x86
.db    0xE1,0xC3
.db    0x74,0xDF
.db    0x3D,0xCA
.db    0x86,0xE1
.db    0xCD,0xD9
.db    0xDD,0xCD
.db    0x66,0xDE
.db    0xC3,0x09
.db    0xDC,0xCD
.db    0xF8,0xDD
.db    0xF5,0xCD
.db    0x5E,0xDC
.db    0xC2,0x09
.db    0xDC,0xCD
.db    0x54,0xDE
.db    0x11,0xCD
.db    0xE1,0xD5
.db    0xCD,0xEF
.db    0xDA,0xD1
.db    0xCD,0x09
.db    0xDB,0xCA
.db    0xFB,0xDF
.db    0xAF,0x32
.db    0xED,0xE1
.db    0xF1,0x6F
.db    0x26,0x00
.db    0x29,0x11
.db    0x00,0x01
.db    0x7C,0xB5
.db    0xCA,0xF1
.db    0xDF,0x2B
.db    0xE5,0x21
.db    0x80,0x00
.db    0x19,0xE5
.db    0xCD,0xD8
.db    0xDB,0x11
.db    0xCD,0xE1
.db    0xCD,0x04
.db    0xDB,0xD1
.db    0xE1,0xC2
.db    0xFB,0xDF
.db    0xC3,0xD4
.db    0xDF,0x11
.db    0xCD,0xE1
.db    0xCD,0xDA
.db    0xDA,0x3C
.db    0xC2,0x01
.db    0xE0,0x01
.db    0x07,0xE0
.db    0xCD,0xA7
.db    0xDA,0xCD
.db    0xD5,0xDB
.db    0xC3,0x86
.db    0xE1,0x4E
.db    0x4F,0x20
.db    0x53,0x50
.db    0x41,0x43
.db    0x45,0x00
.db    0xCD,0x5E
.db    0xDC,0xC2
.db    0x09,0xDC
.db    0x3A,0xF0
.db    0xE1,0xF5
.db    0xCD,0x54
.db    0xDE,0xCD
.db    0xE9,0xDA
.db    0xC2,0x79
.db    0xE0,0x21
.db    0xCD,0xE1
.db    0x11,0xDD
.db    0xE1,0x06
.db    0x10,0xCD
.db    0x42,0xDE
.db    0x2A,0x88
.db    0xDA,0xEB
.db    0xCD,0x4F
.db    0xDC,0xFE
.db    0x3D,0xCA
.db    0x3F,0xE0
.db    0xFE,0x5F
.db    0xC2,0x73
.db    0xE0,0xEB
.db    0x23,0x22
.db    0x88,0xDA
.db    0xCD,0x5E
.db    0xDC,0xC2
.db    0x73,0xE0
.db    0xF1,0x47
.db    0x21,0xF0
.db    0xE1,0x7E
.db    0xB7,0xCA
.db    0x59,0xE0
.db    0xB8,0x70
.db    0xC2,0x73
.db    0xE0,0x70
.db    0xAF,0x32
.db    0xCD,0xE1
.db    0xCD,0xE9
.db    0xDA,0xCA
.db    0x6D,0xE0
.db    0x11,0xCD
.db    0xE1,0xCD
.db    0x0E,0xDB
.db    0xC3,0x86
.db    0xE1,0xCD
.db    0xEA,0xDD
.db    0xC3,0x86
.db    0xE1,0xCD
.db    0x66,0xDE
.db    0xC3,0x09
.db    0xDC,0x01
.db    0x82,0xE0
.db    0xCD,0xA7
.db    0xDA,0xC3
.db    0x86,0xE1
.db    0x46,0x49
.db    0x4C,0x45
.db    0x20,0x45
.db    0x58,0x49
.db    0x53,0x54
.db    0x53,0x00
.db    0xCD,0xF8
.db    0xDD,0xFE
.db    0x10,0xD2
.db    0x09,0xDC
.db    0x5F,0x3A
.db    0xCE,0xE1
.db    0xFE,0x20
.db    0xCA,0x09
.db    0xDC,0xCD
.db    0x15,0xDB
.db    0xC3,0x89
.db    0xE1,0xCD
.db    0xF5,0xDB
.db    0x3A,0xCE
.db    0xE1,0xFE
.db    0x20,0xC2
.db    0xC4,0xE0
.db    0x3A,0xF0
.db    0xE1,0xB7
.db    0xCA,0x89
.db    0xE1,0x3D
.db    0x32,0xEF
.db    0xE1,0xCD
.db    0x29,0xDB
.db    0xCD,0xBD
.db    0xDA,0xC3
.db    0x89,0xE1
.db    0x11,0xD6
.db    0xE1,0x1A
.db    0xFE,0x20
.db    0xC2,0x09
.db    0xDC,0xD5
.db    0xCD,0x54
.db    0xDE,0xD1
.db    0x21,0x83
.db    0xE1,0xCD
.db    0x40,0xDE
.db    0xCD,0xD0
.db    0xDA,0xCA
.db    0x6B,0xE1
.db    0x21,0x00
.db    0x01,0xE5
.db    0xEB,0xCD
.db    0xD8,0xDB
.db    0x11,0xCD
.db    0xE1,0xCD
.db    0xF9,0xDA
.db    0xC2,0x01
.db    0xE1,0xE1
.db    0x11,0x80
.db    0x00,0x19
.db    0x11,0x00
.db    0xDA,0x7D
.db    0x93,0x7C
.db    0x9A,0xD2
.db    0x71,0xE1
.db    0xC3,0xE1
.db    0xE0,0xE1
.db    0x3D,0xC2
.db    0x71,0xE1
.db    0xCD,0x66
.db    0xDE,0xCD
.db    0x5E,0xDC
.db    0x21,0xF0
.db    0xE1,0xE5
.db    0x7E,0x32
.db    0xCD,0xE1
.db    0x3E,0x10
.db    0xCD,0x60
.db    0xDC,0xE1
.db    0x7E,0x32
.db    0xDD,0xE1
.db    0xAF,0x32
.db    0xED,0xE1
.db    0x11,0x5C
.db    0x00,0x21
.db    0xCD,0xE1
.db    0x06,0x21
.db    0xCD,0x42
.db    0xDE,0x21
.db    0x08,0xDA
.db    0x7E,0xB7
.db    0xCA,0x3E
.db    0xE1,0xFE
.db    0x20,0xCA
.db    0x3E,0xE1
.db    0x23,0xC3
.db    0x30,0xE1
.db    0x06,0x00
.db    0x11,0x81
.db    0x00,0x7E
.db    0x12,0xB7
.db    0xCA,0x4F
.db    0xE1,0x04
.db    0x23,0x13
.db    0xC3,0x43
.db    0xE1,0x78
.db    0x32,0x80
.db    0x00,0xCD
.db    0x98,0xDA
.db    0xCD,0xD5
.db    0xDB,0xCD
.db    0x1A,0xDB
.db    0xCD,0x00
.db    0x01,0x31
.db    0xAB,0xE1
.db    0xCD,0x29
.db    0xDB,0xCD
.db    0xBD,0xDA
.db    0xC3,0x82
.db    0xDD,0xCD
.db    0x66,0xDE
.db    0xC3,0x09
.db    0xDC,0x01
.db    0x7A,0xE1
.db    0xCD,0xA7
.db    0xDA,0xC3
.db    0x86,0xE1
.db    0x42,0x41
.db    0x44,0x20
.db    0x4C,0x4F
.db    0x41,0x44
.db    0x00,0x43
.db    0x4F,0x4D
.db    0xCD,0x66
.db    0xDE,0xCD
.db    0x5E,0xDC
.db    0x3A,0xCE
.db    0xE1,0xD6
.db    0x20,0x21
.db    0xF0,0xE1
.db    0xB6,0xC2
.db    0x09,0xDC
.db    0xC3,0x82
.db    0xDD,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x24
.db    0x24,0x24
.db    0x20,0x20
.db    0x20,0x20
.db    0x20,0x53
.db    0x55,0x42
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x20,0x20
.db    0x20,0x20
.db    0x20,0x20
.db    0x20,0x20
.db    0x20,0x20
.db    0x20,0x00
.db    0x00,0x00
.db    0x2B,0x00
.db    0x20,0x20
.db    0x20,0x20
.db    0x20,0x20
.db    0x20,0x20
.db    0x20,0x20
.db    0x20,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x01,0x00
.db    0x00,0x4E
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
 
; *** Konstanten-STRING-Liste ***
;
 
M_CONST_STRING_0:
 .db    1, "s"
 
M_CONST_STRING_1:
 .db    3, "x21"
 
M_CONST_STRING_2:
 .db    3, "x22"
 
M_CONST_STRING_3:
 .db    3, "x23"
 
M_CONST_STRING_4:
 .db    3, "x24"
 
M_CONST_STRING_5:
 .db    3, "x25"
 
M_CONST_STRING_6:
 .db    0, " "
 
M_CONST_STRING_7:
 .db    1, "u"
 
M_CONST_STRING_8:
 .db    3, "x04"
 
M_CONST_STRING_9:
 .db    1, "r"
 
M_CONST_STRING_10:
 .db    3, "x08"
 
M_CONST_STRING_11:
 .db    1, "v"
 
M_CONST_STRING_12:
 .db    1, "h"
 
M_CONST_STRING_13:
 .db    3, "x14"
 
M_CONST_STRING_14:
 .db    1, "j"
 
M_CONST_STRING_15:
 .db    3, "x11"
 
M_CONST_STRING_16:
 .db    1, "i"
 
M_CONST_STRING_17:
 .db    3, "x12"
 
M_CONST_STRING_18:
 .db    1, "o"
 
M_CONST_STRING_19:
 .db    5, ": -> "
 
M_CONST_STRING_20:
 .db    11, "lokal Flash"
 
M_CONST_STRING_21:
 .db    6, "Serial "
 
M_CONST_STRING_22:
 .db    8, "ITP3 DS0 "
 
M_CONST_STRING_23:
 .db    8, "ITP3 DS1 "
 
M_CONST_STRING_24:
 .db    8, "ITP3 DS2 "
 
M_CONST_STRING_25:
 .db    8, "ITP3 DS3 "
 
M_CONST_STRING_26:
 .db    8, "ITP3 DS4 "
 
M_CONST_STRING_27:
 .db    11, "lokal Flash"
 
M_CONST_STRING_28:
 .db    6, "Serial "
 
M_CONST_STRING_29:
 .db    8, "ITP3 DS0 "
 
M_CONST_STRING_30:
 .db    8, "ITP3 DS1 "
 
M_CONST_STRING_31:
 .db    8, "ITP3 DS2 "
 
M_CONST_STRING_32:
 .db    8, "ITP3 DS3 "
 
M_CONST_STRING_33:
 .db    8, "ITP3 DS4 "
 
M_CONST_STRING_34:
 .db    45, "*** kein lokaler Flash (AT24C512) erkannt ***"
 
M_CONST_STRING_35:
 .db    7, "CONOUT="
 
M_CONST_STRING_36:
 .db    11, "CONOUT_NR1="
 
M_CONST_STRING_37:
 .db    11, "CONOUT_NR2="
 
M_CONST_STRING_38:
 .db    6, "CONIN= "
 
M_CONST_STRING_39:
 .db    6, "SOUND= "
 
M_CONST_STRING_40:
 .db    3, "x80"
 
M_CONST_STRING_41:
 .db    0, " "
 
M_CONST_STRING_42:
 .db    1, " "
 
M_CONST_STRING_43:
 .db    47, "*** Fehler: keine Tastatur angeschlossen!!! ***"
 
M_CONST_STRING_44:
 .db    1, " "
 
M_CONST_STRING_45:
 .db    46, "*** Fehler: kein Laufwerk angeschlossen!!! *** "
 
